import{S as Xm,i as Zm,s as Jm,e as r,k as d,w as f,t as s,M as Km,c as a,d as t,m as c,a as n,x as h,h as i,b as m,N as Qm,G as e,g as p,y as g,q as u,o as _,B as v,v as ed,L as od}from"../../chunks/vendor-hf-doc-builder.js";import{T as td}from"../../chunks/Tip-hf-doc-builder.js";import{D as x}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Ym}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ne}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as rd}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ad(Eo){let S,E,k,$,C;return $=new Ym({props:{code:`from transformers import (
    SamVisionConfig,
    SamPromptEncoderConfig,
    SamMaskDecoderConfig,
    SamModel,
)

# Initializing a SamConfig with \`"facebook/sam-vit-huge"\` style configuration
configuration = SamConfig()

# Initializing a SamModel (with random weights) from the \`"facebook/sam-vit-huge"\` style configuration
model = SamModel(configuration)

# Accessing the model configuration
configuration = model.config

# We can also initialize a SamConfig from a SamVisionConfig, SamPromptEncoderConfig, and SamMaskDecoderConfig

# Initializing SAM vision, SAM Q-Former and language model configurations
vision_config = SamVisionConfig()
prompt_encoder_config = SamPromptEncoderConfig()
mask_decoder_config = SamMaskDecoderConfig()

config = SamConfig(vision_config, prompt_encoder_config, mask_decoder_config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    SamVisionConfig,
<span class="hljs-meta">... </span>    SamPromptEncoderConfig,
<span class="hljs-meta">... </span>    SamMaskDecoderConfig,
<span class="hljs-meta">... </span>    SamModel,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a SamConfig with \`&quot;facebook/sam-vit-huge&quot;\` style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = SamConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a SamModel (with random weights) from the \`&quot;facebook/sam-vit-huge&quot;\` style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = SamModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># We can also initialize a SamConfig from a SamVisionConfig, SamPromptEncoderConfig, and SamMaskDecoderConfig</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing SAM vision, SAM Q-Former and language model configurations</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>vision_config = SamVisionConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_encoder_config = SamPromptEncoderConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_decoder_config = SamMaskDecoderConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span>config = SamConfig(vision_config, prompt_encoder_config, mask_decoder_config)`}}),{c(){S=r("p"),E=s("Example:"),k=d(),f($.$$.fragment)},l(b){S=a(b,"P",{});var z=n(S);E=i(z,"Example:"),z.forEach(t),k=c(b),h($.$$.fragment,b)},m(b,z){p(b,S,z),e(S,E),p(b,k,z),g($,b,z),C=!0},p:od,i(b){C||(u($.$$.fragment,b),C=!0)},o(b){_($.$$.fragment,b),C=!1},d(b){b&&t(S),b&&t(k),v($,b)}}}function nd(Eo){let S,E,k,$,C;return{c(){S=r("p"),E=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),k=r("code"),$=s("Module"),C=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(b){S=a(b,"P",{});var z=n(S);E=i(z,"Although the recipe for forward pass needs to be defined within this function, one should call the "),k=a(z,"CODE",{});var se=n(k);$=i(se,"Module"),se.forEach(t),C=i(z,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),z.forEach(t)},m(b,z){p(b,S,z),e(S,E),e(S,k),e(k,$),e(S,C)},d(b){b&&t(S)}}}function sd(Eo){let S,E,k,$,C,b,z,se,ra,or,W,ie,ut,De,aa,_t,na,tr,me,sa,Me,ia,ma,rr,Do,da,ar,Mo,Ao,vi,nr,No,ca,sr,Lo,Ae,la,Ne,pa,fa,ir,jo,ha,mr,I,vt,ga,ua,bt,_a,va,yt,ba,ya,St,Sa,wa,Le,ka,je,$a,xa,dr,D,za,qe,Pa,Ca,Re,Ia,Ta,Ve,Ea,Da,cr,qo,Ma,lr,Ue,pr,Ro,Aa,fr,de,Vo,Oe,Na,La,ja,Uo,We,qa,Ra,hr,F,ce,wt,Fe,Va,kt,Ua,gr,P,Be,Oa,q,Oo,Wa,Fa,Wo,Ba,Ga,Ge,Ha,Ya,Xa,B,Za,Fo,Ja,Ka,Bo,Qa,en,on,le,tn,pe,He,rn,Ye,an,Go,nn,sn,ur,G,fe,$t,Xe,mn,xt,dn,_r,M,Ze,cn,H,ln,zt,pn,fn,Je,hn,gn,un,Y,_n,Ho,vn,bn,Yo,yn,Sn,vr,X,he,Pt,Ke,wn,Ct,kn,br,A,Qe,$n,Z,xn,It,zn,Pn,eo,Cn,In,Tn,J,En,Xo,Dn,Mn,Zo,An,Nn,yr,K,ge,Tt,oo,Ln,Et,jn,Sr,N,to,qn,L,Rn,Dt,Vn,Un,Mt,On,Wn,ro,Fn,Bn,Gn,Q,Hn,Jo,Yn,Xn,Ko,Zn,Jn,wr,ee,ue,At,ao,Kn,Nt,Qn,kr,j,no,es,Lt,os,ts,R,Qo,rs,as,et,ns,ss,so,jt,is,ms,ds,$r,oe,_e,qt,io,cs,Rt,ls,xr,y,mo,ps,Vt,fs,hs,ve,co,gs,te,us,Ut,_s,vs,Ot,bs,ys,Ss,be,lo,ws,po,ks,Wt,$s,xs,zs,ye,fo,Ps,Ft,Cs,Is,Se,ho,Ts,go,Es,Bt,Ds,Ms,As,we,uo,Ns,Gt,Ls,js,ke,_o,qs,Ht,Rs,Vs,$e,vo,Us,Yt,Os,Ws,xe,bo,Fs,Xt,Bs,Gs,ze,yo,Hs,So,Ys,Zt,Xs,Zs,zr,re,Pe,Jt,wo,Js,Kt,Ks,Pr,T,ko,Qs,$o,ei,ot,oi,ti,ri,xo,ai,zo,ni,si,ii,V,Po,mi,ae,di,tt,ci,li,Qt,pi,fi,hi,Ce,Cr;return b=new ne({}),De=new ne({}),Ue=new Ym({props:{code:`import torch
from PIL import Image
import requests
from transformers import SamModel, SamProcessor

device = "cuda" if torch.cuda.is_available() else "cpu"
model = SamModel.from_pretrained("facebook/sam-vit-huge").to(device)
processor = SamProcessor.from_pretrained("facebook/sam-vit-huge")

img_url = "https://huggingface.co/ybelkada/segment-anything/resolve/main/assets/car.png"
raw_image = Image.open(requests.get(img_url, stream=True).raw).convert("RGB")
input_points = [[[450, 600]]]  # 2D location of a window in the image

inputs = processor(raw_image, input_points=input_points, return_tensors="pt").to(device)
outputs = model(**inputs)

masks = processor.image_processor.post_process_masks(
    outputs.pred_masks.cpu(), inputs["original_sizes"].cpu(), inputs["reshaped_input_sizes"].cpu()
)
scores = outputs.iou_scores`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> SamModel, SamProcessor

device = <span class="hljs-string">&quot;cuda&quot;</span> <span class="hljs-keyword">if</span> torch.cuda.is_available() <span class="hljs-keyword">else</span> <span class="hljs-string">&quot;cpu&quot;</span>
model = SamModel.from_pretrained(<span class="hljs-string">&quot;facebook/sam-vit-huge&quot;</span>).to(device)
processor = SamProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/sam-vit-huge&quot;</span>)

img_url = <span class="hljs-string">&quot;https://huggingface.co/ybelkada/segment-anything/resolve/main/assets/car.png&quot;</span>
raw_image = Image.<span class="hljs-built_in">open</span>(requests.get(img_url, stream=<span class="hljs-literal">True</span>).raw).convert(<span class="hljs-string">&quot;RGB&quot;</span>)
input_points = [[[<span class="hljs-number">450</span>, <span class="hljs-number">600</span>]]]  <span class="hljs-comment"># 2D location of a window in the image</span>

inputs = processor(raw_image, input_points=input_points, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).to(device)
outputs = model(**inputs)

masks = processor.image_processor.post_process_masks(
    outputs.pred_masks.cpu(), inputs[<span class="hljs-string">&quot;original_sizes&quot;</span>].cpu(), inputs[<span class="hljs-string">&quot;reshaped_input_sizes&quot;</span>].cpu()
)
scores = outputs.iou_scores`}}),Fe=new ne({}),Be=new x({props:{name:"class transformers.SamConfig",anchor:"transformers.SamConfig",parameters:[{name:"vision_config",val:" = None"},{name:"prompt_encoder_config",val:" = None"},{name:"mask_decoder_config",val:" = None"},{name:"initializer_range",val:" = 0.02"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamConfig.vision_config",description:`<strong>vision_config</strong> (Union[<code>dict</code>, <code>SamVisionConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamVisionConfig">SamVisionConfig</a>.`,name:"vision_config"},{anchor:"transformers.SamConfig.prompt_encoder_config",description:`<strong>prompt_encoder_config</strong> (Union[<code>dict</code>, <code>SamPromptEncoderConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamPromptEncoderConfig">SamPromptEncoderConfig</a>.`,name:"prompt_encoder_config"},{anchor:"transformers.SamConfig.mask_decoder_config",description:`<strong>mask_decoder_config</strong> (Union[<code>dict</code>, <code>SamMaskDecoderConfig</code>], <em>optional</em>) &#x2014;
Dictionary of configuration options used to initialize <a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamMaskDecoderConfig">SamMaskDecoderConfig</a>.`,name:"mask_decoder_config"},{anchor:"transformers.SamConfig.kwargs",description:`<strong>kwargs</strong> (<em>optional</em>) &#x2014;
Dictionary of keyword arguments.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/configuration_sam.py#L254"}}),le=new rd({props:{anchor:"transformers.SamConfig.example",$$slots:{default:[ad]},$$scope:{ctx:Eo}}}),He=new x({props:{name:"to_dict",anchor:"transformers.SamConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/configuration_sam.py#L332",returnDescription:`
<p>Dictionary of all the attributes that make up this configuration instance,</p>
`,returnType:`
<p><code>Dict[str, any]</code></p>
`}}),Xe=new ne({}),Ze=new x({props:{name:"class transformers.SamVisionConfig",anchor:"transformers.SamVisionConfig",parameters:[{name:"hidden_size",val:" = 768"},{name:"intermediate_size",val:" = 6144"},{name:"projection_dim",val:" = 512"},{name:"output_channels",val:" = 256"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"num_channels",val:" = 3"},{name:"image_size",val:" = 1024"},{name:"patch_size",val:" = 16"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"dropout",val:" = 0.0"},{name:"attention_dropout",val:" = 0.0"},{name:"initializer_range",val:" = 1e-10"},{name:"initializer_factor",val:" = 1.0"},{name:"qkv_bias",val:" = True"},{name:"mlp_ratio",val:" = 4.0"},{name:"use_abs_pos",val:" = True"},{name:"use_rel_pos",val:" = True"},{name:"window_size",val:" = 14"},{name:"global_attn_indexes",val:" = [2, 5, 8, 11]"},{name:"num_pos_feats",val:" = 128"},{name:"mlp_dim",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamVisionConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.SamVisionConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.SamVisionConfig.projection_dim",description:`<strong>projection_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
Dimensionality of the projection layer in the Transformer encoder.`,name:"projection_dim"},{anchor:"transformers.SamVisionConfig.output_channels",description:`<strong>output_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the output channels in the Patch Encoder.`,name:"output_channels"},{anchor:"transformers.SamVisionConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.SamVisionConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.SamVisionConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of channels in the input image.`,name:"num_channels"},{anchor:"transformers.SamVisionConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
Expected resolution. Target size of the resized input image.`,name:"image_size"},{anchor:"transformers.SamVisionConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Size of the patches to be extracted from the input image.`,name:"patch_size"},{anchor:"transformers.SamVisionConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string)`,name:"hidden_act"},{anchor:"transformers.SamVisionConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.SamVisionConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probability.`,name:"dropout"},{anchor:"transformers.SamVisionConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.SamVisionConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-10) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.SamVisionConfig.initializer_factor",description:`<strong>initializer_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
A factor for multiplying the initializer range.`,name:"initializer_factor"},{anchor:"transformers.SamVisionConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to query, key, value projections.`,name:"qkv_bias"},{anchor:"transformers.SamVisionConfig.mlp_ratio",description:`<strong>mlp_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 4.0) &#x2014;
Ratio of mlp hidden dim to embedding dim.`,name:"mlp_ratio"},{anchor:"transformers.SamVisionConfig.use_abs_pos",description:`<strong>use_abs_pos</strong> (<code>bool</code>, <em>optional</em>, defaults to True) &#x2014;
Whether to use absolute position embedding.`,name:"use_abs_pos"},{anchor:"transformers.SamVisionConfig.use_rel_pos",description:`<strong>use_rel_pos</strong> (<code>bool</code>, <em>optional</em>, defaults to True) &#x2014;
Whether to use relative position embedding.`,name:"use_rel_pos"},{anchor:"transformers.SamVisionConfig.window_size",description:`<strong>window_size</strong> (<code>int</code>, <em>optional</em>, defaults to 14) &#x2014;
Window size for relative position.`,name:"window_size"},{anchor:"transformers.SamVisionConfig.global_attn_indexes",description:`<strong>global_attn_indexes</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[2, 5, 8, 11]</code>) &#x2014;
The indexes of the global attention layers.`,name:"global_attn_indexes"},{anchor:"transformers.SamVisionConfig.num_pos_feats",description:`<strong>num_pos_feats</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
The dimensionality of the position embedding.`,name:"num_pos_feats"},{anchor:"transformers.SamVisionConfig.mlp_dim",description:`<strong>mlp_dim</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
The dimensionality of the MLP layer in the Transformer encoder. If <code>None</code>, defaults to <code>mlp_ratio * hidden_size</code>.`,name:"mlp_dim"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/configuration_sam.py#L140"}}),Ke=new ne({}),Qe=new x({props:{name:"class transformers.SamMaskDecoderConfig",anchor:"transformers.SamMaskDecoderConfig",parameters:[{name:"hidden_size",val:" = 256"},{name:"hidden_act",val:" = 'relu'"},{name:"mlp_dim",val:" = 2048"},{name:"num_hidden_layers",val:" = 2"},{name:"num_attention_heads",val:" = 8"},{name:"attention_downsample_rate",val:" = 2"},{name:"num_multimask_outputs",val:" = 3"},{name:"iou_head_depth",val:" = 3"},{name:"iou_head_hidden_dim",val:" = 256"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamMaskDecoderConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the hidden states.`,name:"hidden_size"},{anchor:"transformers.SamMaskDecoderConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function used inside the <code>SamMaskDecoder</code> module.`,name:"hidden_act"},{anchor:"transformers.SamMaskDecoderConfig.mlp_dim",description:`<strong>mlp_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"mlp_dim"},{anchor:"transformers.SamMaskDecoderConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.SamMaskDecoderConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.SamMaskDecoderConfig.attention_downsample_rate",description:`<strong>attention_downsample_rate</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The downsampling rate of the attention layer.`,name:"attention_downsample_rate"},{anchor:"transformers.SamMaskDecoderConfig.num_multimask_outputs",description:`<strong>num_multimask_outputs</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of outputs from the <code>SamMaskDecoder</code> module. In the Segment Anything paper, this is set to 3.`,name:"num_multimask_outputs"},{anchor:"transformers.SamMaskDecoderConfig.iou_head_depth",description:`<strong>iou_head_depth</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of layers in the IoU head module.`,name:"iou_head_depth"},{anchor:"transformers.SamMaskDecoderConfig.iou_head_hidden_dim",description:`<strong>iou_head_hidden_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
The dimensionality of the hidden states in the IoU head module.`,name:"iou_head_hidden_dim"},{anchor:"transformers.SamMaskDecoderConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/configuration_sam.py#L79"}}),oo=new ne({}),to=new x({props:{name:"class transformers.SamPromptEncoderConfig",anchor:"transformers.SamPromptEncoderConfig",parameters:[{name:"hidden_size",val:" = 256"},{name:"image_size",val:" = 1024"},{name:"patch_size",val:" = 16"},{name:"mask_input_channels",val:" = 16"},{name:"num_point_embeddings",val:" = 4"},{name:"hidden_act",val:" = 'gelu'"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamPromptEncoderConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the hidden states.`,name:"hidden_size"},{anchor:"transformers.SamPromptEncoderConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
The expected output resolution of the image.`,name:"image_size"},{anchor:"transformers.SamPromptEncoderConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.SamPromptEncoderConfig.mask_input_channels",description:`<strong>mask_input_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The number of channels to be fed to the <code>MaskDecoder</code> module.`,name:"mask_input_channels"},{anchor:"transformers.SamPromptEncoderConfig.num_point_embeddings",description:`<strong>num_point_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The number of point embeddings to be used.`,name:"num_point_embeddings"},{anchor:"transformers.SamPromptEncoderConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function in the encoder and pooler.`,name:"hidden_act"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/configuration_sam.py#L32"}}),ao=new ne({}),no=new x({props:{name:"class transformers.SamProcessor",anchor:"transformers.SamProcessor",parameters:[{name:"image_processor",val:""}],parametersDescription:[{anchor:"transformers.SamProcessor.image_processor",description:`<strong>image_processor</strong> (<code>SamImageProcessor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamImageProcessor">SamImageProcessor</a>. The image processor is a required input.`,name:"image_processor"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/processing_sam.py#L32"}}),io=new ne({}),mo=new x({props:{name:"class transformers.SamImageProcessor",anchor:"transformers.SamImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": bool = True"},{name:"pad_size",val:": int = None"},{name:"do_convert_rgb",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the image&#x2019;s (height, width) dimensions to the specified <code>size</code>. Can be overridden by the
<code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.SamImageProcessor.size",description:`<strong>size</strong> (<code>dict</code>, <em>optional</em>, defaults to <code>{&quot;longest_edge&quot; -- 1024}</code>):
Size of the output image after resizing. Resizes the longest edge of the image to match
<code>size[&quot;longest_edge&quot;]</code> while maintaining the aspect ratio. Can be overridden by the <code>size</code> parameter in the
<code>preprocess</code> method.`,name:"size"},{anchor:"transformers.SamImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BICUBIC</code>) &#x2014;
Resampling filter to use if resizing the image. Can be overridden by the <code>resample</code> parameter in the
<code>preprocess</code> method.`,name:"resample"},{anchor:"transformers.SamImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Wwhether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the
<code>do_rescale</code> parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.SamImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Only has an effect if <code>do_rescale</code> is set to <code>True</code>. Can be
overridden by the <code>rescale_factor</code> parameter in the <code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.SamImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code>
method. Can be overridden by the <code>do_normalize</code> parameter in the <code>preprocess</code> method.`,name:"do_normalize"},{anchor:"transformers.SamImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_MEAN</code>) &#x2014;
Mean to use if normalizing the image. This is a float or list of floats the length of the number of
channels in the image. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method. Can be
overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.SamImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_STD</code>) &#x2014;
Standard deviation to use if normalizing the image. This is a float or list of floats the length of the
number of channels in the image. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.
Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.SamImageProcessor.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to pad the image to the specified <code>pad_size</code>. Can be overridden by the <code>do_pad</code> parameter in the
<code>preprocess</code> method.`,name:"do_pad"},{anchor:"transformers.SamImageProcessor.pad_size",description:`<strong>pad_size</strong> (<code>dict</code>, <em>optional</em>, defaults to <code>{&quot;height&quot; -- 1024, &quot;width&quot;: 1024}</code>):
Size of the output image after padding. Can be overridden by the <code>pad_size</code> parameter in the <code>preprocess</code>
method.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L50"}}),co=new x({props:{name:"filter_masks",anchor:"transformers.SamImageProcessor.filter_masks",parameters:[{name:"masks",val:""},{name:"iou_scores",val:""},{name:"original_size",val:""},{name:"cropped_box_image",val:""},{name:"pred_iou_thresh",val:" = 0.88"},{name:"stability_score_thresh",val:" = 0.95"},{name:"mask_threshold",val:" = 0"},{name:"stability_score_offset",val:" = 1"}],parametersDescription:[{anchor:"transformers.SamImageProcessor.filter_masks.masks",description:`<strong>masks</strong> (<code>torch.Tensor</code>) &#x2014;
Input masks.`,name:"masks"},{anchor:"transformers.SamImageProcessor.filter_masks.iou_scores",description:`<strong>iou_scores</strong> (<code>torch.Tensor</code>) &#x2014;
List of IoU scores.`,name:"iou_scores"},{anchor:"transformers.SamImageProcessor.filter_masks.original_size",description:`<strong>original_size</strong> (<code>Tuple[int,int]</code>) &#x2014;
Size of the orginal image.`,name:"original_size"},{anchor:"transformers.SamImageProcessor.filter_masks.cropped_box_image",description:`<strong>cropped_box_image</strong> (<code>np.array</code>) &#x2014;
The cropped image.`,name:"cropped_box_image"},{anchor:"transformers.SamImageProcessor.filter_masks.pred_iou_thresh",description:`<strong>pred_iou_thresh</strong> (<code>float</code>, <em>optional</em>, defaults to 0.88) &#x2014;
The threshold for the iou scores.`,name:"pred_iou_thresh"},{anchor:"transformers.SamImageProcessor.filter_masks.stability_score_thresh",description:`<strong>stability_score_thresh</strong> (<code>float</code>, <em>optional</em>, defaults to 0.95) &#x2014;
The threshold for the stability score.`,name:"stability_score_thresh"},{anchor:"transformers.SamImageProcessor.filter_masks.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
The threshold for the predicted masks.`,name:"mask_threshold"},{anchor:"transformers.SamImageProcessor.filter_masks.stability_score_offset",description:`<strong>stability_score_offset</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The offset for the stability score used in the <code>_compute_stability_score</code> method.`,name:"stability_score_offset"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L472"}}),lo=new x({props:{name:"generate_crop_boxes",anchor:"transformers.SamImageProcessor.generate_crop_boxes",parameters:[{name:"image",val:""},{name:"target_size",val:""},{name:"crop_n_layers",val:": int = 0"},{name:"overlap_ratio",val:": float = 0.3413333333333333"},{name:"points_per_crop",val:": typing.Optional[int] = 32"},{name:"crop_n_points_downscale_factor",val:": typing.Optional[typing.List[int]] = 1"},{name:"device",val:": typing.Optional[ForwardRef('torch.device')] = None"}],parametersDescription:[{anchor:"transformers.SamImageProcessor.generate_crop_boxes.image",description:`<strong>image</strong> (<code>np.array</code>) &#x2014;
Input original image`,name:"image"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.target_size",description:`<strong>target_size</strong> (<code>int</code>) &#x2014;
Target size of the resized image`,name:"target_size"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.crop_n_layers",description:`<strong>crop_n_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
If &gt;0, mask prediction will be run again on crops of the image. Sets the number of layers to run, where
each layer has 2**i_layer number of image crops.`,name:"crop_n_layers"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.overlap_ratio",description:`<strong>overlap_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 512/1500) &#x2014;
Sets the degree to which crops overlap. In the first crop layer, crops will overlap by this fraction of
the image length. Later layers with more crops scale down this overlap.`,name:"overlap_ratio"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.points_per_crop",description:`<strong>points_per_crop</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Number of points to sample from each crop.`,name:"points_per_crop"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.crop_n_points_downscale_factor",description:`<strong>crop_n_points_downscale_factor</strong> (<code>List[int]</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of points-per-side sampled in layer n is scaled down by crop_n_points_downscale_factor**n.`,name:"crop_n_points_downscale_factor"},{anchor:"transformers.SamImageProcessor.generate_crop_boxes.device",description:`<strong>device</strong> (<code>torch.device</code>, <em>optional</em>, defaults to None) &#x2014;
Device to use for the computation. If None, cpu will be used.`,name:"device"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L437"}}),fo=new x({props:{name:"normalize",anchor:"transformers.SamImageProcessor.normalize",parameters:[{name:"image",val:": ndarray"},{name:"mean",val:": typing.Union[float, typing.List[float]]"},{name:"std",val:": typing.Union[float, typing.List[float]]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.normalize.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to normalize.`,name:"image"},{anchor:"transformers.SamImageProcessor.normalize.mean",description:`<strong>mean</strong> (<code>float</code> or <code>List[float]</code>) &#x2014;
Image mean.`,name:"mean"},{anchor:"transformers.SamImageProcessor.normalize.std",description:`<strong>std</strong> (<code>float</code> or <code>List[float]</code>) &#x2014;
Image standard deviation.`,name:"std"},{anchor:"transformers.SamImageProcessor.normalize.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L222"}}),ho=new x({props:{name:"pad_image",anchor:"transformers.SamImageProcessor.pad_image",parameters:[{name:"image",val:": ndarray"},{name:"pad_size",val:": typing.Dict[str, int]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.pad_image.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to pad.`,name:"image"},{anchor:"transformers.SamImageProcessor.pad_image.pad_size",description:`<strong>pad_size</strong> (<code>Dict[str, int]</code>) &#x2014;
Size of the output image after padding.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.pad_image.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The data format of the image. Can be either &#x201C;channels_first&#x201D; or &#x201C;channels_last&#x201D;. If <code>None</code>, the
<code>data_format</code> of the <code>image</code> will be used.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L128"}}),uo=new x({props:{name:"post_process_for_mask_generation",anchor:"transformers.SamImageProcessor.post_process_for_mask_generation",parameters:[{name:"all_masks",val:""},{name:"all_scores",val:""},{name:"all_boxes",val:""},{name:"crops_nms_thresh",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.post_process_for_mask_generation.all_masks",description:`<strong>all_masks</strong> (<code>List[torch.Tensor]</code>) &#x2014;
List of all predicted segmentation masks`,name:"all_masks"},{anchor:"transformers.SamImageProcessor.post_process_for_mask_generation.all_scores",description:`<strong>all_scores</strong> (<code>List[torch.Tensor]</code>) &#x2014;
List of all predicted iou scores`,name:"all_scores"},{anchor:"transformers.SamImageProcessor.post_process_for_mask_generation.all_boxes",description:`<strong>all_boxes</strong> (<code>List[torch.Tensor]</code>) &#x2014;
List of all bounding boxes of the predicted masks`,name:"all_boxes"},{anchor:"transformers.SamImageProcessor.post_process_for_mask_generation.crops_nms_thresh",description:`<strong>crops_nms_thresh</strong> (<code>float</code>) &#x2014;
Threshold for NMS (Non Maximum Suppression) algorithm.`,name:"crops_nms_thresh"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L421"}}),_o=new x({props:{name:"post_process_masks",anchor:"transformers.SamImageProcessor.post_process_masks",parameters:[{name:"masks",val:""},{name:"original_sizes",val:""},{name:"reshaped_input_sizes",val:""},{name:"mask_threshold",val:" = 0.0"},{name:"binarize",val:" = True"},{name:"pad_size",val:" = None"}],parametersDescription:[{anchor:"transformers.SamImageProcessor.post_process_masks.masks",description:`<strong>masks</strong> (<code>Union[List[torch.Tensor], List[np.ndarray]]</code>) &#x2014;
Batched masks from the mask_decoder in (batch_size, num_channels, height, width) format.`,name:"masks"},{anchor:"transformers.SamImageProcessor.post_process_masks.original_sizes",description:`<strong>original_sizes</strong> (<code>Union[torch.Tensor, List[Tuple[int,int]]]</code>) &#x2014;
The original sizes of each image before it was resized to the model&#x2019;s expected input shape, in (height,
width) format.`,name:"original_sizes"},{anchor:"transformers.SamImageProcessor.post_process_masks.reshaped_input_sizes",description:`<strong>reshaped_input_sizes</strong> (<code>Union[torch.Tensor, List[Tuple[int,int]]]</code>) &#x2014;
The size of each image as it is fed to the model, in (height, width) format. Used to remove padding.`,name:"reshaped_input_sizes"},{anchor:"transformers.SamImageProcessor.post_process_masks.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The threshold to use for binarizing the masks.`,name:"mask_threshold"},{anchor:"transformers.SamImageProcessor.post_process_masks.binarize",description:`<strong>binarize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to binarize the masks.`,name:"binarize"},{anchor:"transformers.SamImageProcessor.post_process_masks.pad_size",description:`<strong>pad_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>self.pad_size</code>) &#x2014;
The target size the images were padded to before being passed to the model. If None, the target size is
assumed to be the processor&#x2019;s <code>pad_size</code>.`,name:"pad_size"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L374",returnDescription:`
<p>Batched masks in batch_size, num_channels, height, width) format, where (height, width)
is given by original_size.</p>
`,returnType:`
<p>(<code>torch.Tensor</code>)</p>
`}}),vo=new x({props:{name:"preprocess",anchor:"transformers.SamImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"resample",val:": typing.Optional[ForwardRef('PILImageResampling')] = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Union[int, float, NoneType] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": typing.Optional[bool] = None"},{name:"pad_size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"do_convert_rgb",val:": bool = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": ChannelDimension = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image to preprocess.`,name:"images"},{anchor:"transformers.SamImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_resize</code>) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.SamImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.size</code>) &#x2014;
Controls the size of the image after <code>resize</code>. The longest edge of the image is resized to
<code>size[&quot;longest_edge&quot;]</code> whilst preserving the aspect ratio.`,name:"size"},{anchor:"transformers.SamImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>self.resample</code>) &#x2014;
<code>PILImageResampling</code> filter to use when resizing the image e.g. <code>PILImageResampling.BILINEAR</code>.`,name:"resample"},{anchor:"transformers.SamImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_rescale</code>) &#x2014;
Whether to rescale the image pixel values by rescaling factor.`,name:"do_rescale"},{anchor:"transformers.SamImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>self.rescale_factor</code>) &#x2014;
Rescale factor to apply to the image pixel values.`,name:"rescale_factor"},{anchor:"transformers.SamImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_normalize</code>) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.SamImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_mean</code>) &#x2014;
Image mean to normalize the image by if <code>do_normalize</code> is set to <code>True</code>.`,name:"image_mean"},{anchor:"transformers.SamImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>self.image_std</code>) &#x2014;
Image standard deviation to normalize the image by if <code>do_normalize</code> is set to <code>True</code>.`,name:"image_std"},{anchor:"transformers.SamImageProcessor.preprocess.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_pad</code>) &#x2014;
Whether to pad the image.`,name:"do_pad"},{anchor:"transformers.SamImageProcessor.preprocess.pad_size",description:`<strong>pad_size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to <code>self.pad_size</code>) &#x2014;
Controls the size of the padding applied to the image. The image is padded to <code>pad_size[&quot;height&quot;]</code> and
<code>pad_size[&quot;width&quot;]</code> if <code>do_pad</code> is set to <code>True</code>.`,name:"pad_size"},{anchor:"transformers.SamImageProcessor.preprocess.do_convert_rgb",description:`<strong>do_convert_rgb</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>self.do_convert_rgb</code>) &#x2014;
Whether to convert the image to RGB.`,name:"do_convert_rgb"},{anchor:"transformers.SamImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.SamImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>, defaults to <code>ChannelDimension.FIRST</code>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
<li>Unset: Use the channel dimension format of the input image.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L245"}}),bo=new x({props:{name:"rescale",anchor:"transformers.SamImageProcessor.rescale",parameters:[{name:"image",val:": ndarray"},{name:"scale",val:": typing.Union[int, float]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.rescale.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to rescale.`,name:"image"},{anchor:"transformers.SamImageProcessor.rescale.scale",description:`<strong>scale</strong> (<code>int</code> or <code>float</code>) &#x2014;
Scale to apply to the image.`,name:"scale"},{anchor:"transformers.SamImageProcessor.rescale.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L202"}}),yo=new x({props:{name:"resize",anchor:"transformers.SamImageProcessor.resize",parameters:[{name:"image",val:": ndarray"},{name:"size",val:": typing.Dict[str, int]"},{name:"resample",val:": Resampling = <Resampling.BICUBIC: 3>"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamImageProcessor.resize.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
Image to resize.`,name:"image"},{anchor:"transformers.SamImageProcessor.resize.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>) &#x2014;
Dictionary in the format <code>{&quot;longest_edge&quot;: int}</code> specifying the size of the output image. The longest
edge of the image will be resized to the specified size, while the other edge will be resized to
maintain the aspect ratio.
resample &#x2014;
<code>PILImageResampling</code> filter to use when resizing the image e.g. <code>PILImageResampling.BILINEAR</code>.`,name:"size"},{anchor:"transformers.SamImageProcessor.resize.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code> or <code>str</code>, <em>optional</em>) &#x2014;
The channel dimension format for the output image. If unset, the channel dimension format of the input
image is used. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.</li>
</ul>`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/image_processing_sam.py#L167",returnDescription:`
<p>The resized image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),wo=new ne({}),ko=new x({props:{name:"class transformers.SamModel",anchor:"transformers.SamModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.SamModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamConfig">SamConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/modeling_sam.py#L1165"}}),Po=new x({props:{name:"forward",anchor:"transformers.SamModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_points",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"input_boxes",val:": typing.Optional[torch.FloatTensor] = None"},{name:"input_masks",val:": typing.Optional[torch.LongTensor] = None"},{name:"image_embeddings",val:": typing.Optional[torch.FloatTensor] = None"},{name:"multimask_output",val:": bool = True"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.SamModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamProcessor">SamProcessor</a>. See <code>SamProcessor.__call__()</code> for
details.`,name:"pixel_values"},{anchor:"transformers.SamModel.forward.input_points",description:`<strong>input_points</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_points, 2)</code>) &#x2014;
Input 2D spatial points, this is used by the prompt encoder to encode the prompt. Generally yields to much
better results. The points can be obtained by passing a list of list of list to the processor that will
create corresponding <code>torch</code> tensors of dimension 4. The first dimension is the image batch size, the
second dimension is the point batch size (i.e. how many segmentation masks do we want the model to predict
per input point), the third dimension is the number of points per segmentation mask (it is possible to pass
multiple points for a single mask), and the last dimension is the x (vertical) and y (horizontal)
coordinates of the point. If a different number of points is passed either for each image, or for each
mask, the processor will create &#x201C;PAD&#x201D; points that will correspond to the (0, 0) coordinate, and the
computation of the embedding will be skipped for these points using the labels.`,name:"input_points"},{anchor:"transformers.SamModel.forward.input_labels",description:`<strong>input_labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, point_batch_size, num_points)</code>) &#x2014;
Input labels for the points, this is used by the prompt encoder to encode the prompt. According to the
official implementation, there are 3 types of labels</p>
<ul>
<li><code>1</code>: the point is a point that contains the object of interest</li>
<li><code>0</code>: the point is a point that does not contain the object of interest</li>
<li><code>-1</code>: the point corresponds to the background</li>
</ul>
<p>We added the label:</p>
<ul>
<li><code>-10</code>: the point is a padding point, thus should be ignored by the prompt encoder</li>
</ul>
<p>The padding labels should be automatically done by the processor.`,name:"input_labels"},{anchor:"transformers.SamModel.forward.input_boxes",description:`<strong>input_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_boxes, 4)</code>) &#x2014;
Input boxes for the points, this is used by the prompt encoder to encode the prompt. Generally yields to
much better generated masks. The boxes can be obtained by passing a list of list of list to the processor,
that will generate a <code>torch</code> tensor, with each dimension corresponding respectively to the image batch
size, the number of boxes per image and the coordinates of the top left and botton right point of the box.
In the order (<code>x1</code>, <code>y1</code>, <code>x2</code>, <code>y2</code>):</p>
<ul>
<li><code>x1</code>: the x coordinate of the top left point of the input box</li>
<li><code>y1</code>: the y coordinate of the top left point of the input box</li>
<li><code>x2</code>: the x coordinate of the bottom right point of the input box</li>
<li><code>y2</code>: the y coordinate of the bottom right point of the input box</li>
</ul>`,name:"input_boxes"},{anchor:"transformers.SamModel.forward.input_masks",description:`<strong>input_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, image_size, image_size)</code>) &#x2014;
SAM model also accepts segmentation masks as input. The mask will be embedded by the prompt encoder to
generate a corresponding embedding, that will be fed later on to the mask decoder. These masks needs to be
manually fed by the user, and they need to be of shape (<code>batch_size</code>, <code>image_size</code>, <code>image_size</code>).`,name:"input_masks"},{anchor:"transformers.SamModel.forward.image_embeddings",description:`<strong>image_embeddings</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, output_channels, window_size, window_size)</code>) &#x2014;
Image embeddings, this is used by the mask decder to generate masks and iou scores. For more memory
efficient computation, users can first retrieve the image embeddings using the <code>get_image_embeddings</code>
method, and then feed them to the <code>forward</code> method instead of feeding the <code>pixel_values</code>.`,name:"image_embeddings"},{anchor:"transformers.SamModel.forward.multimask_output",description:`<strong>multimask_output</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
In the original implementation and paper, the model always outputs 3 masks per image (or per point / per
bounding box if relevant). However, it is possible to just output a single mask, that corresponds to the
&#x201C;best&#x201D; mask, by specifying <code>multimask_output=False</code>.`,name:"multimask_output"},{anchor:"transformers.SamModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.SamModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.SamModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.</p>
<p>Example &#x2014;`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/sam/modeling_sam.py#L1258"}}),Ce=new td({props:{$$slots:{default:[nd]},$$scope:{ctx:Eo}}}),{c(){S=r("meta"),E=d(),k=r("h1"),$=r("a"),C=r("span"),f(b.$$.fragment),z=d(),se=r("span"),ra=s("SAM"),or=d(),W=r("h2"),ie=r("a"),ut=r("span"),f(De.$$.fragment),aa=d(),_t=r("span"),na=s("Overview"),tr=d(),me=r("p"),sa=s("SAM (Segment Anything Model) was proposed in "),Me=r("a"),ia=s("Segment Anything"),ma=s(" by Alexander Kirillov, Eric Mintun, Nikhila Ravi, Hanzi Mao, Chloe Rolland, Laura Gustafson, Tete Xiao, Spencer Whitehead, Alex Berg, Wan-Yen Lo, Piotr Dollar, Ross Girshick."),rr=d(),Do=r("p"),da=s("The model can be used to predict segmentation masks of any object of interest given an input image."),ar=d(),Mo=r("p"),Ao=r("img"),nr=d(),No=r("p"),ca=s("The abstract from the paper is the following:"),sr=d(),Lo=r("p"),Ae=r("em"),la=s("We introduce the Segment Anything (SA) project: a new task, model, and dataset for image segmentation. Using our efficient model in a data collection loop, we built the largest segmentation dataset to date (by far), with over 1 billion masks on 11M licensed and privacy respecting images. The model is designed and trained to be promptable, so it can transfer zero-shot to new image distributions and tasks. We evaluate its capabilities on numerous tasks and find that its zero-shot performance is impressive \u2014 often competitive with or even superior to prior fully supervised results. We are releasing the Segment Anything Model (SAM) and corresponding dataset (SA-1B) of 1B masks and 11M images at \\href{"),Ne=r("a"),pa=s("https://segment-anything.com}{https://segment-anything.com}"),fa=s(" to foster research into foundation models for computer vision."),ir=d(),jo=r("p"),ha=s("Tips:"),mr=d(),I=r("ul"),vt=r("li"),ga=s("The model predicts binary masks that states the presence or not of the object of interest given an image."),ua=d(),bt=r("li"),_a=s("The model predicts much better results if input 2D points and/or input bounding boxes are provided"),va=d(),yt=r("li"),ba=s("You can prompt multiple points for the same image, and predict a single mask."),ya=d(),St=r("li"),Sa=s("Fine-tuning the model is not supported yet"),wa=d(),Le=r("li"),ka=s("According to the paper, textual input should be also supported. However, at this time of writing this seems to be not supported according to "),je=r("a"),$a=s("the official repository"),xa=s("."),dr=d(),D=r("p"),za=s("This model was contributed by "),qe=r("a"),Pa=s("ybelkada"),Ca=s(" and "),Re=r("a"),Ia=s("ArthurZ"),Ta=s(`.
The original code can be found `),Ve=r("a"),Ea=s("here"),Da=s("."),cr=d(),qo=r("p"),Ma=s("Below is an example on how to run mask generation given an image and a 2D point:"),lr=d(),f(Ue.$$.fragment),pr=d(),Ro=r("p"),Aa=s("Resources:"),fr=d(),de=r("ul"),Vo=r("li"),Oe=r("a"),Na=s("Demo notebook"),La=s(" for using the model"),ja=d(),Uo=r("li"),We=r("a"),qa=s("Demo notebook"),Ra=s(" for using automatic mask generation pipeline."),hr=d(),F=r("h2"),ce=r("a"),wt=r("span"),f(Fe.$$.fragment),Va=d(),kt=r("span"),Ua=s("SamConfig"),gr=d(),P=r("div"),f(Be.$$.fragment),Oa=d(),q=r("p"),Oo=r("a"),Wa=s("SamConfig"),Fa=s(" is the configuration class to store the configuration of a "),Wo=r("a"),Ba=s("SamModel"),Ga=s(`. It is used to instantiate a
SAM model according to the specified arguments, defining the vision model, prompt-encoder model and mask decoder
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
SAM-ViT-H `),Ge=r("a"),Ha=s("facebook/sam-vit-huge"),Ya=s(" architecture."),Xa=d(),B=r("p"),Za=s("Configuration objects inherit from "),Fo=r("a"),Ja=s("PretrainedConfig"),Ka=s(` and can be used to control the model outputs. Read the
documentation from `),Bo=r("a"),Qa=s("PretrainedConfig"),en=s(" for more information."),on=d(),f(le.$$.fragment),tn=d(),pe=r("div"),f(He.$$.fragment),rn=d(),Ye=r("p"),an=s("Serializes this instance to a Python dictionary. Override the default "),Go=r("a"),nn=s("to_dict()"),sn=s("."),ur=d(),G=r("h2"),fe=r("a"),$t=r("span"),f(Xe.$$.fragment),mn=d(),xt=r("span"),dn=s("SamVisionConfig"),_r=d(),M=r("div"),f(Ze.$$.fragment),cn=d(),H=r("p"),ln=s("This is the configuration class to store the configuration of a "),zt=r("code"),pn=s("SamVisionModel"),fn=s(`. It is used to instantiate a SAM
vision encoder according to the specified arguments, defining the model architecture. Instantiating a configuration
defaults will yield a similar configuration to that of the SAM ViT-h
`),Je=r("a"),hn=s("facebook/sam-vit-huge"),gn=s(" architecture."),un=d(),Y=r("p"),_n=s("Configuration objects inherit from "),Ho=r("a"),vn=s("PretrainedConfig"),bn=s(` and can be used to control the model outputs. Read the
documentation from `),Yo=r("a"),yn=s("PretrainedConfig"),Sn=s(" for more information."),vr=d(),X=r("h2"),he=r("a"),Pt=r("span"),f(Ke.$$.fragment),wn=d(),Ct=r("span"),kn=s("SamMaskDecoderConfig"),br=d(),A=r("div"),f(Qe.$$.fragment),$n=d(),Z=r("p"),xn=s("This is the configuration class to store the configuration of a "),It=r("code"),zn=s("SamMaskDecoder"),Pn=s(`. It is used to instantiate a SAM
mask decoder to the specified arguments, defining the model architecture. Instantiating a configuration defaults
will yield a similar configuration to that of the SAM-vit-h
`),eo=r("a"),Cn=s("facebook/sam-vit-huge"),In=s(" architecture."),Tn=d(),J=r("p"),En=s("Configuration objects inherit from "),Xo=r("a"),Dn=s("PretrainedConfig"),Mn=s(` and can be used to control the model outputs. Read the
documentation from `),Zo=r("a"),An=s("PretrainedConfig"),Nn=s(" for more information."),yr=d(),K=r("h2"),ge=r("a"),Tt=r("span"),f(oo.$$.fragment),Ln=d(),Et=r("span"),jn=s("SamPromptEncoderConfig"),Sr=d(),N=r("div"),f(to.$$.fragment),qn=d(),L=r("p"),Rn=s("This is the configuration class to store the configuration of a "),Dt=r("code"),Vn=s("SamPromptEncoder"),Un=s(". The "),Mt=r("code"),On=s("SamPromptEncoder"),Wn=s(`
module is used to encode the input 2D points and bounding boxes. Instantiating a configuration defaults will yield
a similar configuration to that of the SAM-vit-h
`),ro=r("a"),Fn=s("facebook/sam-vit-huge"),Bn=s(" architecture."),Gn=d(),Q=r("p"),Hn=s("Configuration objects inherit from "),Jo=r("a"),Yn=s("PretrainedConfig"),Xn=s(` and can be used to control the model outputs. Read the
documentation from `),Ko=r("a"),Zn=s("PretrainedConfig"),Jn=s(" for more information."),wr=d(),ee=r("h2"),ue=r("a"),At=r("span"),f(ao.$$.fragment),Kn=d(),Nt=r("span"),Qn=s("SamProcessor"),kr=d(),j=r("div"),f(no.$$.fragment),es=d(),Lt=r("p"),os=s(`Constructs a SAM processor which wraps a SAM image processor and an 2D points & Bounding boxes processor into a
single processor.`),ts=d(),R=r("p"),Qo=r("a"),rs=s("SamProcessor"),as=s(" offers all the functionalities of "),et=r("a"),ns=s("SamImageProcessor"),ss=s(`. See the docstring of
`),so=r("a"),jt=r("strong"),is=s("call"),ms=s("()"),ds=s(" for more information."),$r=d(),oe=r("h2"),_e=r("a"),qt=r("span"),f(io.$$.fragment),cs=d(),Rt=r("span"),ls=s("SamImageProcessor"),xr=d(),y=r("div"),f(mo.$$.fragment),ps=d(),Vt=r("p"),fs=s("Constructs a SAM image processor."),hs=d(),ve=r("div"),f(co.$$.fragment),gs=d(),te=r("p"),us=s(`Filters the predicted masks by selecting only the ones that meets several criteria. The first criterion being
that the iou scores needs to be greater than `),Ut=r("code"),_s=s("pred_iou_thresh"),vs=s(`. The second criterion is that the stability
score needs to be greater than `),Ot=r("code"),bs=s("stability_score_thresh"),ys=s(`. The method also converts the predicted masks to
bounding boxes and pad the predicted masks if necessary.`),Ss=d(),be=r("div"),f(lo.$$.fragment),ws=d(),po=r("p"),ks=s("Generates a list of crop boxes of different sizes. Each layer has (2"),Wt=r("strong"),$s=s("i)"),xs=s("2 boxes for the ith layer."),zs=d(),ye=r("div"),f(fo.$$.fragment),Ps=d(),Ft=r("p"),Cs=s("Normalize an image. image = (image - image_mean) / image_std."),Is=d(),Se=r("div"),f(ho.$$.fragment),Ts=d(),go=r("p"),Es=s("Pad an image to "),Bt=r("code"),Ds=s('(pad_size["height"], pad_size["width"])'),Ms=s(" with zeros to the right and bottom."),As=d(),we=r("div"),f(uo.$$.fragment),Ns=d(),Gt=r("p"),Ls=s("Post processes mask that are generated by calling the Non Maximum Suppression algorithm on the predicted masks."),js=d(),ke=r("div"),f(_o.$$.fragment),qs=d(),Ht=r("p"),Rs=s("Remove padding and upscale masks to the original image size."),Vs=d(),$e=r("div"),f(vo.$$.fragment),Us=d(),Yt=r("p"),Os=s("Preprocess an image or batch of images."),Ws=d(),xe=r("div"),f(bo.$$.fragment),Fs=d(),Xt=r("p"),Bs=s("Rescale an image by a scale factor. image = image * scale."),Gs=d(),ze=r("div"),f(yo.$$.fragment),Hs=d(),So=r("p"),Ys=s("Resize an image to "),Zt=r("code"),Xs=s('(size["height"], size["width"])'),Zs=s("."),zr=d(),re=r("h2"),Pe=r("a"),Jt=r("span"),f(wo.$$.fragment),Js=d(),Kt=r("span"),Ks=s("SamModel"),Pr=d(),T=r("div"),f(ko.$$.fragment),Qs=d(),$o=r("p"),ei=s(`Segment Anything Model (SAM) for generating segmentation masks, given an input image and  optional 2D location and bounding boxes.
This model inherits from `),ot=r("a"),oi=s("PreTrainedModel"),ti=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ri=d(),xo=r("p"),ai=s("This model is also a PyTorch "),zo=r("a"),ni=s("torch.nn.Module"),si=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ii=d(),V=r("div"),f(Po.$$.fragment),mi=d(),ae=r("p"),di=s("The "),tt=r("a"),ci=s("SamModel"),li=s(" forward method, overrides the "),Qt=r("code"),pi=s("__call__"),fi=s(" special method."),hi=d(),f(Ce.$$.fragment),this.h()},l(o){const l=Km('[data-svelte="svelte-1phssyn"]',document.head);S=a(l,"META",{name:!0,content:!0}),l.forEach(t),E=c(o),k=a(o,"H1",{class:!0});var Co=n(k);$=a(Co,"A",{id:!0,class:!0,href:!0});var er=n($);C=a(er,"SPAN",{});var bi=n(C);h(b.$$.fragment,bi),bi.forEach(t),er.forEach(t),z=c(Co),se=a(Co,"SPAN",{});var yi=n(se);ra=i(yi,"SAM"),yi.forEach(t),Co.forEach(t),or=c(o),W=a(o,"H2",{class:!0});var Ir=n(W);ie=a(Ir,"A",{id:!0,class:!0,href:!0});var Si=n(ie);ut=a(Si,"SPAN",{});var wi=n(ut);h(De.$$.fragment,wi),wi.forEach(t),Si.forEach(t),aa=c(Ir),_t=a(Ir,"SPAN",{});var ki=n(_t);na=i(ki,"Overview"),ki.forEach(t),Ir.forEach(t),tr=c(o),me=a(o,"P",{});var Tr=n(me);sa=i(Tr,"SAM (Segment Anything Model) was proposed in "),Me=a(Tr,"A",{href:!0,rel:!0});var $i=n(Me);ia=i($i,"Segment Anything"),$i.forEach(t),ma=i(Tr," by Alexander Kirillov, Eric Mintun, Nikhila Ravi, Hanzi Mao, Chloe Rolland, Laura Gustafson, Tete Xiao, Spencer Whitehead, Alex Berg, Wan-Yen Lo, Piotr Dollar, Ross Girshick."),Tr.forEach(t),rr=c(o),Do=a(o,"P",{});var xi=n(Do);da=i(xi,"The model can be used to predict segmentation masks of any object of interest given an input image."),xi.forEach(t),ar=c(o),Mo=a(o,"P",{});var zi=n(Mo);Ao=a(zi,"IMG",{src:!0,alt:!0}),zi.forEach(t),nr=c(o),No=a(o,"P",{});var Pi=n(No);ca=i(Pi,"The abstract from the paper is the following:"),Pi.forEach(t),sr=c(o),Lo=a(o,"P",{});var Ci=n(Lo);Ae=a(Ci,"EM",{});var Er=n(Ae);la=i(Er,"We introduce the Segment Anything (SA) project: a new task, model, and dataset for image segmentation. Using our efficient model in a data collection loop, we built the largest segmentation dataset to date (by far), with over 1 billion masks on 11M licensed and privacy respecting images. The model is designed and trained to be promptable, so it can transfer zero-shot to new image distributions and tasks. We evaluate its capabilities on numerous tasks and find that its zero-shot performance is impressive \u2014 often competitive with or even superior to prior fully supervised results. We are releasing the Segment Anything Model (SAM) and corresponding dataset (SA-1B) of 1B masks and 11M images at \\href{"),Ne=a(Er,"A",{href:!0,rel:!0});var Ii=n(Ne);pa=i(Ii,"https://segment-anything.com}{https://segment-anything.com}"),Ii.forEach(t),fa=i(Er," to foster research into foundation models for computer vision."),Er.forEach(t),Ci.forEach(t),ir=c(o),jo=a(o,"P",{});var Ti=n(jo);ha=i(Ti,"Tips:"),Ti.forEach(t),mr=c(o),I=a(o,"UL",{});var U=n(I);vt=a(U,"LI",{});var Ei=n(vt);ga=i(Ei,"The model predicts binary masks that states the presence or not of the object of interest given an image."),Ei.forEach(t),ua=c(U),bt=a(U,"LI",{});var Di=n(bt);_a=i(Di,"The model predicts much better results if input 2D points and/or input bounding boxes are provided"),Di.forEach(t),va=c(U),yt=a(U,"LI",{});var Mi=n(yt);ba=i(Mi,"You can prompt multiple points for the same image, and predict a single mask."),Mi.forEach(t),ya=c(U),St=a(U,"LI",{});var Ai=n(St);Sa=i(Ai,"Fine-tuning the model is not supported yet"),Ai.forEach(t),wa=c(U),Le=a(U,"LI",{});var Dr=n(Le);ka=i(Dr,"According to the paper, textual input should be also supported. However, at this time of writing this seems to be not supported according to "),je=a(Dr,"A",{href:!0,rel:!0});var Ni=n(je);$a=i(Ni,"the official repository"),Ni.forEach(t),xa=i(Dr,"."),Dr.forEach(t),U.forEach(t),dr=c(o),D=a(o,"P",{});var Ie=n(D);za=i(Ie,"This model was contributed by "),qe=a(Ie,"A",{href:!0,rel:!0});var Li=n(qe);Pa=i(Li,"ybelkada"),Li.forEach(t),Ca=i(Ie," and "),Re=a(Ie,"A",{href:!0,rel:!0});var ji=n(Re);Ia=i(ji,"ArthurZ"),ji.forEach(t),Ta=i(Ie,`.
The original code can be found `),Ve=a(Ie,"A",{href:!0,rel:!0});var qi=n(Ve);Ea=i(qi,"here"),qi.forEach(t),Da=i(Ie,"."),Ie.forEach(t),cr=c(o),qo=a(o,"P",{});var Ri=n(qo);Ma=i(Ri,"Below is an example on how to run mask generation given an image and a 2D point:"),Ri.forEach(t),lr=c(o),h(Ue.$$.fragment,o),pr=c(o),Ro=a(o,"P",{});var Vi=n(Ro);Aa=i(Vi,"Resources:"),Vi.forEach(t),fr=c(o),de=a(o,"UL",{});var Mr=n(de);Vo=a(Mr,"LI",{});var gi=n(Vo);Oe=a(gi,"A",{href:!0,rel:!0});var Ui=n(Oe);Na=i(Ui,"Demo notebook"),Ui.forEach(t),La=i(gi," for using the model"),gi.forEach(t),ja=c(Mr),Uo=a(Mr,"LI",{});var ui=n(Uo);We=a(ui,"A",{href:!0,rel:!0});var Oi=n(We);qa=i(Oi,"Demo notebook"),Oi.forEach(t),Ra=i(ui," for using automatic mask generation pipeline."),ui.forEach(t),Mr.forEach(t),hr=c(o),F=a(o,"H2",{class:!0});var Ar=n(F);ce=a(Ar,"A",{id:!0,class:!0,href:!0});var Wi=n(ce);wt=a(Wi,"SPAN",{});var Fi=n(wt);h(Fe.$$.fragment,Fi),Fi.forEach(t),Wi.forEach(t),Va=c(Ar),kt=a(Ar,"SPAN",{});var Bi=n(kt);Ua=i(Bi,"SamConfig"),Bi.forEach(t),Ar.forEach(t),gr=c(o),P=a(o,"DIV",{class:!0});var O=n(P);h(Be.$$.fragment,O),Oa=c(O),q=a(O,"P",{});var Io=n(q);Oo=a(Io,"A",{href:!0});var Gi=n(Oo);Wa=i(Gi,"SamConfig"),Gi.forEach(t),Fa=i(Io," is the configuration class to store the configuration of a "),Wo=a(Io,"A",{href:!0});var Hi=n(Wo);Ba=i(Hi,"SamModel"),Hi.forEach(t),Ga=i(Io,`. It is used to instantiate a
SAM model according to the specified arguments, defining the vision model, prompt-encoder model and mask decoder
configs. Instantiating a configuration with the defaults will yield a similar configuration to that of the
SAM-ViT-H `),Ge=a(Io,"A",{href:!0,rel:!0});var Yi=n(Ge);Ha=i(Yi,"facebook/sam-vit-huge"),Yi.forEach(t),Ya=i(Io," architecture."),Io.forEach(t),Xa=c(O),B=a(O,"P",{});var rt=n(B);Za=i(rt,"Configuration objects inherit from "),Fo=a(rt,"A",{href:!0});var Xi=n(Fo);Ja=i(Xi,"PretrainedConfig"),Xi.forEach(t),Ka=i(rt,` and can be used to control the model outputs. Read the
documentation from `),Bo=a(rt,"A",{href:!0});var Zi=n(Bo);Qa=i(Zi,"PretrainedConfig"),Zi.forEach(t),en=i(rt," for more information."),rt.forEach(t),on=c(O),h(le.$$.fragment,O),tn=c(O),pe=a(O,"DIV",{class:!0});var Nr=n(pe);h(He.$$.fragment,Nr),rn=c(Nr),Ye=a(Nr,"P",{});var Lr=n(Ye);an=i(Lr,"Serializes this instance to a Python dictionary. Override the default "),Go=a(Lr,"A",{href:!0});var Ji=n(Go);nn=i(Ji,"to_dict()"),Ji.forEach(t),sn=i(Lr,"."),Lr.forEach(t),Nr.forEach(t),O.forEach(t),ur=c(o),G=a(o,"H2",{class:!0});var jr=n(G);fe=a(jr,"A",{id:!0,class:!0,href:!0});var Ki=n(fe);$t=a(Ki,"SPAN",{});var Qi=n($t);h(Xe.$$.fragment,Qi),Qi.forEach(t),Ki.forEach(t),mn=c(jr),xt=a(jr,"SPAN",{});var em=n(xt);dn=i(em,"SamVisionConfig"),em.forEach(t),jr.forEach(t),_r=c(o),M=a(o,"DIV",{class:!0});var at=n(M);h(Ze.$$.fragment,at),cn=c(at),H=a(at,"P",{});var nt=n(H);ln=i(nt,"This is the configuration class to store the configuration of a "),zt=a(nt,"CODE",{});var om=n(zt);pn=i(om,"SamVisionModel"),om.forEach(t),fn=i(nt,`. It is used to instantiate a SAM
vision encoder according to the specified arguments, defining the model architecture. Instantiating a configuration
defaults will yield a similar configuration to that of the SAM ViT-h
`),Je=a(nt,"A",{href:!0,rel:!0});var tm=n(Je);hn=i(tm,"facebook/sam-vit-huge"),tm.forEach(t),gn=i(nt," architecture."),nt.forEach(t),un=c(at),Y=a(at,"P",{});var st=n(Y);_n=i(st,"Configuration objects inherit from "),Ho=a(st,"A",{href:!0});var rm=n(Ho);vn=i(rm,"PretrainedConfig"),rm.forEach(t),bn=i(st,` and can be used to control the model outputs. Read the
documentation from `),Yo=a(st,"A",{href:!0});var am=n(Yo);yn=i(am,"PretrainedConfig"),am.forEach(t),Sn=i(st," for more information."),st.forEach(t),at.forEach(t),vr=c(o),X=a(o,"H2",{class:!0});var qr=n(X);he=a(qr,"A",{id:!0,class:!0,href:!0});var nm=n(he);Pt=a(nm,"SPAN",{});var sm=n(Pt);h(Ke.$$.fragment,sm),sm.forEach(t),nm.forEach(t),wn=c(qr),Ct=a(qr,"SPAN",{});var im=n(Ct);kn=i(im,"SamMaskDecoderConfig"),im.forEach(t),qr.forEach(t),br=c(o),A=a(o,"DIV",{class:!0});var it=n(A);h(Qe.$$.fragment,it),$n=c(it),Z=a(it,"P",{});var mt=n(Z);xn=i(mt,"This is the configuration class to store the configuration of a "),It=a(mt,"CODE",{});var mm=n(It);zn=i(mm,"SamMaskDecoder"),mm.forEach(t),Pn=i(mt,`. It is used to instantiate a SAM
mask decoder to the specified arguments, defining the model architecture. Instantiating a configuration defaults
will yield a similar configuration to that of the SAM-vit-h
`),eo=a(mt,"A",{href:!0,rel:!0});var dm=n(eo);Cn=i(dm,"facebook/sam-vit-huge"),dm.forEach(t),In=i(mt," architecture."),mt.forEach(t),Tn=c(it),J=a(it,"P",{});var dt=n(J);En=i(dt,"Configuration objects inherit from "),Xo=a(dt,"A",{href:!0});var cm=n(Xo);Dn=i(cm,"PretrainedConfig"),cm.forEach(t),Mn=i(dt,` and can be used to control the model outputs. Read the
documentation from `),Zo=a(dt,"A",{href:!0});var lm=n(Zo);An=i(lm,"PretrainedConfig"),lm.forEach(t),Nn=i(dt," for more information."),dt.forEach(t),it.forEach(t),yr=c(o),K=a(o,"H2",{class:!0});var Rr=n(K);ge=a(Rr,"A",{id:!0,class:!0,href:!0});var pm=n(ge);Tt=a(pm,"SPAN",{});var fm=n(Tt);h(oo.$$.fragment,fm),fm.forEach(t),pm.forEach(t),Ln=c(Rr),Et=a(Rr,"SPAN",{});var hm=n(Et);jn=i(hm,"SamPromptEncoderConfig"),hm.forEach(t),Rr.forEach(t),Sr=c(o),N=a(o,"DIV",{class:!0});var ct=n(N);h(to.$$.fragment,ct),qn=c(ct),L=a(ct,"P",{});var Te=n(L);Rn=i(Te,"This is the configuration class to store the configuration of a "),Dt=a(Te,"CODE",{});var gm=n(Dt);Vn=i(gm,"SamPromptEncoder"),gm.forEach(t),Un=i(Te,". The "),Mt=a(Te,"CODE",{});var um=n(Mt);On=i(um,"SamPromptEncoder"),um.forEach(t),Wn=i(Te,`
module is used to encode the input 2D points and bounding boxes. Instantiating a configuration defaults will yield
a similar configuration to that of the SAM-vit-h
`),ro=a(Te,"A",{href:!0,rel:!0});var _m=n(ro);Fn=i(_m,"facebook/sam-vit-huge"),_m.forEach(t),Bn=i(Te," architecture."),Te.forEach(t),Gn=c(ct),Q=a(ct,"P",{});var lt=n(Q);Hn=i(lt,"Configuration objects inherit from "),Jo=a(lt,"A",{href:!0});var vm=n(Jo);Yn=i(vm,"PretrainedConfig"),vm.forEach(t),Xn=i(lt,` and can be used to control the model outputs. Read the
documentation from `),Ko=a(lt,"A",{href:!0});var bm=n(Ko);Zn=i(bm,"PretrainedConfig"),bm.forEach(t),Jn=i(lt," for more information."),lt.forEach(t),ct.forEach(t),wr=c(o),ee=a(o,"H2",{class:!0});var Vr=n(ee);ue=a(Vr,"A",{id:!0,class:!0,href:!0});var ym=n(ue);At=a(ym,"SPAN",{});var Sm=n(At);h(ao.$$.fragment,Sm),Sm.forEach(t),ym.forEach(t),Kn=c(Vr),Nt=a(Vr,"SPAN",{});var wm=n(Nt);Qn=i(wm,"SamProcessor"),wm.forEach(t),Vr.forEach(t),kr=c(o),j=a(o,"DIV",{class:!0});var pt=n(j);h(no.$$.fragment,pt),es=c(pt),Lt=a(pt,"P",{});var km=n(Lt);os=i(km,`Constructs a SAM processor which wraps a SAM image processor and an 2D points & Bounding boxes processor into a
single processor.`),km.forEach(t),ts=c(pt),R=a(pt,"P",{});var To=n(R);Qo=a(To,"A",{href:!0});var $m=n(Qo);rs=i($m,"SamProcessor"),$m.forEach(t),as=i(To," offers all the functionalities of "),et=a(To,"A",{href:!0});var xm=n(et);ns=i(xm,"SamImageProcessor"),xm.forEach(t),ss=i(To,`. See the docstring of
`),so=a(To,"A",{href:!0});var _i=n(so);jt=a(_i,"STRONG",{});var zm=n(jt);is=i(zm,"call"),zm.forEach(t),ms=i(_i,"()"),_i.forEach(t),ds=i(To," for more information."),To.forEach(t),pt.forEach(t),$r=c(o),oe=a(o,"H2",{class:!0});var Ur=n(oe);_e=a(Ur,"A",{id:!0,class:!0,href:!0});var Pm=n(_e);qt=a(Pm,"SPAN",{});var Cm=n(qt);h(io.$$.fragment,Cm),Cm.forEach(t),Pm.forEach(t),cs=c(Ur),Rt=a(Ur,"SPAN",{});var Im=n(Rt);ls=i(Im,"SamImageProcessor"),Im.forEach(t),Ur.forEach(t),xr=c(o),y=a(o,"DIV",{class:!0});var w=n(y);h(mo.$$.fragment,w),ps=c(w),Vt=a(w,"P",{});var Tm=n(Vt);fs=i(Tm,"Constructs a SAM image processor."),Tm.forEach(t),hs=c(w),ve=a(w,"DIV",{class:!0});var Or=n(ve);h(co.$$.fragment,Or),gs=c(Or),te=a(Or,"P",{});var ft=n(te);us=i(ft,`Filters the predicted masks by selecting only the ones that meets several criteria. The first criterion being
that the iou scores needs to be greater than `),Ut=a(ft,"CODE",{});var Em=n(Ut);_s=i(Em,"pred_iou_thresh"),Em.forEach(t),vs=i(ft,`. The second criterion is that the stability
score needs to be greater than `),Ot=a(ft,"CODE",{});var Dm=n(Ot);bs=i(Dm,"stability_score_thresh"),Dm.forEach(t),ys=i(ft,`. The method also converts the predicted masks to
bounding boxes and pad the predicted masks if necessary.`),ft.forEach(t),Or.forEach(t),Ss=c(w),be=a(w,"DIV",{class:!0});var Wr=n(be);h(lo.$$.fragment,Wr),ws=c(Wr),po=a(Wr,"P",{});var Fr=n(po);ks=i(Fr,"Generates a list of crop boxes of different sizes. Each layer has (2"),Wt=a(Fr,"STRONG",{});var Mm=n(Wt);$s=i(Mm,"i)"),Mm.forEach(t),xs=i(Fr,"2 boxes for the ith layer."),Fr.forEach(t),Wr.forEach(t),zs=c(w),ye=a(w,"DIV",{class:!0});var Br=n(ye);h(fo.$$.fragment,Br),Ps=c(Br),Ft=a(Br,"P",{});var Am=n(Ft);Cs=i(Am,"Normalize an image. image = (image - image_mean) / image_std."),Am.forEach(t),Br.forEach(t),Is=c(w),Se=a(w,"DIV",{class:!0});var Gr=n(Se);h(ho.$$.fragment,Gr),Ts=c(Gr),go=a(Gr,"P",{});var Hr=n(go);Es=i(Hr,"Pad an image to "),Bt=a(Hr,"CODE",{});var Nm=n(Bt);Ds=i(Nm,'(pad_size["height"], pad_size["width"])'),Nm.forEach(t),Ms=i(Hr," with zeros to the right and bottom."),Hr.forEach(t),Gr.forEach(t),As=c(w),we=a(w,"DIV",{class:!0});var Yr=n(we);h(uo.$$.fragment,Yr),Ns=c(Yr),Gt=a(Yr,"P",{});var Lm=n(Gt);Ls=i(Lm,"Post processes mask that are generated by calling the Non Maximum Suppression algorithm on the predicted masks."),Lm.forEach(t),Yr.forEach(t),js=c(w),ke=a(w,"DIV",{class:!0});var Xr=n(ke);h(_o.$$.fragment,Xr),qs=c(Xr),Ht=a(Xr,"P",{});var jm=n(Ht);Rs=i(jm,"Remove padding and upscale masks to the original image size."),jm.forEach(t),Xr.forEach(t),Vs=c(w),$e=a(w,"DIV",{class:!0});var Zr=n($e);h(vo.$$.fragment,Zr),Us=c(Zr),Yt=a(Zr,"P",{});var qm=n(Yt);Os=i(qm,"Preprocess an image or batch of images."),qm.forEach(t),Zr.forEach(t),Ws=c(w),xe=a(w,"DIV",{class:!0});var Jr=n(xe);h(bo.$$.fragment,Jr),Fs=c(Jr),Xt=a(Jr,"P",{});var Rm=n(Xt);Bs=i(Rm,"Rescale an image by a scale factor. image = image * scale."),Rm.forEach(t),Jr.forEach(t),Gs=c(w),ze=a(w,"DIV",{class:!0});var Kr=n(ze);h(yo.$$.fragment,Kr),Hs=c(Kr),So=a(Kr,"P",{});var Qr=n(So);Ys=i(Qr,"Resize an image to "),Zt=a(Qr,"CODE",{});var Vm=n(Zt);Xs=i(Vm,'(size["height"], size["width"])'),Vm.forEach(t),Zs=i(Qr,"."),Qr.forEach(t),Kr.forEach(t),w.forEach(t),zr=c(o),re=a(o,"H2",{class:!0});var ea=n(re);Pe=a(ea,"A",{id:!0,class:!0,href:!0});var Um=n(Pe);Jt=a(Um,"SPAN",{});var Om=n(Jt);h(wo.$$.fragment,Om),Om.forEach(t),Um.forEach(t),Js=c(ea),Kt=a(ea,"SPAN",{});var Wm=n(Kt);Ks=i(Wm,"SamModel"),Wm.forEach(t),ea.forEach(t),Pr=c(o),T=a(o,"DIV",{class:!0});var Ee=n(T);h(ko.$$.fragment,Ee),Qs=c(Ee),$o=a(Ee,"P",{});var oa=n($o);ei=i(oa,`Segment Anything Model (SAM) for generating segmentation masks, given an input image and  optional 2D location and bounding boxes.
This model inherits from `),ot=a(oa,"A",{href:!0});var Fm=n(ot);oi=i(Fm,"PreTrainedModel"),Fm.forEach(t),ti=i(oa,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),oa.forEach(t),ri=c(Ee),xo=a(Ee,"P",{});var ta=n(xo);ai=i(ta,"This model is also a PyTorch "),zo=a(ta,"A",{href:!0,rel:!0});var Bm=n(zo);ni=i(Bm,"torch.nn.Module"),Bm.forEach(t),si=i(ta,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ta.forEach(t),ii=c(Ee),V=a(Ee,"DIV",{class:!0});var ht=n(V);h(Po.$$.fragment,ht),mi=c(ht),ae=a(ht,"P",{});var gt=n(ae);di=i(gt,"The "),tt=a(gt,"A",{href:!0});var Gm=n(tt);ci=i(Gm,"SamModel"),Gm.forEach(t),li=i(gt," forward method, overrides the "),Qt=a(gt,"CODE",{});var Hm=n(Qt);pi=i(Hm,"__call__"),Hm.forEach(t),fi=i(gt," special method."),gt.forEach(t),hi=c(ht),h(Ce.$$.fragment,ht),ht.forEach(t),Ee.forEach(t),this.h()},h(){m(S,"name","hf:doc:metadata"),m(S,"content",JSON.stringify(id)),m($,"id","sam"),m($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m($,"href","#sam"),m(k,"class","relative group"),m(ie,"id","overview"),m(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ie,"href","#overview"),m(W,"class","relative group"),m(Me,"href","https://arxiv.org/pdf/2304.02643v1.pdf"),m(Me,"rel","nofollow"),Qm(Ao.src,vi="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/sam-output.png")||m(Ao,"src",vi),m(Ao,"alt","example image"),m(Ne,"href","https://segment-anything.com}{https://segment-anything.com}"),m(Ne,"rel","nofollow"),m(je,"href","https://github.com/facebookresearch/segment-anything/issues/4#issuecomment-1497626844"),m(je,"rel","nofollow"),m(qe,"href","https://huggingface.co/ybelkada"),m(qe,"rel","nofollow"),m(Re,"href","https://huggingface.co/ArthurZ"),m(Re,"rel","nofollow"),m(Ve,"href","https://github.com/facebookresearch/segment-anything"),m(Ve,"rel","nofollow"),m(Oe,"href","https://github.com/huggingface/notebooks/blob/main/examples/segment_anything.ipynb"),m(Oe,"rel","nofollow"),m(We,"href","https://github.com/huggingface/notebooks/blob/main/examples/automatic_mask_generation.ipynb"),m(We,"rel","nofollow"),m(ce,"id","transformers.SamConfig"),m(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ce,"href","#transformers.SamConfig"),m(F,"class","relative group"),m(Oo,"href","/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamConfig"),m(Wo,"href","/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamModel"),m(Ge,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Ge,"rel","nofollow"),m(Fo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(Bo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(Go,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig.to_dict"),m(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(fe,"id","transformers.SamVisionConfig"),m(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(fe,"href","#transformers.SamVisionConfig"),m(G,"class","relative group"),m(Je,"href","https://huggingface.co/facebook/sam-vit-huge"),m(Je,"rel","nofollow"),m(Ho,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(Yo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(he,"id","transformers.SamMaskDecoderConfig"),m(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(he,"href","#transformers.SamMaskDecoderConfig"),m(X,"class","relative group"),m(eo,"href","https://huggingface.co/facebook/sam-vit-huge"),m(eo,"rel","nofollow"),m(Xo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(Zo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ge,"id","transformers.SamPromptEncoderConfig"),m(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ge,"href","#transformers.SamPromptEncoderConfig"),m(K,"class","relative group"),m(ro,"href","https://huggingface.co/facebook/sam-vit-huge"),m(ro,"rel","nofollow"),m(Jo,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(Ko,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),m(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ue,"id","transformers.SamProcessor"),m(ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ue,"href","#transformers.SamProcessor"),m(ee,"class","relative group"),m(Qo,"href","/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamProcessor"),m(et,"href","/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamImageProcessor"),m(so,"href","/docs/transformers/pr_22182/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__"),m(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(_e,"id","transformers.SamImageProcessor"),m(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(_e,"href","#transformers.SamImageProcessor"),m(oe,"class","relative group"),m(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Pe,"id","transformers.SamModel"),m(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Pe,"href","#transformers.SamModel"),m(re,"class","relative group"),m(ot,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),m(zo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(zo,"rel","nofollow"),m(tt,"href","/docs/transformers/pr_22182/en/model_doc/sam#transformers.SamModel"),m(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,l){e(document.head,S),p(o,E,l),p(o,k,l),e(k,$),e($,C),g(b,C,null),e(k,z),e(k,se),e(se,ra),p(o,or,l),p(o,W,l),e(W,ie),e(ie,ut),g(De,ut,null),e(W,aa),e(W,_t),e(_t,na),p(o,tr,l),p(o,me,l),e(me,sa),e(me,Me),e(Me,ia),e(me,ma),p(o,rr,l),p(o,Do,l),e(Do,da),p(o,ar,l),p(o,Mo,l),e(Mo,Ao),p(o,nr,l),p(o,No,l),e(No,ca),p(o,sr,l),p(o,Lo,l),e(Lo,Ae),e(Ae,la),e(Ae,Ne),e(Ne,pa),e(Ae,fa),p(o,ir,l),p(o,jo,l),e(jo,ha),p(o,mr,l),p(o,I,l),e(I,vt),e(vt,ga),e(I,ua),e(I,bt),e(bt,_a),e(I,va),e(I,yt),e(yt,ba),e(I,ya),e(I,St),e(St,Sa),e(I,wa),e(I,Le),e(Le,ka),e(Le,je),e(je,$a),e(Le,xa),p(o,dr,l),p(o,D,l),e(D,za),e(D,qe),e(qe,Pa),e(D,Ca),e(D,Re),e(Re,Ia),e(D,Ta),e(D,Ve),e(Ve,Ea),e(D,Da),p(o,cr,l),p(o,qo,l),e(qo,Ma),p(o,lr,l),g(Ue,o,l),p(o,pr,l),p(o,Ro,l),e(Ro,Aa),p(o,fr,l),p(o,de,l),e(de,Vo),e(Vo,Oe),e(Oe,Na),e(Vo,La),e(de,ja),e(de,Uo),e(Uo,We),e(We,qa),e(Uo,Ra),p(o,hr,l),p(o,F,l),e(F,ce),e(ce,wt),g(Fe,wt,null),e(F,Va),e(F,kt),e(kt,Ua),p(o,gr,l),p(o,P,l),g(Be,P,null),e(P,Oa),e(P,q),e(q,Oo),e(Oo,Wa),e(q,Fa),e(q,Wo),e(Wo,Ba),e(q,Ga),e(q,Ge),e(Ge,Ha),e(q,Ya),e(P,Xa),e(P,B),e(B,Za),e(B,Fo),e(Fo,Ja),e(B,Ka),e(B,Bo),e(Bo,Qa),e(B,en),e(P,on),g(le,P,null),e(P,tn),e(P,pe),g(He,pe,null),e(pe,rn),e(pe,Ye),e(Ye,an),e(Ye,Go),e(Go,nn),e(Ye,sn),p(o,ur,l),p(o,G,l),e(G,fe),e(fe,$t),g(Xe,$t,null),e(G,mn),e(G,xt),e(xt,dn),p(o,_r,l),p(o,M,l),g(Ze,M,null),e(M,cn),e(M,H),e(H,ln),e(H,zt),e(zt,pn),e(H,fn),e(H,Je),e(Je,hn),e(H,gn),e(M,un),e(M,Y),e(Y,_n),e(Y,Ho),e(Ho,vn),e(Y,bn),e(Y,Yo),e(Yo,yn),e(Y,Sn),p(o,vr,l),p(o,X,l),e(X,he),e(he,Pt),g(Ke,Pt,null),e(X,wn),e(X,Ct),e(Ct,kn),p(o,br,l),p(o,A,l),g(Qe,A,null),e(A,$n),e(A,Z),e(Z,xn),e(Z,It),e(It,zn),e(Z,Pn),e(Z,eo),e(eo,Cn),e(Z,In),e(A,Tn),e(A,J),e(J,En),e(J,Xo),e(Xo,Dn),e(J,Mn),e(J,Zo),e(Zo,An),e(J,Nn),p(o,yr,l),p(o,K,l),e(K,ge),e(ge,Tt),g(oo,Tt,null),e(K,Ln),e(K,Et),e(Et,jn),p(o,Sr,l),p(o,N,l),g(to,N,null),e(N,qn),e(N,L),e(L,Rn),e(L,Dt),e(Dt,Vn),e(L,Un),e(L,Mt),e(Mt,On),e(L,Wn),e(L,ro),e(ro,Fn),e(L,Bn),e(N,Gn),e(N,Q),e(Q,Hn),e(Q,Jo),e(Jo,Yn),e(Q,Xn),e(Q,Ko),e(Ko,Zn),e(Q,Jn),p(o,wr,l),p(o,ee,l),e(ee,ue),e(ue,At),g(ao,At,null),e(ee,Kn),e(ee,Nt),e(Nt,Qn),p(o,kr,l),p(o,j,l),g(no,j,null),e(j,es),e(j,Lt),e(Lt,os),e(j,ts),e(j,R),e(R,Qo),e(Qo,rs),e(R,as),e(R,et),e(et,ns),e(R,ss),e(R,so),e(so,jt),e(jt,is),e(so,ms),e(R,ds),p(o,$r,l),p(o,oe,l),e(oe,_e),e(_e,qt),g(io,qt,null),e(oe,cs),e(oe,Rt),e(Rt,ls),p(o,xr,l),p(o,y,l),g(mo,y,null),e(y,ps),e(y,Vt),e(Vt,fs),e(y,hs),e(y,ve),g(co,ve,null),e(ve,gs),e(ve,te),e(te,us),e(te,Ut),e(Ut,_s),e(te,vs),e(te,Ot),e(Ot,bs),e(te,ys),e(y,Ss),e(y,be),g(lo,be,null),e(be,ws),e(be,po),e(po,ks),e(po,Wt),e(Wt,$s),e(po,xs),e(y,zs),e(y,ye),g(fo,ye,null),e(ye,Ps),e(ye,Ft),e(Ft,Cs),e(y,Is),e(y,Se),g(ho,Se,null),e(Se,Ts),e(Se,go),e(go,Es),e(go,Bt),e(Bt,Ds),e(go,Ms),e(y,As),e(y,we),g(uo,we,null),e(we,Ns),e(we,Gt),e(Gt,Ls),e(y,js),e(y,ke),g(_o,ke,null),e(ke,qs),e(ke,Ht),e(Ht,Rs),e(y,Vs),e(y,$e),g(vo,$e,null),e($e,Us),e($e,Yt),e(Yt,Os),e(y,Ws),e(y,xe),g(bo,xe,null),e(xe,Fs),e(xe,Xt),e(Xt,Bs),e(y,Gs),e(y,ze),g(yo,ze,null),e(ze,Hs),e(ze,So),e(So,Ys),e(So,Zt),e(Zt,Xs),e(So,Zs),p(o,zr,l),p(o,re,l),e(re,Pe),e(Pe,Jt),g(wo,Jt,null),e(re,Js),e(re,Kt),e(Kt,Ks),p(o,Pr,l),p(o,T,l),g(ko,T,null),e(T,Qs),e(T,$o),e($o,ei),e($o,ot),e(ot,oi),e($o,ti),e(T,ri),e(T,xo),e(xo,ai),e(xo,zo),e(zo,ni),e(xo,si),e(T,ii),e(T,V),g(Po,V,null),e(V,mi),e(V,ae),e(ae,di),e(ae,tt),e(tt,ci),e(ae,li),e(ae,Qt),e(Qt,pi),e(ae,fi),e(V,hi),g(Ce,V,null),Cr=!0},p(o,[l]){const Co={};l&2&&(Co.$$scope={dirty:l,ctx:o}),le.$set(Co);const er={};l&2&&(er.$$scope={dirty:l,ctx:o}),Ce.$set(er)},i(o){Cr||(u(b.$$.fragment,o),u(De.$$.fragment,o),u(Ue.$$.fragment,o),u(Fe.$$.fragment,o),u(Be.$$.fragment,o),u(le.$$.fragment,o),u(He.$$.fragment,o),u(Xe.$$.fragment,o),u(Ze.$$.fragment,o),u(Ke.$$.fragment,o),u(Qe.$$.fragment,o),u(oo.$$.fragment,o),u(to.$$.fragment,o),u(ao.$$.fragment,o),u(no.$$.fragment,o),u(io.$$.fragment,o),u(mo.$$.fragment,o),u(co.$$.fragment,o),u(lo.$$.fragment,o),u(fo.$$.fragment,o),u(ho.$$.fragment,o),u(uo.$$.fragment,o),u(_o.$$.fragment,o),u(vo.$$.fragment,o),u(bo.$$.fragment,o),u(yo.$$.fragment,o),u(wo.$$.fragment,o),u(ko.$$.fragment,o),u(Po.$$.fragment,o),u(Ce.$$.fragment,o),Cr=!0)},o(o){_(b.$$.fragment,o),_(De.$$.fragment,o),_(Ue.$$.fragment,o),_(Fe.$$.fragment,o),_(Be.$$.fragment,o),_(le.$$.fragment,o),_(He.$$.fragment,o),_(Xe.$$.fragment,o),_(Ze.$$.fragment,o),_(Ke.$$.fragment,o),_(Qe.$$.fragment,o),_(oo.$$.fragment,o),_(to.$$.fragment,o),_(ao.$$.fragment,o),_(no.$$.fragment,o),_(io.$$.fragment,o),_(mo.$$.fragment,o),_(co.$$.fragment,o),_(lo.$$.fragment,o),_(fo.$$.fragment,o),_(ho.$$.fragment,o),_(uo.$$.fragment,o),_(_o.$$.fragment,o),_(vo.$$.fragment,o),_(bo.$$.fragment,o),_(yo.$$.fragment,o),_(wo.$$.fragment,o),_(ko.$$.fragment,o),_(Po.$$.fragment,o),_(Ce.$$.fragment,o),Cr=!1},d(o){t(S),o&&t(E),o&&t(k),v(b),o&&t(or),o&&t(W),v(De),o&&t(tr),o&&t(me),o&&t(rr),o&&t(Do),o&&t(ar),o&&t(Mo),o&&t(nr),o&&t(No),o&&t(sr),o&&t(Lo),o&&t(ir),o&&t(jo),o&&t(mr),o&&t(I),o&&t(dr),o&&t(D),o&&t(cr),o&&t(qo),o&&t(lr),v(Ue,o),o&&t(pr),o&&t(Ro),o&&t(fr),o&&t(de),o&&t(hr),o&&t(F),v(Fe),o&&t(gr),o&&t(P),v(Be),v(le),v(He),o&&t(ur),o&&t(G),v(Xe),o&&t(_r),o&&t(M),v(Ze),o&&t(vr),o&&t(X),v(Ke),o&&t(br),o&&t(A),v(Qe),o&&t(yr),o&&t(K),v(oo),o&&t(Sr),o&&t(N),v(to),o&&t(wr),o&&t(ee),v(ao),o&&t(kr),o&&t(j),v(no),o&&t($r),o&&t(oe),v(io),o&&t(xr),o&&t(y),v(mo),v(co),v(lo),v(fo),v(ho),v(uo),v(_o),v(vo),v(bo),v(yo),o&&t(zr),o&&t(re),v(wo),o&&t(Pr),o&&t(T),v(ko),v(Po),v(Ce)}}}const id={local:"sam",sections:[{local:"overview",title:"Overview"},{local:"transformers.SamConfig",title:"SamConfig"},{local:"transformers.SamVisionConfig",title:"SamVisionConfig"},{local:"transformers.SamMaskDecoderConfig",title:"SamMaskDecoderConfig"},{local:"transformers.SamPromptEncoderConfig",title:"SamPromptEncoderConfig"},{local:"transformers.SamProcessor",title:"SamProcessor"},{local:"transformers.SamImageProcessor",title:"SamImageProcessor"},{local:"transformers.SamModel",title:"SamModel"}],title:"SAM"};function md(Eo){return ed(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gd extends Xm{constructor(S){super();Zm(this,S,md,sd,Jm,{})}}export{gd as default,id as metadata};
