import{S as Ea,i as Pa,s as Ma,e as n,k as u,w as y,t as i,M as Aa,c as o,d as t,m as g,a as r,x as w,h as l,b as d,G as s,g as f,y as j,q as T,o as $,B as x,v as qa,L as Rt}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ca}from"../../chunks/Tip-hf-doc-builder.js";import{D as rs}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Wt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Re}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ut}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Fa(C){let c,b,_,m,v;return m=new Wt({props:{code:`from transformers import TimesformerConfig, TimesformerModel

# Initializing a TimeSformer timesformer-base style configuration
configuration = TimesformerConfig()

# Initializing a model from the configuration
model = TimesformerModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TimesformerConfig, TimesformerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a TimeSformer timesformer-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = TimesformerConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){c=n("p"),b=i("Example:"),_=u(),y(m.$$.fragment)},l(a){c=o(a,"P",{});var h=r(c);b=l(h,"Example:"),h.forEach(t),_=g(a),w(m.$$.fragment,a)},m(a,h){f(a,c,h),s(c,b),f(a,_,h),j(m,a,h),v=!0},p:Rt,i(a){v||(T(m.$$.fragment,a),v=!0)},o(a){$(m.$$.fragment,a),v=!1},d(a){a&&t(c),a&&t(_),x(m,a)}}}function Sa(C){let c,b,_,m,v;return{c(){c=n("p"),b=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),m=i("Module"),v=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){c=o(a,"P",{});var h=r(c);b=l(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=o(h,"CODE",{});var M=r(_);m=l(M,"Module"),M.forEach(t),v=l(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(a,h){f(a,c,h),s(c,b),s(c,_),s(_,m),s(c,v)},d(a){a&&t(c)}}}function za(C){let c,b,_,m,v;return m=new Wt({props:{code:`import av
import numpy as np

from transformers import AutoImageProcessor, TimesformerModel
from huggingface_hub import hf_hub_download

np.random.seed(0)


def read_video_pyav(container, indices):
    '''
    Decode the video with PyAV decoder.
    Args:
        container (\`av.container.input.InputContainer\`): PyAV container.
        indices (\`List[int]\`): List of frame indices to decode.
    Returns:
        result (np.ndarray): np array of decoded frames of shape (num_frames, height, width, 3).
    '''
    frames = []
    container.seek(0)
    start_index = indices[0]
    end_index = indices[-1]
    for i, frame in enumerate(container.decode(video=0)):
        if i > end_index:
            break
        if i >= start_index and i in indices:
            frames.append(frame)
    return np.stack([x.to_ndarray(format="rgb24") for x in frames])


def sample_frame_indices(clip_len, frame_sample_rate, seg_len):
    converted_len = int(clip_len * frame_sample_rate)
    end_idx = np.random.randint(converted_len, seg_len)
    start_idx = end_idx - converted_len
    indices = np.linspace(start_idx, end_idx, num=clip_len)
    indices = np.clip(indices, start_idx, end_idx - 1).astype(np.int64)
    return indices


# video clip consists of 300 frames (10 seconds at 30 FPS)
file_path = hf_hub_download(
    repo_id="nielsr/video-demo", filename="eating_spaghetti.mp4", repo_type="dataset"
)
container = av.open(file_path)

# sample 8 frames
indices = sample_frame_indices(clip_len=8, frame_sample_rate=4, seg_len=container.streams.video[0].frames)
video = read_video_pyav(container, indices)

image_processor = AutoImageProcessor.from_pretrained("MCG-NJU/videomae-base")
model = TimesformerModel.from_pretrained("facebook/timesformer-base-finetuned-k400")

# prepare video for the model
inputs = image_processor(list(video), return_tensors="pt")

# forward pass
outputs = model(**inputs)
last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> av
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, TimesformerModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download

<span class="hljs-meta">&gt;&gt;&gt; </span>np.random.seed(<span class="hljs-number">0</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">read_video_pyav</span>(<span class="hljs-params">container, indices</span>):
<span class="hljs-meta">... </span>    <span class="hljs-string">&#x27;&#x27;&#x27;
<span class="hljs-meta">... </span>    Decode the video with PyAV decoder.
<span class="hljs-meta">... </span>    Args:
<span class="hljs-meta">... </span>        container (\`av.container.input.InputContainer\`): PyAV container.
<span class="hljs-meta">... </span>        indices (\`List[int]\`): List of frame indices to decode.
<span class="hljs-meta">... </span>    Returns:
<span class="hljs-meta">... </span>        result (np.ndarray): np array of decoded frames of shape (num_frames, height, width, 3).
<span class="hljs-meta">... </span>    &#x27;&#x27;&#x27;</span>
<span class="hljs-meta">... </span>    frames = []
<span class="hljs-meta">... </span>    container.seek(<span class="hljs-number">0</span>)
<span class="hljs-meta">... </span>    start_index = indices[<span class="hljs-number">0</span>]
<span class="hljs-meta">... </span>    end_index = indices[-<span class="hljs-number">1</span>]
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, frame <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(container.decode(video=<span class="hljs-number">0</span>)):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">if</span> i &gt; end_index:
<span class="hljs-meta">... </span>            <span class="hljs-keyword">break</span>
<span class="hljs-meta">... </span>        <span class="hljs-keyword">if</span> i &gt;= start_index <span class="hljs-keyword">and</span> i <span class="hljs-keyword">in</span> indices:
<span class="hljs-meta">... </span>            frames.append(frame)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> np.stack([x.to_ndarray(<span class="hljs-built_in">format</span>=<span class="hljs-string">&quot;rgb24&quot;</span>) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> frames])


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">sample_frame_indices</span>(<span class="hljs-params">clip_len, frame_sample_rate, seg_len</span>):
<span class="hljs-meta">... </span>    converted_len = <span class="hljs-built_in">int</span>(clip_len * frame_sample_rate)
<span class="hljs-meta">... </span>    end_idx = np.random.randint(converted_len, seg_len)
<span class="hljs-meta">... </span>    start_idx = end_idx - converted_len
<span class="hljs-meta">... </span>    indices = np.linspace(start_idx, end_idx, num=clip_len)
<span class="hljs-meta">... </span>    indices = np.clip(indices, start_idx, end_idx - <span class="hljs-number">1</span>).astype(np.int64)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> indices


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># video clip consists of 300 frames (10 seconds at 30 FPS)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(
<span class="hljs-meta">... </span>    repo_id=<span class="hljs-string">&quot;nielsr/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;eating_spaghetti.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>container = av.<span class="hljs-built_in">open</span>(file_path)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># sample 8 frames</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>indices = sample_frame_indices(clip_len=<span class="hljs-number">8</span>, frame_sample_rate=<span class="hljs-number">4</span>, seg_len=container.streams.video[<span class="hljs-number">0</span>].frames)
<span class="hljs-meta">&gt;&gt;&gt; </span>video = read_video_pyav(container, indices)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;MCG-NJU/videomae-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerModel.from_pretrained(<span class="hljs-string">&quot;facebook/timesformer-base-finetuned-k400&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare video for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(<span class="hljs-built_in">list</span>(video), return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">1569</span>, <span class="hljs-number">768</span>]`}}),{c(){c=n("p"),b=i("Examples:"),_=u(),y(m.$$.fragment)},l(a){c=o(a,"P",{});var h=r(c);b=l(h,"Examples:"),h.forEach(t),_=g(a),w(m.$$.fragment,a)},m(a,h){f(a,c,h),s(c,b),f(a,_,h),j(m,a,h),v=!0},p:Rt,i(a){v||(T(m.$$.fragment,a),v=!0)},o(a){$(m.$$.fragment,a),v=!1},d(a){a&&t(c),a&&t(_),x(m,a)}}}function Ia(C){let c,b,_,m,v;return{c(){c=n("p"),b=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=n("code"),m=i("Module"),v=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(a){c=o(a,"P",{});var h=r(c);b=l(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=o(h,"CODE",{});var M=r(_);m=l(M,"Module"),M.forEach(t),v=l(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(a,h){f(a,c,h),s(c,b),s(c,_),s(_,m),s(c,v)},d(a){a&&t(c)}}}function Va(C){let c,b,_,m,v;return m=new Wt({props:{code:`import av
import torch
import numpy as np

from transformers import AutoImageProcessor, TimesformerForVideoClassification
from huggingface_hub import hf_hub_download

np.random.seed(0)


def read_video_pyav(container, indices):
    '''
    Decode the video with PyAV decoder.
    Args:
        container (\`av.container.input.InputContainer\`): PyAV container.
        indices (\`List[int]\`): List of frame indices to decode.
    Returns:
        result (np.ndarray): np array of decoded frames of shape (num_frames, height, width, 3).
    '''
    frames = []
    container.seek(0)
    start_index = indices[0]
    end_index = indices[-1]
    for i, frame in enumerate(container.decode(video=0)):
        if i > end_index:
            break
        if i >= start_index and i in indices:
            frames.append(frame)
    return np.stack([x.to_ndarray(format="rgb24") for x in frames])


def sample_frame_indices(clip_len, frame_sample_rate, seg_len):
    converted_len = int(clip_len * frame_sample_rate)
    end_idx = np.random.randint(converted_len, seg_len)
    start_idx = end_idx - converted_len
    indices = np.linspace(start_idx, end_idx, num=clip_len)
    indices = np.clip(indices, start_idx, end_idx - 1).astype(np.int64)
    return indices


# video clip consists of 300 frames (10 seconds at 30 FPS)
file_path = hf_hub_download(
    repo_id="nielsr/video-demo", filename="eating_spaghetti.mp4", repo_type="dataset"
)
container = av.open(file_path)

# sample 8 frames
indices = sample_frame_indices(clip_len=8, frame_sample_rate=1, seg_len=container.streams.video[0].frames)
video = read_video_pyav(container, indices)

image_processor = AutoImageProcessor.from_pretrained("MCG-NJU/videomae-base-finetuned-kinetics")
model = TimesformerForVideoClassification.from_pretrained("facebook/timesformer-base-finetuned-k400")

inputs = image_processor(list(video), return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)
    logits = outputs.logits

# model predicts one of the 400 Kinetics-400 classes
predicted_label = logits.argmax(-1).item()
print(model.config.id2label[predicted_label])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> av
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, TimesformerForVideoClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download

<span class="hljs-meta">&gt;&gt;&gt; </span>np.random.seed(<span class="hljs-number">0</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">read_video_pyav</span>(<span class="hljs-params">container, indices</span>):
<span class="hljs-meta">... </span>    <span class="hljs-string">&#x27;&#x27;&#x27;
<span class="hljs-meta">... </span>    Decode the video with PyAV decoder.
<span class="hljs-meta">... </span>    Args:
<span class="hljs-meta">... </span>        container (\`av.container.input.InputContainer\`): PyAV container.
<span class="hljs-meta">... </span>        indices (\`List[int]\`): List of frame indices to decode.
<span class="hljs-meta">... </span>    Returns:
<span class="hljs-meta">... </span>        result (np.ndarray): np array of decoded frames of shape (num_frames, height, width, 3).
<span class="hljs-meta">... </span>    &#x27;&#x27;&#x27;</span>
<span class="hljs-meta">... </span>    frames = []
<span class="hljs-meta">... </span>    container.seek(<span class="hljs-number">0</span>)
<span class="hljs-meta">... </span>    start_index = indices[<span class="hljs-number">0</span>]
<span class="hljs-meta">... </span>    end_index = indices[-<span class="hljs-number">1</span>]
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> i, frame <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(container.decode(video=<span class="hljs-number">0</span>)):
<span class="hljs-meta">... </span>        <span class="hljs-keyword">if</span> i &gt; end_index:
<span class="hljs-meta">... </span>            <span class="hljs-keyword">break</span>
<span class="hljs-meta">... </span>        <span class="hljs-keyword">if</span> i &gt;= start_index <span class="hljs-keyword">and</span> i <span class="hljs-keyword">in</span> indices:
<span class="hljs-meta">... </span>            frames.append(frame)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> np.stack([x.to_ndarray(<span class="hljs-built_in">format</span>=<span class="hljs-string">&quot;rgb24&quot;</span>) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> frames])


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">sample_frame_indices</span>(<span class="hljs-params">clip_len, frame_sample_rate, seg_len</span>):
<span class="hljs-meta">... </span>    converted_len = <span class="hljs-built_in">int</span>(clip_len * frame_sample_rate)
<span class="hljs-meta">... </span>    end_idx = np.random.randint(converted_len, seg_len)
<span class="hljs-meta">... </span>    start_idx = end_idx - converted_len
<span class="hljs-meta">... </span>    indices = np.linspace(start_idx, end_idx, num=clip_len)
<span class="hljs-meta">... </span>    indices = np.clip(indices, start_idx, end_idx - <span class="hljs-number">1</span>).astype(np.int64)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> indices


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># video clip consists of 300 frames (10 seconds at 30 FPS)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(
<span class="hljs-meta">... </span>    repo_id=<span class="hljs-string">&quot;nielsr/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;eating_spaghetti.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>container = av.<span class="hljs-built_in">open</span>(file_path)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># sample 8 frames</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>indices = sample_frame_indices(clip_len=<span class="hljs-number">8</span>, frame_sample_rate=<span class="hljs-number">1</span>, seg_len=container.streams.video[<span class="hljs-number">0</span>].frames)
<span class="hljs-meta">&gt;&gt;&gt; </span>video = read_video_pyav(container, indices)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;MCG-NJU/videomae-base-finetuned-kinetics&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerForVideoClassification.from_pretrained(<span class="hljs-string">&quot;facebook/timesformer-base-finetuned-k400&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(<span class="hljs-built_in">list</span>(video), return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)
<span class="hljs-meta">... </span>    logits = outputs.logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 400 Kinetics-400 classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = logits.argmax(-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.config.id2label[predicted_label])
eating spaghetti`}}),{c(){c=n("p"),b=i("Examples:"),_=u(),y(m.$$.fragment)},l(a){c=o(a,"P",{});var h=r(c);b=l(h,"Examples:"),h.forEach(t),_=g(a),w(m.$$.fragment,a)},m(a,h){f(a,c,h),s(c,b),f(a,_,h),j(m,a,h),v=!0},p:Rt,i(a){v||(T(m.$$.fragment,a),v=!0)},o(a){$(m.$$.fragment,a),v=!1},d(a){a&&t(c),a&&t(_),x(m,a)}}}function Da(C){let c,b,_,m,v,a,h,M,As,is,S,R,We,ae,qs,He,Fs,ls,W,Ss,ne,zs,Is,ds,xe,Vs,cs,ke,oe,Ds,re,Ns,Os,ps,Ce,Ls,ms,Ee,Us,fs,F,Rs,ie,Ws,Hs,le,Bs,Ks,hs,z,H,Be,de,Gs,Ke,Js,us,Pe,Ge,Me,Ys,gs,I,B,Je,ce,Qs,Ye,Xs,_s,k,pe,Zs,V,et,Ae,st,tt,me,at,nt,ot,D,rt,qe,it,lt,Fe,dt,ct,pt,K,vs,N,G,Qe,fe,mt,Xe,ft,bs,A,he,ht,ue,ut,ge,gt,_t,vt,E,_e,bt,O,yt,Se,wt,jt,Ze,Tt,$t,xt,J,kt,Y,ys,L,Q,es,ve,Ct,ss,Et,ws,q,be,Pt,ye,Mt,we,At,qt,Ft,P,je,St,U,zt,ze,It,Vt,ts,Dt,Nt,Ot,X,Lt,Z,js;return a=new Re({}),ae=new Re({}),de=new Re({}),ce=new Re({}),pe=new rs({props:{name:"class transformers.TimesformerConfig",anchor:"transformers.TimesformerConfig",parameters:[{name:"image_size",val:" = 224"},{name:"patch_size",val:" = 16"},{name:"num_channels",val:" = 3"},{name:"num_frames",val:" = 8"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.0"},{name:"attention_probs_dropout_prob",val:" = 0.0"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"qkv_bias",val:" = True"},{name:"attention_type",val:" = 'divided_space_time'"},{name:"drop_path_rate",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TimesformerConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.TimesformerConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.TimesformerConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.TimesformerConfig.num_frames",description:`<strong>num_frames</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
The number of frames in each video.`,name:"num_frames"},{anchor:"transformers.TimesformerConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.TimesformerConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.TimesformerConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.TimesformerConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.TimesformerConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.TimesformerConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.TimesformerConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.TimesformerConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.TimesformerConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.TimesformerConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to the queries, keys and values.`,name:"qkv_bias"},{anchor:"transformers.TimesformerConfig.attention_type",description:`<strong>attention_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;divided_space_time&quot;</code>) &#x2014;
The attention type to use. Must be one of <code>&quot;divided_space_time&quot;</code>, <code>&quot;space_only&quot;</code>, <code>&quot;joint_space_time&quot;</code>.`,name:"attention_type"},{anchor:"transformers.TimesformerConfig.drop_path_rate",description:`<strong>drop_path_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
The dropout ratio for stochastic depth.`,name:"drop_path_rate"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/timesformer/configuration_timesformer.py#L28"}}),K=new Ut({props:{anchor:"transformers.TimesformerConfig.example",$$slots:{default:[Fa]},$$scope:{ctx:C}}}),fe=new Re({}),he=new rs({props:{name:"class transformers.TimesformerModel",anchor:"transformers.TimesformerModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TimesformerModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerConfig">TimesformerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/timesformer/modeling_timesformer.py#L534"}}),_e=new rs({props:{name:"forward",anchor:"transformers.TimesformerModel.forward",parameters:[{name:"pixel_values",val:""},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.TimesformerModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<a href="/docs/transformers/pr_22182/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">VideoMAEFeatureExtractor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TimesformerModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TimesformerModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TimesformerModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/timesformer/modeling_timesformer.py#L558",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerConfig"
>TimesformerConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),J=new Ca({props:{$$slots:{default:[Sa]},$$scope:{ctx:C}}}),Y=new Ut({props:{anchor:"transformers.TimesformerModel.forward.example",$$slots:{default:[za]},$$scope:{ctx:C}}}),ve=new Re({}),be=new rs({props:{name:"class transformers.TimesformerForVideoClassification",anchor:"transformers.TimesformerForVideoClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TimesformerForVideoClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerConfig">TimesformerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/timesformer/modeling_timesformer.py#L667"}}),je=new rs({props:{name:"forward",anchor:"transformers.TimesformerForVideoClassification.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.TimesformerForVideoClassification.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<a href="/docs/transformers/pr_22182/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">VideoMAEFeatureExtractor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TimesformerForVideoClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TimesformerForVideoClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TimesformerForVideoClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.TimesformerForVideoClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/timesformer/modeling_timesformer.py#L680",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerConfig"
>TimesformerConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each stage) of shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states
(also called feature maps) of the model at the output of each stage.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),X=new Ca({props:{$$slots:{default:[Ia]},$$scope:{ctx:C}}}),Z=new Ut({props:{anchor:"transformers.TimesformerForVideoClassification.forward.example",$$slots:{default:[Va]},$$scope:{ctx:C}}}),{c(){c=n("meta"),b=u(),_=n("h1"),m=n("a"),v=n("span"),y(a.$$.fragment),h=u(),M=n("span"),As=i("TimeSformer"),is=u(),S=n("h2"),R=n("a"),We=n("span"),y(ae.$$.fragment),qs=u(),He=n("span"),Fs=i("Overview"),ls=u(),W=n("p"),Ss=i("The TimeSformer model was proposed in "),ne=n("a"),zs=i("TimeSformer: Is Space-Time Attention All You Need for Video Understanding?"),Is=i(` by Facebook Research.
This work is a milestone in action-recognition field being the first video transformer. It inspired many transformer based video understanding and classification papers.`),ds=u(),xe=n("p"),Vs=i("The abstract from the paper is the following:"),cs=u(),ke=n("p"),oe=n("em"),Ds=i("We present a convolution-free approach to video classification built exclusively on self-attention over space and time. Our method, named \u201CTimeSformer,\u201D adapts the standard Transformer architecture to video by enabling spatiotemporal feature learning directly from a sequence of frame-level patches. Our experimental study compares different self-attention schemes and suggests that \u201Cdivided attention,\u201D where temporal attention and spatial attention are separately applied within each block, leads to the best video classification accuracy among the design choices considered. Despite the radically new design, TimeSformer achieves state-of-the-art results on several action recognition benchmarks, including the best reported accuracy on Kinetics-400 and Kinetics-600. Finally, compared to 3D convolutional networks, our model is faster to train, it can achieve dramatically higher test efficiency (at a small drop in accuracy), and it can also be applied to much longer video clips (over one minute long). Code and models are available at: "),re=n("a"),Ns=i("this https URL"),Os=i("."),ps=u(),Ce=n("p"),Ls=i("Tips:"),ms=u(),Ee=n("p"),Us=i("There are many pretrained variants. Select your pretrained model based on the dataset it is trained on. Moreover, the number of input frames per clip changes based on the model size so you should consider this parameter while selecting your pretrained model."),fs=u(),F=n("p"),Rs=i("This model was contributed by "),ie=n("a"),Ws=i("fcakyon"),Hs=i(`.
The original code can be found `),le=n("a"),Bs=i("here"),Ks=i("."),hs=u(),z=n("h2"),H=n("a"),Be=n("span"),y(de.$$.fragment),Gs=u(),Ke=n("span"),Js=i("Documentation resources"),us=u(),Pe=n("ul"),Ge=n("li"),Me=n("a"),Ys=i("Video classification task guide"),gs=u(),I=n("h2"),B=n("a"),Je=n("span"),y(ce.$$.fragment),Qs=u(),Ye=n("span"),Xs=i("TimesformerConfig"),_s=u(),k=n("div"),y(pe.$$.fragment),Zs=u(),V=n("p"),et=i("This is the configuration class to store the configuration of a "),Ae=n("a"),st=i("TimesformerModel"),tt=i(`. It is used to instantiate a
TimeSformer model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the TimeSformer
`),me=n("a"),at=i("facebook/timesformer-base-finetuned-k600"),nt=i(`
architecture.`),ot=u(),D=n("p"),rt=i("Configuration objects inherit from "),qe=n("a"),it=i("PretrainedConfig"),lt=i(` and can be used to control the model outputs. Read the
documentation from `),Fe=n("a"),dt=i("PretrainedConfig"),ct=i(" for more information."),pt=u(),y(K.$$.fragment),vs=u(),N=n("h2"),G=n("a"),Qe=n("span"),y(fe.$$.fragment),mt=u(),Xe=n("span"),ft=i("TimesformerModel"),bs=u(),A=n("div"),y(he.$$.fragment),ht=u(),ue=n("p"),ut=i(`The bare TimeSformer Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ge=n("a"),gt=i("torch.nn.Module"),_t=i(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),vt=u(),E=n("div"),y(_e.$$.fragment),bt=u(),O=n("p"),yt=i("The "),Se=n("a"),wt=i("TimesformerModel"),jt=i(" forward method, overrides the "),Ze=n("code"),Tt=i("__call__"),$t=i(" special method."),xt=u(),y(J.$$.fragment),kt=u(),y(Y.$$.fragment),ys=u(),L=n("h2"),Q=n("a"),es=n("span"),y(ve.$$.fragment),Ct=u(),ss=n("span"),Et=i("TimesformerForVideoClassification"),ws=u(),q=n("div"),y(be.$$.fragment),Pt=u(),ye=n("p"),Mt=i(`TimeSformer Model transformer with a video classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.
This model is a PyTorch `),we=n("a"),At=i("torch.nn.Module"),qt=i(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ft=u(),P=n("div"),y(je.$$.fragment),St=u(),U=n("p"),zt=i("The "),ze=n("a"),It=i("TimesformerForVideoClassification"),Vt=i(" forward method, overrides the "),ts=n("code"),Dt=i("__call__"),Nt=i(" special method."),Ot=u(),y(X.$$.fragment),Lt=u(),y(Z.$$.fragment),this.h()},l(e){const p=Aa('[data-svelte="svelte-1phssyn"]',document.head);c=o(p,"META",{name:!0,content:!0}),p.forEach(t),b=g(e),_=o(e,"H1",{class:!0});var Te=r(_);m=o(Te,"A",{id:!0,class:!0,href:!0});var as=r(m);v=o(as,"SPAN",{});var ns=r(v);w(a.$$.fragment,ns),ns.forEach(t),as.forEach(t),h=g(Te),M=o(Te,"SPAN",{});var os=r(M);As=l(os,"TimeSformer"),os.forEach(t),Te.forEach(t),is=g(e),S=o(e,"H2",{class:!0});var $e=r(S);R=o($e,"A",{id:!0,class:!0,href:!0});var Ht=r(R);We=o(Ht,"SPAN",{});var Bt=r(We);w(ae.$$.fragment,Bt),Bt.forEach(t),Ht.forEach(t),qs=g($e),He=o($e,"SPAN",{});var Kt=r(He);Fs=l(Kt,"Overview"),Kt.forEach(t),$e.forEach(t),ls=g(e),W=o(e,"P",{});var Ts=r(W);Ss=l(Ts,"The TimeSformer model was proposed in "),ne=o(Ts,"A",{href:!0,rel:!0});var Gt=r(ne);zs=l(Gt,"TimeSformer: Is Space-Time Attention All You Need for Video Understanding?"),Gt.forEach(t),Is=l(Ts,` by Facebook Research.
This work is a milestone in action-recognition field being the first video transformer. It inspired many transformer based video understanding and classification papers.`),Ts.forEach(t),ds=g(e),xe=o(e,"P",{});var Jt=r(xe);Vs=l(Jt,"The abstract from the paper is the following:"),Jt.forEach(t),cs=g(e),ke=o(e,"P",{});var Yt=r(ke);oe=o(Yt,"EM",{});var $s=r(oe);Ds=l($s,"We present a convolution-free approach to video classification built exclusively on self-attention over space and time. Our method, named \u201CTimeSformer,\u201D adapts the standard Transformer architecture to video by enabling spatiotemporal feature learning directly from a sequence of frame-level patches. Our experimental study compares different self-attention schemes and suggests that \u201Cdivided attention,\u201D where temporal attention and spatial attention are separately applied within each block, leads to the best video classification accuracy among the design choices considered. Despite the radically new design, TimeSformer achieves state-of-the-art results on several action recognition benchmarks, including the best reported accuracy on Kinetics-400 and Kinetics-600. Finally, compared to 3D convolutional networks, our model is faster to train, it can achieve dramatically higher test efficiency (at a small drop in accuracy), and it can also be applied to much longer video clips (over one minute long). Code and models are available at: "),re=o($s,"A",{href:!0,rel:!0});var Qt=r(re);Ns=l(Qt,"this https URL"),Qt.forEach(t),Os=l($s,"."),$s.forEach(t),Yt.forEach(t),ps=g(e),Ce=o(e,"P",{});var Xt=r(Ce);Ls=l(Xt,"Tips:"),Xt.forEach(t),ms=g(e),Ee=o(e,"P",{});var Zt=r(Ee);Us=l(Zt,"There are many pretrained variants. Select your pretrained model based on the dataset it is trained on. Moreover, the number of input frames per clip changes based on the model size so you should consider this parameter while selecting your pretrained model."),Zt.forEach(t),fs=g(e),F=o(e,"P",{});var Ie=r(F);Rs=l(Ie,"This model was contributed by "),ie=o(Ie,"A",{href:!0,rel:!0});var ea=r(ie);Ws=l(ea,"fcakyon"),ea.forEach(t),Hs=l(Ie,`.
The original code can be found `),le=o(Ie,"A",{href:!0,rel:!0});var sa=r(le);Bs=l(sa,"here"),sa.forEach(t),Ks=l(Ie,"."),Ie.forEach(t),hs=g(e),z=o(e,"H2",{class:!0});var xs=r(z);H=o(xs,"A",{id:!0,class:!0,href:!0});var ta=r(H);Be=o(ta,"SPAN",{});var aa=r(Be);w(de.$$.fragment,aa),aa.forEach(t),ta.forEach(t),Gs=g(xs),Ke=o(xs,"SPAN",{});var na=r(Ke);Js=l(na,"Documentation resources"),na.forEach(t),xs.forEach(t),us=g(e),Pe=o(e,"UL",{});var oa=r(Pe);Ge=o(oa,"LI",{});var ra=r(Ge);Me=o(ra,"A",{href:!0});var ia=r(Me);Ys=l(ia,"Video classification task guide"),ia.forEach(t),ra.forEach(t),oa.forEach(t),gs=g(e),I=o(e,"H2",{class:!0});var ks=r(I);B=o(ks,"A",{id:!0,class:!0,href:!0});var la=r(B);Je=o(la,"SPAN",{});var da=r(Je);w(ce.$$.fragment,da),da.forEach(t),la.forEach(t),Qs=g(ks),Ye=o(ks,"SPAN",{});var ca=r(Ye);Xs=l(ca,"TimesformerConfig"),ca.forEach(t),ks.forEach(t),_s=g(e),k=o(e,"DIV",{class:!0});var ee=r(k);w(pe.$$.fragment,ee),Zs=g(ee),V=o(ee,"P",{});var Ve=r(V);et=l(Ve,"This is the configuration class to store the configuration of a "),Ae=o(Ve,"A",{href:!0});var pa=r(Ae);st=l(pa,"TimesformerModel"),pa.forEach(t),tt=l(Ve,`. It is used to instantiate a
TimeSformer model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the TimeSformer
`),me=o(Ve,"A",{href:!0,rel:!0});var ma=r(me);at=l(ma,"facebook/timesformer-base-finetuned-k600"),ma.forEach(t),nt=l(Ve,`
architecture.`),Ve.forEach(t),ot=g(ee),D=o(ee,"P",{});var De=r(D);rt=l(De,"Configuration objects inherit from "),qe=o(De,"A",{href:!0});var fa=r(qe);it=l(fa,"PretrainedConfig"),fa.forEach(t),lt=l(De,` and can be used to control the model outputs. Read the
documentation from `),Fe=o(De,"A",{href:!0});var ha=r(Fe);dt=l(ha,"PretrainedConfig"),ha.forEach(t),ct=l(De," for more information."),De.forEach(t),pt=g(ee),w(K.$$.fragment,ee),ee.forEach(t),vs=g(e),N=o(e,"H2",{class:!0});var Cs=r(N);G=o(Cs,"A",{id:!0,class:!0,href:!0});var ua=r(G);Qe=o(ua,"SPAN",{});var ga=r(Qe);w(fe.$$.fragment,ga),ga.forEach(t),ua.forEach(t),mt=g(Cs),Xe=o(Cs,"SPAN",{});var _a=r(Xe);ft=l(_a,"TimesformerModel"),_a.forEach(t),Cs.forEach(t),bs=g(e),A=o(e,"DIV",{class:!0});var Ne=r(A);w(he.$$.fragment,Ne),ht=g(Ne),ue=o(Ne,"P",{});var Es=r(ue);ut=l(Es,`The bare TimeSformer Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ge=o(Es,"A",{href:!0,rel:!0});var va=r(ge);gt=l(va,"torch.nn.Module"),va.forEach(t),_t=l(Es,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Es.forEach(t),vt=g(Ne),E=o(Ne,"DIV",{class:!0});var se=r(E);w(_e.$$.fragment,se),bt=g(se),O=o(se,"P",{});var Oe=r(O);yt=l(Oe,"The "),Se=o(Oe,"A",{href:!0});var ba=r(Se);wt=l(ba,"TimesformerModel"),ba.forEach(t),jt=l(Oe," forward method, overrides the "),Ze=o(Oe,"CODE",{});var ya=r(Ze);Tt=l(ya,"__call__"),ya.forEach(t),$t=l(Oe," special method."),Oe.forEach(t),xt=g(se),w(J.$$.fragment,se),kt=g(se),w(Y.$$.fragment,se),se.forEach(t),Ne.forEach(t),ys=g(e),L=o(e,"H2",{class:!0});var Ps=r(L);Q=o(Ps,"A",{id:!0,class:!0,href:!0});var wa=r(Q);es=o(wa,"SPAN",{});var ja=r(es);w(ve.$$.fragment,ja),ja.forEach(t),wa.forEach(t),Ct=g(Ps),ss=o(Ps,"SPAN",{});var Ta=r(ss);Et=l(Ta,"TimesformerForVideoClassification"),Ta.forEach(t),Ps.forEach(t),ws=g(e),q=o(e,"DIV",{class:!0});var Le=r(q);w(be.$$.fragment,Le),Pt=g(Le),ye=o(Le,"P",{});var Ms=r(ye);Mt=l(Ms,`TimeSformer Model transformer with a video classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.
This model is a PyTorch `),we=o(Ms,"A",{href:!0,rel:!0});var $a=r(we);At=l($a,"torch.nn.Module"),$a.forEach(t),qt=l(Ms,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ms.forEach(t),Ft=g(Le),P=o(Le,"DIV",{class:!0});var te=r(P);w(je.$$.fragment,te),St=g(te),U=o(te,"P",{});var Ue=r(U);zt=l(Ue,"The "),ze=o(Ue,"A",{href:!0});var xa=r(ze);It=l(xa,"TimesformerForVideoClassification"),xa.forEach(t),Vt=l(Ue," forward method, overrides the "),ts=o(Ue,"CODE",{});var ka=r(ts);Dt=l(ka,"__call__"),ka.forEach(t),Nt=l(Ue," special method."),Ue.forEach(t),Ot=g(te),w(X.$$.fragment,te),Lt=g(te),w(Z.$$.fragment,te),te.forEach(t),Le.forEach(t),this.h()},h(){d(c,"name","hf:doc:metadata"),d(c,"content",JSON.stringify(Na)),d(m,"id","timesformer"),d(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(m,"href","#timesformer"),d(_,"class","relative group"),d(R,"id","overview"),d(R,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(R,"href","#overview"),d(S,"class","relative group"),d(ne,"href","https://arxiv.org/abs/2102.05095"),d(ne,"rel","nofollow"),d(re,"href","https://github.com/facebookresearch/TimeSformer"),d(re,"rel","nofollow"),d(ie,"href","https://huggingface.co/fcakyon"),d(ie,"rel","nofollow"),d(le,"href","https://github.com/facebookresearch/TimeSformer"),d(le,"rel","nofollow"),d(H,"id","documentation-resources"),d(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(H,"href","#documentation-resources"),d(z,"class","relative group"),d(Me,"href","../tasks/video_classification"),d(B,"id","transformers.TimesformerConfig"),d(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(B,"href","#transformers.TimesformerConfig"),d(I,"class","relative group"),d(Ae,"href","/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerModel"),d(me,"href","https://huggingface.co/facebook/timesformer-base-finetuned-k600"),d(me,"rel","nofollow"),d(qe,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),d(Fe,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(G,"id","transformers.TimesformerModel"),d(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(G,"href","#transformers.TimesformerModel"),d(N,"class","relative group"),d(ge,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(ge,"rel","nofollow"),d(Se,"href","/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerModel"),d(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Q,"id","transformers.TimesformerForVideoClassification"),d(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Q,"href","#transformers.TimesformerForVideoClassification"),d(L,"class","relative group"),d(we,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(we,"rel","nofollow"),d(ze,"href","/docs/transformers/pr_22182/en/model_doc/timesformer#transformers.TimesformerForVideoClassification"),d(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,p){s(document.head,c),f(e,b,p),f(e,_,p),s(_,m),s(m,v),j(a,v,null),s(_,h),s(_,M),s(M,As),f(e,is,p),f(e,S,p),s(S,R),s(R,We),j(ae,We,null),s(S,qs),s(S,He),s(He,Fs),f(e,ls,p),f(e,W,p),s(W,Ss),s(W,ne),s(ne,zs),s(W,Is),f(e,ds,p),f(e,xe,p),s(xe,Vs),f(e,cs,p),f(e,ke,p),s(ke,oe),s(oe,Ds),s(oe,re),s(re,Ns),s(oe,Os),f(e,ps,p),f(e,Ce,p),s(Ce,Ls),f(e,ms,p),f(e,Ee,p),s(Ee,Us),f(e,fs,p),f(e,F,p),s(F,Rs),s(F,ie),s(ie,Ws),s(F,Hs),s(F,le),s(le,Bs),s(F,Ks),f(e,hs,p),f(e,z,p),s(z,H),s(H,Be),j(de,Be,null),s(z,Gs),s(z,Ke),s(Ke,Js),f(e,us,p),f(e,Pe,p),s(Pe,Ge),s(Ge,Me),s(Me,Ys),f(e,gs,p),f(e,I,p),s(I,B),s(B,Je),j(ce,Je,null),s(I,Qs),s(I,Ye),s(Ye,Xs),f(e,_s,p),f(e,k,p),j(pe,k,null),s(k,Zs),s(k,V),s(V,et),s(V,Ae),s(Ae,st),s(V,tt),s(V,me),s(me,at),s(V,nt),s(k,ot),s(k,D),s(D,rt),s(D,qe),s(qe,it),s(D,lt),s(D,Fe),s(Fe,dt),s(D,ct),s(k,pt),j(K,k,null),f(e,vs,p),f(e,N,p),s(N,G),s(G,Qe),j(fe,Qe,null),s(N,mt),s(N,Xe),s(Xe,ft),f(e,bs,p),f(e,A,p),j(he,A,null),s(A,ht),s(A,ue),s(ue,ut),s(ue,ge),s(ge,gt),s(ue,_t),s(A,vt),s(A,E),j(_e,E,null),s(E,bt),s(E,O),s(O,yt),s(O,Se),s(Se,wt),s(O,jt),s(O,Ze),s(Ze,Tt),s(O,$t),s(E,xt),j(J,E,null),s(E,kt),j(Y,E,null),f(e,ys,p),f(e,L,p),s(L,Q),s(Q,es),j(ve,es,null),s(L,Ct),s(L,ss),s(ss,Et),f(e,ws,p),f(e,q,p),j(be,q,null),s(q,Pt),s(q,ye),s(ye,Mt),s(ye,we),s(we,At),s(ye,qt),s(q,Ft),s(q,P),j(je,P,null),s(P,St),s(P,U),s(U,zt),s(U,ze),s(ze,It),s(U,Vt),s(U,ts),s(ts,Dt),s(U,Nt),s(P,Ot),j(X,P,null),s(P,Lt),j(Z,P,null),js=!0},p(e,[p]){const Te={};p&2&&(Te.$$scope={dirty:p,ctx:e}),K.$set(Te);const as={};p&2&&(as.$$scope={dirty:p,ctx:e}),J.$set(as);const ns={};p&2&&(ns.$$scope={dirty:p,ctx:e}),Y.$set(ns);const os={};p&2&&(os.$$scope={dirty:p,ctx:e}),X.$set(os);const $e={};p&2&&($e.$$scope={dirty:p,ctx:e}),Z.$set($e)},i(e){js||(T(a.$$.fragment,e),T(ae.$$.fragment,e),T(de.$$.fragment,e),T(ce.$$.fragment,e),T(pe.$$.fragment,e),T(K.$$.fragment,e),T(fe.$$.fragment,e),T(he.$$.fragment,e),T(_e.$$.fragment,e),T(J.$$.fragment,e),T(Y.$$.fragment,e),T(ve.$$.fragment,e),T(be.$$.fragment,e),T(je.$$.fragment,e),T(X.$$.fragment,e),T(Z.$$.fragment,e),js=!0)},o(e){$(a.$$.fragment,e),$(ae.$$.fragment,e),$(de.$$.fragment,e),$(ce.$$.fragment,e),$(pe.$$.fragment,e),$(K.$$.fragment,e),$(fe.$$.fragment,e),$(he.$$.fragment,e),$(_e.$$.fragment,e),$(J.$$.fragment,e),$(Y.$$.fragment,e),$(ve.$$.fragment,e),$(be.$$.fragment,e),$(je.$$.fragment,e),$(X.$$.fragment,e),$(Z.$$.fragment,e),js=!1},d(e){t(c),e&&t(b),e&&t(_),x(a),e&&t(is),e&&t(S),x(ae),e&&t(ls),e&&t(W),e&&t(ds),e&&t(xe),e&&t(cs),e&&t(ke),e&&t(ps),e&&t(Ce),e&&t(ms),e&&t(Ee),e&&t(fs),e&&t(F),e&&t(hs),e&&t(z),x(de),e&&t(us),e&&t(Pe),e&&t(gs),e&&t(I),x(ce),e&&t(_s),e&&t(k),x(pe),x(K),e&&t(vs),e&&t(N),x(fe),e&&t(bs),e&&t(A),x(he),x(_e),x(J),x(Y),e&&t(ys),e&&t(L),x(ve),e&&t(ws),e&&t(q),x(be),x(je),x(X),x(Z)}}}const Na={local:"timesformer",sections:[{local:"overview",title:"Overview"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.TimesformerConfig",title:"TimesformerConfig"},{local:"transformers.TimesformerModel",title:"TimesformerModel"},{local:"transformers.TimesformerForVideoClassification",title:"TimesformerForVideoClassification"}],title:"TimeSformer"};function Oa(C){return qa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ka extends Ea{constructor(c){super();Pa(this,c,Oa,Da,Ma,{})}}export{Ka as default,Na as metadata};
