import{S as Cp,i as Dp,s as Up,e as s,k as m,w as v,t as n,M as Rp,c as r,d as t,m as c,a,x as b,h as i,b as l,N as Hp,G as e,g as f,y as F,q as w,o as y,B as M,v as Wp,L as zt}from"../../chunks/vendor-hf-doc-builder.js";import{T as an}from"../../chunks/Tip-hf-doc-builder.js";import{D as $}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Et}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as R}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as jt}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Bp(x){let h,T,_,g,k;return g=new Et({props:{code:`from transformers import Mask2FormerConfig, Mask2FormerModel

# Initializing a Mask2Former facebook/mask2former-swin-small-coco-instance configuration
configuration = Mask2FormerConfig()

# Initializing a model (with random weights) from the facebook/mask2former-swin-small-coco-instance style configuration
model = Mask2FormerModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Mask2FormerConfig, Mask2FormerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Mask2Former facebook/mask2former-swin-small-coco-instance configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Mask2FormerConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the facebook/mask2former-swin-small-coco-instance style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Mask2FormerModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){h=s("p"),T=n("Examples:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Examples:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function Gp(x){let h,T,_,g,k;return{c(){h=s("p"),T=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),g=n("Module"),k=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(u,"CODE",{});var z=a(_);g=i(z,"Module"),z.forEach(t),k=i(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){f(d,h,u),e(h,T),e(h,_),e(_,g),e(h,k)},d(d){d&&t(h)}}}function Yp(x){let h,T,_,g,k;return g=new Et({props:{code:`import torch
from PIL import Image
import requests
from transformers import AutoImageProcessor, Mask2FormerModel

# load image
url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

# load image preprocessor and Mask2FormerModel trained on COCO instance segmentation dataset
image_processor = AutoImageProcessor.from_pretrained("facebook/mask2former-swin-small-coco-instance")
model = Mask2FormerModel.from_pretrained("facebook/mask2former-swin-small-coco-instance")
inputs = image_processor(image, return_tensors="pt")

# forward pass
with torch.no_grad():
    outputs = model(**inputs)

# model outputs last hidden states of shape (batch_size, num_queries, hidden_size)
print(outputs.transformer_decoder_last_hidden_state.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, Mask2FormerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load image preprocessor and Mask2FormerModel trained on COCO instance segmentation dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-coco-instance&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Mask2FormerModel.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-coco-instance&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model outputs last hidden states of shape (batch_size, num_queries, hidden_size)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(outputs.transformer_decoder_last_hidden_state.shape)
torch.Size([<span class="hljs-number">1</span>, <span class="hljs-number">100</span>, <span class="hljs-number">256</span>])`}}),{c(){h=s("p"),T=n("Examples:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Examples:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function Kp(x){let h,T,_,g,k;return{c(){h=s("p"),T=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),g=n("Module"),k=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(u,"CODE",{});var z=a(_);g=i(z,"Module"),z.forEach(t),k=i(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){f(d,h,u),e(h,T),e(h,_),e(_,g),e(h,k)},d(d){d&&t(h)}}}function Xp(x){let h,T,_,g,k;return g=new Et({props:{code:`from transformers import AutoImageProcessor, Mask2FormerForUniversalSegmentation
from PIL import Image
import requests
import torch

# Load Mask2Former trained on COCO instance segmentation dataset
image_processor = AutoImageProcessor.from_pretrained("facebook/mask2former-swin-small-coco-instance")
model = Mask2FormerForUniversalSegmentation.from_pretrained(
    "facebook/mask2former-swin-small-coco-instance"
)

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)
inputs = image_processor(image, return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)

# Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`
# and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`
class_queries_logits = outputs.class_queries_logits
masks_queries_logits = outputs.masks_queries_logits

# Perform post-processing to get instance segmentation map
pred_instance_map = image_processor.post_process_semantic_segmentation(
    outputs, target_sizes=[image.size[::-1]]
)[0]
print(pred_instance_map.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, Mask2FormerForUniversalSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load Mask2Former trained on COCO instance segmentation dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-coco-instance&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Mask2FormerForUniversalSegmentation.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/mask2former-swin-small-coco-instance&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>class_queries_logits = outputs.class_queries_logits
<span class="hljs-meta">&gt;&gt;&gt; </span>masks_queries_logits = outputs.masks_queries_logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Perform post-processing to get instance segmentation map</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pred_instance_map = image_processor.post_process_semantic_segmentation(
<span class="hljs-meta">... </span>    outputs, target_sizes=[image.size[::-<span class="hljs-number">1</span>]]
<span class="hljs-meta">... </span>)[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(pred_instance_map.shape)
torch.Size([<span class="hljs-number">480</span>, <span class="hljs-number">640</span>])`}}),{c(){h=s("p"),T=n("Instance segmentation example:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Instance segmentation example:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function Qp(x){let h,T,_,g,k;return g=new Et({props:{code:`from transformers import AutoImageProcessor, Mask2FormerForUniversalSegmentation
from PIL import Image
import requests
import torch

# Load Mask2Former trained on ADE20k semantic segmentation dataset
image_processor = AutoImageProcessor.from_pretrained("facebook/mask2former-swin-small-ade-semantic")
model = Mask2FormerForUniversalSegmentation.from_pretrained("facebook/mask2former-swin-small-ade-semantic")

url = (
    "https://huggingface.co/datasets/hf-internal-testing/fixtures_ade20k/resolve/main/ADE_val_00000001.jpg"
)
image = Image.open(requests.get(url, stream=True).raw)
inputs = image_processor(image, return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)

# Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`
# and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`
class_queries_logits = outputs.class_queries_logits
masks_queries_logits = outputs.masks_queries_logits

# Perform post-processing to get semantic segmentation map
pred_semantic_map = image_processor.post_process_semantic_segmentation(
    outputs, target_sizes=[image.size[::-1]]
)[0]
print(pred_semantic_map.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, Mask2FormerForUniversalSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load Mask2Former trained on ADE20k semantic segmentation dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-ade-semantic&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Mask2FormerForUniversalSegmentation.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-ade-semantic&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/datasets/hf-internal-testing/fixtures_ade20k/resolve/main/ADE_val_00000001.jpg&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>class_queries_logits = outputs.class_queries_logits
<span class="hljs-meta">&gt;&gt;&gt; </span>masks_queries_logits = outputs.masks_queries_logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Perform post-processing to get semantic segmentation map</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pred_semantic_map = image_processor.post_process_semantic_segmentation(
<span class="hljs-meta">... </span>    outputs, target_sizes=[image.size[::-<span class="hljs-number">1</span>]]
<span class="hljs-meta">... </span>)[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(pred_semantic_map.shape)
torch.Size([<span class="hljs-number">512</span>, <span class="hljs-number">683</span>])`}}),{c(){h=s("p"),T=n("Semantic segmentation example:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Semantic segmentation example:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function Zp(x){let h,T,_,g,k;return g=new Et({props:{code:`from transformers import AutoImageProcessor, Mask2FormerForUniversalSegmentation
from PIL import Image
import requests
import torch

# Load Mask2Former trained on CityScapes panoptic segmentation dataset
image_processor = AutoImageProcessor.from_pretrained("facebook/mask2former-swin-small-cityscapes-panoptic")
model = Mask2FormerForUniversalSegmentation.from_pretrained(
    "facebook/mask2former-swin-small-cityscapes-panoptic"
)

url = "https://cdn-media.huggingface.co/Inference-API/Sample-results-on-the-Cityscapes-dataset-The-above-images-show-how-our-method-can-handle.png"
image = Image.open(requests.get(url, stream=True).raw)
inputs = image_processor(image, return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)

# Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`
# and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`
class_queries_logits = outputs.class_queries_logits
masks_queries_logits = outputs.masks_queries_logits

# Perform post-processing to get panoptic segmentation map
pred_panoptic_map = image_processor.post_process_panoptic_segmentation(
    outputs, target_sizes=[image.size[::-1]]
)[0]["segmentation"]
print(pred_panoptic_map.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, Mask2FormerForUniversalSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load Mask2Former trained on CityScapes panoptic segmentation dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/mask2former-swin-small-cityscapes-panoptic&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Mask2FormerForUniversalSegmentation.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/mask2former-swin-small-cityscapes-panoptic&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;https://cdn-media.huggingface.co/Inference-API/Sample-results-on-the-Cityscapes-dataset-The-above-images-show-how-our-method-can-handle.png&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model predicts class_queries_logits of shape \`(batch_size, num_queries)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># and masks_queries_logits of shape \`(batch_size, num_queries, height, width)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>class_queries_logits = outputs.class_queries_logits
<span class="hljs-meta">&gt;&gt;&gt; </span>masks_queries_logits = outputs.masks_queries_logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Perform post-processing to get panoptic segmentation map</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pred_panoptic_map = image_processor.post_process_panoptic_segmentation(
<span class="hljs-meta">... </span>    outputs, target_sizes=[image.size[::-<span class="hljs-number">1</span>]]
<span class="hljs-meta">... </span>)[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segmentation&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(pred_panoptic_map.shape)
torch.Size([<span class="hljs-number">338</span>, <span class="hljs-number">676</span>])`}}),{c(){h=s("p"),T=n("Panoptic segmentation example:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Panoptic segmentation example:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function Jp(x){let h,T,_,g,k;return{c(){h=s("p"),T=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),g=n("Module"),k=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(u,"CODE",{});var z=a(_);g=i(z,"Module"),z.forEach(t),k=i(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){f(d,h,u),e(h,T),e(h,_),e(_,g),e(h,k)},d(d){d&&t(h)}}}function eh(x){let h,T,_,g,k;return g=new Et({props:{code:`import torch
import torchvision
from huggingface_hub import hf_hub_download
from transformers import AutoImageProcessor, VideoMask2FormerModel

file_path = hf_hub_download(repo_id="shivi/video-demo", filename="cars.mp4", repo_type="dataset")
video = torchvision.io.read_video(file_path)[0]

# load image preprocessor and VideoMask2FormerModel trained on Youtube-VIS 2021 instance segmentation dataset
image_processor = AutoImageProcessor.from_pretrained(
    "facebook/video-mask2former-swin-tiny-youtubevis-2021-instance"
)
model = VideoMask2FormerModel.from_pretrained(
    "facebook/video-mask2former-swin-tiny-youtubevis-2021-instance"
)

video_input = image_processor(video, return_tensors="pt")

# forward pass
with torch.no_grad():
    outputs = model(**video_input)

# model outputs last hidden states of shape (batch_size, num_queries, hidden_size)
print(outputs.transformer_decoder_last_hidden_state.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torchvision
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, VideoMask2FormerModel

<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(repo_id=<span class="hljs-string">&quot;shivi/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;cars.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>video = torchvision.io.read_video(file_path)[<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load image preprocessor and VideoMask2FormerModel trained on Youtube-VIS 2021 instance segmentation dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/video-mask2former-swin-tiny-youtubevis-2021-instance&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = VideoMask2FormerModel.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/video-mask2former-swin-tiny-youtubevis-2021-instance&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>video_input = image_processor(video, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**video_input)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model outputs last hidden states of shape (batch_size, num_queries, hidden_size)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(outputs.transformer_decoder_last_hidden_state.shape)
torch.Size([<span class="hljs-number">1</span>, <span class="hljs-number">100</span>, <span class="hljs-number">256</span>])`}}),{c(){h=s("p"),T=n("Examples:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Examples:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function oh(x){let h,T,_,g,k;return{c(){h=s("p"),T=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),g=n("Module"),k=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(u,"CODE",{});var z=a(_);g=i(z,"Module"),z.forEach(t),k=i(u,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),u.forEach(t)},m(d,u){f(d,h,u),e(h,T),e(h,_),e(_,g),e(h,k)},d(d){d&&t(h)}}}function th(x){let h,T,_,g,k;return g=new Et({props:{code:`from transformers import AutoImageProcessor, VideoMask2FormerForVideoSegmentation
import torch
import torchvision
from huggingface_hub import hf_hub_download

# Load Video Mask2Former trained on YouTubeVIS 2021 dataset
image_processor = AutoImageProcessor.from_pretrained(
    "facebook/video-mask2former-swin-tiny-youtubevis-2021-instance"
)
model = VideoMask2FormerForVideoSegmentation.from_pretrained(
    "facebook/video-mask2former-swin-tiny-youtubevis-2021-instance"
)

file_path = hf_hub_download(repo_id="shivi/video-demo", filename="cars.mp4", repo_type="dataset")
video = torchvision.io.read_video(file_path)[0]

video_input = image_processor(list(video[:5]), return_tensors="pt")

with torch.no_grad():
    outputs = model(**video_input)

# Model predicts class_queries_logits of shape \`(batch_size, num_queries, num_classes+1)\`
# and masks_queries_logits of shape \`(num_queries, batch_size, height, width)\`
class_queries_logits = outputs.class_queries_logits
masks_queries_logits = outputs.masks_queries_logits

# Perform post-processing to get video instance segmentation map
pred_video_instance_map = image_processor.post_process_instance_segmentation(
    outputs, target_sizes=[tuple(video.shape[1:3])]
)[0]["segmentation"]
print(pred_video_instance_map.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, VideoMask2FormerForVideoSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torchvision
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load Video Mask2Former trained on YouTubeVIS 2021 dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/video-mask2former-swin-tiny-youtubevis-2021-instance&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = VideoMask2FormerForVideoSegmentation.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;facebook/video-mask2former-swin-tiny-youtubevis-2021-instance&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(repo_id=<span class="hljs-string">&quot;shivi/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;cars.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>video = torchvision.io.read_video(file_path)[<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>video_input = image_processor(<span class="hljs-built_in">list</span>(video[:<span class="hljs-number">5</span>]), return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**video_input)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Model predicts class_queries_logits of shape \`(batch_size, num_queries, num_classes+1)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># and masks_queries_logits of shape \`(num_queries, batch_size, height, width)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>class_queries_logits = outputs.class_queries_logits
<span class="hljs-meta">&gt;&gt;&gt; </span>masks_queries_logits = outputs.masks_queries_logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Perform post-processing to get video instance segmentation map</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pred_video_instance_map = image_processor.post_process_instance_segmentation(
<span class="hljs-meta">... </span>    outputs, target_sizes=[<span class="hljs-built_in">tuple</span>(video.shape[<span class="hljs-number">1</span>:<span class="hljs-number">3</span>])]
<span class="hljs-meta">... </span>)[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segmentation&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(pred_video_instance_map.shape)`}}),{c(){h=s("p"),T=n("Video instance segmentation example:"),_=m(),v(g.$$.fragment)},l(d){h=r(d,"P",{});var u=a(h);T=i(u,"Video instance segmentation example:"),u.forEach(t),_=c(d),b(g.$$.fragment,d)},m(d,u){f(d,h,u),e(h,T),f(d,_,u),F(g,d,u),k=!0},p:zt,i(d){k||(w(g.$$.fragment,d),k=!0)},o(d){y(g.$$.fragment,d),k=!1},d(d){d&&t(h),d&&t(_),M(g,d)}}}function sh(x){let h,T,_,g,k,d,u,z,nn,Or,ae,$e,Es,co,dn,qs,ln,Vr,ee,mn,po,cn,pn,qt,hn,fn,Sr,Ot,gn,Ar,Vt,Os,un,Lr,xe,_n,ho,kn,vn,Nr,St,bn,Cr,At,Vs,Fn,Dr,Lt,wn,Ur,oe,H,yn,Nt,Mn,Tn,Ct,$n,xn,Dt,In,Pn,jn,O,zn,Ut,En,qn,Rt,On,Vn,Ht,Sn,An,Wt,Ln,Nn,Ss,Cn,Dn,Un,fo,Rn,Bt,Hn,Wn,Rr,Ie,Hm,Hr,go,Bn,Gt,Gn,Wr,L,Yn,uo,Kn,Xn,_o,Qn,Zn,ko,Jn,ei,Br,ne,Pe,As,vo,oi,Ls,ti,Gr,Yt,si,Yr,je,bo,ri,Fo,ai,ni,ii,ie,di,Kt,li,mi,wo,ci,pi,Kr,Xt,hi,Xr,de,ze,Ns,yo,fi,Cs,gi,Qr,le,Mo,ui,To,_i,Qt,ki,vi,Zr,W,$o,bi,xo,Fi,Ds,wi,yi,Mi,B,Ti,Zt,$i,xi,Jt,Ii,Pi,es,ji,zi,Jr,me,Ee,Us,Io,Ei,Rs,qi,ea,P,Po,Oi,ce,Vi,os,Si,Ai,jo,Li,Ni,Ci,pe,Di,ts,Ui,Ri,ss,Hi,Wi,Bi,zo,Gi,rs,Yi,Ki,Xi,qe,Qi,Oe,Eo,Zi,qo,Ji,as,ed,od,td,Ve,Oo,sd,Vo,rd,ns,ad,nd,oa,he,Se,Hs,So,id,Ws,dd,ta,I,Ao,ld,Bs,md,cd,Lo,pd,Gs,hd,fd,gd,is,No,ud,te,Co,_d,Do,kd,Ys,vd,bd,Fd,G,wd,Ks,yd,Md,Xs,Td,$d,Qs,xd,Id,Pd,Ae,Uo,jd,Ro,zd,ds,Ed,qd,Od,Le,Ho,Vd,Wo,Sd,Zs,Ad,Ld,Nd,Ne,Bo,Cd,Go,Dd,Js,Ud,Rd,sa,fe,Ce,er,Yo,Hd,or,Wd,ra,Y,Ko,Bd,Xo,Gd,Qo,Yd,Kd,Xd,N,Zo,Qd,ge,Zd,ls,Jd,el,tr,ol,tl,sl,De,rl,Ue,aa,ue,Re,sr,Jo,al,rr,nl,na,K,et,il,ot,dl,tt,ll,ml,cl,j,st,pl,_e,hl,ms,fl,gl,ar,ul,_l,kl,He,vl,nr,bl,Fl,We,wl,Be,yl,Ge,ia,ke,Ye,ir,rt,Ml,dr,Tl,da,ve,at,$l,nt,xl,cs,Il,Pl,la,X,it,jl,dt,zl,lr,El,ql,Ol,lt,Vl,ps,Sl,Al,ma,be,Ke,mr,mt,Ll,cr,Nl,ca,E,ct,Cl,pr,Dl,Ul,pt,Rl,hr,Hl,Wl,Bl,hs,ht,Gl,se,ft,Yl,gt,Kl,fr,Xl,Ql,Zl,Q,Jl,gr,em,om,ur,tm,sm,_r,rm,am,nm,Xe,ut,im,_t,dm,kr,lm,mm,pa,Fe,Qe,vr,kt,cm,br,pm,ha,Z,vt,hm,bt,fm,Ft,gm,um,_m,C,wt,km,we,vm,fs,bm,Fm,Fr,wm,ym,Mm,Ze,Tm,Je,fa,ye,eo,wr,yt,$m,yr,xm,ga,J,Mt,Im,Tt,Pm,$t,jm,zm,Em,V,xt,qm,Me,Om,gs,Vm,Sm,Mr,Am,Lm,Nm,oo,Cm,Tr,Dm,Um,to,ua;return d=new R({}),co=new R({}),vo=new R({}),yo=new R({}),Mo=new $({props:{name:"class transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput",anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput",parameters:[{name:"encoder_last_hidden_state",val:": FloatTensor = None"},{name:"pixel_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"transformer_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"pixel_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_intermediate_states",val:": typing.Tuple[torch.FloatTensor] = None"},{name:"masks_queries_logits",val:": typing.Tuple[torch.FloatTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) &#x2014;
Last hidden states (final feature map) of the last stage of the encoder model (backbone). Returned when
<code>output_hidden_states=True</code> is passed.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"encoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.pixel_decoder_last_hidden_state",description:`<strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) &#x2014;
Last hidden states (final feature map) of the last stage of the pixel decoder model.`,name:"pixel_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.pixel_decoder_hidden_states",description:`<strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, , <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"pixel_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.transformer_decoder_last_hidden_state",description:`<strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) &#x2014;
Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.`,name:"transformer_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.transformer_decoder_hidden_states",description:`<strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"transformer_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.transformer_decoder_intermediate_states",description:`<strong>transformer_decoder_intermediate_states</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(num_queries, 1, hidden_size)</code>) &#x2014;
Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.`,name:"transformer_decoder_intermediate_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.masks_queries_logits",description:`<strong>masks_queries_logits</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(batch_size, num_queries, height, width)</code>) &#x2014;
Mask Predictions from each layer in the transformer decoder.`,name:"masks_queries_logits"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self attentions weights from transformer decoder.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L147"}}),$o=new $({props:{name:"class transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput",anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"class_queries_logits",val:": FloatTensor = None"},{name:"masks_queries_logits",val:": FloatTensor = None"},{name:"auxiliary_logits",val:": typing.Union[typing.List[typing.Dict[str, torch.FloatTensor]], NoneType] = None"},{name:"encoder_last_hidden_state",val:": FloatTensor = None"},{name:"pixel_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"transformer_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"pixel_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.loss",description:`<strong>loss</strong> (<code>torch.Tensor</code>, <em>optional</em>) &#x2014;
The computed loss, returned when labels are present.`,name:"loss"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.class_queries_logits",description:`<strong>class_queries_logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
A tensor of shape <code>(batch_size, num_queries, num_labels + 1)</code> representing the proposed classes for each
query. Note the <code>+ 1</code> is needed because we incorporate the null class.`,name:"class_queries_logits"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.masks_queries_logits",description:`<strong>masks_queries_logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
A tensor of shape <code>(batch_size, num_queries, height, width)</code> representing the proposed masks for each
query.`,name:"masks_queries_logits"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.auxiliary_logits",description:`<strong>auxiliary_logits</strong> (<code>List[Dict(str, torch.FloatTensor)]</code>, <em>optional</em>) &#x2014;
List of class and mask predictions from each layer of the transformer decoder.`,name:"auxiliary_logits"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Last hidden states (final feature map) of the last stage of the encoder model (backbone).`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage.`,name:"encoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.pixel_decoder_last_hidden_state",description:`<strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Last hidden states (final feature map) of the last stage of the pixel decoder model.`,name:"pixel_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.pixel_decoder_hidden_states",description:`<strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage.`,name:"pixel_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.transformer_decoder_last_hidden_state",description:`<strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) &#x2014;
Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.`,name:"transformer_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.transformer_decoder_hidden_states",description:`<strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage.`,name:"transformer_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self and Cross Attentions weights from transformer decoder.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L193"}}),Io=new R({}),Po=new $({props:{name:"class transformers.Mask2FormerConfig",anchor:"transformers.Mask2FormerConfig",parameters:[{name:"backbone_config",val:": typing.Optional[typing.Dict] = None"},{name:"feature_size",val:": int = 256"},{name:"mask_feature_size",val:": int = 256"},{name:"hidden_dim",val:": int = 256"},{name:"encoder_feedforward_dim",val:": int = 1024"},{name:"activation_function",val:": str = 'relu'"},{name:"encoder_layers",val:": int = 6"},{name:"decoder_layers",val:": int = 10"},{name:"num_attention_heads",val:": int = 8"},{name:"dropout",val:": float = 0.0"},{name:"dim_feedforward",val:": int = 2048"},{name:"pre_norm",val:": bool = False"},{name:"enforce_input_projection",val:": bool = False"},{name:"common_stride",val:": int = 4"},{name:"ignore_value",val:": int = 255"},{name:"num_queries",val:": int = 100"},{name:"no_object_weight",val:": float = 0.1"},{name:"class_weight",val:": float = 2.0"},{name:"mask_weight",val:": float = 5.0"},{name:"dice_weight",val:": float = 5.0"},{name:"train_num_points",val:": int = 12544"},{name:"oversample_ratio",val:": float = 3.0"},{name:"importance_sample_ratio",val:": float = 0.75"},{name:"init_std",val:": float = 0.02"},{name:"init_xavier_std",val:": float = 1.0"},{name:"use_auxiliary_loss",val:": bool = True"},{name:"feature_strides",val:": typing.List[int] = [4, 8, 16, 32]"},{name:"output_auxiliary_logits",val:": bool = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Mask2FormerConfig.backbone_config",description:`<strong>backbone_config</strong> (<code>PretrainedConfig</code> or <code>dict</code>, <em>optional</em>, defaults to <code>SwinConfig()</code>) &#x2014;
The configuration of the backbone model. If unset, the configuration corresponding to
<code>swin-base-patch4-window12-384</code> will be used.`,name:"backbone_config"},{anchor:"transformers.Mask2FormerConfig.feature_size",description:`<strong>feature_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
The features (channels) of the resulting feature maps.`,name:"feature_size"},{anchor:"transformers.Mask2FormerConfig.mask_feature_size",description:`<strong>mask_feature_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
The masks&#x2019; features size, this value will also be used to specify the Feature Pyramid Network features&#x2019;
size.`,name:"mask_feature_size"},{anchor:"transformers.Mask2FormerConfig.hidden_dim",description:`<strong>hidden_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the encoder layers.`,name:"hidden_dim"},{anchor:"transformers.Mask2FormerConfig.encoder_feedforward_dim",description:`<strong>encoder_feedforward_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 1024) &#x2014;
Dimension of feedforward network for deformable detr encoder used as part of pixel decoder.`,name:"encoder_feedforward_dim"},{anchor:"transformers.Mask2FormerConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of layers in the deformable detr encoder used as part of pixel decoder.`,name:"encoder_layers"},{anchor:"transformers.Mask2FormerConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 10) &#x2014;
Number of layers in the Transformer decoder.`,name:"decoder_layers"},{anchor:"transformers.Mask2FormerConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer.`,name:"num_attention_heads"},{anchor:"transformers.Mask2FormerConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder.`,name:"dropout"},{anchor:"transformers.Mask2FormerConfig.dim_feedforward",description:`<strong>dim_feedforward</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Feature dimension in feedforward network for transformer decoder.`,name:"dim_feedforward"},{anchor:"transformers.Mask2FormerConfig.pre_norm",description:`<strong>pre_norm</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use pre-LayerNorm or not for transformer decoder.`,name:"pre_norm"},{anchor:"transformers.Mask2FormerConfig.enforce_input_projection",description:`<strong>enforce_input_projection</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to add an input projection 1x1 convolution even if the input channels and hidden dim are identical
in the Transformer decoder.`,name:"enforce_input_projection"},{anchor:"transformers.Mask2FormerConfig.common_stride",description:`<strong>common_stride</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
Parameter used for determining number of FPN levels used as part of pixel decoder.`,name:"common_stride"},{anchor:"transformers.Mask2FormerConfig.ignore_value",description:`<strong>ignore_value</strong> (<code>int</code>, <em>optional</em>, defaults to 255) &#x2014;
Category id to be ignored during training.`,name:"ignore_value"},{anchor:"transformers.Mask2FormerConfig.num_queries",description:`<strong>num_queries</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Number of queries for the decoder.`,name:"num_queries"},{anchor:"transformers.Mask2FormerConfig.no_object_weight",description:`<strong>no_object_weight</strong> (<code>int</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The weight to apply to the null (no object) class.`,name:"no_object_weight"},{anchor:"transformers.Mask2FormerConfig.class_weight",description:`<strong>class_weight</strong> (<code>int</code>, <em>optional</em>, defaults to 2.0) &#x2014;
The weight for the cross entropy loss.`,name:"class_weight"},{anchor:"transformers.Mask2FormerConfig.mask_weight",description:`<strong>mask_weight</strong> (<code>int</code>, <em>optional</em>, defaults to 5.0) &#x2014;
The weight for the mask loss.`,name:"mask_weight"},{anchor:"transformers.Mask2FormerConfig.dice_weight",description:`<strong>dice_weight</strong> (<code>int</code>, <em>optional</em>, defaults to 5.0) &#x2014;
The weight for the dice loss.`,name:"dice_weight"},{anchor:"transformers.Mask2FormerConfig.train_num_points",description:`<strong>train_num_points</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to 12544) &#x2014;
Number of points used for sampling during loss calculation.`,name:"train_num_points"},{anchor:"transformers.Mask2FormerConfig.oversample_ratio",description:`<strong>oversample_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 3.0) &#x2014;
Oversampling parameter used for calculating no. of sampled points`,name:"oversample_ratio"},{anchor:"transformers.Mask2FormerConfig.importance_sample_ratio",description:`<strong>importance_sample_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 0.75) &#x2014;
Ratio of points that are sampled via importance sampling.`,name:"importance_sample_ratio"},{anchor:"transformers.Mask2FormerConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.Mask2FormerConfig.init_xavier_std",description:`<strong>init_xavier_std</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The scaling factor used for the Xavier initialization gain in the HM Attention map module.`,name:"init_xavier_std"},{anchor:"transformers.Mask2FormerConfig.use_auxiliary_loss",description:`<strong>use_auxiliary_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If <code>True</code> <code>Mask2FormerForUniversalSegmentationOutput</code> will contain the auxiliary losses computed using
the logits from each decoder&#x2019;s stage.`,name:"use_auxiliary_loss"},{anchor:"transformers.Mask2FormerConfig.feature_strides",description:`<strong>feature_strides</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[4, 8, 16, 32]</code>) &#x2014;
Feature strides corresponding to features generated from backbone network.`,name:"feature_strides"},{anchor:"transformers.Mask2FormerConfig.output_auxiliary_logits",description:`<strong>output_auxiliary_logits</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Should the model output its <code>auxiliary_logits</code> or not.`,name:"output_auxiliary_logits"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/configuration_mask2former.py#L41"}}),qe=new jt({props:{anchor:"transformers.Mask2FormerConfig.example",$$slots:{default:[Bp]},$$scope:{ctx:x}}}),Eo=new $({props:{name:"from_backbone_config",anchor:"transformers.Mask2FormerConfig.from_backbone_config",parameters:[{name:"backbone_config",val:": PretrainedConfig"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Mask2FormerConfig.from_backbone_config.backbone_config",description:`<strong>backbone_config</strong> (<a href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig">PretrainedConfig</a>) &#x2014;
The backbone configuration.`,name:"backbone_config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/configuration_mask2former.py#L218",returnDescription:`
<p>An instance of a configuration object</p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"
>Mask2FormerConfig</a></p>
`}}),Oo=new $({props:{name:"to_dict",anchor:"transformers.Mask2FormerConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/configuration_mask2former.py#L234",returnDescription:`
<p>Dictionary of all the attributes that make up this configuration instance,</p>
`,returnType:`
<p><code>Dict[str, any]</code></p>
`}}),So=new R({}),Ao=new $({props:{name:"class transformers.Mask2FormerImageProcessor",anchor:"transformers.Mask2FormerImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"size_divisor",val:": int = 32"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": float = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float]] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float]] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Mask2FormerImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the input to a certain <code>size</code>.`,name:"do_resize"},{anchor:"transformers.Mask2FormerImageProcessor.size",description:`<strong>size</strong> (<code>int</code>, <em>optional</em>, defaults to 800) &#x2014;
Resize the input to the given size. Only has an effect if <code>do_resize</code> is set to <code>True</code>. If size is a
sequence like <code>(width, height)</code>, output size will be matched to this. If size is an int, smaller edge of
the image will be matched to this number. i.e, if <code>height &gt; width</code>, then image will be rescaled to <code>(size * height / width, size)</code>.`,name:"size"},{anchor:"transformers.Mask2FormerImageProcessor.max_size",description:`<strong>max_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1333) &#x2014;
The largest size an image dimension can have (otherwise it&#x2019;s capped). Only has an effect if <code>do_resize</code> is
set to <code>True</code>.`,name:"max_size"},{anchor:"transformers.Mask2FormerImageProcessor.resample",description:`<strong>resample</strong> (<code>int</code>, <em>optional</em>, defaults to <code>PIL.Image.Resampling.BILINEAR</code>) &#x2014;
An optional resampling filter. This can be one of <code>PIL.Image.Resampling.NEAREST</code>,
<code>PIL.Image.Resampling.BOX</code>, <code>PIL.Image.Resampling.BILINEAR</code>, <code>PIL.Image.Resampling.HAMMING</code>,
<code>PIL.Image.Resampling.BICUBIC</code> or <code>PIL.Image.Resampling.LANCZOS</code>. Only has an effect if <code>do_resize</code> is set
to <code>True</code>.`,name:"resample"},{anchor:"transformers.Mask2FormerImageProcessor.size_divisor",description:`<strong>size_divisor</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Some backbones need images divisible by a certain number. If not passed, it defaults to the value used in
Swin Transformer.`,name:"size_divisor"},{anchor:"transformers.Mask2FormerImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to rescale the input to a certain <code>scale</code>.`,name:"do_rescale"},{anchor:"transformers.Mask2FormerImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1/ 255) &#x2014;
Rescale the input by the given factor. Only has an effect if <code>do_rescale</code> is set to <code>True</code>.`,name:"rescale_factor"},{anchor:"transformers.Mask2FormerImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to normalize the input with mean and standard deviation.`,name:"do_normalize"},{anchor:"transformers.Mask2FormerImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.485, 0.456, 0.406]</code>) &#x2014;
The sequence of means for each channel, to be used when normalizing images. Defaults to the ImageNet mean.`,name:"image_mean"},{anchor:"transformers.Mask2FormerImageProcessor.image_std",description:`<strong>image_std</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.229, 0.224, 0.225]</code>) &#x2014;
The sequence of standard deviations for each channel, to be used when normalizing images. Defaults to the
ImageNet std.`,name:"image_std"},{anchor:"transformers.Mask2FormerImageProcessor.ignore_index",description:`<strong>ignore_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Label to be assigned to background pixels in segmentation maps. If provided, segmentation map pixels
denoted with 0 (background) will be replaced with <code>ignore_index</code>.`,name:"ignore_index"},{anchor:"transformers.Mask2FormerImageProcessor.reduce_labels",description:`<strong>reduce_labels</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to decrement all label values of segmentation maps by 1. Usually used for datasets where 0
is used for background, and background itself is not included in all classes of a dataset (e.g. ADE20k).
The background label will be replaced by <code>ignore_index</code>.`,name:"reduce_labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L331"}}),No=new $({props:{name:"preprocess",anchor:"transformers.Mask2FormerImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"segmentation_maps",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')], NoneType] = None"},{name:"instance_id_to_semantic_id",val:": typing.Union[typing.Dict[int, int], NoneType] = None"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"size_divisor",val:": typing.Optional[int] = None"},{name:"resample",val:": Resampling = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Optional[float] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": typing.Optional[bool] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension] = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L629"}}),Co=new $({props:{name:"encode_inputs",anchor:"transformers.Mask2FormerImageProcessor.encode_inputs",parameters:[{name:"pixel_values_list",val:": typing.List[typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]]"},{name:"segmentation_maps",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]] = None"},{name:"instance_id_to_semantic_id",val:": typing.Union[typing.List[typing.Dict[int, int]], typing.Dict[int, int], NoneType] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": bool = False"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Mask2FormerImageProcessor.encode_inputs.pixel_values_list",description:`<strong>pixel_values_list</strong> (<code>List[ImageInput]</code>) &#x2014;
List of images (pixel values) to be padded. Each image should be a tensor of shape <code>(channels, height, width)</code>.`,name:"pixel_values_list"},{anchor:"transformers.Mask2FormerImageProcessor.encode_inputs.segmentation_maps",description:`<strong>segmentation_maps</strong> (<code>ImageInput</code>, <em>optional</em>) &#x2014;
The corresponding semantic segmentation maps with the pixel-wise annotations.</p>
<p>(<code>bool</code>, <em>optional</em>, defaults to <code>True</code>):
Whether or not to pad images up to the largest image in a batch and create a pixel mask.</p>
<p>If left to the default, will return a pixel mask that is:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>`,name:"segmentation_maps"},{anchor:"transformers.Mask2FormerImageProcessor.encode_inputs.instance_id_to_semantic_id",description:`<strong>instance_id_to_semantic_id</strong> (<code>List[Dict[int, int]]</code> or <code>Dict[int, int]</code>, <em>optional</em>) &#x2014;
A mapping between object instance ids and class ids. If passed, <code>segmentation_maps</code> is treated as an
instance segmentation map where each pixel represents an instance id. Can be provided as a single
dictionary with a global/dataset-level mapping or as a list of dictionaries (one per image), to map
instance ids in each image separately.`,name:"instance_id_to_semantic_id"},{anchor:"transformers.Mask2FormerImageProcessor.encode_inputs.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of NumPy arrays. If set to <code>&apos;pt&apos;</code>, return PyTorch <code>torch.Tensor</code>
objects.`,name:"return_tensors"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L784",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li><strong>pixel_values</strong> \u2014 Pixel values to be fed to a model.</li>
<li><strong>pixel_mask</strong> \u2014 Pixel mask to be fed to a model (when <code>=True</code> or if <code>pixel_mask</code> is in
<code>self.model_input_names</code>).</li>
<li><strong>mask_labels</strong> \u2014 Optional list of mask labels of shape <code>(labels, height, width)</code> to be fed to a model
(when <code>annotations</code> are provided).</li>
<li><strong>class_labels</strong> \u2014 Optional list of class labels of shape <code>(labels)</code> to be fed to a model (when
<code>annotations</code> are provided). They identify the labels of <code>mask_labels</code>, e.g. the label of
<code>mask_labels[i][j]</code> if <code>class_labels[i][j]</code>.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),Uo=new $({props:{name:"post_process_semantic_segmentation",anchor:"transformers.Mask2FormerImageProcessor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.Mask2FormerImageProcessor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation">Mask2FormerForUniversalSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If left to None, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L883",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),Ho=new $({props:{name:"post_process_instance_segmentation",anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"},{name:"return_binary_maps",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation">Mask2FormerForUniversalSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If left to None, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE) format.`,name:"return_coco_annotation"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_instance_segmentation.return_binary_maps",description:`<strong>return_binary_maps</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If set to <code>True</code>, segmentation maps are returned as a concatenated tensor of binary segmentation maps
(one per detected instance).`,name:"return_binary_maps"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L938",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Bo=new $({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<code>Mask2FormerForUniversalSegmentationOutput</code>) &#x2014;
The outputs from <a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation">Mask2FormerForUniversalSegmentation</a>.`,name:"outputs"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If left to None, predictions will not be
resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_mask2former.py#L1056",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code>, set
to <code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized
to the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Yo=new R({}),Ko=new $({props:{name:"class transformers.Mask2FormerModel",anchor:"transformers.Mask2FormerModel",parameters:[{name:"config",val:": Mask2FormerConfig"}],parametersDescription:[{anchor:"transformers.Mask2FormerModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig">Mask2FormerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L2215"}}),Zo=new $({props:{name:"forward",anchor:"transformers.Mask2FormerModel.forward",parameters:[{name:"pixel_values",val:": Tensor"},{name:"pixel_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Mask2FormerModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<code>AutoFeatureExtractor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.Mask2FormerModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.Mask2FormerModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Mask2FormerModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of Detr&#x2019;s decoder attention layers.`,name:"output_attentions"},{anchor:"transformers.Mask2FormerModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <code>~Mask2FormerModelOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L2225",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput"
>transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"
>Mask2FormerConfig</a>) and inputs.</p>
<ul>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) \u2014 Last hidden states (final feature map) of the last stage of the encoder model (backbone). Returned when
<code>output_hidden_states=True</code> is passed.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) \u2014 Last hidden states (final feature map) of the last stage of the pixel decoder model.</li>
<li><strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, , <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) \u2014 Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.</li>
<li><strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>transformer_decoder_intermediate_states</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(num_queries, 1, hidden_size)</code>) \u2014 Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.</li>
<li><strong>masks_queries_logits</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(batch_size, num_queries, height, width)</code>)
Mask Predictions from each layer in the transformer decoder.</li>
<li><strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self attentions weights from transformer decoder.</li>
</ul>
<p><code>Mask2FormerModelOutput</code></p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput"
>transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),De=new an({props:{$$slots:{default:[Gp]},$$scope:{ctx:x}}}),Ue=new jt({props:{anchor:"transformers.Mask2FormerModel.forward.example",$$slots:{default:[Yp]},$$scope:{ctx:x}}}),Jo=new R({}),et=new $({props:{name:"class transformers.Mask2FormerForUniversalSegmentation",anchor:"transformers.Mask2FormerForUniversalSegmentation",parameters:[{name:"config",val:": Mask2FormerConfig"}],parametersDescription:[{anchor:"transformers.Mask2FormerForUniversalSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig">Mask2FormerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L2319"}}),st=new $({props:{name:"forward",anchor:"transformers.Mask2FormerForUniversalSegmentation.forward",parameters:[{name:"pixel_values",val:": Tensor"},{name:"mask_labels",val:": typing.Optional[typing.List[torch.Tensor]] = None"},{name:"class_labels",val:": typing.Optional[typing.List[torch.Tensor]] = None"},{name:"pixel_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_auxiliary_logits",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<code>AutoFeatureExtractor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of Detr&#x2019;s decoder attention layers.`,name:"output_attentions"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <code>~Mask2FormerModelOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.mask_labels",description:`<strong>mask_labels</strong> (<code>List[torch.Tensor]</code>, <em>optional</em>) &#x2014;
List of mask labels of shape <code>(num_labels, height, width)</code> to be fed to a model`,name:"mask_labels"},{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.class_labels",description:`<strong>class_labels</strong> (<code>List[torch.LongTensor]</code>, <em>optional</em>) &#x2014;
list of target class labels of shape <code>(num_labels, height, width)</code> to be fed to a model. They identify the
labels of <code>mask_labels</code>, e.g. the label of <code>mask_labels[i][j]</code> if <code>class_labels[i][j]</code>.`,name:"class_labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_mask2former.py#L2372",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput"
>transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"
>Mask2FormerConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.Tensor</code>, <em>optional</em>) \u2014 The computed loss, returned when labels are present.</li>
<li><strong>class_queries_logits</strong> (<code>torch.FloatTensor</code>) \u2014 A tensor of shape <code>(batch_size, num_queries, num_labels + 1)</code> representing the proposed classes for each
query. Note the <code>+ 1</code> is needed because we incorporate the null class.</li>
<li><strong>masks_queries_logits</strong> (<code>torch.FloatTensor</code>) \u2014 A tensor of shape <code>(batch_size, num_queries, height, width)</code> representing the proposed masks for each
query.</li>
<li><strong>auxiliary_logits</strong> (<code>List[Dict(str, torch.FloatTensor)]</code>, <em>optional</em>) \u2014 List of class and mask predictions from each layer of the transformer decoder.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) \u2014 Last hidden states (final feature map) of the last stage of the encoder model (backbone).</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage.</li>
<li><strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) \u2014 Last hidden states (final feature map) of the last stage of the pixel decoder model.</li>
<li><strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage.</li>
<li><strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) \u2014 Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.</li>
<li><strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage.</li>
<li><strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self and Cross Attentions weights from transformer decoder.</li>
</ul>
<p><code>Mask2FormerUniversalSegmentationOutput</code></p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput"
>transformers.models.mask2former.modeling_mask2former.Mask2FormerForUniversalSegmentationOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),He=new an({props:{$$slots:{default:[Kp]},$$scope:{ctx:x}}}),We=new jt({props:{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.example",$$slots:{default:[Xp]},$$scope:{ctx:x}}}),Be=new jt({props:{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.example-2",$$slots:{default:[Qp]},$$scope:{ctx:x}}}),Ge=new jt({props:{anchor:"transformers.Mask2FormerForUniversalSegmentation.forward.example-3",$$slots:{default:[Zp]},$$scope:{ctx:x}}}),rt=new R({}),at=new $({props:{name:"class transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput",anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput",parameters:[{name:"encoder_last_hidden_state",val:": FloatTensor = None"},{name:"pixel_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"transformer_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"pixel_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_intermediate_states",val:": typing.Tuple[torch.FloatTensor] = None"},{name:"masks_queries_logits",val:": typing.Tuple[torch.FloatTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) &#x2014;
Last hidden states (final feature map) of the last stage of the encoder model (backbone). Returned when
<code>output_hidden_states=True</code> is passed.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"encoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.pixel_decoder_last_hidden_state",description:`<strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) &#x2014;
Last hidden states (final feature map) of the last stage of the pixel decoder model.`,name:"pixel_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.pixel_decoder_hidden_states",description:`<strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, , <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"pixel_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.transformer_decoder_last_hidden_state",description:`<strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) &#x2014;
Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.`,name:"transformer_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.transformer_decoder_hidden_states",description:`<strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.`,name:"transformer_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.transformer_decoder_intermediate_states",description:`<strong>transformer_decoder_intermediate_states</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(num_queries, 1, hidden_size)</code>) &#x2014;
Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.`,name:"transformer_decoder_intermediate_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.masks_queries_logits",description:`<strong>masks_queries_logits</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(batch_size, num_queries, height, width)</code>) &#x2014;
Mask Predictions from each layer in the transformer decoder.`,name:"masks_queries_logits"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self attentions weights from transformer decoder.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L147"}}),it=new $({props:{name:"class transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput",anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"class_queries_logits",val:": FloatTensor = None"},{name:"masks_queries_logits",val:": FloatTensor = None"},{name:"auxiliary_logits",val:": typing.Union[typing.List[typing.Dict[str, torch.FloatTensor]], NoneType] = None"},{name:"encoder_last_hidden_state",val:": FloatTensor = None"},{name:"pixel_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"transformer_decoder_last_hidden_state",val:": FloatTensor = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"pixel_decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"transformer_decoder_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.loss",description:`<strong>loss</strong> (<code>torch.Tensor</code>, <em>optional</em>) &#x2014;
The computed loss, returned when labels are present.`,name:"loss"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.class_queries_logits",description:`<strong>class_queries_logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
A tensor of shape <code>(batch_size, num_queries, num_labels + 1)</code> representing the proposed classes for each
query. Note the <code>+ 1</code> is needed because we incorporate the null class.`,name:"class_queries_logits"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.masks_queries_logits",description:`<strong>masks_queries_logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
A tensor of shape <code>(batch_size, num_queries, height, width)</code> representing the proposed masks for each
query.`,name:"masks_queries_logits"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.auxiliary_logits",description:`<strong>auxiliary_logits</strong> (<code>List[Dict(str, torch.FloatTensor)]</code>, <em>optional</em>) &#x2014;
List of class and mask predictions from each layer of the transformer decoder.`,name:"auxiliary_logits"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Last hidden states (final feature map) of the last stage of the encoder model (backbone).`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage.`,name:"encoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.pixel_decoder_last_hidden_state",description:`<strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Last hidden states (final feature map) of the last stage of the pixel decoder model.`,name:"pixel_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.pixel_decoder_hidden_states",description:`<strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage.`,name:"pixel_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.transformer_decoder_last_hidden_state",description:`<strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) &#x2014;
Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.`,name:"transformer_decoder_last_hidden_state"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.transformer_decoder_hidden_states",description:`<strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage.`,name:"transformer_decoder_hidden_states"},{anchor:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self and Cross Attentions weights from transformer decoder.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L194"}}),mt=new R({}),ct=new $({props:{name:"class transformers.VideoMask2FormerImageProcessor",anchor:"transformers.VideoMask2FormerImageProcessor",parameters:[{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"size_divisor",val:": int = 32"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": float = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float]] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float]] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.VideoMask2FormerImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the input to a certain <code>size</code>.`,name:"do_resize"},{anchor:"transformers.VideoMask2FormerImageProcessor.size",description:`<strong>size</strong> (<code>int</code>, <em>optional</em>, defaults to 800) &#x2014;
Resize the input to the given size. Only has an effect if <code>do_resize</code> is set to <code>True</code>. If size is a
sequence like <code>(width, height)</code>, output size will be matched to this. If size is an int, smaller edge of
the image will be matched to this number. i.e, if <code>height &gt; width</code>, then image will be rescaled to <code>(size * height / width, size)</code>.`,name:"size"},{anchor:"transformers.VideoMask2FormerImageProcessor.max_size",description:`<strong>max_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1333) &#x2014;
The largest size an image dimension can have (otherwise it&#x2019;s capped). Only has an effect if <code>do_resize</code> is
set to <code>True</code>.`,name:"max_size"},{anchor:"transformers.VideoMask2FormerImageProcessor.resample",description:`<strong>resample</strong> (<code>int</code>, <em>optional</em>, defaults to <code>PIL.Image.Resampling.BILINEAR</code>) &#x2014;
An optional resampling filter. This can be one of <code>PIL.Image.Resampling.NEAREST</code>,
<code>PIL.Image.Resampling.BOX</code>, <code>PIL.Image.Resampling.BILINEAR</code>, <code>PIL.Image.Resampling.HAMMING</code>,
<code>PIL.Image.Resampling.BICUBIC</code> or <code>PIL.Image.Resampling.LANCZOS</code>. Only has an effect if <code>do_resize</code> is set
to <code>True</code>.`,name:"resample"},{anchor:"transformers.VideoMask2FormerImageProcessor.size_divisor",description:`<strong>size_divisor</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Some backbones need images divisible by a certain number. If not passed, it defaults to the value used in
Swin Transformer.`,name:"size_divisor"},{anchor:"transformers.VideoMask2FormerImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to rescale the input to a certain <code>scale</code>.`,name:"do_rescale"},{anchor:"transformers.VideoMask2FormerImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to 1/ 255) &#x2014;
Rescale the input by the given factor. Only has an effect if <code>do_rescale</code> is set to <code>True</code>.`,name:"rescale_factor"},{anchor:"transformers.VideoMask2FormerImageProcessor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to normalize the input with mean and standard deviation.`,name:"do_normalize"},{anchor:"transformers.VideoMask2FormerImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.485, 0.456, 0.406]</code>) &#x2014;
The sequence of means for each channel, to be used when normalizing images. Defaults to the ImageNet mean.`,name:"image_mean"},{anchor:"transformers.VideoMask2FormerImageProcessor.image_std",description:`<strong>image_std</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.229, 0.224, 0.225]</code>) &#x2014;
The sequence of standard deviations for each channel, to be used when normalizing images. Defaults to the
ImageNet std.`,name:"image_std"},{anchor:"transformers.VideoMask2FormerImageProcessor.ignore_index",description:`<strong>ignore_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Label to be assigned to background pixels in segmentation maps. If provided, segmentation map pixels
denoted with 0 (background) will be replaced with <code>ignore_index</code>.`,name:"ignore_index"},{anchor:"transformers.VideoMask2FormerImageProcessor.reduce_labels",description:`<strong>reduce_labels</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to decrement all label values of segmentation maps by 1. Usually used for datasets where 0
is used for background, and background itself is not included in all classes of a dataset (e.g. ADE20k).
The background label will be replaced by <code>ignore_index</code>.`,name:"reduce_labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_video_mask2former.py#L333"}}),ht=new $({props:{name:"preprocess",anchor:"transformers.VideoMask2FormerImageProcessor.preprocess",parameters:[{name:"video_frames",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"segmentation_maps",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')], NoneType] = None"},{name:"do_sampling",val:": bool = False"},{name:"instance_id_to_semantic_id",val:": typing.Union[typing.Dict[int, int], NoneType] = None"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"size_divisor",val:": typing.Optional[int] = None"},{name:"resample",val:": Resampling = None"},{name:"sampling_frame_range",val:": typing.Optional[int] = 20"},{name:"sampling_frame_num",val:": typing.Optional[int] = 2"},{name:"sampling_frame_shuffle",val:": typing.Optional[bool] = False"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Optional[float] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": typing.Optional[bool] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension] = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_video_mask2former.py#L635"}}),ft=new $({props:{name:"encode_inputs",anchor:"transformers.VideoMask2FormerImageProcessor.encode_inputs",parameters:[{name:"pixel_values_list",val:": typing.List[typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]]"},{name:"segmentation_maps",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]] = None"},{name:"instance_id_to_semantic_id",val:": typing.Union[typing.List[typing.Dict[int, int]], typing.Dict[int, int], NoneType] = None"},{name:"ignore_index",val:": typing.Optional[int] = None"},{name:"reduce_labels",val:": bool = False"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.VideoMask2FormerImageProcessor.encode_inputs.pixel_values_list",description:`<strong>pixel_values_list</strong> (<code>List[ImageInput]</code>) &#x2014;
List of images (pixel values) to be padded. Each image should be a tensor of shape <code>(channels, height, width)</code>.`,name:"pixel_values_list"},{anchor:"transformers.VideoMask2FormerImageProcessor.encode_inputs.segmentation_maps",description:`<strong>segmentation_maps</strong> (<code>ImageInput</code>, <em>optional</em>) &#x2014;
The corresponding semantic segmentation maps with the pixel-wise annotations.</p>
<p>(<code>bool</code>, <em>optional</em>, defaults to <code>True</code>):
Whether or not to pad images up to the largest image in a batch and create a pixel mask.</p>
<p>If left to the default, will return a pixel mask that is:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>`,name:"segmentation_maps"},{anchor:"transformers.VideoMask2FormerImageProcessor.encode_inputs.instance_id_to_semantic_id",description:`<strong>instance_id_to_semantic_id</strong> (<code>List[Dict[int, int]]</code> or <code>Dict[int, int]</code>, <em>optional</em>) &#x2014;
A mapping between object instance ids and class ids. If passed, <code>segmentation_maps</code> is treated as an
instance segmentation map where each pixel represents an instance id. Can be provided as a single
dictionary with a global/dataset-level mapping or as a list of dictionaries (one per image), to map
instance ids in each image separately.`,name:"instance_id_to_semantic_id"},{anchor:"transformers.VideoMask2FormerImageProcessor.encode_inputs.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of NumPy arrays. If set to <code>&apos;pt&apos;</code>, return PyTorch <code>torch.Tensor</code>
objects.`,name:"return_tensors"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_video_mask2former.py#L828",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li><strong>pixel_values</strong> \u2014 Pixel values to be fed to a model.</li>
<li><strong>pixel_mask</strong> \u2014 Pixel mask to be fed to a model (when <code>=True</code> or if <code>pixel_mask</code> is in
<code>self.model_input_names</code>).</li>
<li><strong>mask_labels</strong> \u2014 Optional list of mask labels of shape <code>(labels, num_frames, height, width)</code> to be fed
to a model (when <code>annotations</code> are provided).</li>
<li><strong>class_labels</strong> \u2014 Optional list of class labels of shape <code>(labels)</code> to be fed to a model (when
<code>annotations</code> are provided). They identify the labels of <code>mask_labels</code>, e.g. the label of
<code>mask_labels[i][j]</code> if <code>class_labels[i][j]</code>.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/image_processor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),ut=new $({props:{name:"post_process_instance_segmentation",anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"},{name:"return_binary_maps",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<code>VideoMask2FormerForVideoSegmentationOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If left to None, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE) format.`,name:"return_coco_annotation"},{anchor:"transformers.VideoMask2FormerImageProcessor.post_process_instance_segmentation.return_binary_maps",description:`<strong>return_binary_maps</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If set to <code>True</code>, segmentation maps are returned as a concatenated tensor of binary segmentation maps
(one per detected instance).`,name:"return_binary_maps"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/image_processing_video_mask2former.py#L953",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),kt=new R({}),vt=new $({props:{name:"class transformers.VideoMask2FormerModel",anchor:"transformers.VideoMask2FormerModel",parameters:[{name:"config",val:": Mask2FormerConfig"}],parametersDescription:[{anchor:"transformers.VideoMask2FormerModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig">Mask2FormerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L2300"}}),wt=new $({props:{name:"forward",anchor:"transformers.VideoMask2FormerModel.forward",parameters:[{name:"pixel_values",val:": Tensor"},{name:"pixel_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.VideoMask2FormerModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<code>AutoFeatureExtractor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.VideoMask2FormerModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.VideoMask2FormerModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.VideoMask2FormerModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of Detr&#x2019;s decoder attention layers.`,name:"output_attentions"},{anchor:"transformers.VideoMask2FormerModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <code>~VideoMask2FormerModelOutput</code> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L2310",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput"
>transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"
>Mask2FormerConfig</a>) and inputs.</p>
<ul>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) \u2014 Last hidden states (final feature map) of the last stage of the encoder model (backbone). Returned when
<code>output_hidden_states=True</code> is passed.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>, <em>optional</em>) \u2014 Last hidden states (final feature map) of the last stage of the pixel decoder model.</li>
<li><strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, , <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) \u2014 Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.</li>
<li><strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage. Returned when <code>output_hidden_states=True</code> is passed.</li>
<li><strong>transformer_decoder_intermediate_states</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(num_queries, 1, hidden_size)</code>) \u2014 Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.</li>
<li><strong>masks_queries_logits</strong> (<code>tuple(torch.FloatTensor)</code> of shape <code>(batch_size, num_queries, height, width)</code>)
Mask Predictions from each layer in the transformer decoder.</li>
<li><strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self attentions weights from transformer decoder.</li>
</ul>
<p><code>VideoMask2FormerModelOutput</code></p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput"
>transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ze=new an({props:{$$slots:{default:[Jp]},$$scope:{ctx:x}}}),Je=new jt({props:{anchor:"transformers.VideoMask2FormerModel.forward.example",$$slots:{default:[eh]},$$scope:{ctx:x}}}),yt=new R({}),Mt=new $({props:{name:"class transformers.VideoMask2FormerForVideoSegmentation",anchor:"transformers.VideoMask2FormerForVideoSegmentation",parameters:[{name:"config",val:": Mask2FormerConfig"}],parametersDescription:[{anchor:"transformers.VideoMask2FormerForVideoSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig">Mask2FormerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L2408"}}),xt=new $({props:{name:"forward",anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward",parameters:[{name:"pixel_values",val:": Tensor"},{name:"mask_labels",val:": typing.Optional[typing.List[torch.Tensor]] = None"},{name:"class_labels",val:": typing.Optional[typing.List[torch.Tensor]] = None"},{name:"pixel_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"output_auxiliary_logits",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<code>AutoFeatureExtractor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of Detr&#x2019;s decoder attention layers.`,name:"output_attentions"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <code>~VideoMask2FormerModelOutput</code> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.mask_labels",description:`<strong>mask_labels</strong> (<code>List[torch.Tensor]</code>, <em>optional</em>) &#x2014;
List of mask labels of shape <code>(num_labels, height, width)</code> to be fed to a model`,name:"mask_labels"},{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.class_labels",description:`<strong>class_labels</strong> (<code>List[torch.LongTensor]</code>, <em>optional</em>) &#x2014;
list of target class labels of shape <code>(num_labels, height, width)</code> to be fed to a model. They identify the
labels of <code>mask_labels</code>, e.g. the label of <code>mask_labels[i][j]</code> if <code>class_labels[i][j]</code>.`,name:"class_labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mask2former/modeling_video_mask2former.py#L2461",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput"
>transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"
>Mask2FormerConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.Tensor</code>, <em>optional</em>) \u2014 The computed loss, returned when labels are present.</li>
<li><strong>class_queries_logits</strong> (<code>torch.FloatTensor</code>) \u2014 A tensor of shape <code>(batch_size, num_queries, num_labels + 1)</code> representing the proposed classes for each
query. Note the <code>+ 1</code> is needed because we incorporate the null class.</li>
<li><strong>masks_queries_logits</strong> (<code>torch.FloatTensor</code>) \u2014 A tensor of shape <code>(batch_size, num_queries, height, width)</code> representing the proposed masks for each
query.</li>
<li><strong>auxiliary_logits</strong> (<code>List[Dict(str, torch.FloatTensor)]</code>, <em>optional</em>) \u2014 List of class and mask predictions from each layer of the transformer decoder.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) \u2014 Last hidden states (final feature map) of the last stage of the encoder model (backbone).</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the encoder
model at the output of each stage.</li>
<li><strong>pixel_decoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) \u2014 Last hidden states (final feature map) of the last stage of the pixel decoder model.</li>
<li><strong>pixel_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, num_channels, height, width)</code>. Hidden-states (also called feature maps) of the pixel
decoder model at the output of each stage.</li>
<li><strong>transformer_decoder_last_hidden_state</strong> (<code>tuple(torch.FloatTensor)</code>) \u2014 Final output of the transformer decoder <code>(batch_size, sequence_length, hidden_size)</code>.</li>
<li><strong>transformer_decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states (also called feature maps) of the
transformer decoder at the output of each stage.</li>
<li><strong>attentions</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Self and Cross Attentions weights from transformer decoder.</li>
</ul>
<p><code>Mask2FormerVideoSegmentationOutput</code></p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput"
>transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerForVideoSegmentationOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),oo=new an({props:{$$slots:{default:[oh]},$$scope:{ctx:x}}}),to=new jt({props:{anchor:"transformers.VideoMask2FormerForVideoSegmentation.forward.example",$$slots:{default:[th]},$$scope:{ctx:x}}}),{c(){h=s("meta"),T=m(),_=s("h1"),g=s("a"),k=s("span"),v(d.$$.fragment),u=m(),z=s("span"),nn=n("Mask2Former"),Or=m(),ae=s("h2"),$e=s("a"),Es=s("span"),v(co.$$.fragment),dn=m(),qs=s("span"),ln=n("Overview"),Vr=m(),ee=s("p"),mn=n("The Mask2Former model was proposed in "),po=s("a"),cn=n("Masked-attention Mask Transformer for Universal Image Segmentation"),pn=n(" by Bowen Cheng, Ishan Misra, Alexander G. Schwing, Alexander Kirillov, Rohit Girdhar. Mask2Former is a unified framework for panoptic, instance and semantic segmentation and features significant performance and efficiency improvements over "),qt=s("a"),hn=n("MaskFormer"),fn=n("."),Sr=m(),Ot=s("p"),gn=n("The abstract from the paper is the following:"),Ar=m(),Vt=s("p"),Os=s("em"),un=n(`Image segmentation groups pixels with different semantics, e.g., category or instance membership. Each choice
of semantics defines a task. While only the semantics of each task differ, current research focuses on designing specialized architectures for each task. We present Masked-attention Mask Transformer (Mask2Former), a new architecture capable of addressing any image segmentation task (panoptic, instance or semantic). Its key components include masked attention, which extracts localized features by constraining cross-attention within predicted mask regions. In addition to reducing the research effort by at least three times, it outperforms the best specialized architectures by a significant margin on four popular datasets. Most notably, Mask2Former sets a new state-of-the-art for panoptic segmentation (57.8 PQ on COCO), instance segmentation (50.1 AP on COCO) and semantic segmentation (57.7 mIoU on ADE20K).`),Lr=m(),xe=s("p"),_n=n("A follow up work on Mask2Former for video segmentation was also released in "),ho=s("a"),kn=n("Mask2Former for Video Instance Segmentation"),vn=n(" by Bowen Cheng, Anwesa Choudhuri, Ishan Misra, Alexander Kirillov, Rohit Girdhar, Alexander G. Schwing."),Nr=m(),St=s("p"),bn=n("The abstract from the video instance segmentation paper is the following:"),Cr=m(),At=s("p"),Vs=s("em"),Fn=n("We find Mask2Former also achieves state-of-the-art performance on video instance segmentation without modifying the architecture, the loss or even the training pipeline. In this report, we show universal image segmentation architectures trivially generalize to video segmentation by directly predicting 3D segmentation volumes. Specifically, Mask2Former sets a new state-of-the-art of 60.4 AP on YouTubeVIS-2019 and 52.6 AP on YouTubeVIS-2021. We believe Mask2Former is also capable of handling video semantic and panoptic segmentation, given its versatility in image segmentation. We hope this will make state-of-the-art video segmentation research more accessible and bring more attention to designing universal image and video segmentation architectures."),Dr=m(),Lt=s("p"),wn=n("Tips:"),Ur=m(),oe=s("ul"),H=s("li"),yn=n("Mask2Former uses the same preprocessing and postprocessing steps as "),Nt=s("a"),Mn=n("MaskFormer"),Tn=n(". Use "),Ct=s("a"),$n=n("Mask2FormerImageProcessor"),xn=n(" or "),Dt=s("a"),In=n("AutoImageProcessor"),Pn=n(" to prepare images and optional targets for the model."),jn=m(),O=s("li"),zn=n("To get the final segmentation, depending on the task, you can call "),Ut=s("a"),En=n("post_process_semantic_segmentation()"),qn=n(" or "),Rt=s("a"),On=n("post_process_instance_segmentation()"),Vn=n(" or "),Ht=s("a"),Sn=n("post_process_panoptic_segmentation()"),An=n(". All three tasks can be solved using "),Wt=s("a"),Ln=n("Mask2FormerForUniversalSegmentation"),Nn=n(" output, panoptic segmentation accepts an optional "),Ss=s("code"),Cn=n("label_ids_to_fuse"),Dn=n(" argument to fuse instances of the target object/s (e.g. sky) together."),Un=m(),fo=s("li"),Rn=n("To get the final segmentation result for video instance segmentation task, you can call "),Bt=s("a"),Hn=n("post_process_instance_segmentation()"),Wn=n("."),Rr=m(),Ie=s("img"),Hr=m(),go=s("small"),Bn=n("Mask2Former architecture. Taken from the "),Gt=s("a"),Gn=n("original paper."),Wr=m(),L=s("p"),Yn=n("This model was contributed by "),uo=s("a"),Kn=n("Shivalika Singh"),Xn=n(" and "),_o=s("a"),Qn=n("Alara Dirik"),Zn=n(". The original code can be found "),ko=s("a"),Jn=n("here"),ei=n("."),Br=m(),ne=s("h2"),Pe=s("a"),As=s("span"),v(vo.$$.fragment),oi=m(),Ls=s("span"),ti=n("Resources"),Gr=m(),Yt=s("p"),si=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with Mask2Former."),Yr=m(),je=s("ul"),bo=s("li"),ri=n("Demo notebooks regarding inference + fine-tuning Mask2Former on custom data can be found "),Fo=s("a"),ai=n("here"),ni=n("."),ii=m(),ie=s("li"),di=n("An extensive tutorial to fine-tune Mask2Former\u2019s predecessor "),Kt=s("a"),li=n("MaskFormer"),mi=n(" for the instance segmentation task can be found "),wo=s("a"),ci=n("here"),pi=n(". The same steps can be used to fine-tune Mask2Former once the image processor and model names are replaced with the corresponding Mask2Former class names."),Kr=m(),Xt=s("p"),hi=n(`If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we will review it.
The resource should ideally demonstrate something new instead of duplicating an existing resource.`),Xr=m(),de=s("h2"),ze=s("a"),Ns=s("span"),v(yo.$$.fragment),fi=m(),Cs=s("span"),gi=n("Mask2Former specific outputs"),Qr=m(),le=s("div"),v(Mo.$$.fragment),ui=m(),To=s("p"),_i=n("Class for outputs of "),Qt=s("a"),ki=n("Mask2FormerModel"),vi=n(". This class returns all the needed hidden states to compute the logits."),Zr=m(),W=s("div"),v($o.$$.fragment),bi=m(),xo=s("p"),Fi=n("Class for outputs of "),Ds=s("code"),wi=n("Mask2FormerForUniversalSegmentationOutput"),yi=n("."),Mi=m(),B=s("p"),Ti=n("This output can be directly passed to "),Zt=s("a"),$i=n("post_process_semantic_segmentation()"),xi=n(` or
`),Jt=s("a"),Ii=n("post_process_instance_segmentation()"),Pi=n(` or
`),es=s("a"),ji=n("post_process_panoptic_segmentation()"),zi=n(" to compute final segmentation maps. Please, see\n[`~Mask2FormerImageProcessor] for details regarding usage."),Jr=m(),me=s("h2"),Ee=s("a"),Us=s("span"),v(Io.$$.fragment),Ei=m(),Rs=s("span"),qi=n("Mask2FormerConfig"),ea=m(),P=s("div"),v(Po.$$.fragment),Oi=m(),ce=s("p"),Vi=n("This is the configuration class to store the configuration of a "),os=s("a"),Si=n("Mask2FormerModel"),Ai=n(`. It is used to instantiate a
Mask2Former model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the Mask2Former
`),jo=s("a"),Li=n("facebook/mask2former-swin-small-coco-instance"),Ni=n(`
architecture.`),Ci=m(),pe=s("p"),Di=n("Configuration objects inherit from "),ts=s("a"),Ui=n("PretrainedConfig"),Ri=n(` and can be used to control the model outputs. Read the
documentation from `),ss=s("a"),Hi=n("PretrainedConfig"),Wi=n(" for more information."),Bi=m(),zo=s("p"),Gi=n("Currently, Mask2Former only supports the "),rs=s("a"),Yi=n("Swin Transformer"),Ki=n(" as backbone."),Xi=m(),v(qe.$$.fragment),Qi=m(),Oe=s("div"),v(Eo.$$.fragment),Zi=m(),qo=s("p"),Ji=n("Instantiate a "),as=s("a"),ed=n("Mask2FormerConfig"),od=n(" (or a derived class) from a pre-trained backbone model configuration."),td=m(),Ve=s("div"),v(Oo.$$.fragment),sd=m(),Vo=s("p"),rd=n("Serializes this instance to a Python dictionary. Override the default "),ns=s("a"),ad=n("to_dict()"),nd=n("."),oa=m(),he=s("h2"),Se=s("a"),Hs=s("span"),v(So.$$.fragment),id=m(),Ws=s("span"),dd=n("Mask2FormerImageProcessor"),ta=m(),I=s("div"),v(Ao.$$.fragment),ld=m(),Bs=s("p"),md=n(`Constructs a Mask2Former image processor. The image processor can be used to prepare image(s) and optional targets
for the model.`),cd=m(),Lo=s("p"),pd=n("This image processor inherits from "),Gs=s("code"),hd=n("BaseImageProcessor"),fd=n(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),gd=m(),is=s("div"),v(No.$$.fragment),ud=m(),te=s("div"),v(Co.$$.fragment),_d=m(),Do=s("p"),kd=n("Pad images up to the largest image in a batch and create a corresponding "),Ys=s("code"),vd=n("pixel_mask"),bd=n("."),Fd=m(),G=s("p"),wd=n(`Mask2Former addresses semantic segmentation with a mask classification paradigm, thus input segmentation maps
will be converted to lists of binary masks and their respective labels. Let\u2019s see an example, assuming
`),Ks=s("code"),yd=n("segmentation_maps = [[2,6,7,9]]"),Md=n(", the output will contain "),Xs=s("code"),Td=n("mask_labels = [[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]"),$d=n(" (four binary masks) and "),Qs=s("code"),xd=n("class_labels = [2,6,7,9]"),Id=n(`, the labels for
each mask.`),Pd=m(),Ae=s("div"),v(Uo.$$.fragment),jd=m(),Ro=s("p"),zd=n("Converts the output of "),ds=s("a"),Ed=n("Mask2FormerForUniversalSegmentation"),qd=n(` into semantic segmentation maps. Only supports
PyTorch.`),Od=m(),Le=s("div"),v(Ho.$$.fragment),Vd=m(),Wo=s("p"),Sd=n("Converts the output of "),Zs=s("code"),Ad=n("Mask2FormerForUniversalSegmentationOutput"),Ld=n(` into instance segmentation predictions.
Only supports PyTorch.`),Nd=m(),Ne=s("div"),v(Bo.$$.fragment),Cd=m(),Go=s("p"),Dd=n("Converts the output of "),Js=s("code"),Ud=n("Mask2FormerForUniversalSegmentationOutput"),Rd=n(` into image panoptic segmentation
predictions. Only supports PyTorch.`),sa=m(),fe=s("h2"),Ce=s("a"),er=s("span"),v(Yo.$$.fragment),Hd=m(),or=s("span"),Wd=n("Mask2FormerModel"),ra=m(),Y=s("div"),v(Ko.$$.fragment),Bd=m(),Xo=s("p"),Gd=n(`The bare Mask2Former Model outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Qo=s("a"),Yd=n("torch.nn.Module"),Kd=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Xd=m(),N=s("div"),v(Zo.$$.fragment),Qd=m(),ge=s("p"),Zd=n("The "),ls=s("a"),Jd=n("Mask2FormerModel"),el=n(" forward method, overrides the "),tr=s("code"),ol=n("__call__"),tl=n(" special method."),sl=m(),v(De.$$.fragment),rl=m(),v(Ue.$$.fragment),aa=m(),ue=s("h2"),Re=s("a"),sr=s("span"),v(Jo.$$.fragment),al=m(),rr=s("span"),nl=n("Mask2FormerForUniversalSegmentation"),na=m(),K=s("div"),v(et.$$.fragment),il=m(),ot=s("p"),dl=n(`The Mask2Former Model with heads on top for instance/semantic/panoptic segmentation.
This model is a PyTorch `),tt=s("a"),ll=n("torch.nn.Module"),ml=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),cl=m(),j=s("div"),v(st.$$.fragment),pl=m(),_e=s("p"),hl=n("The "),ms=s("a"),fl=n("Mask2FormerForUniversalSegmentation"),gl=n(" forward method, overrides the "),ar=s("code"),ul=n("__call__"),_l=n(" special method."),kl=m(),v(He.$$.fragment),vl=m(),nr=s("p"),bl=n("Examples:"),Fl=m(),v(We.$$.fragment),wl=m(),v(Be.$$.fragment),yl=m(),v(Ge.$$.fragment),ia=m(),ke=s("h2"),Ye=s("a"),ir=s("span"),v(rt.$$.fragment),Ml=m(),dr=s("span"),Tl=n("Video Mask2Former specific outputs"),da=m(),ve=s("div"),v(at.$$.fragment),$l=m(),nt=s("p"),xl=n("Class for outputs of "),cs=s("a"),Il=n("VideoMask2FormerModel"),Pl=n(`. This class returns all the needed hidden states to compute the
logits.`),la=m(),X=s("div"),v(it.$$.fragment),jl=m(),dt=s("p"),zl=n("Class for outputs of "),lr=s("code"),El=n("VideoMask2FormerForVideoSegmentationOutput"),ql=n("."),Ol=m(),lt=s("p"),Vl=n("This output can be directly passed to "),ps=s("a"),Sl=n("post_process_instance_segmentation()"),Al=n(" to compute\nfinal segmentation maps. Please, see [`~Mask2FormerImageProcessor] for details regarding usage."),ma=m(),be=s("h2"),Ke=s("a"),mr=s("span"),v(mt.$$.fragment),Ll=m(),cr=s("span"),Nl=n("VideoMask2FormerImageProcessor"),ca=m(),E=s("div"),v(ct.$$.fragment),Cl=m(),pr=s("p"),Dl=n(`Constructs a Video Mask2Former image processor. The image processor can be used to prepare image(s) and optional
targets for the model.`),Ul=m(),pt=s("p"),Rl=n("This image processor inherits from "),hr=s("code"),Hl=n("BaseImageProcessor"),Wl=n(` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),Bl=m(),hs=s("div"),v(ht.$$.fragment),Gl=m(),se=s("div"),v(ft.$$.fragment),Yl=m(),gt=s("p"),Kl=n("Pad images up to the largest image in a batch and create a corresponding "),fr=s("code"),Xl=n("pixel_mask"),Ql=n("."),Zl=m(),Q=s("p"),Jl=n(`Video Mask2Former addresses semantic segmentation with a mask classification paradigm, thus input segmentation
maps will be converted to lists of binary masks and their respective labels. Let\u2019s see an example, assuming
`),gr=s("code"),em=n("segmentation_maps = [[2,6,7,9]]"),om=n(", the output will contain "),ur=s("code"),tm=n("mask_labels = [[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]"),sm=n(" (four binary masks) and "),_r=s("code"),rm=n("class_labels = [2,6,7,9]"),am=n(`, the labels for
each mask.`),nm=m(),Xe=s("div"),v(ut.$$.fragment),im=m(),_t=s("p"),dm=n("Converts the output of "),kr=s("code"),lm=n("VideoMask2FormerForVideoSegmentationOutput"),mm=n(` into instance segmentation predictions.
Only supports PyTorch.`),pa=m(),Fe=s("h2"),Qe=s("a"),vr=s("span"),v(kt.$$.fragment),cm=m(),br=s("span"),pm=n("VideoMask2FormerModel"),ha=m(),Z=s("div"),v(vt.$$.fragment),hm=m(),bt=s("p"),fm=n(`The bare Video Mask2Former Model outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Ft=s("a"),gm=n("torch.nn.Module"),um=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),_m=m(),C=s("div"),v(wt.$$.fragment),km=m(),we=s("p"),vm=n("The "),fs=s("a"),bm=n("VideoMask2FormerModel"),Fm=n(" forward method, overrides the "),Fr=s("code"),wm=n("__call__"),ym=n(" special method."),Mm=m(),v(Ze.$$.fragment),Tm=m(),v(Je.$$.fragment),fa=m(),ye=s("h2"),eo=s("a"),wr=s("span"),v(yt.$$.fragment),$m=m(),yr=s("span"),xm=n("VideoMask2FormerForVideoSegmentation"),ga=m(),J=s("div"),v(Mt.$$.fragment),Im=m(),Tt=s("p"),Pm=n(`The Video Mask2Former model with heads on top for video segmentation.
This model is a PyTorch `),$t=s("a"),jm=n("torch.nn.Module"),zm=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Em=m(),V=s("div"),v(xt.$$.fragment),qm=m(),Me=s("p"),Om=n("The "),gs=s("a"),Vm=n("VideoMask2FormerForVideoSegmentation"),Sm=n(" forward method, overrides the "),Mr=s("code"),Am=n("__call__"),Lm=n(" special method."),Nm=m(),v(oo.$$.fragment),Cm=m(),Tr=s("p"),Dm=n("Examples:"),Um=m(),v(to.$$.fragment),this.h()},l(o){const p=Rp('[data-svelte="svelte-1phssyn"]',document.head);h=r(p,"META",{name:!0,content:!0}),p.forEach(t),T=c(o),_=r(o,"H1",{class:!0});var It=a(_);g=r(It,"A",{id:!0,class:!0,href:!0});var $r=a(g);k=r($r,"SPAN",{});var xr=a(k);b(d.$$.fragment,xr),xr.forEach(t),$r.forEach(t),u=c(It),z=r(It,"SPAN",{});var Ir=a(z);nn=i(Ir,"Mask2Former"),Ir.forEach(t),It.forEach(t),Or=c(o),ae=r(o,"H2",{class:!0});var Pt=a(ae);$e=r(Pt,"A",{id:!0,class:!0,href:!0});var Pr=a($e);Es=r(Pr,"SPAN",{});var jr=a(Es);b(co.$$.fragment,jr),jr.forEach(t),Pr.forEach(t),dn=c(Pt),qs=r(Pt,"SPAN",{});var zr=a(qs);ln=i(zr,"Overview"),zr.forEach(t),Pt.forEach(t),Vr=c(o),ee=r(o,"P",{});var Te=a(ee);mn=i(Te,"The Mask2Former model was proposed in "),po=r(Te,"A",{href:!0,rel:!0});var Er=a(po);cn=i(Er,"Masked-attention Mask Transformer for Universal Image Segmentation"),Er.forEach(t),pn=i(Te," by Bowen Cheng, Ishan Misra, Alexander G. Schwing, Alexander Kirillov, Rohit Girdhar. Mask2Former is a unified framework for panoptic, instance and semantic segmentation and features significant performance and efficiency improvements over "),qt=r(Te,"A",{href:!0});var qr=a(qt);hn=i(qr,"MaskFormer"),qr.forEach(t),fn=i(Te,"."),Te.forEach(t),Sr=c(o),Ot=r(o,"P",{});var Wm=a(Ot);gn=i(Wm,"The abstract from the paper is the following:"),Wm.forEach(t),Ar=c(o),Vt=r(o,"P",{});var Bm=a(Vt);Os=r(Bm,"EM",{});var Gm=a(Os);un=i(Gm,`Image segmentation groups pixels with different semantics, e.g., category or instance membership. Each choice
of semantics defines a task. While only the semantics of each task differ, current research focuses on designing specialized architectures for each task. We present Masked-attention Mask Transformer (Mask2Former), a new architecture capable of addressing any image segmentation task (panoptic, instance or semantic). Its key components include masked attention, which extracts localized features by constraining cross-attention within predicted mask regions. In addition to reducing the research effort by at least three times, it outperforms the best specialized architectures by a significant margin on four popular datasets. Most notably, Mask2Former sets a new state-of-the-art for panoptic segmentation (57.8 PQ on COCO), instance segmentation (50.1 AP on COCO) and semantic segmentation (57.7 mIoU on ADE20K).`),Gm.forEach(t),Bm.forEach(t),Lr=c(o),xe=r(o,"P",{});var _a=a(xe);_n=i(_a,"A follow up work on Mask2Former for video segmentation was also released in "),ho=r(_a,"A",{href:!0,rel:!0});var Ym=a(ho);kn=i(Ym,"Mask2Former for Video Instance Segmentation"),Ym.forEach(t),vn=i(_a," by Bowen Cheng, Anwesa Choudhuri, Ishan Misra, Alexander Kirillov, Rohit Girdhar, Alexander G. Schwing."),_a.forEach(t),Nr=c(o),St=r(o,"P",{});var Km=a(St);bn=i(Km,"The abstract from the video instance segmentation paper is the following:"),Km.forEach(t),Cr=c(o),At=r(o,"P",{});var Xm=a(At);Vs=r(Xm,"EM",{});var Qm=a(Vs);Fn=i(Qm,"We find Mask2Former also achieves state-of-the-art performance on video instance segmentation without modifying the architecture, the loss or even the training pipeline. In this report, we show universal image segmentation architectures trivially generalize to video segmentation by directly predicting 3D segmentation volumes. Specifically, Mask2Former sets a new state-of-the-art of 60.4 AP on YouTubeVIS-2019 and 52.6 AP on YouTubeVIS-2021. We believe Mask2Former is also capable of handling video semantic and panoptic segmentation, given its versatility in image segmentation. We hope this will make state-of-the-art video segmentation research more accessible and bring more attention to designing universal image and video segmentation architectures."),Qm.forEach(t),Xm.forEach(t),Dr=c(o),Lt=r(o,"P",{});var Zm=a(Lt);wn=i(Zm,"Tips:"),Zm.forEach(t),Ur=c(o),oe=r(o,"UL",{});var us=a(oe);H=r(us,"LI",{});var so=a(H);yn=i(so,"Mask2Former uses the same preprocessing and postprocessing steps as "),Nt=r(so,"A",{href:!0});var Jm=a(Nt);Mn=i(Jm,"MaskFormer"),Jm.forEach(t),Tn=i(so,". Use "),Ct=r(so,"A",{href:!0});var ec=a(Ct);$n=i(ec,"Mask2FormerImageProcessor"),ec.forEach(t),xn=i(so," or "),Dt=r(so,"A",{href:!0});var oc=a(Dt);In=i(oc,"AutoImageProcessor"),oc.forEach(t),Pn=i(so," to prepare images and optional targets for the model."),so.forEach(t),jn=c(us),O=r(us,"LI",{});var D=a(O);zn=i(D,"To get the final segmentation, depending on the task, you can call "),Ut=r(D,"A",{href:!0});var tc=a(Ut);En=i(tc,"post_process_semantic_segmentation()"),tc.forEach(t),qn=i(D," or "),Rt=r(D,"A",{href:!0});var sc=a(Rt);On=i(sc,"post_process_instance_segmentation()"),sc.forEach(t),Vn=i(D," or "),Ht=r(D,"A",{href:!0});var rc=a(Ht);Sn=i(rc,"post_process_panoptic_segmentation()"),rc.forEach(t),An=i(D,". All three tasks can be solved using "),Wt=r(D,"A",{href:!0});var ac=a(Wt);Ln=i(ac,"Mask2FormerForUniversalSegmentation"),ac.forEach(t),Nn=i(D," output, panoptic segmentation accepts an optional "),Ss=r(D,"CODE",{});var nc=a(Ss);Cn=i(nc,"label_ids_to_fuse"),nc.forEach(t),Dn=i(D," argument to fuse instances of the target object/s (e.g. sky) together."),D.forEach(t),Un=c(us),fo=r(us,"LI",{});var ka=a(fo);Rn=i(ka,"To get the final segmentation result for video instance segmentation task, you can call "),Bt=r(ka,"A",{href:!0});var ic=a(Bt);Hn=i(ic,"post_process_instance_segmentation()"),ic.forEach(t),Wn=i(ka,"."),ka.forEach(t),us.forEach(t),Rr=c(o),Ie=r(o,"IMG",{src:!0,alt:!0,width:!0}),Hr=c(o),go=r(o,"SMALL",{});var Rm=a(go);Bn=i(Rm,"Mask2Former architecture. Taken from the "),Gt=r(Rm,"A",{href:!0});var dc=a(Gt);Gn=i(dc,"original paper."),dc.forEach(t),Rm.forEach(t),Wr=c(o),L=r(o,"P",{});var ro=a(L);Yn=i(ro,"This model was contributed by "),uo=r(ro,"A",{href:!0,rel:!0});var lc=a(uo);Kn=i(lc,"Shivalika Singh"),lc.forEach(t),Xn=i(ro," and "),_o=r(ro,"A",{href:!0,rel:!0});var mc=a(_o);Qn=i(mc,"Alara Dirik"),mc.forEach(t),Zn=i(ro,". The original code can be found "),ko=r(ro,"A",{href:!0,rel:!0});var cc=a(ko);Jn=i(cc,"here"),cc.forEach(t),ei=i(ro,"."),ro.forEach(t),Br=c(o),ne=r(o,"H2",{class:!0});var va=a(ne);Pe=r(va,"A",{id:!0,class:!0,href:!0});var pc=a(Pe);As=r(pc,"SPAN",{});var hc=a(As);b(vo.$$.fragment,hc),hc.forEach(t),pc.forEach(t),oi=c(va),Ls=r(va,"SPAN",{});var fc=a(Ls);ti=i(fc,"Resources"),fc.forEach(t),va.forEach(t),Gr=c(o),Yt=r(o,"P",{});var gc=a(Yt);si=i(gc,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with Mask2Former."),gc.forEach(t),Yr=c(o),je=r(o,"UL",{});var ba=a(je);bo=r(ba,"LI",{});var Fa=a(bo);ri=i(Fa,"Demo notebooks regarding inference + fine-tuning Mask2Former on custom data can be found "),Fo=r(Fa,"A",{href:!0,rel:!0});var uc=a(Fo);ai=i(uc,"here"),uc.forEach(t),ni=i(Fa,"."),Fa.forEach(t),ii=c(ba),ie=r(ba,"LI",{});var _s=a(ie);di=i(_s,"An extensive tutorial to fine-tune Mask2Former\u2019s predecessor "),Kt=r(_s,"A",{href:!0});var _c=a(Kt);li=i(_c,"MaskFormer"),_c.forEach(t),mi=i(_s," for the instance segmentation task can be found "),wo=r(_s,"A",{href:!0,rel:!0});var kc=a(wo);ci=i(kc,"here"),kc.forEach(t),pi=i(_s,". The same steps can be used to fine-tune Mask2Former once the image processor and model names are replaced with the corresponding Mask2Former class names."),_s.forEach(t),ba.forEach(t),Kr=c(o),Xt=r(o,"P",{});var vc=a(Xt);hi=i(vc,`If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we will review it.
The resource should ideally demonstrate something new instead of duplicating an existing resource.`),vc.forEach(t),Xr=c(o),de=r(o,"H2",{class:!0});var wa=a(de);ze=r(wa,"A",{id:!0,class:!0,href:!0});var bc=a(ze);Ns=r(bc,"SPAN",{});var Fc=a(Ns);b(yo.$$.fragment,Fc),Fc.forEach(t),bc.forEach(t),fi=c(wa),Cs=r(wa,"SPAN",{});var wc=a(Cs);gi=i(wc,"Mask2Former specific outputs"),wc.forEach(t),wa.forEach(t),Qr=c(o),le=r(o,"DIV",{class:!0});var ya=a(le);b(Mo.$$.fragment,ya),ui=c(ya),To=r(ya,"P",{});var Ma=a(To);_i=i(Ma,"Class for outputs of "),Qt=r(Ma,"A",{href:!0});var yc=a(Qt);ki=i(yc,"Mask2FormerModel"),yc.forEach(t),vi=i(Ma,". This class returns all the needed hidden states to compute the logits."),Ma.forEach(t),ya.forEach(t),Zr=c(o),W=r(o,"DIV",{class:!0});var ks=a(W);b($o.$$.fragment,ks),bi=c(ks),xo=r(ks,"P",{});var Ta=a(xo);Fi=i(Ta,"Class for outputs of "),Ds=r(Ta,"CODE",{});var Mc=a(Ds);wi=i(Mc,"Mask2FormerForUniversalSegmentationOutput"),Mc.forEach(t),yi=i(Ta,"."),Ta.forEach(t),Mi=c(ks),B=r(ks,"P",{});var ao=a(B);Ti=i(ao,"This output can be directly passed to "),Zt=r(ao,"A",{href:!0});var Tc=a(Zt);$i=i(Tc,"post_process_semantic_segmentation()"),Tc.forEach(t),xi=i(ao,` or
`),Jt=r(ao,"A",{href:!0});var $c=a(Jt);Ii=i($c,"post_process_instance_segmentation()"),$c.forEach(t),Pi=i(ao,` or
`),es=r(ao,"A",{href:!0});var xc=a(es);ji=i(xc,"post_process_panoptic_segmentation()"),xc.forEach(t),zi=i(ao," to compute final segmentation maps. Please, see\n[`~Mask2FormerImageProcessor] for details regarding usage."),ao.forEach(t),ks.forEach(t),Jr=c(o),me=r(o,"H2",{class:!0});var $a=a(me);Ee=r($a,"A",{id:!0,class:!0,href:!0});var Ic=a(Ee);Us=r(Ic,"SPAN",{});var Pc=a(Us);b(Io.$$.fragment,Pc),Pc.forEach(t),Ic.forEach(t),Ei=c($a),Rs=r($a,"SPAN",{});var jc=a(Rs);qi=i(jc,"Mask2FormerConfig"),jc.forEach(t),$a.forEach(t),ea=c(o),P=r(o,"DIV",{class:!0});var S=a(P);b(Po.$$.fragment,S),Oi=c(S),ce=r(S,"P",{});var vs=a(ce);Vi=i(vs,"This is the configuration class to store the configuration of a "),os=r(vs,"A",{href:!0});var zc=a(os);Si=i(zc,"Mask2FormerModel"),zc.forEach(t),Ai=i(vs,`. It is used to instantiate a
Mask2Former model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the Mask2Former
`),jo=r(vs,"A",{href:!0,rel:!0});var Ec=a(jo);Li=i(Ec,"facebook/mask2former-swin-small-coco-instance"),Ec.forEach(t),Ni=i(vs,`
architecture.`),vs.forEach(t),Ci=c(S),pe=r(S,"P",{});var bs=a(pe);Di=i(bs,"Configuration objects inherit from "),ts=r(bs,"A",{href:!0});var qc=a(ts);Ui=i(qc,"PretrainedConfig"),qc.forEach(t),Ri=i(bs,` and can be used to control the model outputs. Read the
documentation from `),ss=r(bs,"A",{href:!0});var Oc=a(ss);Hi=i(Oc,"PretrainedConfig"),Oc.forEach(t),Wi=i(bs," for more information."),bs.forEach(t),Bi=c(S),zo=r(S,"P",{});var xa=a(zo);Gi=i(xa,"Currently, Mask2Former only supports the "),rs=r(xa,"A",{href:!0});var Vc=a(rs);Yi=i(Vc,"Swin Transformer"),Vc.forEach(t),Ki=i(xa," as backbone."),xa.forEach(t),Xi=c(S),b(qe.$$.fragment,S),Qi=c(S),Oe=r(S,"DIV",{class:!0});var Ia=a(Oe);b(Eo.$$.fragment,Ia),Zi=c(Ia),qo=r(Ia,"P",{});var Pa=a(qo);Ji=i(Pa,"Instantiate a "),as=r(Pa,"A",{href:!0});var Sc=a(as);ed=i(Sc,"Mask2FormerConfig"),Sc.forEach(t),od=i(Pa," (or a derived class) from a pre-trained backbone model configuration."),Pa.forEach(t),Ia.forEach(t),td=c(S),Ve=r(S,"DIV",{class:!0});var ja=a(Ve);b(Oo.$$.fragment,ja),sd=c(ja),Vo=r(ja,"P",{});var za=a(Vo);rd=i(za,"Serializes this instance to a Python dictionary. Override the default "),ns=r(za,"A",{href:!0});var Ac=a(ns);ad=i(Ac,"to_dict()"),Ac.forEach(t),nd=i(za,"."),za.forEach(t),ja.forEach(t),S.forEach(t),oa=c(o),he=r(o,"H2",{class:!0});var Ea=a(he);Se=r(Ea,"A",{id:!0,class:!0,href:!0});var Lc=a(Se);Hs=r(Lc,"SPAN",{});var Nc=a(Hs);b(So.$$.fragment,Nc),Nc.forEach(t),Lc.forEach(t),id=c(Ea),Ws=r(Ea,"SPAN",{});var Cc=a(Ws);dd=i(Cc,"Mask2FormerImageProcessor"),Cc.forEach(t),Ea.forEach(t),ta=c(o),I=r(o,"DIV",{class:!0});var q=a(I);b(Ao.$$.fragment,q),ld=c(q),Bs=r(q,"P",{});var Dc=a(Bs);md=i(Dc,`Constructs a Mask2Former image processor. The image processor can be used to prepare image(s) and optional targets
for the model.`),Dc.forEach(t),cd=c(q),Lo=r(q,"P",{});var qa=a(Lo);pd=i(qa,"This image processor inherits from "),Gs=r(qa,"CODE",{});var Uc=a(Gs);hd=i(Uc,"BaseImageProcessor"),Uc.forEach(t),fd=i(qa,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),qa.forEach(t),gd=c(q),is=r(q,"DIV",{class:!0});var Rc=a(is);b(No.$$.fragment,Rc),Rc.forEach(t),ud=c(q),te=r(q,"DIV",{class:!0});var Fs=a(te);b(Co.$$.fragment,Fs),_d=c(Fs),Do=r(Fs,"P",{});var Oa=a(Do);kd=i(Oa,"Pad images up to the largest image in a batch and create a corresponding "),Ys=r(Oa,"CODE",{});var Hc=a(Ys);vd=i(Hc,"pixel_mask"),Hc.forEach(t),bd=i(Oa,"."),Oa.forEach(t),Fd=c(Fs),G=r(Fs,"P",{});var no=a(G);wd=i(no,`Mask2Former addresses semantic segmentation with a mask classification paradigm, thus input segmentation maps
will be converted to lists of binary masks and their respective labels. Let\u2019s see an example, assuming
`),Ks=r(no,"CODE",{});var Wc=a(Ks);yd=i(Wc,"segmentation_maps = [[2,6,7,9]]"),Wc.forEach(t),Md=i(no,", the output will contain "),Xs=r(no,"CODE",{});var Bc=a(Xs);Td=i(Bc,"mask_labels = [[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]"),Bc.forEach(t),$d=i(no," (four binary masks) and "),Qs=r(no,"CODE",{});var Gc=a(Qs);xd=i(Gc,"class_labels = [2,6,7,9]"),Gc.forEach(t),Id=i(no,`, the labels for
each mask.`),no.forEach(t),Fs.forEach(t),Pd=c(q),Ae=r(q,"DIV",{class:!0});var Va=a(Ae);b(Uo.$$.fragment,Va),jd=c(Va),Ro=r(Va,"P",{});var Sa=a(Ro);zd=i(Sa,"Converts the output of "),ds=r(Sa,"A",{href:!0});var Yc=a(ds);Ed=i(Yc,"Mask2FormerForUniversalSegmentation"),Yc.forEach(t),qd=i(Sa,` into semantic segmentation maps. Only supports
PyTorch.`),Sa.forEach(t),Va.forEach(t),Od=c(q),Le=r(q,"DIV",{class:!0});var Aa=a(Le);b(Ho.$$.fragment,Aa),Vd=c(Aa),Wo=r(Aa,"P",{});var La=a(Wo);Sd=i(La,"Converts the output of "),Zs=r(La,"CODE",{});var Kc=a(Zs);Ad=i(Kc,"Mask2FormerForUniversalSegmentationOutput"),Kc.forEach(t),Ld=i(La,` into instance segmentation predictions.
Only supports PyTorch.`),La.forEach(t),Aa.forEach(t),Nd=c(q),Ne=r(q,"DIV",{class:!0});var Na=a(Ne);b(Bo.$$.fragment,Na),Cd=c(Na),Go=r(Na,"P",{});var Ca=a(Go);Dd=i(Ca,"Converts the output of "),Js=r(Ca,"CODE",{});var Xc=a(Js);Ud=i(Xc,"Mask2FormerForUniversalSegmentationOutput"),Xc.forEach(t),Rd=i(Ca,` into image panoptic segmentation
predictions. Only supports PyTorch.`),Ca.forEach(t),Na.forEach(t),q.forEach(t),sa=c(o),fe=r(o,"H2",{class:!0});var Da=a(fe);Ce=r(Da,"A",{id:!0,class:!0,href:!0});var Qc=a(Ce);er=r(Qc,"SPAN",{});var Zc=a(er);b(Yo.$$.fragment,Zc),Zc.forEach(t),Qc.forEach(t),Hd=c(Da),or=r(Da,"SPAN",{});var Jc=a(or);Wd=i(Jc,"Mask2FormerModel"),Jc.forEach(t),Da.forEach(t),ra=c(o),Y=r(o,"DIV",{class:!0});var ws=a(Y);b(Ko.$$.fragment,ws),Bd=c(ws),Xo=r(ws,"P",{});var Ua=a(Xo);Gd=i(Ua,`The bare Mask2Former Model outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Qo=r(Ua,"A",{href:!0,rel:!0});var ep=a(Qo);Yd=i(ep,"torch.nn.Module"),ep.forEach(t),Kd=i(Ua,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ua.forEach(t),Xd=c(ws),N=r(ws,"DIV",{class:!0});var io=a(N);b(Zo.$$.fragment,io),Qd=c(io),ge=r(io,"P",{});var ys=a(ge);Zd=i(ys,"The "),ls=r(ys,"A",{href:!0});var op=a(ls);Jd=i(op,"Mask2FormerModel"),op.forEach(t),el=i(ys," forward method, overrides the "),tr=r(ys,"CODE",{});var tp=a(tr);ol=i(tp,"__call__"),tp.forEach(t),tl=i(ys," special method."),ys.forEach(t),sl=c(io),b(De.$$.fragment,io),rl=c(io),b(Ue.$$.fragment,io),io.forEach(t),ws.forEach(t),aa=c(o),ue=r(o,"H2",{class:!0});var Ra=a(ue);Re=r(Ra,"A",{id:!0,class:!0,href:!0});var sp=a(Re);sr=r(sp,"SPAN",{});var rp=a(sr);b(Jo.$$.fragment,rp),rp.forEach(t),sp.forEach(t),al=c(Ra),rr=r(Ra,"SPAN",{});var ap=a(rr);nl=i(ap,"Mask2FormerForUniversalSegmentation"),ap.forEach(t),Ra.forEach(t),na=c(o),K=r(o,"DIV",{class:!0});var Ms=a(K);b(et.$$.fragment,Ms),il=c(Ms),ot=r(Ms,"P",{});var Ha=a(ot);dl=i(Ha,`The Mask2Former Model with heads on top for instance/semantic/panoptic segmentation.
This model is a PyTorch `),tt=r(Ha,"A",{href:!0,rel:!0});var np=a(tt);ll=i(np,"torch.nn.Module"),np.forEach(t),ml=i(Ha,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ha.forEach(t),cl=c(Ms),j=r(Ms,"DIV",{class:!0});var A=a(j);b(st.$$.fragment,A),pl=c(A),_e=r(A,"P",{});var Ts=a(_e);hl=i(Ts,"The "),ms=r(Ts,"A",{href:!0});var ip=a(ms);fl=i(ip,"Mask2FormerForUniversalSegmentation"),ip.forEach(t),gl=i(Ts," forward method, overrides the "),ar=r(Ts,"CODE",{});var dp=a(ar);ul=i(dp,"__call__"),dp.forEach(t),_l=i(Ts," special method."),Ts.forEach(t),kl=c(A),b(He.$$.fragment,A),vl=c(A),nr=r(A,"P",{});var lp=a(nr);bl=i(lp,"Examples:"),lp.forEach(t),Fl=c(A),b(We.$$.fragment,A),wl=c(A),b(Be.$$.fragment,A),yl=c(A),b(Ge.$$.fragment,A),A.forEach(t),Ms.forEach(t),ia=c(o),ke=r(o,"H2",{class:!0});var Wa=a(ke);Ye=r(Wa,"A",{id:!0,class:!0,href:!0});var mp=a(Ye);ir=r(mp,"SPAN",{});var cp=a(ir);b(rt.$$.fragment,cp),cp.forEach(t),mp.forEach(t),Ml=c(Wa),dr=r(Wa,"SPAN",{});var pp=a(dr);Tl=i(pp,"Video Mask2Former specific outputs"),pp.forEach(t),Wa.forEach(t),da=c(o),ve=r(o,"DIV",{class:!0});var Ba=a(ve);b(at.$$.fragment,Ba),$l=c(Ba),nt=r(Ba,"P",{});var Ga=a(nt);xl=i(Ga,"Class for outputs of "),cs=r(Ga,"A",{href:!0});var hp=a(cs);Il=i(hp,"VideoMask2FormerModel"),hp.forEach(t),Pl=i(Ga,`. This class returns all the needed hidden states to compute the
logits.`),Ga.forEach(t),Ba.forEach(t),la=c(o),X=r(o,"DIV",{class:!0});var $s=a(X);b(it.$$.fragment,$s),jl=c($s),dt=r($s,"P",{});var Ya=a(dt);zl=i(Ya,"Class for outputs of "),lr=r(Ya,"CODE",{});var fp=a(lr);El=i(fp,"VideoMask2FormerForVideoSegmentationOutput"),fp.forEach(t),ql=i(Ya,"."),Ya.forEach(t),Ol=c($s),lt=r($s,"P",{});var Ka=a(lt);Vl=i(Ka,"This output can be directly passed to "),ps=r(Ka,"A",{href:!0});var gp=a(ps);Sl=i(gp,"post_process_instance_segmentation()"),gp.forEach(t),Al=i(Ka," to compute\nfinal segmentation maps. Please, see [`~Mask2FormerImageProcessor] for details regarding usage."),Ka.forEach(t),$s.forEach(t),ma=c(o),be=r(o,"H2",{class:!0});var Xa=a(be);Ke=r(Xa,"A",{id:!0,class:!0,href:!0});var up=a(Ke);mr=r(up,"SPAN",{});var _p=a(mr);b(mt.$$.fragment,_p),_p.forEach(t),up.forEach(t),Ll=c(Xa),cr=r(Xa,"SPAN",{});var kp=a(cr);Nl=i(kp,"VideoMask2FormerImageProcessor"),kp.forEach(t),Xa.forEach(t),ca=c(o),E=r(o,"DIV",{class:!0});var U=a(E);b(ct.$$.fragment,U),Cl=c(U),pr=r(U,"P",{});var vp=a(pr);Dl=i(vp,`Constructs a Video Mask2Former image processor. The image processor can be used to prepare image(s) and optional
targets for the model.`),vp.forEach(t),Ul=c(U),pt=r(U,"P",{});var Qa=a(pt);Rl=i(Qa,"This image processor inherits from "),hr=r(Qa,"CODE",{});var bp=a(hr);Hl=i(bp,"BaseImageProcessor"),bp.forEach(t),Wl=i(Qa,` which contains most of the main methods. Users should
refer to this superclass for more information regarding those methods.`),Qa.forEach(t),Bl=c(U),hs=r(U,"DIV",{class:!0});var Fp=a(hs);b(ht.$$.fragment,Fp),Fp.forEach(t),Gl=c(U),se=r(U,"DIV",{class:!0});var xs=a(se);b(ft.$$.fragment,xs),Yl=c(xs),gt=r(xs,"P",{});var Za=a(gt);Kl=i(Za,"Pad images up to the largest image in a batch and create a corresponding "),fr=r(Za,"CODE",{});var wp=a(fr);Xl=i(wp,"pixel_mask"),wp.forEach(t),Ql=i(Za,"."),Za.forEach(t),Zl=c(xs),Q=r(xs,"P",{});var lo=a(Q);Jl=i(lo,`Video Mask2Former addresses semantic segmentation with a mask classification paradigm, thus input segmentation
maps will be converted to lists of binary masks and their respective labels. Let\u2019s see an example, assuming
`),gr=r(lo,"CODE",{});var yp=a(gr);em=i(yp,"segmentation_maps = [[2,6,7,9]]"),yp.forEach(t),om=i(lo,", the output will contain "),ur=r(lo,"CODE",{});var Mp=a(ur);tm=i(Mp,"mask_labels = [[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]]"),Mp.forEach(t),sm=i(lo," (four binary masks) and "),_r=r(lo,"CODE",{});var Tp=a(_r);rm=i(Tp,"class_labels = [2,6,7,9]"),Tp.forEach(t),am=i(lo,`, the labels for
each mask.`),lo.forEach(t),xs.forEach(t),nm=c(U),Xe=r(U,"DIV",{class:!0});var Ja=a(Xe);b(ut.$$.fragment,Ja),im=c(Ja),_t=r(Ja,"P",{});var en=a(_t);dm=i(en,"Converts the output of "),kr=r(en,"CODE",{});var $p=a(kr);lm=i($p,"VideoMask2FormerForVideoSegmentationOutput"),$p.forEach(t),mm=i(en,` into instance segmentation predictions.
Only supports PyTorch.`),en.forEach(t),Ja.forEach(t),U.forEach(t),pa=c(o),Fe=r(o,"H2",{class:!0});var on=a(Fe);Qe=r(on,"A",{id:!0,class:!0,href:!0});var xp=a(Qe);vr=r(xp,"SPAN",{});var Ip=a(vr);b(kt.$$.fragment,Ip),Ip.forEach(t),xp.forEach(t),cm=c(on),br=r(on,"SPAN",{});var Pp=a(br);pm=i(Pp,"VideoMask2FormerModel"),Pp.forEach(t),on.forEach(t),ha=c(o),Z=r(o,"DIV",{class:!0});var Is=a(Z);b(vt.$$.fragment,Is),hm=c(Is),bt=r(Is,"P",{});var tn=a(bt);fm=i(tn,`The bare Video Mask2Former Model outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Ft=r(tn,"A",{href:!0,rel:!0});var jp=a(Ft);gm=i(jp,"torch.nn.Module"),jp.forEach(t),um=i(tn,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),tn.forEach(t),_m=c(Is),C=r(Is,"DIV",{class:!0});var mo=a(C);b(wt.$$.fragment,mo),km=c(mo),we=r(mo,"P",{});var Ps=a(we);vm=i(Ps,"The "),fs=r(Ps,"A",{href:!0});var zp=a(fs);bm=i(zp,"VideoMask2FormerModel"),zp.forEach(t),Fm=i(Ps," forward method, overrides the "),Fr=r(Ps,"CODE",{});var Ep=a(Fr);wm=i(Ep,"__call__"),Ep.forEach(t),ym=i(Ps," special method."),Ps.forEach(t),Mm=c(mo),b(Ze.$$.fragment,mo),Tm=c(mo),b(Je.$$.fragment,mo),mo.forEach(t),Is.forEach(t),fa=c(o),ye=r(o,"H2",{class:!0});var sn=a(ye);eo=r(sn,"A",{id:!0,class:!0,href:!0});var qp=a(eo);wr=r(qp,"SPAN",{});var Op=a(wr);b(yt.$$.fragment,Op),Op.forEach(t),qp.forEach(t),$m=c(sn),yr=r(sn,"SPAN",{});var Vp=a(yr);xm=i(Vp,"VideoMask2FormerForVideoSegmentation"),Vp.forEach(t),sn.forEach(t),ga=c(o),J=r(o,"DIV",{class:!0});var js=a(J);b(Mt.$$.fragment,js),Im=c(js),Tt=r(js,"P",{});var rn=a(Tt);Pm=i(rn,`The Video Mask2Former model with heads on top for video segmentation.
This model is a PyTorch `),$t=r(rn,"A",{href:!0,rel:!0});var Sp=a($t);jm=i(Sp,"torch.nn.Module"),Sp.forEach(t),zm=i(rn,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),rn.forEach(t),Em=c(js),V=r(js,"DIV",{class:!0});var re=a(V);b(xt.$$.fragment,re),qm=c(re),Me=r(re,"P",{});var zs=a(Me);Om=i(zs,"The "),gs=r(zs,"A",{href:!0});var Ap=a(gs);Vm=i(Ap,"VideoMask2FormerForVideoSegmentation"),Ap.forEach(t),Sm=i(zs," forward method, overrides the "),Mr=r(zs,"CODE",{});var Lp=a(Mr);Am=i(Lp,"__call__"),Lp.forEach(t),Lm=i(zs," special method."),zs.forEach(t),Nm=c(re),b(oo.$$.fragment,re),Cm=c(re),Tr=r(re,"P",{});var Np=a(Tr);Dm=i(Np,"Examples:"),Np.forEach(t),Um=c(re),b(to.$$.fragment,re),re.forEach(t),js.forEach(t),this.h()},h(){l(h,"name","hf:doc:metadata"),l(h,"content",JSON.stringify(rh)),l(g,"id","mask2former"),l(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(g,"href","#mask2former"),l(_,"class","relative group"),l($e,"id","overview"),l($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l($e,"href","#overview"),l(ae,"class","relative group"),l(po,"href","https://arxiv.org/abs/2112.01527"),l(po,"rel","nofollow"),l(qt,"href","maskformer"),l(ho,"href","https://arxiv.org/abs/2112.10764"),l(ho,"rel","nofollow"),l(Nt,"href","maskformer"),l(Ct,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor"),l(Dt,"href","/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoImageProcessor"),l(Ut,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_semantic_segmentation"),l(Rt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_instance_segmentation"),l(Ht,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation"),l(Wt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation"),l(Bt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_instance_segmentation"),Hp(Ie.src,Hm="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/model_doc/mask2former_architecture.jpg")||l(Ie,"src",Hm),l(Ie,"alt","drawing"),l(Ie,"width","600"),l(Gt,"href","https://arxiv.org/abs/2112.01527"),l(uo,"href","https://huggingface.co/shivi"),l(uo,"rel","nofollow"),l(_o,"href","https://huggingface.co/adirik"),l(_o,"rel","nofollow"),l(ko,"href","https://github.com/facebookresearch/Mask2Former"),l(ko,"rel","nofollow"),l(Pe,"id","resources"),l(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Pe,"href","#resources"),l(ne,"class","relative group"),l(Fo,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/Mask2Former"),l(Fo,"rel","nofollow"),l(Kt,"href","maskformer"),l(wo,"href","https://pyimagesearch.com/2023/03/13/train-a-maskformer-segmentation-model-with-hugging-face-transformers/"),l(wo,"rel","nofollow"),l(ze,"id","transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput"),l(ze,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ze,"href","#transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput"),l(de,"class","relative group"),l(Qt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerModel"),l(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Zt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_semantic_segmentation"),l(Jt,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_instance_segmentation"),l(es,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_panoptic_segmentation"),l(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ee,"id","transformers.Mask2FormerConfig"),l(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ee,"href","#transformers.Mask2FormerConfig"),l(me,"class","relative group"),l(os,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerModel"),l(jo,"href","https://huggingface.co/facebook/mask2former-swin-small-coco-instance"),l(jo,"rel","nofollow"),l(ts,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),l(ss,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),l(rs,"href","swin"),l(as,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerConfig"),l(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ns,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig.to_dict"),l(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Se,"id","transformers.Mask2FormerImageProcessor"),l(Se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Se,"href","#transformers.Mask2FormerImageProcessor"),l(he,"class","relative group"),l(is,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ds,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation"),l(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ce,"id","transformers.Mask2FormerModel"),l(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ce,"href","#transformers.Mask2FormerModel"),l(fe,"class","relative group"),l(Qo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Qo,"rel","nofollow"),l(ls,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerModel"),l(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Re,"id","transformers.Mask2FormerForUniversalSegmentation"),l(Re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Re,"href","#transformers.Mask2FormerForUniversalSegmentation"),l(ue,"class","relative group"),l(tt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(tt,"rel","nofollow"),l(ms,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerForUniversalSegmentation"),l(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ye,"id","transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput"),l(Ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ye,"href","#transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput"),l(ke,"class","relative group"),l(cs,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.VideoMask2FormerModel"),l(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ps,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.Mask2FormerImageProcessor.post_process_instance_segmentation"),l(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ke,"id","transformers.VideoMask2FormerImageProcessor"),l(Ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ke,"href","#transformers.VideoMask2FormerImageProcessor"),l(be,"class","relative group"),l(hs,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Qe,"id","transformers.VideoMask2FormerModel"),l(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Qe,"href","#transformers.VideoMask2FormerModel"),l(Fe,"class","relative group"),l(Ft,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ft,"rel","nofollow"),l(fs,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.VideoMask2FormerModel"),l(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(eo,"id","transformers.VideoMask2FormerForVideoSegmentation"),l(eo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(eo,"href","#transformers.VideoMask2FormerForVideoSegmentation"),l(ye,"class","relative group"),l($t,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l($t,"rel","nofollow"),l(gs,"href","/docs/transformers/pr_22182/en/model_doc/mask2former#transformers.VideoMask2FormerForVideoSegmentation"),l(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,p){e(document.head,h),f(o,T,p),f(o,_,p),e(_,g),e(g,k),F(d,k,null),e(_,u),e(_,z),e(z,nn),f(o,Or,p),f(o,ae,p),e(ae,$e),e($e,Es),F(co,Es,null),e(ae,dn),e(ae,qs),e(qs,ln),f(o,Vr,p),f(o,ee,p),e(ee,mn),e(ee,po),e(po,cn),e(ee,pn),e(ee,qt),e(qt,hn),e(ee,fn),f(o,Sr,p),f(o,Ot,p),e(Ot,gn),f(o,Ar,p),f(o,Vt,p),e(Vt,Os),e(Os,un),f(o,Lr,p),f(o,xe,p),e(xe,_n),e(xe,ho),e(ho,kn),e(xe,vn),f(o,Nr,p),f(o,St,p),e(St,bn),f(o,Cr,p),f(o,At,p),e(At,Vs),e(Vs,Fn),f(o,Dr,p),f(o,Lt,p),e(Lt,wn),f(o,Ur,p),f(o,oe,p),e(oe,H),e(H,yn),e(H,Nt),e(Nt,Mn),e(H,Tn),e(H,Ct),e(Ct,$n),e(H,xn),e(H,Dt),e(Dt,In),e(H,Pn),e(oe,jn),e(oe,O),e(O,zn),e(O,Ut),e(Ut,En),e(O,qn),e(O,Rt),e(Rt,On),e(O,Vn),e(O,Ht),e(Ht,Sn),e(O,An),e(O,Wt),e(Wt,Ln),e(O,Nn),e(O,Ss),e(Ss,Cn),e(O,Dn),e(oe,Un),e(oe,fo),e(fo,Rn),e(fo,Bt),e(Bt,Hn),e(fo,Wn),f(o,Rr,p),f(o,Ie,p),f(o,Hr,p),f(o,go,p),e(go,Bn),e(go,Gt),e(Gt,Gn),f(o,Wr,p),f(o,L,p),e(L,Yn),e(L,uo),e(uo,Kn),e(L,Xn),e(L,_o),e(_o,Qn),e(L,Zn),e(L,ko),e(ko,Jn),e(L,ei),f(o,Br,p),f(o,ne,p),e(ne,Pe),e(Pe,As),F(vo,As,null),e(ne,oi),e(ne,Ls),e(Ls,ti),f(o,Gr,p),f(o,Yt,p),e(Yt,si),f(o,Yr,p),f(o,je,p),e(je,bo),e(bo,ri),e(bo,Fo),e(Fo,ai),e(bo,ni),e(je,ii),e(je,ie),e(ie,di),e(ie,Kt),e(Kt,li),e(ie,mi),e(ie,wo),e(wo,ci),e(ie,pi),f(o,Kr,p),f(o,Xt,p),e(Xt,hi),f(o,Xr,p),f(o,de,p),e(de,ze),e(ze,Ns),F(yo,Ns,null),e(de,fi),e(de,Cs),e(Cs,gi),f(o,Qr,p),f(o,le,p),F(Mo,le,null),e(le,ui),e(le,To),e(To,_i),e(To,Qt),e(Qt,ki),e(To,vi),f(o,Zr,p),f(o,W,p),F($o,W,null),e(W,bi),e(W,xo),e(xo,Fi),e(xo,Ds),e(Ds,wi),e(xo,yi),e(W,Mi),e(W,B),e(B,Ti),e(B,Zt),e(Zt,$i),e(B,xi),e(B,Jt),e(Jt,Ii),e(B,Pi),e(B,es),e(es,ji),e(B,zi),f(o,Jr,p),f(o,me,p),e(me,Ee),e(Ee,Us),F(Io,Us,null),e(me,Ei),e(me,Rs),e(Rs,qi),f(o,ea,p),f(o,P,p),F(Po,P,null),e(P,Oi),e(P,ce),e(ce,Vi),e(ce,os),e(os,Si),e(ce,Ai),e(ce,jo),e(jo,Li),e(ce,Ni),e(P,Ci),e(P,pe),e(pe,Di),e(pe,ts),e(ts,Ui),e(pe,Ri),e(pe,ss),e(ss,Hi),e(pe,Wi),e(P,Bi),e(P,zo),e(zo,Gi),e(zo,rs),e(rs,Yi),e(zo,Ki),e(P,Xi),F(qe,P,null),e(P,Qi),e(P,Oe),F(Eo,Oe,null),e(Oe,Zi),e(Oe,qo),e(qo,Ji),e(qo,as),e(as,ed),e(qo,od),e(P,td),e(P,Ve),F(Oo,Ve,null),e(Ve,sd),e(Ve,Vo),e(Vo,rd),e(Vo,ns),e(ns,ad),e(Vo,nd),f(o,oa,p),f(o,he,p),e(he,Se),e(Se,Hs),F(So,Hs,null),e(he,id),e(he,Ws),e(Ws,dd),f(o,ta,p),f(o,I,p),F(Ao,I,null),e(I,ld),e(I,Bs),e(Bs,md),e(I,cd),e(I,Lo),e(Lo,pd),e(Lo,Gs),e(Gs,hd),e(Lo,fd),e(I,gd),e(I,is),F(No,is,null),e(I,ud),e(I,te),F(Co,te,null),e(te,_d),e(te,Do),e(Do,kd),e(Do,Ys),e(Ys,vd),e(Do,bd),e(te,Fd),e(te,G),e(G,wd),e(G,Ks),e(Ks,yd),e(G,Md),e(G,Xs),e(Xs,Td),e(G,$d),e(G,Qs),e(Qs,xd),e(G,Id),e(I,Pd),e(I,Ae),F(Uo,Ae,null),e(Ae,jd),e(Ae,Ro),e(Ro,zd),e(Ro,ds),e(ds,Ed),e(Ro,qd),e(I,Od),e(I,Le),F(Ho,Le,null),e(Le,Vd),e(Le,Wo),e(Wo,Sd),e(Wo,Zs),e(Zs,Ad),e(Wo,Ld),e(I,Nd),e(I,Ne),F(Bo,Ne,null),e(Ne,Cd),e(Ne,Go),e(Go,Dd),e(Go,Js),e(Js,Ud),e(Go,Rd),f(o,sa,p),f(o,fe,p),e(fe,Ce),e(Ce,er),F(Yo,er,null),e(fe,Hd),e(fe,or),e(or,Wd),f(o,ra,p),f(o,Y,p),F(Ko,Y,null),e(Y,Bd),e(Y,Xo),e(Xo,Gd),e(Xo,Qo),e(Qo,Yd),e(Xo,Kd),e(Y,Xd),e(Y,N),F(Zo,N,null),e(N,Qd),e(N,ge),e(ge,Zd),e(ge,ls),e(ls,Jd),e(ge,el),e(ge,tr),e(tr,ol),e(ge,tl),e(N,sl),F(De,N,null),e(N,rl),F(Ue,N,null),f(o,aa,p),f(o,ue,p),e(ue,Re),e(Re,sr),F(Jo,sr,null),e(ue,al),e(ue,rr),e(rr,nl),f(o,na,p),f(o,K,p),F(et,K,null),e(K,il),e(K,ot),e(ot,dl),e(ot,tt),e(tt,ll),e(ot,ml),e(K,cl),e(K,j),F(st,j,null),e(j,pl),e(j,_e),e(_e,hl),e(_e,ms),e(ms,fl),e(_e,gl),e(_e,ar),e(ar,ul),e(_e,_l),e(j,kl),F(He,j,null),e(j,vl),e(j,nr),e(nr,bl),e(j,Fl),F(We,j,null),e(j,wl),F(Be,j,null),e(j,yl),F(Ge,j,null),f(o,ia,p),f(o,ke,p),e(ke,Ye),e(Ye,ir),F(rt,ir,null),e(ke,Ml),e(ke,dr),e(dr,Tl),f(o,da,p),f(o,ve,p),F(at,ve,null),e(ve,$l),e(ve,nt),e(nt,xl),e(nt,cs),e(cs,Il),e(nt,Pl),f(o,la,p),f(o,X,p),F(it,X,null),e(X,jl),e(X,dt),e(dt,zl),e(dt,lr),e(lr,El),e(dt,ql),e(X,Ol),e(X,lt),e(lt,Vl),e(lt,ps),e(ps,Sl),e(lt,Al),f(o,ma,p),f(o,be,p),e(be,Ke),e(Ke,mr),F(mt,mr,null),e(be,Ll),e(be,cr),e(cr,Nl),f(o,ca,p),f(o,E,p),F(ct,E,null),e(E,Cl),e(E,pr),e(pr,Dl),e(E,Ul),e(E,pt),e(pt,Rl),e(pt,hr),e(hr,Hl),e(pt,Wl),e(E,Bl),e(E,hs),F(ht,hs,null),e(E,Gl),e(E,se),F(ft,se,null),e(se,Yl),e(se,gt),e(gt,Kl),e(gt,fr),e(fr,Xl),e(gt,Ql),e(se,Zl),e(se,Q),e(Q,Jl),e(Q,gr),e(gr,em),e(Q,om),e(Q,ur),e(ur,tm),e(Q,sm),e(Q,_r),e(_r,rm),e(Q,am),e(E,nm),e(E,Xe),F(ut,Xe,null),e(Xe,im),e(Xe,_t),e(_t,dm),e(_t,kr),e(kr,lm),e(_t,mm),f(o,pa,p),f(o,Fe,p),e(Fe,Qe),e(Qe,vr),F(kt,vr,null),e(Fe,cm),e(Fe,br),e(br,pm),f(o,ha,p),f(o,Z,p),F(vt,Z,null),e(Z,hm),e(Z,bt),e(bt,fm),e(bt,Ft),e(Ft,gm),e(bt,um),e(Z,_m),e(Z,C),F(wt,C,null),e(C,km),e(C,we),e(we,vm),e(we,fs),e(fs,bm),e(we,Fm),e(we,Fr),e(Fr,wm),e(we,ym),e(C,Mm),F(Ze,C,null),e(C,Tm),F(Je,C,null),f(o,fa,p),f(o,ye,p),e(ye,eo),e(eo,wr),F(yt,wr,null),e(ye,$m),e(ye,yr),e(yr,xm),f(o,ga,p),f(o,J,p),F(Mt,J,null),e(J,Im),e(J,Tt),e(Tt,Pm),e(Tt,$t),e($t,jm),e(Tt,zm),e(J,Em),e(J,V),F(xt,V,null),e(V,qm),e(V,Me),e(Me,Om),e(Me,gs),e(gs,Vm),e(Me,Sm),e(Me,Mr),e(Mr,Am),e(Me,Lm),e(V,Nm),F(oo,V,null),e(V,Cm),e(V,Tr),e(Tr,Dm),e(V,Um),F(to,V,null),ua=!0},p(o,[p]){const It={};p&2&&(It.$$scope={dirty:p,ctx:o}),qe.$set(It);const $r={};p&2&&($r.$$scope={dirty:p,ctx:o}),De.$set($r);const xr={};p&2&&(xr.$$scope={dirty:p,ctx:o}),Ue.$set(xr);const Ir={};p&2&&(Ir.$$scope={dirty:p,ctx:o}),He.$set(Ir);const Pt={};p&2&&(Pt.$$scope={dirty:p,ctx:o}),We.$set(Pt);const Pr={};p&2&&(Pr.$$scope={dirty:p,ctx:o}),Be.$set(Pr);const jr={};p&2&&(jr.$$scope={dirty:p,ctx:o}),Ge.$set(jr);const zr={};p&2&&(zr.$$scope={dirty:p,ctx:o}),Ze.$set(zr);const Te={};p&2&&(Te.$$scope={dirty:p,ctx:o}),Je.$set(Te);const Er={};p&2&&(Er.$$scope={dirty:p,ctx:o}),oo.$set(Er);const qr={};p&2&&(qr.$$scope={dirty:p,ctx:o}),to.$set(qr)},i(o){ua||(w(d.$$.fragment,o),w(co.$$.fragment,o),w(vo.$$.fragment,o),w(yo.$$.fragment,o),w(Mo.$$.fragment,o),w($o.$$.fragment,o),w(Io.$$.fragment,o),w(Po.$$.fragment,o),w(qe.$$.fragment,o),w(Eo.$$.fragment,o),w(Oo.$$.fragment,o),w(So.$$.fragment,o),w(Ao.$$.fragment,o),w(No.$$.fragment,o),w(Co.$$.fragment,o),w(Uo.$$.fragment,o),w(Ho.$$.fragment,o),w(Bo.$$.fragment,o),w(Yo.$$.fragment,o),w(Ko.$$.fragment,o),w(Zo.$$.fragment,o),w(De.$$.fragment,o),w(Ue.$$.fragment,o),w(Jo.$$.fragment,o),w(et.$$.fragment,o),w(st.$$.fragment,o),w(He.$$.fragment,o),w(We.$$.fragment,o),w(Be.$$.fragment,o),w(Ge.$$.fragment,o),w(rt.$$.fragment,o),w(at.$$.fragment,o),w(it.$$.fragment,o),w(mt.$$.fragment,o),w(ct.$$.fragment,o),w(ht.$$.fragment,o),w(ft.$$.fragment,o),w(ut.$$.fragment,o),w(kt.$$.fragment,o),w(vt.$$.fragment,o),w(wt.$$.fragment,o),w(Ze.$$.fragment,o),w(Je.$$.fragment,o),w(yt.$$.fragment,o),w(Mt.$$.fragment,o),w(xt.$$.fragment,o),w(oo.$$.fragment,o),w(to.$$.fragment,o),ua=!0)},o(o){y(d.$$.fragment,o),y(co.$$.fragment,o),y(vo.$$.fragment,o),y(yo.$$.fragment,o),y(Mo.$$.fragment,o),y($o.$$.fragment,o),y(Io.$$.fragment,o),y(Po.$$.fragment,o),y(qe.$$.fragment,o),y(Eo.$$.fragment,o),y(Oo.$$.fragment,o),y(So.$$.fragment,o),y(Ao.$$.fragment,o),y(No.$$.fragment,o),y(Co.$$.fragment,o),y(Uo.$$.fragment,o),y(Ho.$$.fragment,o),y(Bo.$$.fragment,o),y(Yo.$$.fragment,o),y(Ko.$$.fragment,o),y(Zo.$$.fragment,o),y(De.$$.fragment,o),y(Ue.$$.fragment,o),y(Jo.$$.fragment,o),y(et.$$.fragment,o),y(st.$$.fragment,o),y(He.$$.fragment,o),y(We.$$.fragment,o),y(Be.$$.fragment,o),y(Ge.$$.fragment,o),y(rt.$$.fragment,o),y(at.$$.fragment,o),y(it.$$.fragment,o),y(mt.$$.fragment,o),y(ct.$$.fragment,o),y(ht.$$.fragment,o),y(ft.$$.fragment,o),y(ut.$$.fragment,o),y(kt.$$.fragment,o),y(vt.$$.fragment,o),y(wt.$$.fragment,o),y(Ze.$$.fragment,o),y(Je.$$.fragment,o),y(yt.$$.fragment,o),y(Mt.$$.fragment,o),y(xt.$$.fragment,o),y(oo.$$.fragment,o),y(to.$$.fragment,o),ua=!1},d(o){t(h),o&&t(T),o&&t(_),M(d),o&&t(Or),o&&t(ae),M(co),o&&t(Vr),o&&t(ee),o&&t(Sr),o&&t(Ot),o&&t(Ar),o&&t(Vt),o&&t(Lr),o&&t(xe),o&&t(Nr),o&&t(St),o&&t(Cr),o&&t(At),o&&t(Dr),o&&t(Lt),o&&t(Ur),o&&t(oe),o&&t(Rr),o&&t(Ie),o&&t(Hr),o&&t(go),o&&t(Wr),o&&t(L),o&&t(Br),o&&t(ne),M(vo),o&&t(Gr),o&&t(Yt),o&&t(Yr),o&&t(je),o&&t(Kr),o&&t(Xt),o&&t(Xr),o&&t(de),M(yo),o&&t(Qr),o&&t(le),M(Mo),o&&t(Zr),o&&t(W),M($o),o&&t(Jr),o&&t(me),M(Io),o&&t(ea),o&&t(P),M(Po),M(qe),M(Eo),M(Oo),o&&t(oa),o&&t(he),M(So),o&&t(ta),o&&t(I),M(Ao),M(No),M(Co),M(Uo),M(Ho),M(Bo),o&&t(sa),o&&t(fe),M(Yo),o&&t(ra),o&&t(Y),M(Ko),M(Zo),M(De),M(Ue),o&&t(aa),o&&t(ue),M(Jo),o&&t(na),o&&t(K),M(et),M(st),M(He),M(We),M(Be),M(Ge),o&&t(ia),o&&t(ke),M(rt),o&&t(da),o&&t(ve),M(at),o&&t(la),o&&t(X),M(it),o&&t(ma),o&&t(be),M(mt),o&&t(ca),o&&t(E),M(ct),M(ht),M(ft),M(ut),o&&t(pa),o&&t(Fe),M(kt),o&&t(ha),o&&t(Z),M(vt),M(wt),M(Ze),M(Je),o&&t(fa),o&&t(ye),M(yt),o&&t(ga),o&&t(J),M(Mt),M(xt),M(oo),M(to)}}}const rh={local:"mask2former",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.models.mask2former.modeling_mask2former.Mask2FormerModelOutput",title:"Mask2Former specific outputs"},{local:"transformers.Mask2FormerConfig",title:"Mask2FormerConfig"},{local:"transformers.Mask2FormerImageProcessor",title:"Mask2FormerImageProcessor"},{local:"transformers.Mask2FormerModel",title:"Mask2FormerModel"},{local:"transformers.Mask2FormerForUniversalSegmentation",title:"Mask2FormerForUniversalSegmentation"},{local:"transformers.models.mask2former.modeling_video_mask2former.VideoMask2FormerModelOutput",title:"Video Mask2Former specific outputs"},{local:"transformers.VideoMask2FormerImageProcessor",title:"VideoMask2FormerImageProcessor"},{local:"transformers.VideoMask2FormerModel",title:"VideoMask2FormerModel"},{local:"transformers.VideoMask2FormerForVideoSegmentation",title:"VideoMask2FormerForVideoSegmentation"}],title:"Mask2Former"};function ah(x){return Wp(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ph extends Cp{constructor(h){super();Dp(this,h,ah,sh,Up,{})}}export{ph as default,rh as metadata};
