import{S as vx,i as bx,s as wx,e as n,k as d,w,t as a,M as yx,c as r,d as t,m as p,a as i,x as y,h as s,b as c,G as e,g as _,y as k,q as T,o as x,B as $,v as kx,L as Ge}from"../../chunks/vendor-hf-doc-builder.js";import{T as je}from"../../chunks/Tip-hf-doc-builder.js";import{D as F}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Oe}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as K}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Xe}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as _x}from"../../chunks/PipelineTag-hf-doc-builder.js";function Tx(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import Wav2Vec2Config, Wav2Vec2Model

# Initializing a Wav2Vec2 facebook/wav2vec2-base-960h style configuration
configuration = Wav2Vec2Config()

# Initializing a model (with random weights) from the facebook/wav2vec2-base-960h style configuration
model = Wav2Vec2Model(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> Wav2Vec2Config, Wav2Vec2Model

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Wav2Vec2 facebook/wav2vec2-base-960h style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = Wav2Vec2Config()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the facebook/wav2vec2-base-960h style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2Model(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function xx(W){let m,b,g,f,v;return f=new Oe({props:{code:`# Let's see how to retrieve time steps for a model
from transformers import AutoTokenizer, AutoFeatureExtractor, AutoModelForCTC
from datasets import load_dataset
import datasets
import torch

# import model, feature extractor, tokenizer
model = AutoModelForCTC.from_pretrained("facebook/wav2vec2-base-960h")
tokenizer = AutoTokenizer.from_pretrained("facebook/wav2vec2-base-960h")
feature_extractor = AutoFeatureExtractor.from_pretrained("facebook/wav2vec2-base-960h")

# load first sample of English common_voice
dataset = load_dataset("common_voice", "en", split="train", streaming=True)
dataset = dataset.cast_column("audio", datasets.Audio(sampling_rate=16_000))
dataset_iter = iter(dataset)
sample = next(dataset_iter)

# forward sample through model to get greedily predicted transcription ids
input_values = feature_extractor(sample["audio"]["array"], return_tensors="pt").input_values
logits = model(input_values).logits[0]
pred_ids = torch.argmax(logits, axis=-1)

# retrieve word stamps (analogous commands for \`output_char_offsets\`)
outputs = tokenizer.decode(pred_ids, output_word_offsets=True)
# compute \`time_offset\` in seconds as product of downsampling ratio and sampling_rate
time_offset = model.config.inputs_to_logits_ratio / feature_extractor.sampling_rate

word_offsets = [
    {
        "word": d["word"],
        "start_time": round(d["start_offset"] * time_offset, 2),
        "end_time": round(d["end_offset"] * time_offset, 2),
    }
    for d in outputs.word_offsets
]
# compare word offsets with audio \`common_voice_en_100038.mp3\` online on the dataset viewer:
# https://huggingface.co/datasets/common_voice/viewer/en/train
word_offsets[:3]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Let&#x27;s see how to retrieve time steps for a model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoFeatureExtractor, AutoModelForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> datasets
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># import model, feature extractor, tokenizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCTC.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load first sample of English common_voice</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;common_voice&quot;</span>, <span class="hljs-string">&quot;en&quot;</span>, split=<span class="hljs-string">&quot;train&quot;</span>, streaming=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, datasets.Audio(sampling_rate=<span class="hljs-number">16_000</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset_iter = <span class="hljs-built_in">iter</span>(dataset)
<span class="hljs-meta">&gt;&gt;&gt; </span>sample = <span class="hljs-built_in">next</span>(dataset_iter)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward sample through model to get greedily predicted transcription ids</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = feature_extractor(sample[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_values
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(input_values).logits[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>pred_ids = torch.argmax(logits, axis=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve word stamps (analogous commands for \`output_char_offsets\`)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = tokenizer.decode(pred_ids, output_word_offsets=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute \`time_offset\` in seconds as product of downsampling ratio and sampling_rate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>time_offset = model.config.inputs_to_logits_ratio / feature_extractor.sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>word_offsets = [
<span class="hljs-meta">... </span>    {
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;word&quot;</span>: d[<span class="hljs-string">&quot;word&quot;</span>],
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;start_time&quot;</span>: <span class="hljs-built_in">round</span>(d[<span class="hljs-string">&quot;start_offset&quot;</span>] * time_offset, <span class="hljs-number">2</span>),
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;end_time&quot;</span>: <span class="hljs-built_in">round</span>(d[<span class="hljs-string">&quot;end_offset&quot;</span>] * time_offset, <span class="hljs-number">2</span>),
<span class="hljs-meta">... </span>    }
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> d <span class="hljs-keyword">in</span> outputs.word_offsets
<span class="hljs-meta">... </span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compare word offsets with audio \`common_voice_en_100038.mp3\` online on the dataset viewer:</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># https://huggingface.co/datasets/common_voice/viewer/en/train</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>word_offsets[:<span class="hljs-number">3</span>]
[{<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;WHY&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">1.42</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">1.54</span>}, {<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;DOES&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">1.64</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">1.9</span>}, {<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;MILISANDRA&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">2.26</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">2.9</span>}]`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function $x(W){let m,b,g,f,v,l,h,V;return{c(){m=n("p"),b=a("This class method is simply calling "),g=n("a"),f=a("save_pretrained()"),v=a(` and
`),l=n("a"),h=a("save_pretrained()"),V=a(`. Please refer to the docstrings of the
methods above for more information.`),this.h()},l(M){m=r(M,"P",{});var L=i(m);b=s(L,"This class method is simply calling "),g=r(L,"A",{href:!0});var A=i(g);f=s(A,"save_pretrained()"),A.forEach(t),v=s(L,` and
`),l=r(L,"A",{href:!0});var z=i(l);h=s(z,"save_pretrained()"),z.forEach(t),V=s(L,`. Please refer to the docstrings of the
methods above for more information.`),L.forEach(t),this.h()},h(){c(g,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained"),c(l,"href","/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.save_pretrained")},m(M,L){_(M,m,L),e(m,b),e(m,g),e(g,f),e(m,v),e(m,l),e(l,h),e(m,V)},d(M){M&&t(m)}}}function jx(W){let m,b,g,f,v,l,h,V,M,L,A,z,N,E;return{c(){m=n("p"),b=a(`This class method is simply calling Wav2Vec2FeatureExtractor\u2019s
`),g=n("a"),f=a("from_pretrained()"),v=a(`, Wav2Vec2CTCTokenizer\u2019s
`),l=n("a"),h=a("from_pretrained()"),V=a(`, and
`),M=n("code"),L=a("pyctcdecode.BeamSearchDecoderCTC.load_from_hf_hub"),A=a("."),z=d(),N=n("p"),E=a("Please refer to the docstrings of the methods above for more information."),this.h()},l(O){m=r(O,"P",{});var C=i(m);b=s(C,`This class method is simply calling Wav2Vec2FeatureExtractor\u2019s
`),g=r(C,"A",{href:!0});var ce=i(g);f=s(ce,"from_pretrained()"),ce.forEach(t),v=s(C,`, Wav2Vec2CTCTokenizer\u2019s
`),l=r(C,"A",{href:!0});var J=i(l);h=s(J,"from_pretrained()"),J.forEach(t),V=s(C,`, and
`),M=r(C,"CODE",{});var S=i(M);L=s(S,"pyctcdecode.BeamSearchDecoderCTC.load_from_hf_hub"),S.forEach(t),A=s(C,"."),C.forEach(t),z=p(O),N=r(O,"P",{});var de=i(N);E=s(de,"Please refer to the docstrings of the methods above for more information."),de.forEach(t),this.h()},h(){c(g,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.from_pretrained"),c(l,"href","/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.from_pretrained")},m(O,C){_(O,m,C),e(m,b),e(m,g),e(g,f),e(m,v),e(m,l),e(l,h),e(m,V),e(m,M),e(M,L),e(m,A),_(O,z,C),_(O,N,C),e(N,E)},d(O){O&&t(m),O&&t(z),O&&t(N)}}}function Wx(W){let m,b,g,f,v,l,h,V,M,L,A,z,N,E,O,C,ce,J,S,de;return{c(){m=n("p"),b=a(`This function makes use of Python\u2019s multiprocessing. Currently, multiprocessing is available only on Unix
systems (see this `),g=n("a"),f=a("issue"),v=a(")."),l=d(),h=n("p"),V=a("If you are decoding multiple batches, consider creating a "),M=n("code"),L=a("Pool"),A=a(" and passing it to "),z=n("code"),N=a("batch_decode"),E=a(`. Otherwise,
`),O=n("code"),C=a("batch_decode"),ce=a(" will be very slow since it will create a fresh "),J=n("code"),S=a("Pool"),de=a(" for each call. See usage example below."),this.h()},l(I){m=r(I,"P",{});var R=i(m);b=s(R,`This function makes use of Python\u2019s multiprocessing. Currently, multiprocessing is available only on Unix
systems (see this `),g=r(R,"A",{href:!0,rel:!0});var De=i(g);f=s(De,"issue"),De.forEach(t),v=s(R,")."),R.forEach(t),l=p(I),h=r(I,"P",{});var X=i(h);V=s(X,"If you are decoding multiple batches, consider creating a "),M=r(X,"CODE",{});var Z=i(M);L=s(Z,"Pool"),Z.forEach(t),A=s(X," and passing it to "),z=r(X,"CODE",{});var Se=i(z);N=s(Se,"batch_decode"),Se.forEach(t),E=s(X,`. Otherwise,
`),O=r(X,"CODE",{});var We=i(O);C=s(We,"batch_decode"),We.forEach(t),ce=s(X," will be very slow since it will create a fresh "),J=r(X,"CODE",{});var Q=i(J);S=s(Q,"Pool"),Q.forEach(t),de=s(X," for each call. See usage example below."),X.forEach(t),this.h()},h(){c(g,"href","https://github.com/kensho-technologies/pyctcdecode/issues/65"),c(g,"rel","nofollow")},m(I,R){_(I,m,R),e(m,b),e(m,g),e(g,f),e(m,v),_(I,l,R),_(I,h,R),e(h,V),e(h,M),e(M,L),e(h,A),e(h,z),e(z,N),e(h,E),e(h,O),e(O,C),e(h,ce),e(h,J),e(J,S),e(h,de)},d(I){I&&t(m),I&&t(l),I&&t(h)}}}function Vx(W){let m,b,g,f,v;return f=new Oe({props:{code:`# Let's see how to retrieve time steps for a model
from transformers import AutoTokenizer, AutoProcessor, AutoModelForCTC
from datasets import load_dataset
import datasets
import torch

# import model, feature extractor, tokenizer
model = AutoModelForCTC.from_pretrained("patrickvonplaten/wav2vec2-base-100h-with-lm")
processor = AutoProcessor.from_pretrained("patrickvonplaten/wav2vec2-base-100h-with-lm")

# load first sample of English common_voice
dataset = load_dataset("common_voice", "en", split="train", streaming=True)
dataset = dataset.cast_column("audio", datasets.Audio(sampling_rate=16_000))
dataset_iter = iter(dataset)
sample = next(dataset_iter)

# forward sample through model to get greedily predicted transcription ids
input_values = processor(sample["audio"]["array"], return_tensors="pt").input_values
with torch.no_grad():
    logits = model(input_values).logits[0].cpu().numpy()

# retrieve word stamps (analogous commands for \`output_char_offsets\`)
outputs = processor.decode(logits, output_word_offsets=True)
# compute \`time_offset\` in seconds as product of downsampling ratio and sampling_rate
time_offset = model.config.inputs_to_logits_ratio / processor.feature_extractor.sampling_rate

word_offsets = [
    {
        "word": d["word"],
        "start_time": round(d["start_offset"] * time_offset, 2),
        "end_time": round(d["end_offset"] * time_offset, 2),
    }
    for d in outputs.word_offsets
]
# compare word offsets with audio \`common_voice_en_100038.mp3\` online on the dataset viewer:
# https://huggingface.co/datasets/common_voice/viewer/en/train
word_offsets[:4]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Let&#x27;s see how to retrieve time steps for a model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoProcessor, AutoModelForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> datasets
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># import model, feature extractor, tokenizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCTC.from_pretrained(<span class="hljs-string">&quot;patrickvonplaten/wav2vec2-base-100h-with-lm&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;patrickvonplaten/wav2vec2-base-100h-with-lm&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load first sample of English common_voice</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;common_voice&quot;</span>, <span class="hljs-string">&quot;en&quot;</span>, split=<span class="hljs-string">&quot;train&quot;</span>, streaming=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, datasets.Audio(sampling_rate=<span class="hljs-number">16_000</span>))
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset_iter = <span class="hljs-built_in">iter</span>(dataset)
<span class="hljs-meta">&gt;&gt;&gt; </span>sample = <span class="hljs-built_in">next</span>(dataset_iter)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward sample through model to get greedily predicted transcription ids</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = processor(sample[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_values
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(input_values).logits[<span class="hljs-number">0</span>].cpu().numpy()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve word stamps (analogous commands for \`output_char_offsets\`)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = processor.decode(logits, output_word_offsets=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute \`time_offset\` in seconds as product of downsampling ratio and sampling_rate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>time_offset = model.config.inputs_to_logits_ratio / processor.feature_extractor.sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>word_offsets = [
<span class="hljs-meta">... </span>    {
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;word&quot;</span>: d[<span class="hljs-string">&quot;word&quot;</span>],
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;start_time&quot;</span>: <span class="hljs-built_in">round</span>(d[<span class="hljs-string">&quot;start_offset&quot;</span>] * time_offset, <span class="hljs-number">2</span>),
<span class="hljs-meta">... </span>        <span class="hljs-string">&quot;end_time&quot;</span>: <span class="hljs-built_in">round</span>(d[<span class="hljs-string">&quot;end_offset&quot;</span>] * time_offset, <span class="hljs-number">2</span>),
<span class="hljs-meta">... </span>    }
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> d <span class="hljs-keyword">in</span> outputs.word_offsets
<span class="hljs-meta">... </span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compare word offsets with audio \`common_voice_en_100038.mp3\` online on the dataset viewer:</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># https://huggingface.co/datasets/common_voice/viewer/en/train</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>word_offsets[:<span class="hljs-number">4</span>]
[{<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;WHY&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">1.42</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">1.54</span>}, {<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;DOES&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">1.66</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">1.9</span>}, {<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;MILISANDRA&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">2.26</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">2.9</span>}, {<span class="hljs-string">&#x27;word&#x27;</span>: <span class="hljs-string">&#x27;LOOK&#x27;</span>, <span class="hljs-string">&#x27;start_time&#x27;</span>: <span class="hljs-number">3.0</span>, <span class="hljs-string">&#x27;end_time&#x27;</span>: <span class="hljs-number">3.16</span>}]`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Fx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Ex(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoProcessor, Wav2Vec2Model
import torch
from datasets import load_dataset

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-base-960h")
model = Wav2Vec2Model.from_pretrained("facebook/wav2vec2-base-960h")

# audio file is decoded on the fly
inputs = processor(dataset[0]["audio"]["array"], sampling_rate=sampling_rate, return_tensors="pt")
with torch.no_grad():
    outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Wav2Vec2Model
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2Model.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">292</span>, <span class="hljs-number">768</span>]`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Cx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function qx(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoProcessor, Wav2Vec2ForCTC
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-base-960h")
model = Wav2Vec2ForCTC.from_pretrained("facebook/wav2vec2-base-960h")

# audio file is decoded on the fly
inputs = processor(dataset[0]["audio"]["array"], sampling_rate=sampling_rate, return_tensors="pt")
with torch.no_grad():
    logits = model(**inputs).logits
predicted_ids = torch.argmax(logits, dim=-1)

# transcribe speech
transcription = processor.batch_decode(predicted_ids)
transcription[0]

inputs["labels"] = processor(text=dataset[0]["text"], return_tensors="pt").input_ids

# compute loss
loss = model(**inputs).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, Wav2Vec2ForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2ForCTC.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_ids = torch.argmax(logits, dim=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># transcribe speech</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription = processor.batch_decode(predicted_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription[<span class="hljs-number">0</span>]
<span class="hljs-string">&#x27;MISTER QUILTER IS THE APOSTLE OF THE MIDDLE CLASSES AND WE ARE GLAD TO WELCOME HIS GOSPEL&#x27;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs[<span class="hljs-string">&quot;labels&quot;</span>] = processor(text=dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;text&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute loss</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">53.48</span>`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Px(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Ax(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoFeatureExtractor, Wav2Vec2ForSequenceClassification
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

feature_extractor = AutoFeatureExtractor.from_pretrained("superb/wav2vec2-base-superb-ks")
model = Wav2Vec2ForSequenceClassification.from_pretrained("superb/wav2vec2-base-superb-ks")

# audio file is decoded on the fly
inputs = feature_extractor(dataset[0]["audio"]["array"], sampling_rate=sampling_rate, return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_ids = torch.argmax(logits, dim=-1).item()
predicted_label = model.config.id2label[predicted_class_ids]
predicted_label

# compute loss - target_label is e.g. "down"
target_label = model.config.id2label[0]
inputs["labels"] = torch.tensor([model.config.label2id[target_label]])
loss = model(**inputs).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, Wav2Vec2ForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;superb/wav2vec2-base-superb-ks&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2ForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;superb/wav2vec2-base-superb-ks&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_ids = torch.argmax(logits, dim=-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = model.config.id2label[predicted_class_ids]
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label
<span class="hljs-string">&#x27;_unknown_&#x27;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute loss - target_label is e.g. &quot;down&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_label = model.config.id2label[<span class="hljs-number">0</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs[<span class="hljs-string">&quot;labels&quot;</span>] = torch.tensor([model.config.label2id[target_label]])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">6.54</span>`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function zx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Mx(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoFeatureExtractor, Wav2Vec2ForAudioFrameClassification
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

feature_extractor = AutoFeatureExtractor.from_pretrained("anton-l/wav2vec2-base-superb-sd")
model = Wav2Vec2ForAudioFrameClassification.from_pretrained("anton-l/wav2vec2-base-superb-sd")

# audio file is decoded on the fly
inputs = feature_extractor(dataset[0]["audio"]["array"], return_tensors="pt", sampling_rate=sampling_rate)
with torch.no_grad():
    logits = model(**inputs).logits

probabilities = torch.sigmoid(logits[0])
# labels is a one-hot array of shape (num_frames, num_speakers)
labels = (probabilities > 0.5).long()
labels[0].tolist()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, Wav2Vec2ForAudioFrameClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;anton-l/wav2vec2-base-superb-sd&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2ForAudioFrameClassification.from_pretrained(<span class="hljs-string">&quot;anton-l/wav2vec2-base-superb-sd&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>, sampling_rate=sampling_rate)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>probabilities = torch.sigmoid(logits[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># labels is a one-hot array of shape (num_frames, num_speakers)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = (probabilities &gt; <span class="hljs-number">0.5</span>).long()
<span class="hljs-meta">&gt;&gt;&gt; </span>labels[<span class="hljs-number">0</span>].tolist()
[<span class="hljs-number">0</span>, <span class="hljs-number">0</span>]`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Lx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Ox(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoFeatureExtractor, Wav2Vec2ForXVector
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

feature_extractor = AutoFeatureExtractor.from_pretrained("anton-l/wav2vec2-base-superb-sv")
model = Wav2Vec2ForXVector.from_pretrained("anton-l/wav2vec2-base-superb-sv")

# audio file is decoded on the fly
inputs = feature_extractor(
    [d["array"] for d in dataset[:2]["audio"]], sampling_rate=sampling_rate, return_tensors="pt", padding=True
)
with torch.no_grad():
    embeddings = model(**inputs).embeddings

embeddings = torch.nn.functional.normalize(embeddings, dim=-1).cpu()

# the resulting embeddings can be used for cosine similarity-based retrieval
cosine_sim = torch.nn.CosineSimilarity(dim=-1)
similarity = cosine_sim(embeddings[0], embeddings[1])
threshold = 0.7  # the optimal threshold is dataset-dependent
if similarity < threshold:
    print("Speakers are not the same!")
round(similarity.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, Wav2Vec2ForXVector
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;anton-l/wav2vec2-base-superb-sv&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2ForXVector.from_pretrained(<span class="hljs-string">&quot;anton-l/wav2vec2-base-superb-sv&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(
<span class="hljs-meta">... </span>    [d[<span class="hljs-string">&quot;array&quot;</span>] <span class="hljs-keyword">for</span> d <span class="hljs-keyword">in</span> dataset[:<span class="hljs-number">2</span>][<span class="hljs-string">&quot;audio&quot;</span>]], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>, padding=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    embeddings = model(**inputs).embeddings

<span class="hljs-meta">&gt;&gt;&gt; </span>embeddings = torch.nn.functional.normalize(embeddings, dim=-<span class="hljs-number">1</span>).cpu()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the resulting embeddings can be used for cosine similarity-based retrieval</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>cosine_sim = torch.nn.CosineSimilarity(dim=-<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>similarity = cosine_sim(embeddings[<span class="hljs-number">0</span>], embeddings[<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>threshold = <span class="hljs-number">0.7</span>  <span class="hljs-comment"># the optimal threshold is dataset-dependent</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> similarity &lt; threshold:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Speakers are not the same!&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(similarity.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">0.98</span>`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Dx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Sx(W){let m,b,g,f,v;return f=new Oe({props:{code:`import torch
from transformers import AutoFeatureExtractor, Wav2Vec2ForPreTraining
from transformers.models.wav2vec2.modeling_wav2vec2 import _compute_mask_indices, _sample_negative_indices
from datasets import load_dataset

feature_extractor = AutoFeatureExtractor.from_pretrained("facebook/wav2vec2-base")
model = Wav2Vec2ForPreTraining.from_pretrained("facebook/wav2vec2-base")

ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
input_values = feature_extractor(ds[0]["audio"]["array"], return_tensors="pt").input_values  # Batch size 1

# compute masked indices
batch_size, raw_sequence_length = input_values.shape
sequence_length = model._get_feat_extract_output_lengths(raw_sequence_length).item()
mask_time_indices = _compute_mask_indices(
    shape=(batch_size, sequence_length), mask_prob=0.2, mask_length=2
)
sampled_negative_indices = _sample_negative_indices(
    features_shape=(batch_size, sequence_length),
    num_negatives=model.config.num_negatives,
    mask_time_indices=mask_time_indices,
)
mask_time_indices = torch.tensor(data=mask_time_indices, device=input_values.device, dtype=torch.long)
sampled_negative_indices = torch.tensor(
    data=sampled_negative_indices, device=input_values.device, dtype=torch.long
)

with torch.no_grad():
    outputs = model(input_values, mask_time_indices=mask_time_indices)

# compute cosine similarity between predicted (=projected_states) and target (=projected_quantized_states)
cosine_sim = torch.cosine_similarity(outputs.projected_states, outputs.projected_quantized_states, dim=-1)

# show that cosine similarity is much higher than random
cosine_sim[mask_time_indices.to(torch.bool)].mean() > 0.5

# for contrastive loss training model should be put into train mode
model = model.train()
loss = model(
    input_values, mask_time_indices=mask_time_indices, sampled_negative_indices=sampled_negative_indices
).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, Wav2Vec2ForPreTraining
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.models.wav2vec2.modeling_wav2vec2 <span class="hljs-keyword">import</span> _compute_mask_indices, _sample_negative_indices
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = Wav2Vec2ForPreTraining.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = feature_extractor(ds[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_values  <span class="hljs-comment"># Batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute masked indices</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>batch_size, raw_sequence_length = input_values.shape
<span class="hljs-meta">&gt;&gt;&gt; </span>sequence_length = model._get_feat_extract_output_lengths(raw_sequence_length).item()
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_time_indices = _compute_mask_indices(
<span class="hljs-meta">... </span>    shape=(batch_size, sequence_length), mask_prob=<span class="hljs-number">0.2</span>, mask_length=<span class="hljs-number">2</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampled_negative_indices = _sample_negative_indices(
<span class="hljs-meta">... </span>    features_shape=(batch_size, sequence_length),
<span class="hljs-meta">... </span>    num_negatives=model.config.num_negatives,
<span class="hljs-meta">... </span>    mask_time_indices=mask_time_indices,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_time_indices = torch.tensor(data=mask_time_indices, device=input_values.device, dtype=torch.long)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampled_negative_indices = torch.tensor(
<span class="hljs-meta">... </span>    data=sampled_negative_indices, device=input_values.device, dtype=torch.long
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(input_values, mask_time_indices=mask_time_indices)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute cosine similarity between predicted (=projected_states) and target (=projected_quantized_states)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>cosine_sim = torch.cosine_similarity(outputs.projected_states, outputs.projected_quantized_states, dim=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># show that cosine similarity is much higher than random</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>cosine_sim[mask_time_indices.to(torch.<span class="hljs-built_in">bool</span>)].mean() &gt; <span class="hljs-number">0.5</span>
tensor(<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># for contrastive loss training model should be put into train mode</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = model.train()
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(
<span class="hljs-meta">... </span>    input_values, mask_time_indices=mask_time_indices, sampled_negative_indices=sampled_negative_indices
<span class="hljs-meta">... </span>).loss`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Ix(W){let m,b,g,f,v,l,h,V,M,L,A,z,N,E,O,C,ce,J,S,de,I,R,De,X,Z,Se,We,Q,Ke,$t,Ie,D,Y,tt,ae,Je,jt,Ve,Fe,Wt,U,Vt,Ee,ot,we,Ce,qe,Ft,he,at,ee,ye,Pe,B,Et,te,Ct,st;return{c(){m=n("p"),b=a("TensorFlow models and layers in "),g=n("code"),f=a("transformers"),v=a(" accept two formats as input:"),l=d(),h=n("ul"),V=n("li"),M=a("having all inputs as keyword arguments (like PyTorch models), or"),L=d(),A=n("li"),z=a("having all inputs as a list, tuple or dict in the first positional argument."),N=d(),E=n("p"),O=a(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),C=n("code"),ce=a("model.fit()"),J=a(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),S=n("code"),de=a("model.fit()"),I=a(` supports! If, however, you want to use the second
format outside of Keras methods like `),R=n("code"),De=a("fit()"),X=a(" and "),Z=n("code"),Se=a("predict()"),We=a(`, such as when creating your own layers or models with
the Keras `),Q=n("code"),Ke=a("Functional"),$t=a(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),Ie=d(),D=n("ul"),Y=n("li"),tt=a("a single Tensor with "),ae=n("code"),Je=a("input_values"),jt=a(" only and nothing else: "),Ve=n("code"),Fe=a("model(input_values)"),Wt=d(),U=n("li"),Vt=a(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Ee=n("code"),ot=a("model([input_values, attention_mask])"),we=a(" or "),Ce=n("code"),qe=a("model([input_values, attention_mask, token_type_ids])"),Ft=d(),he=n("li"),at=a(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),ee=n("code"),ye=a('model({"input_values": input_values, "token_type_ids": token_type_ids})'),Pe=d(),B=n("p"),Et=a(`Note that when creating models and layers with
`),te=n("a"),Ct=a("subclassing"),st=a(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(j){m=r(j,"P",{});var q=i(m);b=s(q,"TensorFlow models and layers in "),g=r(q,"CODE",{});var Nt=i(g);f=s(Nt,"transformers"),Nt.forEach(t),v=s(q," accept two formats as input:"),q.forEach(t),l=p(j),h=r(j,"UL",{});var fe=i(h);V=r(fe,"LI",{});var Bt=i(V);M=s(Bt,"having all inputs as keyword arguments (like PyTorch models), or"),Bt.forEach(t),L=p(fe),A=r(fe,"LI",{});var ke=i(A);z=s(ke,"having all inputs as a list, tuple or dict in the first positional argument."),ke.forEach(t),fe.forEach(t),N=p(j),E=r(j,"P",{});var P=i(E);O=s(P,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),C=r(P,"CODE",{});var Qt=i(C);ce=s(Qt,"model.fit()"),Qt.forEach(t),J=s(P,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),S=r(P,"CODE",{});var Ze=i(S);de=s(Ze,"model.fit()"),Ze.forEach(t),I=s(P,` supports! If, however, you want to use the second
format outside of Keras methods like `),R=r(P,"CODE",{});var Yt=i(R);De=s(Yt,"fit()"),Yt.forEach(t),X=s(P," and "),Z=r(P,"CODE",{});var eo=i(Z);Se=s(eo,"predict()"),eo.forEach(t),We=s(P,`, such as when creating your own layers or models with
the Keras `),Q=r(P,"CODE",{});var to=i(Q);Ke=s(to,"Functional"),to.forEach(t),$t=s(P,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),P.forEach(t),Ie=p(j),D=r(j,"UL",{});var H=i(D);Y=r(H,"LI",{});var pe=i(Y);tt=s(pe,"a single Tensor with "),ae=r(pe,"CODE",{});var oo=i(ae);Je=s(oo,"input_values"),oo.forEach(t),jt=s(pe," only and nothing else: "),Ve=r(pe,"CODE",{});var ao=i(Ve);Fe=s(ao,"model(input_values)"),ao.forEach(t),pe.forEach(t),Wt=p(H),U=r(H,"LI",{});var se=i(U);Vt=s(se,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Ee=r(se,"CODE",{});var so=i(Ee);ot=s(so,"model([input_values, attention_mask])"),so.forEach(t),we=s(se," or "),Ce=r(se,"CODE",{});var no=i(Ce);qe=s(no,"model([input_values, attention_mask, token_type_ids])"),no.forEach(t),se.forEach(t),Ft=p(H),he=r(H,"LI",{});var Ae=i(he);at=s(Ae,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),ee=r(Ae,"CODE",{});var ro=i(ee);ye=s(ro,'model({"input_values": input_values, "token_type_ids": token_type_ids})'),ro.forEach(t),Ae.forEach(t),H.forEach(t),Pe=p(j),B=r(j,"P",{});var Qe=i(B);Et=s(Qe,`Note that when creating models and layers with
`),te=r(Qe,"A",{href:!0,rel:!0});var io=i(te);Ct=s(io,"subclassing"),io.forEach(t),st=s(Qe,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),Qe.forEach(t),this.h()},h(){c(te,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(te,"rel","nofollow")},m(j,q){_(j,m,q),e(m,b),e(m,g),e(g,f),e(m,v),_(j,l,q),_(j,h,q),e(h,V),e(V,M),e(h,L),e(h,A),e(A,z),_(j,N,q),_(j,E,q),e(E,O),e(E,C),e(C,ce),e(E,J),e(E,S),e(S,de),e(E,I),e(E,R),e(R,De),e(E,X),e(E,Z),e(Z,Se),e(E,We),e(E,Q),e(Q,Ke),e(E,$t),_(j,Ie,q),_(j,D,q),e(D,Y),e(Y,tt),e(Y,ae),e(ae,Je),e(Y,jt),e(Y,Ve),e(Ve,Fe),e(D,Wt),e(D,U),e(U,Vt),e(U,Ee),e(Ee,ot),e(U,we),e(U,Ce),e(Ce,qe),e(D,Ft),e(D,he),e(he,at),e(he,ee),e(ee,ye),_(j,Pe,q),_(j,B,q),e(B,Et),e(B,te),e(te,Ct),e(B,st)},d(j){j&&t(m),j&&t(l),j&&t(h),j&&t(N),j&&t(E),j&&t(Ie),j&&t(D),j&&t(Pe),j&&t(B)}}}function Nx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Bx(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoProcessor, TFWav2Vec2Model
from datasets import load_dataset
import soundfile as sf

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-base-960h")
model = TFWav2Vec2Model.from_pretrained("facebook/wav2vec2-base-960h")


def map_to_array(batch):
    speech, _ = sf.read(batch["file"])
    batch["speech"] = speech
    return batch


ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
ds = ds.map(map_to_array)

input_values = processor(ds["speech"][0], return_tensors="tf").input_values  # Batch size 1
hidden_states = model(input_values).last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, TFWav2Vec2Model
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> soundfile <span class="hljs-keyword">as</span> sf

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFWav2Vec2Model.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    speech, _ = sf.read(batch[<span class="hljs-string">&quot;file&quot;</span>])
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = speech
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.<span class="hljs-built_in">map</span>(map_to_array)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = processor(ds[<span class="hljs-string">&quot;speech&quot;</span>][<span class="hljs-number">0</span>], return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_values  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>hidden_states = model(input_values).last_hidden_state`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Rx(W){let m,b,g,f,v,l,h,V,M,L,A,z,N,E,O,C,ce,J,S,de,I,R,De,X,Z,Se,We,Q,Ke,$t,Ie,D,Y,tt,ae,Je,jt,Ve,Fe,Wt,U,Vt,Ee,ot,we,Ce,qe,Ft,he,at,ee,ye,Pe,B,Et,te,Ct,st;return{c(){m=n("p"),b=a("TensorFlow models and layers in "),g=n("code"),f=a("transformers"),v=a(" accept two formats as input:"),l=d(),h=n("ul"),V=n("li"),M=a("having all inputs as keyword arguments (like PyTorch models), or"),L=d(),A=n("li"),z=a("having all inputs as a list, tuple or dict in the first positional argument."),N=d(),E=n("p"),O=a(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),C=n("code"),ce=a("model.fit()"),J=a(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),S=n("code"),de=a("model.fit()"),I=a(` supports! If, however, you want to use the second
format outside of Keras methods like `),R=n("code"),De=a("fit()"),X=a(" and "),Z=n("code"),Se=a("predict()"),We=a(`, such as when creating your own layers or models with
the Keras `),Q=n("code"),Ke=a("Functional"),$t=a(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),Ie=d(),D=n("ul"),Y=n("li"),tt=a("a single Tensor with "),ae=n("code"),Je=a("input_values"),jt=a(" only and nothing else: "),Ve=n("code"),Fe=a("model(input_values)"),Wt=d(),U=n("li"),Vt=a(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Ee=n("code"),ot=a("model([input_values, attention_mask])"),we=a(" or "),Ce=n("code"),qe=a("model([input_values, attention_mask, token_type_ids])"),Ft=d(),he=n("li"),at=a(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),ee=n("code"),ye=a('model({"input_values": input_values, "token_type_ids": token_type_ids})'),Pe=d(),B=n("p"),Et=a(`Note that when creating models and layers with
`),te=n("a"),Ct=a("subclassing"),st=a(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(j){m=r(j,"P",{});var q=i(m);b=s(q,"TensorFlow models and layers in "),g=r(q,"CODE",{});var Nt=i(g);f=s(Nt,"transformers"),Nt.forEach(t),v=s(q," accept two formats as input:"),q.forEach(t),l=p(j),h=r(j,"UL",{});var fe=i(h);V=r(fe,"LI",{});var Bt=i(V);M=s(Bt,"having all inputs as keyword arguments (like PyTorch models), or"),Bt.forEach(t),L=p(fe),A=r(fe,"LI",{});var ke=i(A);z=s(ke,"having all inputs as a list, tuple or dict in the first positional argument."),ke.forEach(t),fe.forEach(t),N=p(j),E=r(j,"P",{});var P=i(E);O=s(P,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),C=r(P,"CODE",{});var Qt=i(C);ce=s(Qt,"model.fit()"),Qt.forEach(t),J=s(P,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),S=r(P,"CODE",{});var Ze=i(S);de=s(Ze,"model.fit()"),Ze.forEach(t),I=s(P,` supports! If, however, you want to use the second
format outside of Keras methods like `),R=r(P,"CODE",{});var Yt=i(R);De=s(Yt,"fit()"),Yt.forEach(t),X=s(P," and "),Z=r(P,"CODE",{});var eo=i(Z);Se=s(eo,"predict()"),eo.forEach(t),We=s(P,`, such as when creating your own layers or models with
the Keras `),Q=r(P,"CODE",{});var to=i(Q);Ke=s(to,"Functional"),to.forEach(t),$t=s(P,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),P.forEach(t),Ie=p(j),D=r(j,"UL",{});var H=i(D);Y=r(H,"LI",{});var pe=i(Y);tt=s(pe,"a single Tensor with "),ae=r(pe,"CODE",{});var oo=i(ae);Je=s(oo,"input_values"),oo.forEach(t),jt=s(pe," only and nothing else: "),Ve=r(pe,"CODE",{});var ao=i(Ve);Fe=s(ao,"model(input_values)"),ao.forEach(t),pe.forEach(t),Wt=p(H),U=r(H,"LI",{});var se=i(U);Vt=s(se,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),Ee=r(se,"CODE",{});var so=i(Ee);ot=s(so,"model([input_values, attention_mask])"),so.forEach(t),we=s(se," or "),Ce=r(se,"CODE",{});var no=i(Ce);qe=s(no,"model([input_values, attention_mask, token_type_ids])"),no.forEach(t),se.forEach(t),Ft=p(H),he=r(H,"LI",{});var Ae=i(he);at=s(Ae,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),ee=r(Ae,"CODE",{});var ro=i(ee);ye=s(ro,'model({"input_values": input_values, "token_type_ids": token_type_ids})'),ro.forEach(t),Ae.forEach(t),H.forEach(t),Pe=p(j),B=r(j,"P",{});var Qe=i(B);Et=s(Qe,`Note that when creating models and layers with
`),te=r(Qe,"A",{href:!0,rel:!0});var io=i(te);Ct=s(io,"subclassing"),io.forEach(t),st=s(Qe,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),Qe.forEach(t),this.h()},h(){c(te,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),c(te,"rel","nofollow")},m(j,q){_(j,m,q),e(m,b),e(m,g),e(g,f),e(m,v),_(j,l,q),_(j,h,q),e(h,V),e(V,M),e(h,L),e(h,A),e(A,z),_(j,N,q),_(j,E,q),e(E,O),e(E,C),e(C,ce),e(E,J),e(E,S),e(S,de),e(E,I),e(E,R),e(R,De),e(E,X),e(E,Z),e(Z,Se),e(E,We),e(E,Q),e(Q,Ke),e(E,$t),_(j,Ie,q),_(j,D,q),e(D,Y),e(Y,tt),e(Y,ae),e(ae,Je),e(Y,jt),e(Y,Ve),e(Ve,Fe),e(D,Wt),e(D,U),e(U,Vt),e(U,Ee),e(Ee,ot),e(U,we),e(U,Ce),e(Ce,qe),e(D,Ft),e(D,he),e(he,at),e(he,ee),e(ee,ye),_(j,Pe,q),_(j,B,q),e(B,Et),e(B,te),e(te,Ct),e(B,st)},d(j){j&&t(m),j&&t(l),j&&t(h),j&&t(N),j&&t(E),j&&t(Ie),j&&t(D),j&&t(Pe),j&&t(B)}}}function Ux(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Hx(W){let m,b,g,f,v;return f=new Oe({props:{code:`import tensorflow as tf
from transformers import AutoProcessor, TFWav2Vec2ForCTC
from datasets import load_dataset
import soundfile as sf

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-base-960h")
model = TFWav2Vec2ForCTC.from_pretrained("facebook/wav2vec2-base-960h")


def map_to_array(batch):
    speech, _ = sf.read(batch["file"])
    batch["speech"] = speech
    return batch


ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
ds = ds.map(map_to_array)

input_values = processor(ds["speech"][0], return_tensors="tf").input_values  # Batch size 1
logits = model(input_values).logits
predicted_ids = tf.argmax(logits, axis=-1)

transcription = processor.decode(predicted_ids[0])

# compute loss
target_transcription = "A MAN SAID TO THE UNIVERSE SIR I EXIST"

# Pass transcription as \`text\` to encode labels
labels = processor(text=transcription, return_tensors="tf").input_ids

loss = model(input_values, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, TFWav2Vec2ForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> soundfile <span class="hljs-keyword">as</span> sf

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFWav2Vec2ForCTC.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-base-960h&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    speech, _ = sf.read(batch[<span class="hljs-string">&quot;file&quot;</span>])
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = speech
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.<span class="hljs-built_in">map</span>(map_to_array)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = processor(ds[<span class="hljs-string">&quot;speech&quot;</span>][<span class="hljs-number">0</span>], return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_values  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(input_values).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_ids = tf.argmax(logits, axis=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>transcription = processor.decode(predicted_ids[<span class="hljs-number">0</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute loss</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_transcription = <span class="hljs-string">&quot;A MAN SAID TO THE UNIVERSE SIR I EXIST&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Pass transcription as \`text\` to encode labels</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = processor(text=transcription, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(input_values, labels=labels).loss`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Xx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Gx(W){let m,b,g,f,v;return f=new Oe({props:{code:`from transformers import AutoProcessor, FlaxWav2Vec2Model
from datasets import load_dataset
import soundfile as sf

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-large-lv60")
model = FlaxWav2Vec2Model.from_pretrained("facebook/wav2vec2-large-lv60")


def map_to_array(batch):
    speech, _ = sf.read(batch["file"])
    batch["speech"] = speech
    return batch


ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
ds = ds.map(map_to_array)

input_values = processor(
    ds["speech"][0], sampling_rate=16_000, return_tensors="np"
).input_values  # Batch size 1
hidden_states = model(input_values).last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, FlaxWav2Vec2Model
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> soundfile <span class="hljs-keyword">as</span> sf

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-lv60&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxWav2Vec2Model.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-lv60&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    speech, _ = sf.read(batch[<span class="hljs-string">&quot;file&quot;</span>])
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = speech
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.<span class="hljs-built_in">map</span>(map_to_array)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = processor(
<span class="hljs-meta">... </span>    ds[<span class="hljs-string">&quot;speech&quot;</span>][<span class="hljs-number">0</span>], sampling_rate=<span class="hljs-number">16_000</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>
<span class="hljs-meta">... </span>).input_values  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>hidden_states = model(input_values).last_hidden_state`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Kx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Jx(W){let m,b,g,f,v;return f=new Oe({props:{code:`import jax.numpy as jnp
from transformers import AutoProcessor, FlaxWav2Vec2ForCTC
from datasets import load_dataset
import soundfile as sf

processor = AutoProcessor.from_pretrained("facebook/wav2vec2-large-960h-lv60")
model = FlaxWav2Vec2ForCTC.from_pretrained("facebook/wav2vec2-large-960h-lv60")


def map_to_array(batch):
    speech, _ = sf.read(batch["file"])
    batch["speech"] = speech
    return batch


ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
ds = ds.map(map_to_array)

input_values = processor(
    ds["speech"][0], sampling_rate=16_000, return_tensors="np"
).input_values  # Batch size 1
logits = model(input_values).logits
predicted_ids = jnp.argmax(logits, axis=-1)

transcription = processor.decode(predicted_ids[0])
# should give:  "A MAN SAID TO THE UNIVERSE SIR I EXIST"`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, FlaxWav2Vec2ForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> soundfile <span class="hljs-keyword">as</span> sf

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-960h-lv60&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxWav2Vec2ForCTC.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-960h-lv60&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    speech, _ = sf.read(batch[<span class="hljs-string">&quot;file&quot;</span>])
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = speech
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.<span class="hljs-built_in">map</span>(map_to_array)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = processor(
<span class="hljs-meta">... </span>    ds[<span class="hljs-string">&quot;speech&quot;</span>][<span class="hljs-number">0</span>], sampling_rate=<span class="hljs-number">16_000</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>
<span class="hljs-meta">... </span>).input_values  <span class="hljs-comment"># Batch size 1</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(input_values).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_ids = jnp.argmax(logits, axis=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>transcription = processor.decode(predicted_ids[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># should give:  &quot;A MAN SAID TO THE UNIVERSE SIR I EXIST&quot;</span>`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Zx(W){let m,b,g,f,v;return{c(){m=n("p"),b=a("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),f=a("Module"),v=a(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=r(h,"CODE",{});var V=i(g);f=s(V,"Module"),V.forEach(t),v=s(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(t)},m(l,h){_(l,m,h),e(m,b),e(m,g),e(g,f),e(m,v)},d(l){l&&t(m)}}}function Qx(W){let m,b,g,f,v;return f=new Oe({props:{code:`import optax
import numpy as np
import jax.numpy as jnp
from transformers import AutoFeatureExtractor, FlaxWav2Vec2ForPreTraining
from transformers.models.wav2vec2.modeling_flax_wav2vec2 import _compute_mask_indices
from datasets import load_dataset
import soundfile as sf

feature_extractor = AutoFeatureExtractor.from_pretrained("facebook/wav2vec2-large-lv60")
model = FlaxWav2Vec2ForPreTraining.from_pretrained("facebook/wav2vec2-large-lv60")


def map_to_array(batch):
    speech, _ = sf.read(batch["file"])
    batch["speech"] = speech
    return batch


ds = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
ds = ds.map(map_to_array)

input_values = feature_extractor(ds["speech"][0], return_tensors="np").input_values  # Batch size 1

# compute masked indices
batch_size, raw_sequence_length = input_values.shape
sequence_length = model._get_feat_extract_output_lengths(raw_sequence_length)
mask_time_indices = _compute_mask_indices((batch_size, sequence_length), mask_prob=0.2, mask_length=2)

outputs = model(input_values, mask_time_indices=mask_time_indices)

# compute cosine similarity between predicted (=projected_states) and target (=projected_quantized_states)
cosine_sim = optax.cosine_similarity(outputs.projected_states, outputs.projected_quantized_states)

# show that cosine similarity is much higher than random
assert np.asarray(cosine_sim)[mask_time_indices].mean() > 0.5`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> optax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax.numpy <span class="hljs-keyword">as</span> jnp
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, FlaxWav2Vec2ForPreTraining
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.models.wav2vec2.modeling_flax_wav2vec2 <span class="hljs-keyword">import</span> _compute_mask_indices
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> soundfile <span class="hljs-keyword">as</span> sf

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-lv60&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxWav2Vec2ForPreTraining.from_pretrained(<span class="hljs-string">&quot;facebook/wav2vec2-large-lv60&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    speech, _ = sf.read(batch[<span class="hljs-string">&quot;file&quot;</span>])
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = speech
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span>ds = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.<span class="hljs-built_in">map</span>(map_to_array)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_values = feature_extractor(ds[<span class="hljs-string">&quot;speech&quot;</span>][<span class="hljs-number">0</span>], return_tensors=<span class="hljs-string">&quot;np&quot;</span>).input_values  <span class="hljs-comment"># Batch size 1</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute masked indices</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>batch_size, raw_sequence_length = input_values.shape
<span class="hljs-meta">&gt;&gt;&gt; </span>sequence_length = model._get_feat_extract_output_lengths(raw_sequence_length)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_time_indices = _compute_mask_indices((batch_size, sequence_length), mask_prob=<span class="hljs-number">0.2</span>, mask_length=<span class="hljs-number">2</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_values, mask_time_indices=mask_time_indices)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute cosine similarity between predicted (=projected_states) and target (=projected_quantized_states)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>cosine_sim = optax.cosine_similarity(outputs.projected_states, outputs.projected_quantized_states)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># show that cosine similarity is much higher than random</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">assert</span> np.asarray(cosine_sim)[mask_time_indices].mean() &gt; <span class="hljs-number">0.5</span>`}}),{c(){m=n("p"),b=a("Example:"),g=d(),w(f.$$.fragment)},l(l){m=r(l,"P",{});var h=i(m);b=s(h,"Example:"),h.forEach(t),g=p(l),y(f.$$.fragment,l)},m(l,h){_(l,m,h),e(m,b),_(l,g,h),k(f,l,h),v=!0},p:Ge,i(l){v||(T(f.$$.fragment,l),v=!0)},o(l){x(f.$$.fragment,l),v=!1},d(l){l&&t(m),l&&t(g),$(f,l)}}}function Yx(W){let m,b,g,f,v,l,h,V,M,L,A,z,N,E,O,C,ce,J,S,de,I,R,De,X,Z,Se,We,Q,Ke,$t,Ie,D,Y,tt,ae,Je,jt,Ve,Fe,Wt,U,Vt,Ee,ot,we,Ce,qe,Ft,he,at,ee,ye,Pe,B,Et,te,Ct,st,j,q,Nt,fe,Bt,ke,P,Qt,Ze,Yt,eo,to,H,pe,oo,ao,se,so,no,Ae,ro,Qe,io,tc,Mi,Lh,vp,xs,bp,Te,$s,Oh,js,Dh,Sh,Ih,Ws,Nh,Vs,Bh,Rh,Uh,Fs,Hh,Es,Xh,Gh,Kh,Cs,Jh,qs,Zh,Qh,Yh,Rt,Li,ef,tf,Ps,of,af,As,sf,nf,rf,oc,Oi,lf,wp,Di,cf,yp,Si,zs,df,Ms,pf,mf,kp,lo,Jo,ac,Ls,hf,sc,ff,Tp,Ye,Os,uf,co,gf,Ii,_f,vf,Ds,bf,wf,yf,po,kf,Ni,Tf,xf,Bi,$f,jf,Wf,Zo,xp,mo,Qo,nc,Ss,Vf,rc,Ff,$p,ne,Is,Ef,ic,Cf,qf,Ns,Pf,Ri,Af,zf,Mf,Yo,Bs,Lf,lc,Of,Df,Ui,Rs,Sf,nt,Us,If,cc,Nf,Bf,Hs,Rf,dc,Uf,Hf,Xf,ea,Gf,ta,Xs,Kf,pc,Jf,jp,ho,oa,mc,Gs,Zf,hc,Qf,Wp,et,Ks,Yf,fc,eu,tu,Js,ou,Hi,au,su,nu,aa,Zs,ru,uc,iu,Vp,fo,sa,gc,Qs,lu,_c,cu,Fp,G,Ys,du,vc,pu,mu,Ne,Xi,hu,fu,Gi,uu,gu,Ki,_u,vu,en,bc,bu,wu,yu,Ji,ku,Tu,xu,na,tn,$u,qt,ju,on,wc,Wu,Vu,Fu,yc,Eu,Cu,an,kc,qu,Pu,Au,zu,ra,sn,Mu,Pt,Lu,Zi,Ou,Du,Tc,Su,Iu,Qi,Nu,Bu,Ru,Yi,nn,Uu,Ut,rn,Hu,ln,Xu,el,Gu,Ku,Ju,ia,Zu,la,cn,Qu,dn,Yu,tl,eg,tg,og,ca,pn,ag,mn,sg,ol,ng,rg,Ep,uo,da,xc,hn,ig,$c,lg,Cp,oe,fn,cg,jc,dg,pg,pa,un,mg,At,hg,gn,Wc,fg,ug,gg,Vc,_g,vg,_n,Fc,bg,wg,yg,kg,ma,vn,Tg,zt,xg,al,$g,jg,Ec,Wg,Vg,sl,Fg,Eg,Cg,Ht,bn,qg,wn,Pg,nl,Ag,zg,Mg,ha,Lg,rl,yn,Og,rt,kn,Dg,Cc,Sg,Ig,fa,Ng,Tn,Bg,il,Rg,Ug,Hg,Xt,xn,Xg,qc,Gg,Kg,ua,qp,go,ga,Pc,$n,Jg,Ac,Zg,Pp,xe,Qg,ll,Yg,e_,zc,t_,o_,cl,a_,s_,dl,n_,r_,Mc,i_,l_,Ap,jn,zp,_o,_a,Lc,Wn,c_,Oc,d_,Mp,vo,Vn,p_,Fn,m_,Dc,h_,f_,Lp,bo,En,u_,Sc,g_,Op,wo,Cn,__,qn,v_,pl,b_,w_,Dp,Mt,Pn,y_,An,k_,Ic,T_,x_,$_,va,zn,j_,Nc,W_,Sp,Lt,Mn,V_,Ln,F_,Bc,E_,C_,q_,ba,On,P_,Rc,A_,Ip,yo,wa,Uc,Dn,z_,Hc,M_,Np,ze,Sn,L_,In,O_,Nn,D_,S_,I_,Bn,N_,ml,B_,R_,U_,Rn,H_,Un,X_,G_,K_,it,Hn,J_,ko,Z_,hl,Q_,Y_,Xc,e2,t2,o2,ya,a2,ka,Bp,To,Ta,Gc,Xn,s2,Kc,n2,Rp,Me,Gn,r2,xo,i2,Jc,l2,c2,Kn,d2,p2,m2,Jn,h2,fl,f2,u2,g2,Zn,_2,Qn,v2,b2,w2,lt,Yn,y2,$o,k2,ul,T2,x2,Zc,$2,j2,W2,xa,V2,$a,Up,jo,ja,Qc,er,F2,Yc,E2,Hp,ue,tr,C2,ed,q2,P2,or,A2,ar,z2,M2,L2,sr,O2,gl,D2,S2,I2,nr,N2,rr,B2,R2,U2,ct,ir,H2,Wo,X2,_l,G2,K2,td,J2,Z2,Q2,Wa,Y2,Va,Xp,Vo,Fa,od,lr,ev,ad,tv,Gp,ge,cr,ov,sd,av,sv,dr,nv,pr,rv,iv,lv,mr,cv,vl,dv,pv,mv,hr,hv,fr,fv,uv,gv,dt,ur,_v,Fo,vv,bl,bv,wv,nd,yv,kv,Tv,Ea,xv,Ca,Kp,Eo,qa,rd,gr,$v,id,jv,Jp,_e,_r,Wv,ld,Vv,Fv,vr,Ev,br,Cv,qv,Pv,wr,Av,wl,zv,Mv,Lv,yr,Ov,kr,Dv,Sv,Iv,pt,Tr,Nv,Co,Bv,yl,Rv,Uv,cd,Hv,Xv,Gv,Pa,Kv,Aa,Zp,qo,za,dd,xr,Jv,pd,Zv,Qp,Le,$r,Qv,Po,Yv,md,eb,tb,jr,ob,ab,sb,Wr,nb,kl,rb,ib,lb,Vr,cb,Fr,db,pb,mb,mt,Er,hb,Ao,fb,Tl,ub,gb,hd,_b,vb,bb,Ma,wb,La,Yp,zo,Oa,fd,Cr,yb,ud,kb,em,ve,qr,Tb,gd,xb,$b,Pr,jb,xl,Wb,Vb,Fb,Ar,Eb,zr,Cb,qb,Pb,Da,Ab,ht,Mr,zb,Mo,Mb,$l,Lb,Ob,_d,Db,Sb,Ib,Sa,Nb,Ia,tm,Lo,Na,vd,Lr,Bb,bd,Rb,om,Oo,Or,Ub,jl,Dr,am,Do,Ba,wd,Sr,Hb,yd,Xb,sm,be,Ir,Gb,Nr,Kb,kd,Jb,Zb,Qb,Br,Yb,Wl,ew,tw,ow,Rr,aw,Ur,sw,nw,rw,Ra,iw,ft,Hr,lw,So,cw,Vl,dw,pw,Td,mw,hw,fw,Ua,uw,Ha,nm,Io,Xa,xd,Xr,gw,$d,_w,rm,re,Gr,vw,Kr,bw,Jr,ww,yw,kw,Zr,Tw,Fl,xw,$w,jw,Qr,Ww,Yr,Vw,Fw,Ew,jd,Cw,qw,Ot,Wd,ei,Pw,Aw,Vd,ti,zw,Mw,Fd,oi,Lw,Ow,Ed,ai,Dw,Sw,ut,si,Iw,No,Nw,Cd,Bw,Rw,qd,Uw,Hw,Xw,Ga,Gw,Ka,im,Bo,Ja,Pd,ni,Kw,Ad,Jw,lm,ie,ri,Zw,Ro,Qw,zd,Yw,e1,ii,t1,o1,a1,li,s1,El,n1,r1,i1,ci,l1,di,c1,d1,p1,Md,m1,h1,Dt,Ld,pi,f1,u1,Od,mi,g1,_1,Dd,hi,v1,b1,Sd,fi,w1,y1,gt,ui,k1,Uo,T1,Id,x1,$1,Nd,j1,W1,V1,Za,F1,Qa,cm,Ho,Ya,Bd,gi,E1,Rd,C1,dm,le,_i,q1,Xo,P1,Ud,A1,z1,vi,M1,L1,O1,bi,D1,Cl,S1,I1,N1,wi,B1,yi,R1,U1,H1,Hd,X1,G1,St,Xd,ki,K1,J1,Gd,Ti,Z1,Q1,Kd,xi,Y1,ey,Jd,$i,ty,oy,_t,ji,ay,Go,sy,ql,ny,ry,Zd,iy,ly,cy,es,dy,ts,pm;return l=new K({}),E=new K({}),B=new K({}),fe=new _x({props:{pipeline:"audio-classification"}}),xs=new _x({props:{pipeline:"automatic-speech-recognition"}}),Ls=new K({}),Os=new F({props:{name:"class transformers.Wav2Vec2Config",anchor:"transformers.Wav2Vec2Config",parameters:[{name:"vocab_size",val:" = 32"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout",val:" = 0.1"},{name:"activation_dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.1"},{name:"feat_proj_dropout",val:" = 0.0"},{name:"feat_quantizer_dropout",val:" = 0.0"},{name:"final_dropout",val:" = 0.1"},{name:"layerdrop",val:" = 0.1"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"feat_extract_norm",val:" = 'group'"},{name:"feat_extract_activation",val:" = 'gelu'"},{name:"conv_dim",val:" = (512, 512, 512, 512, 512, 512, 512)"},{name:"conv_stride",val:" = (5, 2, 2, 2, 2, 2, 2)"},{name:"conv_kernel",val:" = (10, 3, 3, 3, 3, 2, 2)"},{name:"conv_bias",val:" = False"},{name:"num_conv_pos_embeddings",val:" = 128"},{name:"num_conv_pos_embedding_groups",val:" = 16"},{name:"do_stable_layer_norm",val:" = False"},{name:"apply_spec_augment",val:" = True"},{name:"mask_time_prob",val:" = 0.05"},{name:"mask_time_length",val:" = 10"},{name:"mask_time_min_masks",val:" = 2"},{name:"mask_feature_prob",val:" = 0.0"},{name:"mask_feature_length",val:" = 10"},{name:"mask_feature_min_masks",val:" = 0"},{name:"num_codevectors_per_group",val:" = 320"},{name:"num_codevector_groups",val:" = 2"},{name:"contrastive_logits_temperature",val:" = 0.1"},{name:"num_negatives",val:" = 100"},{name:"codevector_dim",val:" = 256"},{name:"proj_codevector_dim",val:" = 256"},{name:"diversity_loss_weight",val:" = 0.1"},{name:"ctc_loss_reduction",val:" = 'sum'"},{name:"ctc_zero_infinity",val:" = False"},{name:"use_weighted_layer_sum",val:" = False"},{name:"classifier_proj_size",val:" = 256"},{name:"tdnn_dim",val:" = (512, 512, 512, 512, 1500)"},{name:"tdnn_kernel",val:" = (5, 3, 3, 1, 1)"},{name:"tdnn_dilation",val:" = (1, 2, 3, 1, 1)"},{name:"xvector_output_dim",val:" = 512"},{name:"pad_token_id",val:" = 0"},{name:"bos_token_id",val:" = 1"},{name:"eos_token_id",val:" = 2"},{name:"add_adapter",val:" = False"},{name:"adapter_kernel_size",val:" = 3"},{name:"adapter_stride",val:" = 2"},{name:"num_adapter_layers",val:" = 3"},{name:"output_hidden_size",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2Config.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Vocabulary size of the Wav2Vec2 model. Defines the number of different tokens that can be represented by
the <code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Model">Wav2Vec2Model</a> or <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.TFWav2Vec2Model">TFWav2Vec2Model</a>. Vocabulary size of the
model. Defines the different tokens that can be represented by the <em>inputs_ids</em> passed to the forward
method of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Model">Wav2Vec2Model</a>.`,name:"vocab_size"},{anchor:"transformers.Wav2Vec2Config.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.Wav2Vec2Config.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.Wav2Vec2Config.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.Wav2Vec2Config.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.Wav2Vec2Config.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.Wav2Vec2Config.hidden_dropout",description:`<strong>hidden_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout"},{anchor:"transformers.Wav2Vec2Config.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.Wav2Vec2Config.final_dropout",description:`<strong>final_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for the final projection layer of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC">Wav2Vec2ForCTC</a>.`,name:"final_dropout"},{anchor:"transformers.Wav2Vec2Config.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.Wav2Vec2Config.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.Wav2Vec2Config.feat_extract_norm",description:`<strong>feat_extract_norm</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;group&quot;</code>) &#x2014;
The norm to be applied to 1D convolutional layers in feature encoder. One of <code>&quot;group&quot;</code> for group
normalization of only the first 1D convolutional layer or <code>&quot;layer&quot;</code> for layer normalization of all 1D
convolutional layers.`,name:"feat_extract_norm"},{anchor:"transformers.Wav2Vec2Config.feat_proj_dropout",description:`<strong>feat_proj_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probability for output of the feature encoder.`,name:"feat_proj_dropout"},{anchor:"transformers.Wav2Vec2Config.feat_extract_activation",description:"<strong>feat_extract_activation</strong> (<code>str, </code>optional<code>, defaults to </code>&#x201C;gelu&#x201D;<code>) -- The non-linear activation function (function or string) in the 1D convolutional layers of the feature extractor. If string, </code>&#x201C;gelu&#x201D;<code>, </code>&#x201C;relu&#x201D;<code>, </code>&#x201C;selu&#x201D;<code>and</code>&#x201C;gelu_new&#x201D;` are supported.",name:"feat_extract_activation"},{anchor:"transformers.Wav2Vec2Config.feat_quantizer_dropout",description:`<strong>feat_quantizer_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for quantized feature encoder states.`,name:"feat_quantizer_dropout"},{anchor:"transformers.Wav2Vec2Config.conv_dim",description:`<strong>conv_dim</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(512, 512, 512, 512, 512, 512, 512)</code>) &#x2014;
A tuple of integers defining the number of input and output channels of each 1D convolutional layer in the
feature encoder. The length of <em>conv_dim</em> defines the number of 1D convolutional layers.`,name:"conv_dim"},{anchor:"transformers.Wav2Vec2Config.conv_stride",description:`<strong>conv_stride</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(5, 2, 2, 2, 2, 2, 2)</code>) &#x2014;
A tuple of integers defining the stride of each 1D convolutional layer in the feature encoder. The length
of <em>conv_stride</em> defines the number of convolutional layers and has to match the length of <em>conv_dim</em>.`,name:"conv_stride"},{anchor:"transformers.Wav2Vec2Config.conv_kernel",description:`<strong>conv_kernel</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(10, 3, 3, 3, 3, 3, 3)</code>) &#x2014;
A tuple of integers defining the kernel size of each 1D convolutional layer in the feature encoder. The
length of <em>conv_kernel</em> defines the number of convolutional layers and has to match the length of
<em>conv_dim</em>.`,name:"conv_kernel"},{anchor:"transformers.Wav2Vec2Config.conv_bias",description:`<strong>conv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the 1D convolutional layers have a bias.`,name:"conv_bias"},{anchor:"transformers.Wav2Vec2Config.num_conv_pos_embeddings",description:`<strong>num_conv_pos_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 128) &#x2014;
Number of convolutional positional embeddings. Defines the kernel size of 1D convolutional positional
embeddings layer.`,name:"num_conv_pos_embeddings"},{anchor:"transformers.Wav2Vec2Config.num_conv_pos_embedding_groups",description:`<strong>num_conv_pos_embedding_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of groups of 1D convolutional positional embeddings layer.`,name:"num_conv_pos_embedding_groups"},{anchor:"transformers.Wav2Vec2Config.do_stable_layer_norm",description:`<strong>do_stable_layer_norm</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to apply <em>stable</em> layer norm architecture of the Transformer encoder. <code>do_stable_layer_norm is True</code> corresponds to applying layer norm before the attention layer, whereas <code>do_stable_layer_norm is False</code> corresponds to applying layer norm after the attention layer.`,name:"do_stable_layer_norm"},{anchor:"transformers.Wav2Vec2Config.apply_spec_augment",description:`<strong>apply_spec_augment</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to apply <em>SpecAugment</em> data augmentation to the outputs of the feature encoder. For reference see
<a href="https://arxiv.org/abs/1904.08779" rel="nofollow">SpecAugment: A Simple Data Augmentation Method for Automatic Speech
Recognition</a>.`,name:"apply_spec_augment"},{anchor:"transformers.Wav2Vec2Config.mask_time_prob",description:`<strong>mask_time_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.05) &#x2014;
Percentage (between 0 and 1) of all feature vectors along the time axis which will be masked. The masking
procecure generates &#x201D;mask_time_prob<em>len(time_axis)/mask_time_length&#x201D; independent masks over the axis. If
reasoning from the propability of each feature vector to be chosen as the start of the vector span to be
masked, </em>mask_time_prob<em> should be \`prob_vector_start</em>mask_time_length<code>. Note that overlap may decrease the actual percentage of masked vectors. This is only relevant if </code>apply_spec_augment is True\`.`,name:"mask_time_prob"},{anchor:"transformers.Wav2Vec2Config.mask_time_length",description:`<strong>mask_time_length</strong> (<code>int</code>, <em>optional</em>, defaults to 10) &#x2014;
Length of vector span along the time axis.`,name:"mask_time_length"},{anchor:"transformers.Wav2Vec2Config.mask_time_min_masks",description:`<strong>mask_time_min_masks</strong> (<code>int</code>, <em>optional</em>, defaults to 2), &#x2014;
The minimum number of masks of length <code>mask_feature_length</code> generated along the time axis, each time step,
irrespectively of <code>mask_feature_prob</code>. Only relevant if &#x201D;mask_time_prob*len(time_axis)/mask_time_length &lt;
mask_time_min_masks&#x201D;`,name:"mask_time_min_masks"},{anchor:"transformers.Wav2Vec2Config.mask_feature_prob",description:`<strong>mask_feature_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Percentage (between 0 and 1) of all feature vectors along the feature axis which will be masked. The
masking procecure generates &#x201D;mask_feature_prob<em>len(feature_axis)/mask_time_length&#x201D; independent masks over
the axis. If reasoning from the propability of each feature vector to be chosen as the start of the vector
span to be masked, </em>mask_feature_prob<em> should be \`prob_vector_start</em>mask_feature_length<code>. Note that overlap may decrease the actual percentage of masked vectors. This is only relevant if </code>apply_spec_augment is
True\`.`,name:"mask_feature_prob"},{anchor:"transformers.Wav2Vec2Config.mask_feature_length",description:`<strong>mask_feature_length</strong> (<code>int</code>, <em>optional</em>, defaults to 10) &#x2014;
Length of vector span along the feature axis.`,name:"mask_feature_length"},{anchor:"transformers.Wav2Vec2Config.mask_feature_min_masks",description:`<strong>mask_feature_min_masks</strong> (<code>int</code>, <em>optional</em>, defaults to 0), &#x2014;
The minimum number of masks of length <code>mask_feature_length</code> generated along the feature axis, each time
step, irrespectively of <code>mask_feature_prob</code>. Only relevant if
&#x201D;mask_feature_prob*len(feature_axis)/mask_feature_length &lt; mask_feature_min_masks&#x201D;`,name:"mask_feature_min_masks"},{anchor:"transformers.Wav2Vec2Config.num_codevectors_per_group",description:`<strong>num_codevectors_per_group</strong> (<code>int</code>, <em>optional</em>, defaults to 320) &#x2014;
Number of entries in each quantization codebook (group).`,name:"num_codevectors_per_group"},{anchor:"transformers.Wav2Vec2Config.num_codevector_groups",description:`<strong>num_codevector_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
Number of codevector groups for product codevector quantization.`,name:"num_codevector_groups"},{anchor:"transformers.Wav2Vec2Config.contrastive_logits_temperature",description:`<strong>contrastive_logits_temperature</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The temperature <em>kappa</em> in the contrastive loss.`,name:"contrastive_logits_temperature"},{anchor:"transformers.Wav2Vec2Config.feat_quantizer_dropout",description:`<strong>feat_quantizer_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for the output of the feature encoder that&#x2019;s used by the quantizer.`,name:"feat_quantizer_dropout"},{anchor:"transformers.Wav2Vec2Config.num_negatives",description:`<strong>num_negatives</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Number of negative samples for the contrastive loss.`,name:"num_negatives"},{anchor:"transformers.Wav2Vec2Config.codevector_dim",description:`<strong>codevector_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the quantized feature vectors.`,name:"codevector_dim"},{anchor:"transformers.Wav2Vec2Config.proj_codevector_dim",description:`<strong>proj_codevector_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the final projection of both the quantized and the transformer features.`,name:"proj_codevector_dim"},{anchor:"transformers.Wav2Vec2Config.diversity_loss_weight",description:`<strong>diversity_loss_weight</strong> (<code>int</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The weight of the codebook diversity loss component.`,name:"diversity_loss_weight"},{anchor:"transformers.Wav2Vec2Config.ctc_loss_reduction",description:`<strong>ctc_loss_reduction</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sum&quot;</code>) &#x2014;
Specifies the reduction to apply to the output of <code>torch.nn.CTCLoss</code>. Only relevant when training an
instance of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC">Wav2Vec2ForCTC</a>.`,name:"ctc_loss_reduction"},{anchor:"transformers.Wav2Vec2Config.ctc_zero_infinity",description:`<strong>ctc_zero_infinity</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to zero infinite losses and the associated gradients of <code>torch.nn.CTCLoss</code>. Infinite losses mainly
occur when the inputs are too short to be aligned to the targets. Only relevant when training an instance
of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC">Wav2Vec2ForCTC</a>.`,name:"ctc_zero_infinity"},{anchor:"transformers.Wav2Vec2Config.use_weighted_layer_sum",description:`<strong>use_weighted_layer_sum</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use a weighted average of layer outputs with learned weights. Only relevant when using an
instance of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForSequenceClassification">Wav2Vec2ForSequenceClassification</a>.`,name:"use_weighted_layer_sum"},{anchor:"transformers.Wav2Vec2Config.classifier_proj_size",description:`<strong>classifier_proj_size</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimensionality of the projection before token mean-pooling for classification.`,name:"classifier_proj_size"},{anchor:"transformers.Wav2Vec2Config.tdnn_dim",description:`<strong>tdnn_dim</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(512, 512, 512, 512, 1500)</code>) &#x2014;
A tuple of integers defining the number of output channels of each 1D convolutional layer in the <em>TDNN</em>
module of the <em>XVector</em> model. The length of <em>tdnn_dim</em> defines the number of <em>TDNN</em> layers.`,name:"tdnn_dim"},{anchor:"transformers.Wav2Vec2Config.tdnn_kernel",description:`<strong>tdnn_kernel</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(5, 3, 3, 1, 1)</code>) &#x2014;
A tuple of integers defining the kernel size of each 1D convolutional layer in the <em>TDNN</em> module of the
<em>XVector</em> model. The length of <em>tdnn_kernel</em> has to match the length of <em>tdnn_dim</em>.`,name:"tdnn_kernel"},{anchor:"transformers.Wav2Vec2Config.tdnn_dilation",description:`<strong>tdnn_dilation</strong> (<code>Tuple[int]</code> or <code>List[int]</code>, <em>optional</em>, defaults to <code>(1, 2, 3, 1, 1)</code>) &#x2014;
A tuple of integers defining the dilation factor of each 1D convolutional layer in <em>TDNN</em> module of the
<em>XVector</em> model. The length of <em>tdnn_dilation</em> has to match the length of <em>tdnn_dim</em>.`,name:"tdnn_dilation"},{anchor:"transformers.Wav2Vec2Config.xvector_output_dim",description:`<strong>xvector_output_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
Dimensionality of the <em>XVector</em> embedding vectors.`,name:"xvector_output_dim"},{anchor:"transformers.Wav2Vec2Config.add_adapter",description:`<strong>add_adapter</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether a convolutional network should be stacked on top of the Wav2Vec2 Encoder. Can be very useful for
warm-starting Wav2Vec2 for SpeechEncoderDecoder models.`,name:"add_adapter"},{anchor:"transformers.Wav2Vec2Config.adapter_kernel_size",description:`<strong>adapter_kernel_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Kernel size of the convolutional layers in the adapter network. Only relevant if <code>add_adapter is True</code>.`,name:"adapter_kernel_size"},{anchor:"transformers.Wav2Vec2Config.adapter_stride",description:`<strong>adapter_stride</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
Stride of the convolutional layers in the adapter network. Only relevant if <code>add_adapter is True</code>.`,name:"adapter_stride"},{anchor:"transformers.Wav2Vec2Config.num_adapter_layers",description:`<strong>num_adapter_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
Number of convolutional layers that should be used in the adapter network. Only relevant if <code>add_adapter is True</code>.`,name:"num_adapter_layers"},{anchor:"transformers.Wav2Vec2Config.output_hidden_size",description:`<strong>output_hidden_size</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Dimensionality of the encoder output layer. If not defined, this defaults to <em>hidden-size</em>. Only relevant
if <code>add_adapter is True</code>.`,name:"output_hidden_size"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/configuration_wav2vec2.py#L32"}}),Zo=new Xe({props:{anchor:"transformers.Wav2Vec2Config.example",$$slots:{default:[Tx]},$$scope:{ctx:W}}}),Ss=new K({}),Is=new F({props:{name:"class transformers.Wav2Vec2CTCTokenizer",anchor:"transformers.Wav2Vec2CTCTokenizer",parameters:[{name:"vocab_file",val:""},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"unk_token",val:" = '<unk>'"},{name:"pad_token",val:" = '<pad>'"},{name:"word_delimiter_token",val:" = '|'"},{name:"replace_word_delimiter_char",val:" = ' '"},{name:"do_lower_case",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2CTCTokenizer.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
File containing the vocabulary.`,name:"vocab_file"},{anchor:"transformers.Wav2Vec2CTCTokenizer.bos_token",description:`<strong>bos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;s&gt;&quot;</code>) &#x2014;
The beginning of sentence token.`,name:"bos_token"},{anchor:"transformers.Wav2Vec2CTCTokenizer.eos_token",description:`<strong>eos_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;/s&gt;&quot;</code>) &#x2014;
The end of sentence token.`,name:"eos_token"},{anchor:"transformers.Wav2Vec2CTCTokenizer.unk_token",description:`<strong>unk_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;unk&gt;&quot;</code>) &#x2014;
The unknown token. A token that is not in the vocabulary cannot be converted to an ID and is set to be this
token instead.`,name:"unk_token"},{anchor:"transformers.Wav2Vec2CTCTokenizer.pad_token",description:`<strong>pad_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&lt;pad&gt;&quot;</code>) &#x2014;
The token used for padding, for example when batching sequences of different lengths.`,name:"pad_token"},{anchor:"transformers.Wav2Vec2CTCTokenizer.word_delimiter_token",description:`<strong>word_delimiter_token</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;|&quot;</code>) &#x2014;
The token used for defining the end of a word.`,name:"word_delimiter_token"},{anchor:"transformers.Wav2Vec2CTCTokenizer.do_lower_case",description:`<strong>do_lower_case</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to accept lowercase input and lowercase the output when decoding.</p>
<p>**kwargs &#x2014;
Additional keyword arguments passed along to <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>`,name:"do_lower_case"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/tokenization_wav2vec2.py#L127"}}),Bs=new F({props:{name:"__call__",anchor:"transformers.Wav2Vec2CTCTokenizer.__call__",parameters:[{name:"text",val:": typing.Union[str, typing.List[str], typing.List[typing.List[str]]] = None"},{name:"text_pair",val:": typing.Union[str, typing.List[str], typing.List[typing.List[str]], NoneType] = None"},{name:"text_target",val:": typing.Union[str, typing.List[str], typing.List[typing.List[str]]] = None"},{name:"text_pair_target",val:": typing.Union[str, typing.List[str], typing.List[typing.List[str]], NoneType] = None"},{name:"add_special_tokens",val:": bool = True"},{name:"padding",val:": typing.Union[bool, str, transformers.utils.generic.PaddingStrategy] = False"},{name:"truncation",val:": typing.Union[bool, str, transformers.tokenization_utils_base.TruncationStrategy] = None"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"stride",val:": int = 0"},{name:"is_split_into_words",val:": bool = False"},{name:"pad_to_multiple_of",val:": typing.Optional[int] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"return_token_type_ids",val:": typing.Optional[bool] = None"},{name:"return_attention_mask",val:": typing.Optional[bool] = None"},{name:"return_overflowing_tokens",val:": bool = False"},{name:"return_special_tokens_mask",val:": bool = False"},{name:"return_offsets_mapping",val:": bool = False"},{name:"return_length",val:": bool = False"},{name:"verbose",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.text",description:`<strong>text</strong> (<code>str</code>, <code>List[str]</code>, <code>List[List[str]]</code>, <em>optional</em>) &#x2014;
The sequence or batch of sequences to be encoded. Each sequence can be a string or a list of strings
(pretokenized string). If the sequences are provided as list of strings (pretokenized), you must set
<code>is_split_into_words=True</code> (to lift the ambiguity with a batch of sequences).`,name:"text"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.text_pair",description:`<strong>text_pair</strong> (<code>str</code>, <code>List[str]</code>, <code>List[List[str]]</code>, <em>optional</em>) &#x2014;
The sequence or batch of sequences to be encoded. Each sequence can be a string or a list of strings
(pretokenized string). If the sequences are provided as list of strings (pretokenized), you must set
<code>is_split_into_words=True</code> (to lift the ambiguity with a batch of sequences).`,name:"text_pair"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.text_target",description:`<strong>text_target</strong> (<code>str</code>, <code>List[str]</code>, <code>List[List[str]]</code>, <em>optional</em>) &#x2014;
The sequence or batch of sequences to be encoded as target texts. Each sequence can be a string or a
list of strings (pretokenized string). If the sequences are provided as list of strings (pretokenized),
you must set <code>is_split_into_words=True</code> (to lift the ambiguity with a batch of sequences).`,name:"text_target"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.text_pair_target",description:`<strong>text_pair_target</strong> (<code>str</code>, <code>List[str]</code>, <code>List[List[str]]</code>, <em>optional</em>) &#x2014;
The sequence or batch of sequences to be encoded as target texts. Each sequence can be a string or a
list of strings (pretokenized string). If the sequences are provided as list of strings (pretokenized),
you must set <code>is_split_into_words=True</code> (to lift the ambiguity with a batch of sequences).`,name:"text_pair_target"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.add_special_tokens",description:`<strong>add_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to encode the sequences with the special tokens relative to their model.`,name:"add_special_tokens"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.padding",description:`<strong>padding</strong> (<code>bool</code>, <code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.utils.PaddingStrategy">PaddingStrategy</a>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Activates and controls padding. Accepts the following values:</p>
<ul>
<li><code>True</code> or <code>&apos;longest&apos;</code>: Pad to the longest sequence in the batch (or no padding if only a single
sequence if provided).</li>
<li><code>&apos;max_length&apos;</code>: Pad to a maximum length specified with the argument <code>max_length</code> or to the maximum
acceptable input length for the model if that argument is not provided.</li>
<li><code>False</code> or <code>&apos;do_not_pad&apos;</code> (default): No padding (i.e., can output a batch with sequences of different
lengths).</li>
</ul>`,name:"padding"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.truncation",description:`<strong>truncation</strong> (<code>bool</code>, <code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.tokenization_utils_base.TruncationStrategy">TruncationStrategy</a>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Activates and controls truncation. Accepts the following values:</p>
<ul>
<li><code>True</code> or <code>&apos;longest_first&apos;</code>: Truncate to a maximum length specified with the argument <code>max_length</code> or
to the maximum acceptable input length for the model if that argument is not provided. This will
truncate token by token, removing a token from the longest sequence in the pair if a pair of
sequences (or a batch of pairs) is provided.</li>
<li><code>&apos;only_first&apos;</code>: Truncate to a maximum length specified with the argument <code>max_length</code> or to the
maximum acceptable input length for the model if that argument is not provided. This will only
truncate the first sequence of a pair if a pair of sequences (or a batch of pairs) is provided.</li>
<li><code>&apos;only_second&apos;</code>: Truncate to a maximum length specified with the argument <code>max_length</code> or to the
maximum acceptable input length for the model if that argument is not provided. This will only
truncate the second sequence of a pair if a pair of sequences (or a batch of pairs) is provided.</li>
<li><code>False</code> or <code>&apos;do_not_truncate&apos;</code> (default): No truncation (i.e., can output batch with sequence lengths
greater than the model maximum admissible input size).</li>
</ul>`,name:"truncation"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Controls the maximum length to use by one of the truncation/padding parameters.</p>
<p>If left unset or set to <code>None</code>, this will use the predefined model maximum length if a maximum length
is required by one of the truncation/padding parameters. If the model has no specific maximum input
length (like XLNet) truncation/padding to a maximum length will be deactivated.`,name:"max_length"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.stride",description:`<strong>stride</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
If set to a number along with <code>max_length</code>, the overflowing tokens returned when
<code>return_overflowing_tokens=True</code> will contain some tokens from the end of the truncated sequence
returned to provide some overlap between truncated and overflowing sequences. The value of this
argument defines the number of overlapping tokens.`,name:"stride"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.is_split_into_words",description:`<strong>is_split_into_words</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the input is already pre-tokenized (e.g., split into words). If set to <code>True</code>, the
tokenizer assumes the input is already split into words (for instance, by splitting it on whitespace)
which it will tokenize. This is useful for NER or token classification.`,name:"is_split_into_words"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.pad_to_multiple_of",description:`<strong>pad_to_multiple_of</strong> (<code>int</code>, <em>optional</em>) &#x2014;
If set will pad the sequence to a multiple of the provided value. Requires <code>padding</code> to be activated.
This is especially useful to enable the use of Tensor Cores on NVIDIA hardware with compute capability
<code>&gt;= 7.5</code> (Volta).`,name:"pad_to_multiple_of"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of list of python integers. Acceptable values are:</p>
<ul>
<li><code>&apos;tf&apos;</code>: Return TensorFlow <code>tf.constant</code> objects.</li>
<li><code>&apos;pt&apos;</code>: Return PyTorch <code>torch.Tensor</code> objects.</li>
<li><code>&apos;np&apos;</code>: Return Numpy <code>np.ndarray</code> objects.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_token_type_ids",description:`<strong>return_token_type_ids</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to return token type IDs. If left to the default, will return the token type IDs according to
the specific tokenizer&#x2019;s default, defined by the <code>return_outputs</code> attribute.</p>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"return_token_type_ids"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_attention_mask",description:`<strong>return_attention_mask</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to return the attention mask. If left to the default, will return the attention mask according
to the specific tokenizer&#x2019;s default, defined by the <code>return_outputs</code> attribute.</p>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"return_attention_mask"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_overflowing_tokens",description:`<strong>return_overflowing_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return overflowing token sequences. If a pair of sequences of input ids (or a batch
of pairs) is provided with <code>truncation_strategy = longest_first</code> or <code>True</code>, an error is raised instead
of returning overflowing tokens.`,name:"return_overflowing_tokens"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_special_tokens_mask",description:`<strong>return_special_tokens_mask</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return special tokens mask information.`,name:"return_special_tokens_mask"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_offsets_mapping",description:`<strong>return_offsets_mapping</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return <code>(char_start, char_end)</code> for each token.</p>
<p>This is only available on fast tokenizers inheriting from <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast">PreTrainedTokenizerFast</a>, if using
Python&#x2019;s tokenizer, this method will raise <code>NotImplementedError</code>.`,name:"return_offsets_mapping"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.return_length",description:`<strong>return_length</strong>  (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to return the lengths of the encoded inputs.`,name:"return_length"},{anchor:"transformers.Wav2Vec2CTCTokenizer.__call__.verbose",description:`<strong>verbose</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to print more information and warnings.
**kwargs &#x2014; passed to the <code>self.tokenize()</code> method`,name:"verbose"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/tokenization_utils_base.py#L2474",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.BatchEncoding"
>BatchEncoding</a> with the following fields:</p>
<ul>
<li>
<p><strong>input_ids</strong> \u2014 List of token ids to be fed to a model.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a></p>
</li>
<li>
<p><strong>token_type_ids</strong> \u2014 List of token type ids to be fed to a model (when <code>return_token_type_ids=True</code> or
if <em>\u201Ctoken_type_ids\u201D</em> is in <code>self.model_input_names</code>).</p>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a></p>
</li>
<li>
<p><strong>attention_mask</strong> \u2014 List of indices specifying which tokens should be attended to by the model (when
<code>return_attention_mask=True</code> or if <em>\u201Cattention_mask\u201D</em> is in <code>self.model_input_names</code>).</p>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
</li>
<li>
<p><strong>overflowing_tokens</strong> \u2014 List of overflowing tokens sequences (when a <code>max_length</code> is specified and
<code>return_overflowing_tokens=True</code>).</p>
</li>
<li>
<p><strong>num_truncated_tokens</strong> \u2014 Number of tokens truncated (when a <code>max_length</code> is specified and
<code>return_overflowing_tokens=True</code>).</p>
</li>
<li>
<p><strong>special_tokens_mask</strong> \u2014 List of 0s and 1s, with 1 specifying added special tokens and 0 specifying
regular sequence tokens (when <code>add_special_tokens=True</code> and <code>return_special_tokens_mask=True</code>).</p>
</li>
<li>
<p><strong>length</strong> \u2014 The length of the inputs (when <code>return_length=True</code>)</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.BatchEncoding"
>BatchEncoding</a></p>
`}}),Rs=new F({props:{name:"save_vocabulary",anchor:"transformers.Wav2Vec2CTCTokenizer.save_vocabulary",parameters:[{name:"save_directory",val:": str"},{name:"filename_prefix",val:": typing.Optional[str] = None"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/tokenization_wav2vec2.py#L600"}}),Us=new F({props:{name:"decode",anchor:"transformers.Wav2Vec2CTCTokenizer.decode",parameters:[{name:"token_ids",val:": typing.Union[int, typing.List[int], ForwardRef('np.ndarray'), ForwardRef('torch.Tensor'), ForwardRef('tf.Tensor')]"},{name:"skip_special_tokens",val:": bool = False"},{name:"clean_up_tokenization_spaces",val:": bool = None"},{name:"output_char_offsets",val:": bool = False"},{name:"output_word_offsets",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.token_ids",description:`<strong>token_ids</strong> (<code>Union[int, List[int], np.ndarray, torch.Tensor, tf.Tensor]</code>) &#x2014;
List of tokenized input ids. Can be obtained using the <code>__call__</code> method.`,name:"token_ids"},{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.skip_special_tokens",description:`<strong>skip_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to remove special tokens in the decoding.`,name:"skip_special_tokens"},{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.clean_up_tokenization_spaces",description:`<strong>clean_up_tokenization_spaces</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to clean up the tokenization spaces.`,name:"clean_up_tokenization_spaces"},{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.output_char_offsets",description:`<strong>output_char_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output character offsets. Character offsets can be used in combination with the
sampling rate and model downsampling rate to compute the time-stamps of transcribed characters.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the example below to better understand how to make use of <code>output_char_offsets</code>.</p>

					</div>`,name:"output_char_offsets"},{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.output_word_offsets",description:`<strong>output_word_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output word offsets. Word offsets can be used in combination with the sampling rate
and model downsampling rate to compute the time-stamps of transcribed words.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the example below to better understand how to make use of <code>output_word_offsets</code>.</p>

					</div>`,name:"output_word_offsets"},{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.kwargs",description:`<strong>kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Will be passed to the underlying model specific decode method.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/tokenization_wav2vec2.py#L495",returnDescription:`
<p>The list of decoded
sentences. Will be a <code>Wav2Vec2CTCTokenizerOutput</code> when
<code>output_char_offsets == True</code> or <code>output_word_offsets == True</code>.</p>
`,returnType:`
<p><code>str</code> or <code>Wav2Vec2CTCTokenizerOutput</code></p>
`}}),ea=new Xe({props:{anchor:"transformers.Wav2Vec2CTCTokenizer.decode.example",$$slots:{default:[xx]},$$scope:{ctx:W}}}),Xs=new F({props:{name:"batch_decode",anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode",parameters:[{name:"sequences",val:": typing.Union[typing.List[int], typing.List[typing.List[int]], ForwardRef('np.ndarray'), ForwardRef('torch.Tensor'), ForwardRef('tf.Tensor')]"},{name:"skip_special_tokens",val:": bool = False"},{name:"clean_up_tokenization_spaces",val:": bool = None"},{name:"output_char_offsets",val:": bool = False"},{name:"output_word_offsets",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.sequences",description:`<strong>sequences</strong> (<code>Union[List[int], List[List[int]], np.ndarray, torch.Tensor, tf.Tensor]</code>) &#x2014;
List of tokenized input ids. Can be obtained using the <code>__call__</code> method.`,name:"sequences"},{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.skip_special_tokens",description:`<strong>skip_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to remove special tokens in the decoding.`,name:"skip_special_tokens"},{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.clean_up_tokenization_spaces",description:`<strong>clean_up_tokenization_spaces</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to clean up the tokenization spaces.`,name:"clean_up_tokenization_spaces"},{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.output_char_offsets",description:`<strong>output_char_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output character offsets. Character offsets can be used in combination with the
sampling rate and model downsampling rate to compute the time-stamps of transcribed characters.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the Example of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer.decode">decode()</a> to better understand how to make
use of <code>output_char_offsets</code>. <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer.batch_decode">batch_decode()</a> works the same way with batched
output.</p>

					</div>`,name:"output_char_offsets"},{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.output_word_offsets",description:`<strong>output_word_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output word offsets. Word offsets can be used in combination with the sampling rate
and model downsampling rate to compute the time-stamps of transcribed words.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the Example of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer.decode">decode()</a> to better understand how to make
use of <code>output_word_offsets</code>. <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer.batch_decode">batch_decode()</a> works the same way with batched
output.</p>

					</div>`,name:"output_word_offsets"},{anchor:"transformers.Wav2Vec2CTCTokenizer.batch_decode.kwargs",description:`<strong>kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Will be passed to the underlying model specific decode method.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/tokenization_wav2vec2.py#L425",returnDescription:`
<p>The list of decoded
sentences. Will be a <code>Wav2Vec2CTCTokenizerOutput</code> when
<code>output_char_offsets == True</code> or <code>output_word_offsets == True</code>.</p>
`,returnType:`
<p><code>List[str]</code> or <code>Wav2Vec2CTCTokenizerOutput</code></p>
`}}),Gs=new K({}),Ks=new F({props:{name:"class transformers.Wav2Vec2FeatureExtractor",anchor:"transformers.Wav2Vec2FeatureExtractor",parameters:[{name:"feature_size",val:" = 1"},{name:"sampling_rate",val:" = 16000"},{name:"padding_value",val:" = 0.0"},{name:"return_attention_mask",val:" = False"},{name:"do_normalize",val:" = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2FeatureExtractor.feature_size",description:`<strong>feature_size</strong> (<code>int</code>, defaults to 1) &#x2014;
The feature dimension of the extracted features.`,name:"feature_size"},{anchor:"transformers.Wav2Vec2FeatureExtractor.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, defaults to 16000) &#x2014;
The sampling rate at which the audio files should be digitalized expressed in hertz (Hz).`,name:"sampling_rate"},{anchor:"transformers.Wav2Vec2FeatureExtractor.padding_value",description:`<strong>padding_value</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The value that is used to fill the padding values.`,name:"padding_value"},{anchor:"transformers.Wav2Vec2FeatureExtractor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to zero-mean unit-variance normalize the input. Normalizing can help to significantly
improve the performance for some models, <em>e.g.</em>,
<a href="https://huggingface.co/models?search=lv60" rel="nofollow">wav2vec2-lv60</a>.`,name:"do_normalize"},{anchor:"transformers.Wav2Vec2FeatureExtractor.return_attention_mask",description:`<strong>return_attention_mask</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor.__call__"><strong>call</strong>()</a> should return <code>attention_mask</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Wav2Vec2 models that have set <code>config.feat_extract_norm == &quot;group&quot;</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, have <strong>not</strong> been trained using
<code>attention_mask</code>. For such models, <code>input_values</code> should simply be padded with 0 and no <code>attention_mask</code>
should be passed.</p>
<p>For Wav2Vec2 models that have set <code>config.feat_extract_norm == &quot;layer&quot;</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-large-960h-lv60-self" rel="nofollow">wav2vec2-lv60</a>, <code>attention_mask</code> should be
passed for batched inference.</p>

					</div>`,name:"return_attention_mask"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/feature_extraction_wav2vec2.py#L31"}}),Zs=new F({props:{name:"__call__",anchor:"transformers.Wav2Vec2FeatureExtractor.__call__",parameters:[{name:"raw_speech",val:": typing.Union[numpy.ndarray, typing.List[float], typing.List[numpy.ndarray], typing.List[typing.List[float]]]"},{name:"padding",val:": typing.Union[bool, str, transformers.utils.generic.PaddingStrategy] = False"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"truncation",val:": bool = False"},{name:"pad_to_multiple_of",val:": typing.Optional[int] = None"},{name:"return_attention_mask",val:": typing.Optional[bool] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"sampling_rate",val:": typing.Optional[int] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.raw_speech",description:`<strong>raw_speech</strong> (<code>np.ndarray</code>, <code>List[float]</code>, <code>List[np.ndarray]</code>, <code>List[List[float]]</code>) &#x2014;
The sequence or batch of sequences to be padded. Each sequence can be a numpy array, a list of float
values, a list of numpy arrays or a list of list of float values.`,name:"raw_speech"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.padding",description:`<strong>padding</strong> (<code>bool</code>, <code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.utils.PaddingStrategy">PaddingStrategy</a>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Select a strategy to pad the returned sequences (according to the model&#x2019;s padding side and padding
index) among:</p>
<ul>
<li><code>True</code> or <code>&apos;longest&apos;</code>: Pad to the longest sequence in the batch (or no padding if only a single
sequence if provided).</li>
<li><code>&apos;max_length&apos;</code>: Pad to a maximum length specified with the argument <code>max_length</code> or to the maximum
acceptable input length for the model if that argument is not provided.</li>
<li><code>False</code> or <code>&apos;do_not_pad&apos;</code> (default): No padding (i.e., can output a batch with sequences of different
lengths).</li>
</ul>`,name:"padding"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Maximum length of the returned list and optionally padding length (see above).`,name:"max_length"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.truncation",description:`<strong>truncation</strong> (<code>bool</code>) &#x2014;
Activates truncation to cut input sequences longer than <em>max_length</em> to <em>max_length</em>.`,name:"truncation"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.pad_to_multiple_of",description:`<strong>pad_to_multiple_of</strong> (<code>int</code>, <em>optional</em>) &#x2014;
If set will pad the sequence to a multiple of the provided value.</p>
<p>This is especially useful to enable the use of Tensor Cores on NVIDIA hardware with compute capability
<code>&gt;= 7.5</code> (Volta), or on TPUs which benefit from having sequence lengths be a multiple of 128.`,name:"pad_to_multiple_of"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.return_attention_mask",description:`<strong>return_attention_mask</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to return the attention mask. If left to the default, will return the attention mask according
to the specific feature_extractor&#x2019;s default.</p>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Wav2Vec2 models that have set <code>config.feat_extract_norm == &quot;group&quot;</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, have <strong>not</strong> been trained using
<code>attention_mask</code>. For such models, <code>input_values</code> should simply be padded with 0 and no
<code>attention_mask</code> should be passed.</p>
<p>For Wav2Vec2 models that have set <code>config.feat_extract_norm == &quot;layer&quot;</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-large-960h-lv60-self" rel="nofollow">wav2vec2-lv60</a>, <code>attention_mask</code> should
be passed for batched inference.</p>

					</div>`,name:"return_attention_mask"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of list of python integers. Acceptable values are:</p>
<ul>
<li><code>&apos;tf&apos;</code>: Return TensorFlow <code>tf.constant</code> objects.</li>
<li><code>&apos;pt&apos;</code>: Return PyTorch <code>torch.Tensor</code> objects.</li>
<li><code>&apos;np&apos;</code>: Return Numpy <code>np.ndarray</code> objects.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The sampling rate at which the <code>raw_speech</code> input was sampled. It is strongly recommended to pass
<code>sampling_rate</code> at the forward call to prevent silent errors.`,name:"sampling_rate"},{anchor:"transformers.Wav2Vec2FeatureExtractor.__call__.padding_value",description:"<strong>padding_value</strong> (<code>float</code>, defaults to 0.0) &#x2014;",name:"padding_value"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/feature_extraction_wav2vec2.py#L102"}}),Qs=new K({}),Ys=new F({props:{name:"class transformers.Wav2Vec2Processor",anchor:"transformers.Wav2Vec2Processor",parameters:[{name:"feature_extractor",val:""},{name:"tokenizer",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2Processor.feature_extractor",description:`<strong>feature_extractor</strong> (<code>Wav2Vec2FeatureExtractor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor">Wav2Vec2FeatureExtractor</a>. The feature extractor is a required input.`,name:"feature_extractor"},{anchor:"transformers.Wav2Vec2Processor.tokenizer",description:`<strong>tokenizer</strong> (<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a>. The tokenizer is a required input.`,name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L26"}}),tn=new F({props:{name:"__call__",anchor:"transformers.Wav2Vec2Processor.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L67"}}),sn=new F({props:{name:"pad",anchor:"transformers.Wav2Vec2Processor.pad",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L105"}}),nn=new F({props:{name:"from_pretrained",anchor:"transformers.Wav2Vec2Processor.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L48"}}),rn=new F({props:{name:"save_pretrained",anchor:"transformers.Wav2Vec2Processor.save_pretrained",parameters:[{name:"save_directory",val:""},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2Processor.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the feature extractor JSON file and the tokenizer files will be saved (directory will
be created if it does not exist).`,name:"save_directory"},{anchor:"transformers.Wav2Vec2Processor.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Hugging Face model hub after saving it. You can specify the
repository you want to push to with <code>repo_id</code> (will default to the name of <code>save_directory</code> in your
namespace).
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.push_to_hub">push_to_hub()</a> method.`,name:"push_to_hub"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/processing_utils.py#L91"}}),ia=new je({props:{$$slots:{default:[$x]},$$scope:{ctx:W}}}),cn=new F({props:{name:"batch_decode",anchor:"transformers.Wav2Vec2Processor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L135"}}),pn=new F({props:{name:"decode",anchor:"transformers.Wav2Vec2Processor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/processing_wav2vec2.py#L142"}}),hn=new K({}),fn=new F({props:{name:"class transformers.Wav2Vec2ProcessorWithLM",anchor:"transformers.Wav2Vec2ProcessorWithLM",parameters:[{name:"feature_extractor",val:": FeatureExtractionMixin"},{name:"tokenizer",val:": PreTrainedTokenizerBase"},{name:"decoder",val:": BeamSearchDecoderCTC"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ProcessorWithLM.feature_extractor",description:`<strong>feature_extractor</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor">Wav2Vec2FeatureExtractor</a>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor">Wav2Vec2FeatureExtractor</a>. The feature extractor is a required input.`,name:"feature_extractor"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.tokenizer",description:`<strong>tokenizer</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer">Wav2Vec2CTCTokenizer</a>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer">Wav2Vec2CTCTokenizer</a>. The tokenizer is a required input.`,name:"tokenizer"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decoder",description:`<strong>decoder</strong> (<code>pyctcdecode.BeamSearchDecoderCTC</code>) &#x2014;
An instance of <code>pyctcdecode.BeamSearchDecoderCTC</code>. The decoder is a required input.`,name:"decoder"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L67"}}),un=new F({props:{name:"__call__",anchor:"transformers.Wav2Vec2ProcessorWithLM.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L214"}}),vn=new F({props:{name:"pad",anchor:"transformers.Wav2Vec2ProcessorWithLM.pad",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L253"}}),bn=new F({props:{name:"from_pretrained",anchor:"transformers.Wav2Vec2ProcessorWithLM.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2ProcessorWithLM.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
This can be either:</p>
<ul>
<li>a string, the <em>model id</em> of a pretrained feature_extractor hosted inside a model repo on
huggingface.co. Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or
namespaced under a user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>a path to a <em>directory</em> containing a feature extractor file saved using the
<a href="/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained">save_pretrained()</a> method, e.g., <code>./my_model_directory/</code>.</li>
<li>a path or url to a saved feature extractor JSON <em>file</em>, e.g.,
<code>./my_model_directory/preprocessor_config.json</code>.
**kwargs &#x2014;
Additional keyword arguments passed along to both <a href="/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.SequenceFeatureExtractor">SequenceFeatureExtractor</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer">PreTrainedTokenizer</a></li>
</ul>`,name:"pretrained_model_name_or_path"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L112"}}),ha=new je({props:{$$slots:{default:[jx]},$$scope:{ctx:W}}}),yn=new F({props:{name:"save_pretrained",anchor:"transformers.Wav2Vec2ProcessorWithLM.save_pretrained",parameters:[{name:"save_directory",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L108"}}),kn=new F({props:{name:"batch_decode",anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode",parameters:[{name:"logits",val:": ndarray"},{name:"pool",val:": typing.Union[<bound method BaseContext.Pool of <multiprocessing.context.DefaultContext object at 0x7f1720f30f10>>, NoneType] = None"},{name:"num_processes",val:": typing.Optional[int] = None"},{name:"beam_width",val:": typing.Optional[int] = None"},{name:"beam_prune_logp",val:": typing.Optional[float] = None"},{name:"token_min_logp",val:": typing.Optional[float] = None"},{name:"hotwords",val:": typing.Optional[typing.Iterable[str]] = None"},{name:"hotword_weight",val:": typing.Optional[float] = None"},{name:"alpha",val:": typing.Optional[float] = None"},{name:"beta",val:": typing.Optional[float] = None"},{name:"unk_score_offset",val:": typing.Optional[float] = None"},{name:"lm_score_boundary",val:": typing.Optional[bool] = None"},{name:"output_word_offsets",val:": bool = False"},{name:"n_best",val:": int = 1"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.logits",description:`<strong>logits</strong> (<code>np.ndarray</code>) &#x2014;
The logits output vector of the model representing the log probabilities for each token.`,name:"logits"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.pool",description:`<strong>pool</strong> (<code>multiprocessing.Pool</code>, <em>optional</em>) &#x2014;
An optional user-managed pool. If not set, one will be automatically created and closed. The pool
should be instantiated <em>after</em> <code>Wav2Vec2ProcessorWithLM</code>. Otherwise, the LM won&#x2019;t be available to the
pool&#x2019;s sub-processes.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Currently, only pools created with a &#x2018;fork&#x2019; context can be used. If a &#x2018;spawn&#x2019; pool is passed, it will
be ignored and sequential decoding will be used instead.</p>

					</div>`,name:"pool"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.num_processes",description:`<strong>num_processes</strong> (<code>int</code>, <em>optional</em>) &#x2014;
If <code>pool</code> is not set, number of processes on which the function should be parallelized over. Defaults
to the number of available CPUs.`,name:"num_processes"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.beam_width",description:`<strong>beam_width</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Maximum number of beams at each step in decoding. Defaults to pyctcdecode&#x2019;s DEFAULT_BEAM_WIDTH.`,name:"beam_width"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.beam_prune_logp",description:`<strong>beam_prune_logp</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Beams that are much worse than best beam will be pruned Defaults to pyctcdecode&#x2019;s DEFAULT_PRUNE_LOGP.`,name:"beam_prune_logp"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.token_min_logp",description:`<strong>token_min_logp</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Tokens below this logp are skipped unless they are argmax of frame Defaults to pyctcdecode&#x2019;s
DEFAULT_MIN_TOKEN_LOGP.`,name:"token_min_logp"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.hotwords",description:`<strong>hotwords</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
List of words with extra importance, can be OOV for LM`,name:"hotwords"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.hotword_weight",description:`<strong>hotword_weight</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Weight factor for hotword importance Defaults to pyctcdecode&#x2019;s DEFAULT_HOTWORD_WEIGHT.`,name:"hotword_weight"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.alpha",description:`<strong>alpha</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Weight for language model during shallow fusion`,name:"alpha"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.beta",description:`<strong>beta</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Weight for length score adjustment of during scoring`,name:"beta"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.unk_score_offset",description:`<strong>unk_score_offset</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Amount of log score offset for unknown tokens`,name:"unk_score_offset"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.lm_score_boundary",description:`<strong>lm_score_boundary</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to have kenlm respect boundaries when scoring`,name:"lm_score_boundary"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.output_word_offsets",description:`<strong>output_word_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output word offsets. Word offsets can be used in combination with the sampling rate
and model downsampling rate to compute the time-stamps of transcribed words.`,name:"output_word_offsets"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.batch_decode.n_best",description:`<strong>n_best</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of best hypotheses to return. If <code>n_best</code> is greater than 1, the returned <code>text</code> will be a list
of lists of strings, <code>logit_score</code> will be a list of lists of floats, and <code>lm_score</code> will be a list of
lists of floats, where the length of the outer list will correspond to the batch size and the length of
the inner list will correspond to the number of returned hypotheses . The value should be &gt;= 1.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the Example of <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM.decode">decode()</a> to better understand how to
make use of <code>output_word_offsets</code>. <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM.batch_decode">batch_decode()</a> works the same way with
batched output.</p>

					</div>`,name:"n_best"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L284",returnDescription:`
<p><code>~models.wav2vec2.Wav2Vec2DecoderWithLMOutput</code>.</p>
`}}),fa=new je({props:{$$slots:{default:[Wx]},$$scope:{ctx:W}}}),xn=new F({props:{name:"decode",anchor:"transformers.Wav2Vec2ProcessorWithLM.decode",parameters:[{name:"logits",val:": ndarray"},{name:"beam_width",val:": typing.Optional[int] = None"},{name:"beam_prune_logp",val:": typing.Optional[float] = None"},{name:"token_min_logp",val:": typing.Optional[float] = None"},{name:"hotwords",val:": typing.Optional[typing.Iterable[str]] = None"},{name:"hotword_weight",val:": typing.Optional[float] = None"},{name:"alpha",val:": typing.Optional[float] = None"},{name:"beta",val:": typing.Optional[float] = None"},{name:"unk_score_offset",val:": typing.Optional[float] = None"},{name:"lm_score_boundary",val:": typing.Optional[bool] = None"},{name:"output_word_offsets",val:": bool = False"},{name:"n_best",val:": int = 1"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.logits",description:`<strong>logits</strong> (<code>np.ndarray</code>) &#x2014;
The logits output vector of the model representing the log probabilities for each token.`,name:"logits"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.beam_width",description:`<strong>beam_width</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Maximum number of beams at each step in decoding. Defaults to pyctcdecode&#x2019;s DEFAULT_BEAM_WIDTH.`,name:"beam_width"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.beam_prune_logp",description:`<strong>beam_prune_logp</strong> (<code>int</code>, <em>optional</em>) &#x2014;
A threshold to prune beams with log-probs less than best_beam_logp + beam_prune_logp. The value should
be &lt;= 0. Defaults to pyctcdecode&#x2019;s DEFAULT_PRUNE_LOGP.`,name:"beam_prune_logp"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.token_min_logp",description:`<strong>token_min_logp</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Tokens with log-probs below token_min_logp are skipped unless they are have the maximum log-prob for an
utterance. Defaults to pyctcdecode&#x2019;s DEFAULT_MIN_TOKEN_LOGP.`,name:"token_min_logp"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.hotwords",description:`<strong>hotwords</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
List of words with extra importance which can be missing from the LM&#x2019;s vocabulary, e.g. [&#x201C;huggingface&#x201D;]`,name:"hotwords"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.hotword_weight",description:`<strong>hotword_weight</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Weight multiplier that boosts hotword scores. Defaults to pyctcdecode&#x2019;s DEFAULT_HOTWORD_WEIGHT.`,name:"hotword_weight"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.alpha",description:`<strong>alpha</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Weight for language model during shallow fusion`,name:"alpha"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.beta",description:`<strong>beta</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Weight for length score adjustment of during scoring`,name:"beta"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.unk_score_offset",description:`<strong>unk_score_offset</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Amount of log score offset for unknown tokens`,name:"unk_score_offset"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.lm_score_boundary",description:`<strong>lm_score_boundary</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to have kenlm respect boundaries when scoring`,name:"lm_score_boundary"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.output_word_offsets",description:`<strong>output_word_offsets</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to output word offsets. Word offsets can be used in combination with the sampling rate
and model downsampling rate to compute the time-stamps of transcribed words.`,name:"output_word_offsets"},{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.n_best",description:`<strong>n_best</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of best hypotheses to return. If <code>n_best</code> is greater than 1, the returned <code>text</code> will be a list
of strings, <code>logit_score</code> will be a list of floats, and <code>lm_score</code> will be a list of floats, where the
length of these lists will correspond to the number of returned hypotheses. The value should be &gt;= 1.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Please take a look at the example below to better understand how to make use of <code>output_word_offsets</code>.</p>

					</div>`,name:"n_best"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L469",returnDescription:`
<p><code>~models.wav2vec2.Wav2Vec2DecoderWithLMOutput</code>.</p>
`}}),ua=new Xe({props:{anchor:"transformers.Wav2Vec2ProcessorWithLM.decode.example",$$slots:{default:[Vx]},$$scope:{ctx:W}}}),$n=new K({}),jn=new Oe({props:{code:`# Let's see how to use a user-managed pool for batch decoding multiple audios
from multiprocessing import get_context
from transformers import AutoTokenizer, AutoProcessor, AutoModelForCTC
from datasets import load_dataset
import datasets
import torch

# import model, feature extractor, tokenizer
model = AutoModelForCTC.from_pretrained("patrickvonplaten/wav2vec2-base-100h-with-lm").to("cuda")
processor = AutoProcessor.from_pretrained("patrickvonplaten/wav2vec2-base-100h-with-lm")

# load example dataset
dataset = load_dataset("hf-internal-testing/librispeech_asr_dummy", "clean", split="validation")
dataset = dataset.cast_column("audio", datasets.Audio(sampling_rate=16_000))


def map_to_array(batch):
    batch["speech"] = batch["audio"]["array"]
    return batch


# prepare speech data for batch inference
dataset = dataset.map(map_to_array, remove_columns=["audio"])


def map_to_pred(batch, pool):
    inputs = processor(batch["speech"], sampling_rate=16_000, padding=True, return_tensors="pt")
    inputs = {k: v.to("cuda") for k, v in inputs.items()}

    with torch.no_grad():
        logits = model(**inputs).logits

    transcription = processor.batch_decode(logits.cpu().numpy(), pool).text
    batch["transcription"] = transcription
    return batch


# note: pool should be instantiated *after* \`Wav2Vec2ProcessorWithLM\`.
#       otherwise, the LM won't be available to the pool's sub-processes
# select number of processes and batch_size based on number of CPU cores available and on dataset size
with get_context("fork").Pool(processes=2) as pool:
    result = dataset.map(
        map_to_pred, batched=True, batch_size=2, fn_kwargs={"pool": pool}, remove_columns=["speech"]
    )

result["transcription"][:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Let&#x27;s see how to use a user-managed pool for batch decoding multiple audios</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> multiprocessing <span class="hljs-keyword">import</span> get_context
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, AutoProcessor, AutoModelForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> datasets
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># import model, feature extractor, tokenizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCTC.from_pretrained(<span class="hljs-string">&quot;patrickvonplaten/wav2vec2-base-100h-with-lm&quot;</span>).to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;patrickvonplaten/wav2vec2-base-100h-with-lm&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load example dataset</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_dummy&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.cast_column(<span class="hljs-string">&quot;audio&quot;</span>, datasets.Audio(sampling_rate=<span class="hljs-number">16_000</span>))


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_array</span>(<span class="hljs-params">batch</span>):
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;speech&quot;</span>] = batch[<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>]
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare speech data for batch inference</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.<span class="hljs-built_in">map</span>(map_to_array, remove_columns=[<span class="hljs-string">&quot;audio&quot;</span>])


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">map_to_pred</span>(<span class="hljs-params">batch, pool</span>):
<span class="hljs-meta">... </span>    inputs = processor(batch[<span class="hljs-string">&quot;speech&quot;</span>], sampling_rate=<span class="hljs-number">16_000</span>, padding=<span class="hljs-literal">True</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">... </span>    inputs = {k: v.to(<span class="hljs-string">&quot;cuda&quot;</span>) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> inputs.items()}

<span class="hljs-meta">... </span>    <span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>        logits = model(**inputs).logits

<span class="hljs-meta">... </span>    transcription = processor.batch_decode(logits.cpu().numpy(), pool).text
<span class="hljs-meta">... </span>    batch[<span class="hljs-string">&quot;transcription&quot;</span>] = transcription
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> batch


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># note: pool should be instantiated *after* \`Wav2Vec2ProcessorWithLM\`.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment">#       otherwise, the LM won&#x27;t be available to the pool&#x27;s sub-processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># select number of processes and batch_size based on number of CPU cores available and on dataset size</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> get_context(<span class="hljs-string">&quot;fork&quot;</span>).Pool(processes=<span class="hljs-number">2</span>) <span class="hljs-keyword">as</span> pool:
<span class="hljs-meta">... </span>    result = dataset.<span class="hljs-built_in">map</span>(
<span class="hljs-meta">... </span>        map_to_pred, batched=<span class="hljs-literal">True</span>, batch_size=<span class="hljs-number">2</span>, fn_kwargs={<span class="hljs-string">&quot;pool&quot;</span>: pool}, remove_columns=[<span class="hljs-string">&quot;speech&quot;</span>]
<span class="hljs-meta">... </span>    )

<span class="hljs-meta">&gt;&gt;&gt; </span>result[<span class="hljs-string">&quot;transcription&quot;</span>][:<span class="hljs-number">2</span>]
[<span class="hljs-string">&#x27;MISTER QUILTER IS THE APOSTLE OF THE MIDDLE CLASSES AND WE ARE GLAD TO WELCOME HIS GOSPEL&#x27;</span>, <span class="hljs-string">&quot;NOR IS MISTER COULTER&#x27;S MANNER LESS INTERESTING THAN HIS MATTER&quot;</span>]`}}),Wn=new K({}),Vn=new F({props:{name:"class transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput",anchor:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput",parameters:[{name:"text",val:": typing.Union[typing.List[typing.List[str]], typing.List[str], str]"},{name:"logit_score",val:": typing.Union[typing.List[typing.List[float]], typing.List[float], float] = None"},{name:"lm_score",val:": typing.Union[typing.List[typing.List[float]], typing.List[float], float] = None"},{name:"word_offsets",val:": typing.Union[typing.List[typing.List[typing.List[typing.Dict[str, typing.Union[int, str]]]]], typing.List[typing.List[typing.Dict[str, typing.Union[int, str]]]], typing.List[typing.Dict[str, typing.Union[int, str]]]] = None"}],parametersDescription:[{anchor:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput.text",description:`<strong>text</strong> (list of <code>str</code> or <code>str</code>) &#x2014;
Decoded logits in text from. Usually the speech transcription.`,name:"text"},{anchor:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput.logit_score",description:`<strong>logit_score</strong> (list of <code>float</code> or <code>float</code>) &#x2014;
Total logit score of the beams associated with produced text.`,name:"logit_score"},{anchor:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput.lm_score",description:`<strong>lm_score</strong> (list of <code>float</code>) &#x2014;
Fused lm_score of the beams associated with produced text.`,name:"lm_score"},{anchor:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput.word_offsets",description:`<strong>word_offsets</strong> (list of <code>List[Dict[str, Union[int, str]]]</code> or <code>List[Dict[str, Union[int, str]]]</code>) &#x2014;
Offsets of the decoded words. In combination with sampling rate and model downsampling rate word offsets
can be used to compute time stamps for each word.`,name:"word_offsets"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2_with_lm/processing_wav2vec2_with_lm.py#L45"}}),En=new F({props:{name:"class transformers.modeling_outputs.Wav2Vec2BaseModelOutput",anchor:"transformers.modeling_outputs.Wav2Vec2BaseModelOutput",parameters:[{name:"last_hidden_state",val:": FloatTensor = None"},{name:"extract_features",val:": FloatTensor = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.modeling_outputs.Wav2Vec2BaseModelOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the model.`,name:"last_hidden_state"},{anchor:"transformers.modeling_outputs.Wav2Vec2BaseModelOutput.extract_features",description:`<strong>extract_features</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, conv_dim[-1])</code>) &#x2014;
Sequence of extracted feature vectors of the last convolutional layer of the model.`,name:"extract_features"},{anchor:"transformers.modeling_outputs.Wav2Vec2BaseModelOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.modeling_outputs.Wav2Vec2BaseModelOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/modeling_outputs.py#L1286"}}),Cn=new F({props:{name:"class transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput",anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"projected_states",val:": FloatTensor = None"},{name:"projected_quantized_states",val:": FloatTensor = None"},{name:"codevector_perplexity",val:": FloatTensor = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"contrastive_loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"diversity_loss",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.loss",description:`<strong>loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) &#x2014;
Total loss as the sum of the contrastive loss (L_m) and the diversity loss (L_d) as stated in the <a href="https://arxiv.org/pdf/2006.11477.pdf" rel="nofollow">official
paper</a> . (classification) loss.`,name:"loss"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.projected_states",description:`<strong>projected_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) &#x2014;
Hidden-states of the model projected to <em>config.proj_codevector_dim</em> that can be used to predict the masked
projected quantized states.`,name:"projected_states"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.projected_quantized_states",description:`<strong>projected_quantized_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) &#x2014;
Quantized extracted feature vectors projected to <em>config.proj_codevector_dim</em> representing the positive
target vectors for contrastive loss.`,name:"projected_quantized_states"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.`,name:"attentions"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.contrastive_loss",description:`<strong>contrastive_loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) &#x2014;
The contrastive loss (L_m) as stated in the <a href="https://arxiv.org/pdf/2006.11477.pdf" rel="nofollow">official paper</a> .`,name:"contrastive_loss"},{anchor:"transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput.diversity_loss",description:`<strong>diversity_loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) &#x2014;
The diversity loss (L_d) as stated in the <a href="https://arxiv.org/pdf/2006.11477.pdf" rel="nofollow">official paper</a> .`,name:"diversity_loss"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L91"}}),Pn=new F({props:{name:"class transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput",anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput",parameters:[{name:"last_hidden_state",val:": ndarray = None"},{name:"extract_features",val:": ndarray = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"}],parametersDescription:[{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput.extract_features",description:`<strong>extract_features</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, last_conv_dim)</code>) &#x2014;
Sequence of extracted feature vectors of the last convolutional layer of the model with <code>last_conv_dim</code>
being the dimension of the last convolutional layer.`,name:"extract_features"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L45"}}),zn=new F({props:{name:"replace",anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/flax/struct.py#L108"}}),Mn=new F({props:{name:"class transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput",anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput",parameters:[{name:"projected_states",val:": ndarray = None"},{name:"projected_quantized_states",val:": ndarray = None"},{name:"codevector_perplexity",val:": ndarray = None"},{name:"hidden_states",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"},{name:"attentions",val:": typing.Optional[typing.Tuple[jax._src.numpy.ndarray.ndarray]] = None"}],parametersDescription:[{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.loss",description:`<strong>loss</strong> (<em>optional</em>, returned when model is in train mode, <code>jnp.ndarray</code> of shape <code>(1,)</code>) &#x2014;
Total loss as the sum of the contrastive loss (L_m) and the diversity loss (L_d) as stated in the <a href="https://arxiv.org/pdf/2006.11477.pdf" rel="nofollow">official
paper</a> . (classification) loss.`,name:"loss"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.projected_states",description:`<strong>projected_states</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) &#x2014;
Hidden-states of the model projected to <em>config.proj_codevector_dim</em> that can be used to predict the masked
projected quantized states.`,name:"projected_states"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.projected_quantized_states",description:`<strong>projected_quantized_states</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) &#x2014;
Quantized extracted feature vectors projected to <em>config.proj_codevector_dim</em> representing the positive
target vectors for contrastive loss.`,name:"projected_quantized_states"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.hidden_states",description:`<strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.`,name:"hidden_states"},{anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.attentions",description:`<strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.`,name:"attentions"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L75"}}),On=new F({props:{name:"replace",anchor:"transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput.replace",parameters:[{name:"**updates",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/flax/struct.py#L108"}}),Dn=new K({}),Sn=new F({props:{name:"class transformers.Wav2Vec2Model",anchor:"transformers.Wav2Vec2Model",parameters:[{name:"config",val:": Wav2Vec2Config"}],parametersDescription:[{anchor:"transformers.Wav2Vec2Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1197"}}),Hn=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2Model.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"mask_time_indices",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2Model.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2Model.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2Model.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2Model.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2Model.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1283",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.Wav2Vec2BaseModelOutput"
>transformers.modeling_outputs.Wav2Vec2BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>extract_features</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, conv_dim[-1])</code>) \u2014 Sequence of extracted feature vectors of the last convolutional layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.Wav2Vec2BaseModelOutput"
>transformers.modeling_outputs.Wav2Vec2BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ya=new je({props:{$$slots:{default:[Fx]},$$scope:{ctx:W}}}),ka=new Xe({props:{anchor:"transformers.Wav2Vec2Model.forward.example",$$slots:{default:[Ex]},$$scope:{ctx:W}}}),Xn=new K({}),Gn=new F({props:{name:"class transformers.Wav2Vec2ForCTC",anchor:"transformers.Wav2Vec2ForCTC",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForCTC.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1616"}}),Yn=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2ForCTC.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForCTC.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2ForCTC.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2ForCTC.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2ForCTC.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2ForCTC.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Wav2Vec2ForCTC.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_length)</code>, <em>optional</em>) &#x2014;
Labels for connectionist temporal classification. Note that <code>target_length</code> has to be smaller or equal to
the sequence length of the output logits. Indices are selected in <code>[-100, 0, ..., config.vocab_size - 1]</code>.
All labels set to <code>-100</code> are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1657",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.CausalLMOutput"
>transformers.modeling_outputs.CausalLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.CausalLMOutput"
>transformers.modeling_outputs.CausalLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),xa=new je({props:{$$slots:{default:[Cx]},$$scope:{ctx:W}}}),$a=new Xe({props:{anchor:"transformers.Wav2Vec2ForCTC.forward.example",$$slots:{default:[qx]},$$scope:{ctx:W}}}),er=new K({}),tr=new F({props:{name:"class transformers.Wav2Vec2ForSequenceClassification",anchor:"transformers.Wav2Vec2ForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1744"}}),ir=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2ForSequenceClassification.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1789",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.SequenceClassifierOutput"
>transformers.modeling_outputs.SequenceClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Wa=new je({props:{$$slots:{default:[Px]},$$scope:{ctx:W}}}),Va=new Xe({props:{anchor:"transformers.Wav2Vec2ForSequenceClassification.forward.example",$$slots:{default:[Ax]},$$scope:{ctx:W}}}),lr=new K({}),cr=new F({props:{name:"class transformers.Wav2Vec2ForAudioFrameClassification",anchor:"transformers.Wav2Vec2ForAudioFrameClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1866"}}),ur=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1910",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided)  \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.num_labels)</code>) \u2014 Classification scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.TokenClassifierOutput"
>transformers.modeling_outputs.TokenClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ea=new je({props:{$$slots:{default:[zx]},$$scope:{ctx:W}}}),Ca=new Xe({props:{anchor:"transformers.Wav2Vec2ForAudioFrameClassification.forward.example",$$slots:{default:[Mx]},$$scope:{ctx:W}}}),gr=new K({}),_r=new F({props:{name:"class transformers.Wav2Vec2ForXVector",anchor:"transformers.Wav2Vec2ForXVector",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForXVector.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L2027"}}),Tr=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2ForXVector.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForXVector.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2ForXVector.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2ForXVector.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2ForXVector.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2ForXVector.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Wav2Vec2ForXVector.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L2089",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.XVectorOutput"
>transformers.modeling_outputs.XVectorOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.xvector_output_dim)</code>) \u2014 Classification hidden states before AMSoftmax.</p>
</li>
<li>
<p><strong>embeddings</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.xvector_output_dim)</code>) \u2014 Utterance embeddings used for vector similarity-based retrieval.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.XVectorOutput"
>transformers.modeling_outputs.XVectorOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Pa=new je({props:{$$slots:{default:[Lx]},$$scope:{ctx:W}}}),Aa=new Xe({props:{anchor:"transformers.Wav2Vec2ForXVector.forward.example",$$slots:{default:[Ox]},$$scope:{ctx:W}}}),xr=new K({}),$r=new F({props:{name:"class transformers.Wav2Vec2ForPreTraining",anchor:"transformers.Wav2Vec2ForPreTraining",parameters:[{name:"config",val:": Wav2Vec2Config"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForPreTraining.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1345"}}),Er=new F({props:{name:"forward",anchor:"transformers.Wav2Vec2ForPreTraining.forward",parameters:[{name:"input_values",val:": typing.Optional[torch.Tensor]"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"mask_time_indices",val:": typing.Optional[torch.BoolTensor] = None"},{name:"sampled_negative_indices",val:": typing.Optional[torch.BoolTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.Wav2Vec2ForPreTraining.forward.input_values",description:`<strong>input_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>torch.FloatTensor</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p><code>attention_mask</code> should only be passed if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.</p>

					</div>`,name:"attention_mask"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.mask_time_indices",description:`<strong>mask_time_indices</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices to mask extracted features for contrastive loss. When in training mode, model learns to predict
masked extracted features in <em>config.proj_codevector_dim</em> space.`,name:"mask_time_indices"},{anchor:"transformers.Wav2Vec2ForPreTraining.forward.sampled_negative_indices",description:`<strong>sampled_negative_indices</strong> (<code>torch.BoolTensor</code> of shape <code>(batch_size, sequence_length, num_negatives)</code>, <em>optional</em>) &#x2014;
Indices indicating which quantized target vectors are used as negative sampled vectors in contrastive loss.
Required input for pre-training.`,name:"sampled_negative_indices"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_wav2vec2.py#L1405",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput"
>transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 Total loss as the sum of the contrastive loss (L_m) and the diversity loss (L_d) as stated in the <a
  href="https://arxiv.org/pdf/2006.11477.pdf"
  rel="nofollow"
>official
paper</a> . (classification) loss.</p>
</li>
<li>
<p><strong>projected_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) \u2014 Hidden-states of the model projected to <em>config.proj_codevector_dim</em> that can be used to predict the masked
projected quantized states.</p>
</li>
<li>
<p><strong>projected_quantized_states</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) \u2014 Quantized extracted feature vectors projected to <em>config.proj_codevector_dim</em> representing the positive
target vectors for contrastive loss.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>contrastive_loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 The contrastive loss (L_m) as stated in the <a
  href="https://arxiv.org/pdf/2006.11477.pdf"
  rel="nofollow"
>official paper</a> .</p>
</li>
<li>
<p><strong>diversity_loss</strong> (<em>optional</em>, returned when <code>sample_negative_indices</code> are passed, <code>torch.FloatTensor</code> of shape <code>(1,)</code>) \u2014 The diversity loss (L_d) as stated in the <a
  href="https://arxiv.org/pdf/2006.11477.pdf"
  rel="nofollow"
>official paper</a> .</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput"
>transformers.models.wav2vec2.modeling_wav2vec2.Wav2Vec2ForPreTrainingOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ma=new je({props:{$$slots:{default:[Dx]},$$scope:{ctx:W}}}),La=new Xe({props:{anchor:"transformers.Wav2Vec2ForPreTraining.forward.example",$$slots:{default:[Sx]},$$scope:{ctx:W}}}),Cr=new K({}),qr=new F({props:{name:"class transformers.TFWav2Vec2Model",anchor:"transformers.TFWav2Vec2Model",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFWav2Vec2Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1358"}}),Da=new je({props:{$$slots:{default:[Ix]},$$scope:{ctx:W}}}),Mr=new F({props:{name:"call",anchor:"transformers.TFWav2Vec2Model.call",parameters:[{name:"input_values",val:": Tensor"},{name:"attention_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"position_ids",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"head_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": bool = False"}],parametersDescription:[{anchor:"transformers.TFWav2Vec2Model.call.input_values",description:`<strong>input_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> <code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>({0})</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_values"},{anchor:"transformers.TFWav2Vec2Model.call.attention_mask",description:`<strong>attention_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFWav2Vec2Model.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFWav2Vec2Model.call.position_ids",description:`<strong>position_ids</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFWav2Vec2Model.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFWav2Vec2Model.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0}, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_values</code> you can choose to directly pass an embedded representation.
This is useful if you want more control over how to convert <code>input_values</code> indices into associated vectors
than the model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFWav2Vec2Model.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFWav2Vec2Model.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFWav2Vec2Model.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFWav2Vec2Model.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to \`False&#x201C;) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1364",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutput"
>transformers.modeling_tf_outputs.TFBaseModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutput"
>transformers.modeling_tf_outputs.TFBaseModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Sa=new je({props:{$$slots:{default:[Nx]},$$scope:{ctx:W}}}),Ia=new Xe({props:{anchor:"transformers.TFWav2Vec2Model.call.example",$$slots:{default:[Bx]},$$scope:{ctx:W}}}),Lr=new K({}),Or=new F({props:{name:"class transformers.TFWav2Vec2ForSequenceClassification",anchor:"transformers.TFWav2Vec2ForSequenceClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1597"}}),Dr=new F({props:{name:"call",anchor:"transformers.TFWav2Vec2ForSequenceClassification.call",parameters:[{name:"input_values",val:": Tensor"},{name:"attention_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"training",val:": bool = False"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1638"}}),Sr=new K({}),Ir=new F({props:{name:"class transformers.TFWav2Vec2ForCTC",anchor:"transformers.TFWav2Vec2ForCTC",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFWav2Vec2ForCTC.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1443"}}),Ra=new je({props:{$$slots:{default:[Rx]},$$scope:{ctx:W}}}),Hr=new F({props:{name:"call",anchor:"transformers.TFWav2Vec2ForCTC.call",parameters:[{name:"input_values",val:": Tensor"},{name:"attention_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"token_type_ids",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"position_ids",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"head_mask",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"inputs_embeds",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[tensorflow.python.framework.ops.Tensor] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFWav2Vec2ForCTC.call.input_values",description:`<strong>input_values</strong> (<code>np.ndarray</code>, <code>tf.Tensor</code>, <code>List[tf.Tensor]</code> <code>Dict[str, tf.Tensor]</code> or <code>Dict[str, np.ndarray]</code> and each example must have the shape <code>({0})</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_values"},{anchor:"transformers.TFWav2Vec2ForCTC.call.attention_mask",description:`<strong>attention_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFWav2Vec2ForCTC.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFWav2Vec2ForCTC.call.position_ids",description:`<strong>position_ids</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFWav2Vec2ForCTC.call.head_mask",description:`<strong>head_mask</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFWav2Vec2ForCTC.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>({0}, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_values</code> you can choose to directly pass an embedded representation.
This is useful if you want more control over how to convert <code>input_values</code> indices into associated vectors
than the model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFWav2Vec2ForCTC.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFWav2Vec2ForCTC.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFWav2Vec2ForCTC.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used in
eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFWav2Vec2ForCTC.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to \`False&#x201C;) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFWav2Vec2ForCTC.call.labels",description:`<strong>labels</strong> (<code>tf.Tensor</code> or <code>np.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should be in <code>[-100, 0, ..., config.vocab_size]</code> (see <code>input_values</code> docstring) Tokens with indices set to <code>-100</code> are ignored (masked),
the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_tf_wav2vec2.py#L1470",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutput"
>transformers.modeling_tf_outputs.TFCausalLMOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config"
>Wav2Vec2Config</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutput"
>transformers.modeling_tf_outputs.TFCausalLMOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ua=new je({props:{$$slots:{default:[Ux]},$$scope:{ctx:W}}}),Ha=new Xe({props:{anchor:"transformers.TFWav2Vec2ForCTC.call.example",$$slots:{default:[Hx]},$$scope:{ctx:W}}}),Xr=new K({}),Gr=new F({props:{name:"class transformers.FlaxWav2Vec2Model",anchor:"transformers.FlaxWav2Vec2Model",parameters:[{name:"config",val:": Wav2Vec2Config"},{name:"input_shape",val:": typing.Tuple = (1, 1024)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2Model.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxWav2Vec2Model.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L1055"}}),si=new F({props:{name:"__call__",anchor:"transformers.FlaxWav2Vec2Model.__call__",parameters:[{name:"input_values",val:""},{name:"attention_mask",val:" = None"},{name:"mask_time_indices",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"freeze_feature_encoder",val:": bool = False"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2Model.__call__.input_values",description:`<strong>input_values</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>jnp.ndarray</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.FlaxWav2Vec2Model.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a> .. warning:: <code>attention_mask</code> should only be passed
if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor
has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.`,name:"attention_mask"},{anchor:"transformers.FlaxWav2Vec2Model.__call__.mask_time_indices",description:`<strong>mask_time_indices</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices to mask extracted features for contrastive loss. When in training mode, model learns to predict
masked extracted features in <em>config.proj_codevector_dim</em> space.`,name:"mask_time_indices"},{anchor:"transformers.FlaxWav2Vec2Model.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxWav2Vec2Model.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxWav2Vec2Model.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L888",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput"
>transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.wav2vec2.configuration_wav2vec2.Wav2Vec2Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>extract_features</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, last_conv_dim)</code>) \u2014 Sequence of extracted feature vectors of the last convolutional layer of the model with <code>last_conv_dim</code>
being the dimension of the last convolutional layer.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput"
>transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ga=new je({props:{$$slots:{default:[Xx]},$$scope:{ctx:W}}}),Ka=new Xe({props:{anchor:"transformers.FlaxWav2Vec2Model.__call__.example",$$slots:{default:[Gx]},$$scope:{ctx:W}}}),ni=new K({}),ri=new F({props:{name:"class transformers.FlaxWav2Vec2ForCTC",anchor:"transformers.FlaxWav2Vec2ForCTC",parameters:[{name:"config",val:": Wav2Vec2Config"},{name:"input_shape",val:": typing.Tuple = (1, 1024)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2ForCTC.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxWav2Vec2ForCTC.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L1173"}}),ui=new F({props:{name:"__call__",anchor:"transformers.FlaxWav2Vec2ForCTC.__call__",parameters:[{name:"input_values",val:""},{name:"attention_mask",val:" = None"},{name:"mask_time_indices",val:" = None"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"freeze_feature_encoder",val:": bool = False"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.input_values",description:`<strong>input_values</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>jnp.ndarray</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a> .. warning:: <code>attention_mask</code> should only be passed
if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor
has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.`,name:"attention_mask"},{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.mask_time_indices",description:`<strong>mask_time_indices</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices to mask extracted features for contrastive loss. When in training mode, model learns to predict
masked extracted features in <em>config.proj_codevector_dim</em> space.`,name:"mask_time_indices"},{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L888",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.wav2vec2.configuration_wav2vec2.Wav2Vec2Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Za=new je({props:{$$slots:{default:[Kx]},$$scope:{ctx:W}}}),Qa=new Xe({props:{anchor:"transformers.FlaxWav2Vec2ForCTC.__call__.example",$$slots:{default:[Jx]},$$scope:{ctx:W}}}),gi=new K({}),_i=new F({props:{name:"class transformers.FlaxWav2Vec2ForPreTraining",anchor:"transformers.FlaxWav2Vec2ForPreTraining",parameters:[{name:"config",val:": Wav2Vec2Config"},{name:"input_shape",val:": typing.Tuple = (1, 1024)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2ForPreTraining.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Config">Wav2Vec2Config</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L1319"}}),ji=new F({props:{name:"__call__",anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__",parameters:[{name:"input_values",val:""},{name:"attention_mask",val:" = None"},{name:"mask_time_indices",val:" = None"},{name:"gumbel_temperature",val:": int = 1"},{name:"params",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"gumbel_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"freeze_feature_encoder",val:": bool = False"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.input_values",description:`<strong>input_values</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Float values of input raw speech waveform. Values can be obtained by loading a <code>.flac</code> or <code>.wav</code> audio file
into an array of type <code>List[float]</code> or a <code>numpy.ndarray</code>, <em>e.g.</em> via the soundfile library (<code>pip install soundfile</code>). To prepare the array into <code>input_values</code>, the <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoProcessor">AutoProcessor</a> should be used for padding and
conversion into a tensor of type <code>jnp.ndarray</code>. See <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__">Wav2Vec2Processor.<strong>call</strong>()</a> for details.`,name:"input_values"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing convolution and attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a> .. warning:: <code>attention_mask</code> should only be passed
if the corresponding processor has <code>config.return_attention_mask == True</code>. For all models whose processor
has <code>config.return_attention_mask == False</code>, such as
<a href="https://huggingface.co/facebook/wav2vec2-base-960h" rel="nofollow">wav2vec2-base</a>, <code>attention_mask</code> should <strong>not</strong> be
passed to avoid degraded performance when doing batched inference. For such models <code>input_values</code> should
simply be padded with 0 and passed without <code>attention_mask</code>. Be aware that these models also yield slightly
different results depending on whether <code>input_values</code> is padded or not.`,name:"attention_mask"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.mask_time_indices",description:`<strong>mask_time_indices</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices to mask extracted features for contrastive loss. When in training mode, model learns to predict
masked extracted features in <em>config.proj_codevector_dim</em> space.`,name:"mask_time_indices"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/wav2vec2/modeling_flax_wav2vec2.py#L1322",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput"
>transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<code>&lt;class 'transformers.models.wav2vec2.configuration_wav2vec2.Wav2Vec2Config'&gt;</code>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<em>optional</em>, returned when model is in train mode, <code>jnp.ndarray</code> of shape <code>(1,)</code>) \u2014 Total loss as the sum of the contrastive loss (L_m) and the diversity loss (L_d) as stated in the <a
  href="https://arxiv.org/pdf/2006.11477.pdf"
  rel="nofollow"
>official
paper</a> . (classification) loss.</p>
</li>
<li>
<p><strong>projected_states</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) \u2014 Hidden-states of the model projected to <em>config.proj_codevector_dim</em> that can be used to predict the masked
projected quantized states.</p>
</li>
<li>
<p><strong>projected_quantized_states</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.proj_codevector_dim)</code>) \u2014 Quantized extracted feature vectors projected to <em>config.proj_codevector_dim</em> representing the positive
target vectors for contrastive loss.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput"
>transformers.models.wav2vec2.modeling_flax_wav2vec2.FlaxWav2Vec2ForPreTrainingOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),es=new je({props:{$$slots:{default:[Zx]},$$scope:{ctx:W}}}),ts=new Xe({props:{anchor:"transformers.FlaxWav2Vec2ForPreTraining.__call__.example",$$slots:{default:[Qx]},$$scope:{ctx:W}}}),{c(){m=n("meta"),b=d(),g=n("h1"),f=n("a"),v=n("span"),w(l.$$.fragment),h=d(),V=n("span"),M=a("Wav2Vec2"),L=d(),A=n("h2"),z=n("a"),N=n("span"),w(E.$$.fragment),O=d(),C=n("span"),ce=a("Overview"),J=d(),S=n("p"),de=a("The Wav2Vec2 model was proposed in "),I=n("a"),R=a("wav2vec 2.0: A Framework for Self-Supervised Learning of Speech Representations"),De=a(" by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael Auli."),X=d(),Z=n("p"),Se=a("The abstract from the paper is the following:"),We=d(),Q=n("p"),Ke=n("em"),$t=a(`We show for the first time that learning powerful representations from speech audio alone followed by fine-tuning on
transcribed speech can outperform the best semi-supervised methods while being conceptually simpler. wav2vec 2.0 masks
the speech input in the latent space and solves a contrastive task defined over a quantization of the latent
representations which are jointly learned. Experiments using all labeled data of Librispeech achieve 1.8/3.3 WER on the
clean/other test sets. When lowering the amount of labeled data to one hour, wav2vec 2.0 outperforms the previous state
of the art on the 100 hour subset while using 100 times less labeled data. Using just ten minutes of labeled data and
pre-training on 53k hours of unlabeled data still achieves 4.8/8.2 WER. This demonstrates the feasibility of speech
recognition with limited amounts of labeled data.`),Ie=d(),D=n("p"),Y=a("Tips:"),tt=d(),ae=n("ul"),Je=n("li"),jt=a("Wav2Vec2 is a speech model that accepts a float array corresponding to the raw waveform of the speech signal."),Ve=d(),Fe=n("li"),Wt=a(`Wav2Vec2 model was trained using connectionist temporal classification (CTC) so the model output has to be decoded
using `),U=n("a"),Vt=a("Wav2Vec2CTCTokenizer"),Ee=a("."),ot=d(),we=n("p"),Ce=a("This model was contributed by "),qe=n("a"),Ft=a("patrickvonplaten"),he=a("."),at=d(),ee=n("h2"),ye=n("a"),Pe=n("span"),w(B.$$.fragment),Et=d(),te=n("span"),Ct=a("Resources"),st=d(),j=n("p"),q=a("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with Wav2Vec2. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Nt=d(),w(fe.$$.fragment),Bt=d(),ke=n("ul"),P=n("li"),Qt=a("A notebook on how to "),Ze=n("a"),Yt=a("leverage a pretrained Wav2Vec2 model for emotion classification"),eo=a(". \u{1F30E}"),to=d(),H=n("li"),pe=n("a"),oo=a("Wav2Vec2ForCTC"),ao=a(" is supported by this "),se=n("a"),so=a("example script"),no=a(" and "),Ae=n("a"),ro=a("notebook"),Qe=a("."),io=d(),tc=n("li"),Mi=n("a"),Lh=a("Audio classification task guide"),vp=d(),w(xs.$$.fragment),bp=d(),Te=n("ul"),$s=n("li"),Oh=a("A blog post on "),js=n("a"),Dh=a("boosting Wav2Vec2 with n-grams in \u{1F917} Transformers"),Sh=a("."),Ih=d(),Ws=n("li"),Nh=a("A blog post on how to "),Vs=n("a"),Bh=a("finetune Wav2Vec2 for English ASR with \u{1F917} Transformers"),Rh=a("."),Uh=d(),Fs=n("li"),Hh=a("A blog post on "),Es=n("a"),Xh=a("finetuning XLS-R for Multi-Lingual ASR with \u{1F917} Transformers"),Gh=a("."),Kh=d(),Cs=n("li"),Jh=a("A notebook on how to "),qs=n("a"),Zh=a("create YouTube captions from any video by transcribing audio with Wav2Vec2"),Qh=a(". \u{1F30E}"),Yh=d(),Rt=n("li"),Li=n("a"),ef=a("Wav2Vec2ForCTC"),tf=a(" is supported by a notebook on "),Ps=n("a"),of=a("how to finetune a speech recognition model in English"),af=a(", and "),As=n("a"),sf=a("how to finetune a speech recognition model in any language"),nf=a("."),rf=d(),oc=n("li"),Oi=n("a"),lf=a("Automatic speech recognition task guide"),wp=d(),Di=n("p"),cf=a("\u{1F680} Deploy"),yp=d(),Si=n("ul"),zs=n("li"),df=a("A blog post on how to deploy Wav2Vec2 for "),Ms=n("a"),pf=a("Automatic Speech Recogntion with Hugging Face\u2019s Transformers & Amazon SageMaker"),mf=a("."),kp=d(),lo=n("h2"),Jo=n("a"),ac=n("span"),w(Ls.$$.fragment),hf=d(),sc=n("span"),ff=a("Wav2Vec2Config"),Tp=d(),Ye=n("div"),w(Os.$$.fragment),uf=d(),co=n("p"),gf=a("This is the configuration class to store the configuration of a "),Ii=n("a"),_f=a("Wav2Vec2Model"),vf=a(`. It is used to instantiate an
Wav2Vec2 model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the Wav2Vec2
`),Ds=n("a"),bf=a("facebook/wav2vec2-base-960h"),wf=a(" architecture."),yf=d(),po=n("p"),kf=a("Configuration objects inherit from "),Ni=n("a"),Tf=a("PretrainedConfig"),xf=a(` and can be used to control the model outputs. Read the
documentation from `),Bi=n("a"),$f=a("PretrainedConfig"),jf=a(" for more information."),Wf=d(),w(Zo.$$.fragment),xp=d(),mo=n("h2"),Qo=n("a"),nc=n("span"),w(Ss.$$.fragment),Vf=d(),rc=n("span"),Ff=a("Wav2Vec2CTCTokenizer"),$p=d(),ne=n("div"),w(Is.$$.fragment),Ef=d(),ic=n("p"),Cf=a("Constructs a Wav2Vec2CTC tokenizer."),qf=d(),Ns=n("p"),Pf=a("This tokenizer inherits from "),Ri=n("a"),Af=a("PreTrainedTokenizer"),zf=a(` which contains some of the main methods. Users should refer to
the superclass for more information regarding such methods.`),Mf=d(),Yo=n("div"),w(Bs.$$.fragment),Lf=d(),lc=n("p"),Of=a(`Main method to tokenize and prepare for the model one or several sequence(s) or one or several pair(s) of
sequences.`),Df=d(),Ui=n("div"),w(Rs.$$.fragment),Sf=d(),nt=n("div"),w(Us.$$.fragment),If=d(),cc=n("p"),Nf=a(`Converts a sequence of ids in a string, using the tokenizer and vocabulary with options to remove special
tokens and clean up tokenization spaces.`),Bf=d(),Hs=n("p"),Rf=a("Similar to doing "),dc=n("code"),Uf=a("self.convert_tokens_to_string(self.convert_ids_to_tokens(token_ids))"),Hf=a("."),Xf=d(),w(ea.$$.fragment),Gf=d(),ta=n("div"),w(Xs.$$.fragment),Kf=d(),pc=n("p"),Jf=a("Convert a list of lists of token ids into a list of strings by calling decode."),jp=d(),ho=n("h2"),oa=n("a"),mc=n("span"),w(Gs.$$.fragment),Zf=d(),hc=n("span"),Qf=a("Wav2Vec2FeatureExtractor"),Wp=d(),et=n("div"),w(Ks.$$.fragment),Yf=d(),fc=n("p"),eu=a("Constructs a Wav2Vec2 feature extractor."),tu=d(),Js=n("p"),ou=a("This feature extractor inherits from "),Hi=n("a"),au=a("SequenceFeatureExtractor"),su=a(` which contains
most of the main methods. Users should refer to this superclass for more information regarding those methods.`),nu=d(),aa=n("div"),w(Zs.$$.fragment),ru=d(),uc=n("p"),iu=a("Main method to featurize and prepare for the model one or several sequence(s)."),Vp=d(),fo=n("h2"),sa=n("a"),gc=n("span"),w(Qs.$$.fragment),lu=d(),_c=n("span"),cu=a("Wav2Vec2Processor"),Fp=d(),G=n("div"),w(Ys.$$.fragment),du=d(),vc=n("p"),pu=a(`Constructs a Wav2Vec2 processor which wraps a Wav2Vec2 feature extractor and a Wav2Vec2 CTC tokenizer into a single
processor.`),mu=d(),Ne=n("p"),Xi=n("a"),hu=a("Wav2Vec2Processor"),fu=a(" offers all the functionalities of "),Gi=n("a"),uu=a("Wav2Vec2FeatureExtractor"),gu=a(" and "),Ki=n("a"),_u=a("PreTrainedTokenizer"),vu=a(`.
See the docstring of `),en=n("a"),bc=n("strong"),bu=a("call"),wu=a("()"),yu=a(" and "),Ji=n("a"),ku=a("decode()"),Tu=a(" for more information."),xu=d(),na=n("div"),w(tn.$$.fragment),$u=d(),qt=n("p"),ju=a(`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),on=n("a"),wc=n("strong"),Wu=a("call"),Vu=a("()"),Fu=a(` and returns its output. If used in the context
`),yc=n("code"),Eu=a("as_target_processor()"),Cu=a(` this method forwards all its arguments to PreTrainedTokenizer\u2019s
`),an=n("a"),kc=n("strong"),qu=a("call"),Pu=a("()"),Au=a(". Please refer to the docstring of the above two methods for more information."),zu=d(),ra=n("div"),w(sn.$$.fragment),Mu=d(),Pt=n("p"),Lu=a(`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),Zi=n("a"),Ou=a("pad()"),Du=a(` and returns its output. If used in the context
`),Tc=n("code"),Su=a("as_target_processor()"),Iu=a(` this method forwards all its arguments to PreTrainedTokenizer\u2019s
`),Qi=n("a"),Nu=a("pad()"),Bu=a(". Please refer to the docstring of the above two methods for more information."),Ru=d(),Yi=n("div"),w(nn.$$.fragment),Uu=d(),Ut=n("div"),w(rn.$$.fragment),Hu=d(),ln=n("p"),Xu=a(`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),el=n("a"),Gu=a("from_pretrained()"),Ku=a(" method."),Ju=d(),w(ia.$$.fragment),Zu=d(),la=n("div"),w(cn.$$.fragment),Qu=d(),dn=n("p"),Yu=a("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),tl=n("a"),eg=a("batch_decode()"),tg=a(`. Please
refer to the docstring of this method for more information.`),og=d(),ca=n("div"),w(pn.$$.fragment),ag=d(),mn=n("p"),sg=a("This method forwards all its arguments to PreTrainedTokenizer\u2019s "),ol=n("a"),ng=a("decode()"),rg=a(`. Please refer
to the docstring of this method for more information.`),Ep=d(),uo=n("h2"),da=n("a"),xc=n("span"),w(hn.$$.fragment),ig=d(),$c=n("span"),lg=a("Wav2Vec2ProcessorWithLM"),Cp=d(),oe=n("div"),w(fn.$$.fragment),cg=d(),jc=n("p"),dg=a(`Constructs a Wav2Vec2 processor which wraps a Wav2Vec2 feature extractor, a Wav2Vec2 CTC tokenizer and a decoder
with language model support into a single processor for language model boosted speech recognition decoding.`),pg=d(),pa=n("div"),w(un.$$.fragment),mg=d(),At=n("p"),hg=a(`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),gn=n("a"),Wc=n("strong"),fg=a("call"),ug=a("()"),gg=a(` and returns its output. If used in the context
`),Vc=n("code"),_g=a("as_target_processor()"),vg=a(` this method forwards all its arguments to
Wav2Vec2CTCTokenizer\u2019s `),_n=n("a"),Fc=n("strong"),bg=a("call"),wg=a("()"),yg=a(`. Please refer to the docstring of the above two
methods for more information.`),kg=d(),ma=n("div"),w(vn.$$.fragment),Tg=d(),zt=n("p"),xg=a(`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),al=n("a"),$g=a("pad()"),jg=a(` and returns its output. If used in the context
`),Ec=n("code"),Wg=a("as_target_processor()"),Vg=a(` this method forwards all its arguments to
Wav2Vec2CTCTokenizer\u2019s `),sl=n("a"),Fg=a("pad()"),Eg=a(`. Please refer to the docstring of the above two methods
for more information.`),Cg=d(),Ht=n("div"),w(bn.$$.fragment),qg=d(),wn=n("p"),Pg=a("Instantiate a "),nl=n("a"),Ag=a("Wav2Vec2ProcessorWithLM"),zg=a(" from a pretrained Wav2Vec2 processor."),Mg=d(),w(ha.$$.fragment),Lg=d(),rl=n("div"),w(yn.$$.fragment),Og=d(),rt=n("div"),w(kn.$$.fragment),Dg=d(),Cc=n("p"),Sg=a("Batch decode output logits to audio transcription with language model support."),Ig=d(),w(fa.$$.fragment),Ng=d(),Tn=n("p"),Bg=a(`Example:
See `),il=n("a"),Rg=a("Decoding multiple audios"),Ug=a("."),Hg=d(),Xt=n("div"),w(xn.$$.fragment),Xg=d(),qc=n("p"),Gg=a("Decode output logits to audio transcription with language model support."),Kg=d(),w(ua.$$.fragment),qp=d(),go=n("h3"),ga=n("a"),Pc=n("span"),w($n.$$.fragment),Jg=d(),Ac=n("span"),Zg=a("Decoding multiple audios"),Pp=d(),xe=n("p"),Qg=a("If you are planning to decode multiple batches of audios, you should consider using "),ll=n("a"),Yg=a("batch_decode()"),e_=a(" and passing an instantiated "),zc=n("code"),t_=a("multiprocessing.Pool"),o_=a(`.
Otherwise, `),cl=n("a"),a_=a("batch_decode()"),s_=a(" performance will be slower than calling "),dl=n("a"),n_=a("decode()"),r_=a(" for each audio individually, as it internally instantiates a new "),Mc=n("code"),i_=a("Pool"),l_=a(" for every call. See the example below:"),Ap=d(),w(jn.$$.fragment),zp=d(),_o=n("h2"),_a=n("a"),Lc=n("span"),w(Wn.$$.fragment),c_=d(),Oc=n("span"),d_=a("Wav2Vec2 specific outputs"),Mp=d(),vo=n("div"),w(Vn.$$.fragment),p_=d(),Fn=n("p"),m_=a("Output type of "),Dc=n("code"),h_=a("Wav2Vec2DecoderWithLM"),f_=a(", with transcription."),Lp=d(),bo=n("div"),w(En.$$.fragment),u_=d(),Sc=n("p"),g_=a("Base class for models that have been trained with the Wav2Vec2 loss objective."),Op=d(),wo=n("div"),w(Cn.$$.fragment),__=d(),qn=n("p"),v_=a("Output type of "),pl=n("a"),b_=a("Wav2Vec2ForPreTraining"),w_=a(", with potential hidden states and attentions."),Dp=d(),Mt=n("div"),w(Pn.$$.fragment),y_=d(),An=n("p"),k_=a("Output type of "),Ic=n("code"),T_=a("FlaxWav2Vec2BaseModelOutput"),x_=a(", with potential hidden states and attentions."),$_=d(),va=n("div"),w(zn.$$.fragment),j_=d(),Nc=n("p"),W_=a("\u201CReturns a new object replacing the specified fields with new values."),Sp=d(),Lt=n("div"),w(Mn.$$.fragment),V_=d(),Ln=n("p"),F_=a("Output type of "),Bc=n("code"),E_=a("FlaxWav2Vec2ForPreTrainingOutput"),C_=a(", with potential hidden states and attentions."),q_=d(),ba=n("div"),w(On.$$.fragment),P_=d(),Rc=n("p"),A_=a("\u201CReturns a new object replacing the specified fields with new values."),Ip=d(),yo=n("h2"),wa=n("a"),Uc=n("span"),w(Dn.$$.fragment),z_=d(),Hc=n("span"),M_=a("Wav2Vec2Model"),Np=d(),ze=n("div"),w(Sn.$$.fragment),L_=d(),In=n("p"),O_=a(`The bare Wav2Vec2 Model transformer outputting raw hidden-states without any specific head on top.
Wav2Vec2 was proposed in `),Nn=n("a"),D_=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),S_=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),I_=d(),Bn=n("p"),N_=a("This model inherits from "),ml=n("a"),B_=a("PreTrainedModel"),R_=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),U_=d(),Rn=n("p"),H_=a("This model is a PyTorch "),Un=n("a"),X_=a("torch.nn.Module"),G_=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),K_=d(),it=n("div"),w(Hn.$$.fragment),J_=d(),ko=n("p"),Z_=a("The "),hl=n("a"),Q_=a("Wav2Vec2Model"),Y_=a(" forward method, overrides the "),Xc=n("code"),e2=a("__call__"),t2=a(" special method."),o2=d(),w(ya.$$.fragment),a2=d(),w(ka.$$.fragment),Bp=d(),To=n("h2"),Ta=n("a"),Gc=n("span"),w(Xn.$$.fragment),s2=d(),Kc=n("span"),n2=a("Wav2Vec2ForCTC"),Rp=d(),Me=n("div"),w(Gn.$$.fragment),r2=d(),xo=n("p"),i2=a("Wav2Vec2 Model with a "),Jc=n("code"),l2=a("language modeling"),c2=a(` head on top for Connectionist Temporal Classification (CTC).
Wav2Vec2 was proposed in `),Kn=n("a"),d2=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),p2=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),m2=d(),Jn=n("p"),h2=a("This model inherits from "),fl=n("a"),f2=a("PreTrainedModel"),u2=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),g2=d(),Zn=n("p"),_2=a("This model is a PyTorch "),Qn=n("a"),v2=a("torch.nn.Module"),b2=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),w2=d(),lt=n("div"),w(Yn.$$.fragment),y2=d(),$o=n("p"),k2=a("The "),ul=n("a"),T2=a("Wav2Vec2ForCTC"),x2=a(" forward method, overrides the "),Zc=n("code"),$2=a("__call__"),j2=a(" special method."),W2=d(),w(xa.$$.fragment),V2=d(),w($a.$$.fragment),Up=d(),jo=n("h2"),ja=n("a"),Qc=n("span"),w(er.$$.fragment),F2=d(),Yc=n("span"),E2=a("Wav2Vec2ForSequenceClassification"),Hp=d(),ue=n("div"),w(tr.$$.fragment),C2=d(),ed=n("p"),q2=a(`Wav2Vec2 Model with a sequence classification head on top (a linear layer over the pooled output) for tasks like
SUPERB Keyword Spotting.`),P2=d(),or=n("p"),A2=a("Wav2Vec2 was proposed in "),ar=n("a"),z2=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),M2=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),L2=d(),sr=n("p"),O2=a("This model inherits from "),gl=n("a"),D2=a("PreTrainedModel"),S2=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),I2=d(),nr=n("p"),N2=a("This model is a PyTorch "),rr=n("a"),B2=a("torch.nn.Module"),R2=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),U2=d(),ct=n("div"),w(ir.$$.fragment),H2=d(),Wo=n("p"),X2=a("The "),_l=n("a"),G2=a("Wav2Vec2ForSequenceClassification"),K2=a(" forward method, overrides the "),td=n("code"),J2=a("__call__"),Z2=a(" special method."),Q2=d(),w(Wa.$$.fragment),Y2=d(),w(Va.$$.fragment),Xp=d(),Vo=n("h2"),Fa=n("a"),od=n("span"),w(lr.$$.fragment),ev=d(),ad=n("span"),tv=a("Wav2Vec2ForAudioFrameClassification"),Gp=d(),ge=n("div"),w(cr.$$.fragment),ov=d(),sd=n("p"),av=a("Wav2Vec2 Model with a frame classification head on top for tasks like Speaker Diarization."),sv=d(),dr=n("p"),nv=a("Wav2Vec2 was proposed in "),pr=n("a"),rv=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),iv=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),lv=d(),mr=n("p"),cv=a("This model inherits from "),vl=n("a"),dv=a("PreTrainedModel"),pv=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),mv=d(),hr=n("p"),hv=a("This model is a PyTorch "),fr=n("a"),fv=a("torch.nn.Module"),uv=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),gv=d(),dt=n("div"),w(ur.$$.fragment),_v=d(),Fo=n("p"),vv=a("The "),bl=n("a"),bv=a("Wav2Vec2ForAudioFrameClassification"),wv=a(" forward method, overrides the "),nd=n("code"),yv=a("__call__"),kv=a(" special method."),Tv=d(),w(Ea.$$.fragment),xv=d(),w(Ca.$$.fragment),Kp=d(),Eo=n("h2"),qa=n("a"),rd=n("span"),w(gr.$$.fragment),$v=d(),id=n("span"),jv=a("Wav2Vec2ForXVector"),Jp=d(),_e=n("div"),w(_r.$$.fragment),Wv=d(),ld=n("p"),Vv=a("Wav2Vec2 Model with an XVector feature extraction head on top for tasks like Speaker Verification."),Fv=d(),vr=n("p"),Ev=a("Wav2Vec2 was proposed in "),br=n("a"),Cv=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),qv=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Pv=d(),wr=n("p"),Av=a("This model inherits from "),wl=n("a"),zv=a("PreTrainedModel"),Mv=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),Lv=d(),yr=n("p"),Ov=a("This model is a PyTorch "),kr=n("a"),Dv=a("torch.nn.Module"),Sv=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Iv=d(),pt=n("div"),w(Tr.$$.fragment),Nv=d(),Co=n("p"),Bv=a("The "),yl=n("a"),Rv=a("Wav2Vec2ForXVector"),Uv=a(" forward method, overrides the "),cd=n("code"),Hv=a("__call__"),Xv=a(" special method."),Gv=d(),w(Pa.$$.fragment),Kv=d(),w(Aa.$$.fragment),Zp=d(),qo=n("h2"),za=n("a"),dd=n("span"),w(xr.$$.fragment),Jv=d(),pd=n("span"),Zv=a("Wav2Vec2ForPreTraining"),Qp=d(),Le=n("div"),w($r.$$.fragment),Qv=d(),Po=n("p"),Yv=a("Wav2Vec2 Model with a quantizer and "),md=n("code"),eb=a("VQ"),tb=a(` head on top.
Wav2Vec2 was proposed in `),jr=n("a"),ob=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),ab=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),sb=d(),Wr=n("p"),nb=a("This model inherits from "),kl=n("a"),rb=a("PreTrainedModel"),ib=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),lb=d(),Vr=n("p"),cb=a("This model is a PyTorch "),Fr=n("a"),db=a("torch.nn.Module"),pb=a(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),mb=d(),mt=n("div"),w(Er.$$.fragment),hb=d(),Ao=n("p"),fb=a("The "),Tl=n("a"),ub=a("Wav2Vec2ForPreTraining"),gb=a(" forward method, overrides the "),hd=n("code"),_b=a("__call__"),vb=a(" special method."),bb=d(),w(Ma.$$.fragment),wb=d(),w(La.$$.fragment),Yp=d(),zo=n("h2"),Oa=n("a"),fd=n("span"),w(Cr.$$.fragment),yb=d(),ud=n("span"),kb=a("TFWav2Vec2Model"),em=d(),ve=n("div"),w(qr.$$.fragment),Tb=d(),gd=n("p"),xb=a("The bare TFWav2Vec2 Model transformer outputing raw hidden-states without any specific head on top."),$b=d(),Pr=n("p"),jb=a("This model inherits from "),xl=n("a"),Wb=a("TFPreTrainedModel"),Vb=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Fb=d(),Ar=n("p"),Eb=a("This model is also a "),zr=n("a"),Cb=a("tf.keras.Model"),qb=a(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Pb=d(),w(Da.$$.fragment),Ab=d(),ht=n("div"),w(Mr.$$.fragment),zb=d(),Mo=n("p"),Mb=a("The "),$l=n("a"),Lb=a("TFWav2Vec2Model"),Ob=a(" forward method, overrides the "),_d=n("code"),Db=a("__call__"),Sb=a(" special method."),Ib=d(),w(Sa.$$.fragment),Nb=d(),w(Ia.$$.fragment),tm=d(),Lo=n("h2"),Na=n("a"),vd=n("span"),w(Lr.$$.fragment),Bb=d(),bd=n("span"),Rb=a("TFWav2Vec2ForSequenceClassification"),om=d(),Oo=n("div"),w(Or.$$.fragment),Ub=d(),jl=n("div"),w(Dr.$$.fragment),am=d(),Do=n("h2"),Ba=n("a"),wd=n("span"),w(Sr.$$.fragment),Hb=d(),yd=n("span"),Xb=a("TFWav2Vec2ForCTC"),sm=d(),be=n("div"),w(Ir.$$.fragment),Gb=d(),Nr=n("p"),Kb=a("TFWav2Vec2 Model with a "),kd=n("code"),Jb=a("language modeling"),Zb=a(" head on top for Connectionist Temporal Classification (CTC)."),Qb=d(),Br=n("p"),Yb=a("This model inherits from "),Wl=n("a"),ew=a("TFPreTrainedModel"),tw=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ow=d(),Rr=n("p"),aw=a("This model is also a "),Ur=n("a"),sw=a("tf.keras.Model"),nw=a(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),rw=d(),w(Ra.$$.fragment),iw=d(),ft=n("div"),w(Hr.$$.fragment),lw=d(),So=n("p"),cw=a("The "),Vl=n("a"),dw=a("TFWav2Vec2ForCTC"),pw=a(" forward method, overrides the "),Td=n("code"),mw=a("__call__"),hw=a(" special method."),fw=d(),w(Ua.$$.fragment),uw=d(),w(Ha.$$.fragment),nm=d(),Io=n("h2"),Xa=n("a"),xd=n("span"),w(Xr.$$.fragment),gw=d(),$d=n("span"),_w=a("FlaxWav2Vec2Model"),rm=d(),re=n("div"),w(Gr.$$.fragment),vw=d(),Kr=n("p"),bw=a(`The bare Wav2Vec2 Model transformer outputting raw hidden-states without any specific head on top.
Wav2Vec2 was proposed in `),Jr=n("a"),ww=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),yw=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),kw=d(),Zr=n("p"),Tw=a("This model inherits from "),Fl=n("a"),xw=a("FlaxPreTrainedModel"),$w=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),jw=d(),Qr=n("p"),Ww=a(`This model is also a Flax Linen
`),Yr=n("a"),Vw=a("flax.nn.Module"),Fw=a(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Ew=d(),jd=n("p"),Cw=a("Finally, this model supports inherent JAX features such as:"),qw=d(),Ot=n("ul"),Wd=n("li"),ei=n("a"),Pw=a("Just-In-Time (JIT) compilation"),Aw=d(),Vd=n("li"),ti=n("a"),zw=a("Automatic Differentiation"),Mw=d(),Fd=n("li"),oi=n("a"),Lw=a("Vectorization"),Ow=d(),Ed=n("li"),ai=n("a"),Dw=a("Parallelization"),Sw=d(),ut=n("div"),w(si.$$.fragment),Iw=d(),No=n("p"),Nw=a("The "),Cd=n("code"),Bw=a("FlaxWav2Vec2PreTrainedModel"),Rw=a(" forward method, overrides the "),qd=n("code"),Uw=a("__call__"),Hw=a(" special method."),Xw=d(),w(Ga.$$.fragment),Gw=d(),w(Ka.$$.fragment),im=d(),Bo=n("h2"),Ja=n("a"),Pd=n("span"),w(ni.$$.fragment),Kw=d(),Ad=n("span"),Jw=a("FlaxWav2Vec2ForCTC"),lm=d(),ie=n("div"),w(ri.$$.fragment),Zw=d(),Ro=n("p"),Qw=a("Wav2Vec2 Model with a "),zd=n("code"),Yw=a("language modeling"),e1=a(` head on top for Connectionist Temporal Classification (CTC).
Wav2Vec2 was proposed in `),ii=n("a"),t1=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),o1=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),a1=d(),li=n("p"),s1=a("This model inherits from "),El=n("a"),n1=a("FlaxPreTrainedModel"),r1=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),i1=d(),ci=n("p"),l1=a(`This model is also a Flax Linen
`),di=n("a"),c1=a("flax.nn.Module"),d1=a(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),p1=d(),Md=n("p"),m1=a("Finally, this model supports inherent JAX features such as:"),h1=d(),Dt=n("ul"),Ld=n("li"),pi=n("a"),f1=a("Just-In-Time (JIT) compilation"),u1=d(),Od=n("li"),mi=n("a"),g1=a("Automatic Differentiation"),_1=d(),Dd=n("li"),hi=n("a"),v1=a("Vectorization"),b1=d(),Sd=n("li"),fi=n("a"),w1=a("Parallelization"),y1=d(),gt=n("div"),w(ui.$$.fragment),k1=d(),Uo=n("p"),T1=a("The "),Id=n("code"),x1=a("FlaxWav2Vec2PreTrainedModel"),$1=a(" forward method, overrides the "),Nd=n("code"),j1=a("__call__"),W1=a(" special method."),V1=d(),w(Za.$$.fragment),F1=d(),w(Qa.$$.fragment),cm=d(),Ho=n("h2"),Ya=n("a"),Bd=n("span"),w(gi.$$.fragment),E1=d(),Rd=n("span"),C1=a("FlaxWav2Vec2ForPreTraining"),dm=d(),le=n("div"),w(_i.$$.fragment),q1=d(),Xo=n("p"),P1=a("Wav2Vec2 Model with a quantizer and "),Ud=n("code"),A1=a("VQ"),z1=a(` head on top.
Wav2Vec2 was proposed in `),vi=n("a"),M1=a(`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),L1=a(` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),O1=d(),bi=n("p"),D1=a("This model inherits from "),Cl=n("a"),S1=a("FlaxPreTrainedModel"),I1=a(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),N1=d(),wi=n("p"),B1=a(`This model is also a Flax Linen
`),yi=n("a"),R1=a("flax.nn.Module"),U1=a(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),H1=d(),Hd=n("p"),X1=a("Finally, this model supports inherent JAX features such as:"),G1=d(),St=n("ul"),Xd=n("li"),ki=n("a"),K1=a("Just-In-Time (JIT) compilation"),J1=d(),Gd=n("li"),Ti=n("a"),Z1=a("Automatic Differentiation"),Q1=d(),Kd=n("li"),xi=n("a"),Y1=a("Vectorization"),ey=d(),Jd=n("li"),$i=n("a"),ty=a("Parallelization"),oy=d(),_t=n("div"),w(ji.$$.fragment),ay=d(),Go=n("p"),sy=a("The "),ql=n("a"),ny=a("FlaxWav2Vec2ForPreTraining"),ry=a(" forward method, overrides the "),Zd=n("code"),iy=a("__call__"),ly=a(" special method."),cy=d(),w(es.$$.fragment),dy=d(),w(ts.$$.fragment),this.h()},l(o){const u=yx('[data-svelte="svelte-1phssyn"]',document.head);m=r(u,"META",{name:!0,content:!0}),u.forEach(t),b=p(o),g=r(o,"H1",{class:!0});var Wi=i(g);f=r(Wi,"A",{id:!0,class:!0,href:!0});var Qd=i(f);v=r(Qd,"SPAN",{});var Yd=i(v);y(l.$$.fragment,Yd),Yd.forEach(t),Qd.forEach(t),h=p(Wi),V=r(Wi,"SPAN",{});var ep=i(V);M=s(ep,"Wav2Vec2"),ep.forEach(t),Wi.forEach(t),L=p(o),A=r(o,"H2",{class:!0});var Vi=i(A);z=r(Vi,"A",{id:!0,class:!0,href:!0});var tp=i(z);N=r(tp,"SPAN",{});var op=i(N);y(E.$$.fragment,op),op.forEach(t),tp.forEach(t),O=p(Vi),C=r(Vi,"SPAN",{});var ap=i(C);ce=s(ap,"Overview"),ap.forEach(t),Vi.forEach(t),J=p(o),S=r(o,"P",{});var Fi=i(S);de=s(Fi,"The Wav2Vec2 model was proposed in "),I=r(Fi,"A",{href:!0,rel:!0});var sp=i(I);R=s(sp,"wav2vec 2.0: A Framework for Self-Supervised Learning of Speech Representations"),sp.forEach(t),De=s(Fi," by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael Auli."),Fi.forEach(t),X=p(o),Z=r(o,"P",{});var np=i(Z);Se=s(np,"The abstract from the paper is the following:"),np.forEach(t),We=p(o),Q=r(o,"P",{});var rp=i(Q);Ke=r(rp,"EM",{});var ip=i(Ke);$t=s(ip,`We show for the first time that learning powerful representations from speech audio alone followed by fine-tuning on
transcribed speech can outperform the best semi-supervised methods while being conceptually simpler. wav2vec 2.0 masks
the speech input in the latent space and solves a contrastive task defined over a quantization of the latent
representations which are jointly learned. Experiments using all labeled data of Librispeech achieve 1.8/3.3 WER on the
clean/other test sets. When lowering the amount of labeled data to one hour, wav2vec 2.0 outperforms the previous state
of the art on the 100 hour subset while using 100 times less labeled data. Using just ten minutes of labeled data and
pre-training on 53k hours of unlabeled data still achieves 4.8/8.2 WER. This demonstrates the feasibility of speech
recognition with limited amounts of labeled data.`),ip.forEach(t),rp.forEach(t),Ie=p(o),D=r(o,"P",{});var lp=i(D);Y=s(lp,"Tips:"),lp.forEach(t),tt=p(o),ae=r(o,"UL",{});var Ei=i(ae);Je=r(Ei,"LI",{});var cp=i(Je);jt=s(cp,"Wav2Vec2 is a speech model that accepts a float array corresponding to the raw waveform of the speech signal."),cp.forEach(t),Ve=p(Ei),Fe=r(Ei,"LI",{});var Ci=i(Fe);Wt=s(Ci,`Wav2Vec2 model was trained using connectionist temporal classification (CTC) so the model output has to be decoded
using `),U=r(Ci,"A",{href:!0});var dp=i(U);Vt=s(dp,"Wav2Vec2CTCTokenizer"),dp.forEach(t),Ee=s(Ci,"."),Ci.forEach(t),Ei.forEach(t),ot=p(o),we=r(o,"P",{});var qi=i(we);Ce=s(qi,"This model was contributed by "),qe=r(qi,"A",{href:!0,rel:!0});var pp=i(qe);Ft=s(pp,"patrickvonplaten"),pp.forEach(t),he=s(qi,"."),qi.forEach(t),at=p(o),ee=r(o,"H2",{class:!0});var Pi=i(ee);ye=r(Pi,"A",{id:!0,class:!0,href:!0});var mp=i(ye);Pe=r(mp,"SPAN",{});var hp=i(Pe);y(B.$$.fragment,hp),hp.forEach(t),mp.forEach(t),Et=p(Pi),te=r(Pi,"SPAN",{});var fp=i(te);Ct=s(fp,"Resources"),fp.forEach(t),Pi.forEach(t),st=p(o),j=r(o,"P",{});var up=i(j);q=s(up,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with Wav2Vec2. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),up.forEach(t),Nt=p(o),y(fe.$$.fragment,o),Bt=p(o),ke=r(o,"UL",{});var Ko=i(ke);P=r(Ko,"LI",{});var Ai=i(P);Qt=s(Ai,"A notebook on how to "),Ze=r(Ai,"A",{href:!0,rel:!0});var gp=i(Ze);Yt=s(gp,"leverage a pretrained Wav2Vec2 model for emotion classification"),gp.forEach(t),eo=s(Ai,". \u{1F30E}"),Ai.forEach(t),to=p(Ko),H=r(Ko,"LI",{});var Gt=i(H);pe=r(Gt,"A",{href:!0});var _p=i(pe);oo=s(_p,"Wav2Vec2ForCTC"),_p.forEach(t),ao=s(Gt," is supported by this "),se=r(Gt,"A",{href:!0,rel:!0});var gy=i(se);so=s(gy,"example script"),gy.forEach(t),no=s(Gt," and "),Ae=r(Gt,"A",{href:!0,rel:!0});var _y=i(Ae);ro=s(_y,"notebook"),_y.forEach(t),Qe=s(Gt,"."),Gt.forEach(t),io=p(Ko),tc=r(Ko,"LI",{});var vy=i(tc);Mi=r(vy,"A",{href:!0});var by=i(Mi);Lh=s(by,"Audio classification task guide"),by.forEach(t),vy.forEach(t),Ko.forEach(t),vp=p(o),y(xs.$$.fragment,o),bp=p(o),Te=r(o,"UL",{});var vt=i(Te);$s=r(vt,"LI",{});var mm=i($s);Oh=s(mm,"A blog post on "),js=r(mm,"A",{href:!0,rel:!0});var wy=i(js);Dh=s(wy,"boosting Wav2Vec2 with n-grams in \u{1F917} Transformers"),wy.forEach(t),Sh=s(mm,"."),mm.forEach(t),Ih=p(vt),Ws=r(vt,"LI",{});var hm=i(Ws);Nh=s(hm,"A blog post on how to "),Vs=r(hm,"A",{href:!0,rel:!0});var yy=i(Vs);Bh=s(yy,"finetune Wav2Vec2 for English ASR with \u{1F917} Transformers"),yy.forEach(t),Rh=s(hm,"."),hm.forEach(t),Uh=p(vt),Fs=r(vt,"LI",{});var fm=i(Fs);Hh=s(fm,"A blog post on "),Es=r(fm,"A",{href:!0,rel:!0});var ky=i(Es);Xh=s(ky,"finetuning XLS-R for Multi-Lingual ASR with \u{1F917} Transformers"),ky.forEach(t),Gh=s(fm,"."),fm.forEach(t),Kh=p(vt),Cs=r(vt,"LI",{});var um=i(Cs);Jh=s(um,"A notebook on how to "),qs=r(um,"A",{href:!0,rel:!0});var Ty=i(qs);Zh=s(Ty,"create YouTube captions from any video by transcribing audio with Wav2Vec2"),Ty.forEach(t),Qh=s(um,". \u{1F30E}"),um.forEach(t),Yh=p(vt),Rt=r(vt,"LI",{});var zi=i(Rt);Li=r(zi,"A",{href:!0});var xy=i(Li);ef=s(xy,"Wav2Vec2ForCTC"),xy.forEach(t),tf=s(zi," is supported by a notebook on "),Ps=r(zi,"A",{href:!0,rel:!0});var $y=i(Ps);of=s($y,"how to finetune a speech recognition model in English"),$y.forEach(t),af=s(zi,", and "),As=r(zi,"A",{href:!0,rel:!0});var jy=i(As);sf=s(jy,"how to finetune a speech recognition model in any language"),jy.forEach(t),nf=s(zi,"."),zi.forEach(t),rf=p(vt),oc=r(vt,"LI",{});var Wy=i(oc);Oi=r(Wy,"A",{href:!0});var Vy=i(Oi);lf=s(Vy,"Automatic speech recognition task guide"),Vy.forEach(t),Wy.forEach(t),vt.forEach(t),wp=p(o),Di=r(o,"P",{});var Fy=i(Di);cf=s(Fy,"\u{1F680} Deploy"),Fy.forEach(t),yp=p(o),Si=r(o,"UL",{});var Ey=i(Si);zs=r(Ey,"LI",{});var gm=i(zs);df=s(gm,"A blog post on how to deploy Wav2Vec2 for "),Ms=r(gm,"A",{href:!0,rel:!0});var Cy=i(Ms);pf=s(Cy,"Automatic Speech Recogntion with Hugging Face\u2019s Transformers & Amazon SageMaker"),Cy.forEach(t),mf=s(gm,"."),gm.forEach(t),Ey.forEach(t),kp=p(o),lo=r(o,"H2",{class:!0});var _m=i(lo);Jo=r(_m,"A",{id:!0,class:!0,href:!0});var qy=i(Jo);ac=r(qy,"SPAN",{});var Py=i(ac);y(Ls.$$.fragment,Py),Py.forEach(t),qy.forEach(t),hf=p(_m),sc=r(_m,"SPAN",{});var Ay=i(sc);ff=s(Ay,"Wav2Vec2Config"),Ay.forEach(t),_m.forEach(t),Tp=p(o),Ye=r(o,"DIV",{class:!0});var os=i(Ye);y(Os.$$.fragment,os),uf=p(os),co=r(os,"P",{});var Pl=i(co);gf=s(Pl,"This is the configuration class to store the configuration of a "),Ii=r(Pl,"A",{href:!0});var zy=i(Ii);_f=s(zy,"Wav2Vec2Model"),zy.forEach(t),vf=s(Pl,`. It is used to instantiate an
Wav2Vec2 model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the Wav2Vec2
`),Ds=r(Pl,"A",{href:!0,rel:!0});var My=i(Ds);bf=s(My,"facebook/wav2vec2-base-960h"),My.forEach(t),wf=s(Pl," architecture."),Pl.forEach(t),yf=p(os),po=r(os,"P",{});var Al=i(po);kf=s(Al,"Configuration objects inherit from "),Ni=r(Al,"A",{href:!0});var Ly=i(Ni);Tf=s(Ly,"PretrainedConfig"),Ly.forEach(t),xf=s(Al,` and can be used to control the model outputs. Read the
documentation from `),Bi=r(Al,"A",{href:!0});var Oy=i(Bi);$f=s(Oy,"PretrainedConfig"),Oy.forEach(t),jf=s(Al," for more information."),Al.forEach(t),Wf=p(os),y(Zo.$$.fragment,os),os.forEach(t),xp=p(o),mo=r(o,"H2",{class:!0});var vm=i(mo);Qo=r(vm,"A",{id:!0,class:!0,href:!0});var Dy=i(Qo);nc=r(Dy,"SPAN",{});var Sy=i(nc);y(Ss.$$.fragment,Sy),Sy.forEach(t),Dy.forEach(t),Vf=p(vm),rc=r(vm,"SPAN",{});var Iy=i(rc);Ff=s(Iy,"Wav2Vec2CTCTokenizer"),Iy.forEach(t),vm.forEach(t),$p=p(o),ne=r(o,"DIV",{class:!0});var Be=i(ne);y(Is.$$.fragment,Be),Ef=p(Be),ic=r(Be,"P",{});var Ny=i(ic);Cf=s(Ny,"Constructs a Wav2Vec2CTC tokenizer."),Ny.forEach(t),qf=p(Be),Ns=r(Be,"P",{});var bm=i(Ns);Pf=s(bm,"This tokenizer inherits from "),Ri=r(bm,"A",{href:!0});var By=i(Ri);Af=s(By,"PreTrainedTokenizer"),By.forEach(t),zf=s(bm,` which contains some of the main methods. Users should refer to
the superclass for more information regarding such methods.`),bm.forEach(t),Mf=p(Be),Yo=r(Be,"DIV",{class:!0});var wm=i(Yo);y(Bs.$$.fragment,wm),Lf=p(wm),lc=r(wm,"P",{});var Ry=i(lc);Of=s(Ry,`Main method to tokenize and prepare for the model one or several sequence(s) or one or several pair(s) of
sequences.`),Ry.forEach(t),wm.forEach(t),Df=p(Be),Ui=r(Be,"DIV",{class:!0});var Uy=i(Ui);y(Rs.$$.fragment,Uy),Uy.forEach(t),Sf=p(Be),nt=r(Be,"DIV",{class:!0});var as=i(nt);y(Us.$$.fragment,as),If=p(as),cc=r(as,"P",{});var Hy=i(cc);Nf=s(Hy,`Converts a sequence of ids in a string, using the tokenizer and vocabulary with options to remove special
tokens and clean up tokenization spaces.`),Hy.forEach(t),Bf=p(as),Hs=r(as,"P",{});var ym=i(Hs);Rf=s(ym,"Similar to doing "),dc=r(ym,"CODE",{});var Xy=i(dc);Uf=s(Xy,"self.convert_tokens_to_string(self.convert_ids_to_tokens(token_ids))"),Xy.forEach(t),Hf=s(ym,"."),ym.forEach(t),Xf=p(as),y(ea.$$.fragment,as),as.forEach(t),Gf=p(Be),ta=r(Be,"DIV",{class:!0});var km=i(ta);y(Xs.$$.fragment,km),Kf=p(km),pc=r(km,"P",{});var Gy=i(pc);Jf=s(Gy,"Convert a list of lists of token ids into a list of strings by calling decode."),Gy.forEach(t),km.forEach(t),Be.forEach(t),jp=p(o),ho=r(o,"H2",{class:!0});var Tm=i(ho);oa=r(Tm,"A",{id:!0,class:!0,href:!0});var Ky=i(oa);mc=r(Ky,"SPAN",{});var Jy=i(mc);y(Gs.$$.fragment,Jy),Jy.forEach(t),Ky.forEach(t),Zf=p(Tm),hc=r(Tm,"SPAN",{});var Zy=i(hc);Qf=s(Zy,"Wav2Vec2FeatureExtractor"),Zy.forEach(t),Tm.forEach(t),Wp=p(o),et=r(o,"DIV",{class:!0});var ss=i(et);y(Ks.$$.fragment,ss),Yf=p(ss),fc=r(ss,"P",{});var Qy=i(fc);eu=s(Qy,"Constructs a Wav2Vec2 feature extractor."),Qy.forEach(t),tu=p(ss),Js=r(ss,"P",{});var xm=i(Js);ou=s(xm,"This feature extractor inherits from "),Hi=r(xm,"A",{href:!0});var Yy=i(Hi);au=s(Yy,"SequenceFeatureExtractor"),Yy.forEach(t),su=s(xm,` which contains
most of the main methods. Users should refer to this superclass for more information regarding those methods.`),xm.forEach(t),nu=p(ss),aa=r(ss,"DIV",{class:!0});var $m=i(aa);y(Zs.$$.fragment,$m),ru=p($m),uc=r($m,"P",{});var ek=i(uc);iu=s(ek,"Main method to featurize and prepare for the model one or several sequence(s)."),ek.forEach(t),$m.forEach(t),ss.forEach(t),Vp=p(o),fo=r(o,"H2",{class:!0});var jm=i(fo);sa=r(jm,"A",{id:!0,class:!0,href:!0});var tk=i(sa);gc=r(tk,"SPAN",{});var ok=i(gc);y(Qs.$$.fragment,ok),ok.forEach(t),tk.forEach(t),lu=p(jm),_c=r(jm,"SPAN",{});var ak=i(_c);cu=s(ak,"Wav2Vec2Processor"),ak.forEach(t),jm.forEach(t),Fp=p(o),G=r(o,"DIV",{class:!0});var me=i(G);y(Ys.$$.fragment,me),du=p(me),vc=r(me,"P",{});var sk=i(vc);pu=s(sk,`Constructs a Wav2Vec2 processor which wraps a Wav2Vec2 feature extractor and a Wav2Vec2 CTC tokenizer into a single
processor.`),sk.forEach(t),mu=p(me),Ne=r(me,"P",{});var It=i(Ne);Xi=r(It,"A",{href:!0});var nk=i(Xi);hu=s(nk,"Wav2Vec2Processor"),nk.forEach(t),fu=s(It," offers all the functionalities of "),Gi=r(It,"A",{href:!0});var rk=i(Gi);uu=s(rk,"Wav2Vec2FeatureExtractor"),rk.forEach(t),gu=s(It," and "),Ki=r(It,"A",{href:!0});var ik=i(Ki);_u=s(ik,"PreTrainedTokenizer"),ik.forEach(t),vu=s(It,`.
See the docstring of `),en=r(It,"A",{href:!0});var py=i(en);bc=r(py,"STRONG",{});var lk=i(bc);bu=s(lk,"call"),lk.forEach(t),wu=s(py,"()"),py.forEach(t),yu=s(It," and "),Ji=r(It,"A",{href:!0});var ck=i(Ji);ku=s(ck,"decode()"),ck.forEach(t),Tu=s(It," for more information."),It.forEach(t),xu=p(me),na=r(me,"DIV",{class:!0});var Wm=i(na);y(tn.$$.fragment,Wm),$u=p(Wm),qt=r(Wm,"P",{});var ns=i(qt);ju=s(ns,`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),on=r(ns,"A",{href:!0});var my=i(on);wc=r(my,"STRONG",{});var dk=i(wc);Wu=s(dk,"call"),dk.forEach(t),Vu=s(my,"()"),my.forEach(t),Fu=s(ns,` and returns its output. If used in the context
`),yc=r(ns,"CODE",{});var pk=i(yc);Eu=s(pk,"as_target_processor()"),pk.forEach(t),Cu=s(ns,` this method forwards all its arguments to PreTrainedTokenizer\u2019s
`),an=r(ns,"A",{href:!0});var hy=i(an);kc=r(hy,"STRONG",{});var mk=i(kc);qu=s(mk,"call"),mk.forEach(t),Pu=s(hy,"()"),hy.forEach(t),Au=s(ns,". Please refer to the docstring of the above two methods for more information."),ns.forEach(t),Wm.forEach(t),zu=p(me),ra=r(me,"DIV",{class:!0});var Vm=i(ra);y(sn.$$.fragment,Vm),Mu=p(Vm),Pt=r(Vm,"P",{});var rs=i(Pt);Lu=s(rs,`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),Zi=r(rs,"A",{href:!0});var hk=i(Zi);Ou=s(hk,"pad()"),hk.forEach(t),Du=s(rs,` and returns its output. If used in the context
`),Tc=r(rs,"CODE",{});var fk=i(Tc);Su=s(fk,"as_target_processor()"),fk.forEach(t),Iu=s(rs,` this method forwards all its arguments to PreTrainedTokenizer\u2019s
`),Qi=r(rs,"A",{href:!0});var uk=i(Qi);Nu=s(uk,"pad()"),uk.forEach(t),Bu=s(rs,". Please refer to the docstring of the above two methods for more information."),rs.forEach(t),Vm.forEach(t),Ru=p(me),Yi=r(me,"DIV",{class:!0});var gk=i(Yi);y(nn.$$.fragment,gk),gk.forEach(t),Uu=p(me),Ut=r(me,"DIV",{class:!0});var zl=i(Ut);y(rn.$$.fragment,zl),Hu=p(zl),ln=r(zl,"P",{});var Fm=i(ln);Xu=s(Fm,`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),el=r(Fm,"A",{href:!0});var _k=i(el);Gu=s(_k,"from_pretrained()"),_k.forEach(t),Ku=s(Fm," method."),Fm.forEach(t),Ju=p(zl),y(ia.$$.fragment,zl),zl.forEach(t),Zu=p(me),la=r(me,"DIV",{class:!0});var Em=i(la);y(cn.$$.fragment,Em),Qu=p(Em),dn=r(Em,"P",{});var Cm=i(dn);Yu=s(Cm,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),tl=r(Cm,"A",{href:!0});var vk=i(tl);eg=s(vk,"batch_decode()"),vk.forEach(t),tg=s(Cm,`. Please
refer to the docstring of this method for more information.`),Cm.forEach(t),Em.forEach(t),og=p(me),ca=r(me,"DIV",{class:!0});var qm=i(ca);y(pn.$$.fragment,qm),ag=p(qm),mn=r(qm,"P",{});var Pm=i(mn);sg=s(Pm,"This method forwards all its arguments to PreTrainedTokenizer\u2019s "),ol=r(Pm,"A",{href:!0});var bk=i(ol);ng=s(bk,"decode()"),bk.forEach(t),rg=s(Pm,`. Please refer
to the docstring of this method for more information.`),Pm.forEach(t),qm.forEach(t),me.forEach(t),Ep=p(o),uo=r(o,"H2",{class:!0});var Am=i(uo);da=r(Am,"A",{id:!0,class:!0,href:!0});var wk=i(da);xc=r(wk,"SPAN",{});var yk=i(xc);y(hn.$$.fragment,yk),yk.forEach(t),wk.forEach(t),ig=p(Am),$c=r(Am,"SPAN",{});var kk=i($c);lg=s(kk,"Wav2Vec2ProcessorWithLM"),kk.forEach(t),Am.forEach(t),Cp=p(o),oe=r(o,"DIV",{class:!0});var $e=i(oe);y(fn.$$.fragment,$e),cg=p($e),jc=r($e,"P",{});var Tk=i(jc);dg=s(Tk,`Constructs a Wav2Vec2 processor which wraps a Wav2Vec2 feature extractor, a Wav2Vec2 CTC tokenizer and a decoder
with language model support into a single processor for language model boosted speech recognition decoding.`),Tk.forEach(t),pg=p($e),pa=r($e,"DIV",{class:!0});var zm=i(pa);y(un.$$.fragment,zm),mg=p(zm),At=r(zm,"P",{});var is=i(At);hg=s(is,`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),gn=r(is,"A",{href:!0});var fy=i(gn);Wc=r(fy,"STRONG",{});var xk=i(Wc);fg=s(xk,"call"),xk.forEach(t),ug=s(fy,"()"),fy.forEach(t),gg=s(is,` and returns its output. If used in the context
`),Vc=r(is,"CODE",{});var $k=i(Vc);_g=s($k,"as_target_processor()"),$k.forEach(t),vg=s(is,` this method forwards all its arguments to
Wav2Vec2CTCTokenizer\u2019s `),_n=r(is,"A",{href:!0});var uy=i(_n);Fc=r(uy,"STRONG",{});var jk=i(Fc);bg=s(jk,"call"),jk.forEach(t),wg=s(uy,"()"),uy.forEach(t),yg=s(is,`. Please refer to the docstring of the above two
methods for more information.`),is.forEach(t),zm.forEach(t),kg=p($e),ma=r($e,"DIV",{class:!0});var Mm=i(ma);y(vn.$$.fragment,Mm),Tg=p(Mm),zt=r(Mm,"P",{});var ls=i(zt);xg=s(ls,`When used in normal mode, this method forwards all its arguments to Wav2Vec2FeatureExtractor\u2019s
`),al=r(ls,"A",{href:!0});var Wk=i(al);$g=s(Wk,"pad()"),Wk.forEach(t),jg=s(ls,` and returns its output. If used in the context
`),Ec=r(ls,"CODE",{});var Vk=i(Ec);Wg=s(Vk,"as_target_processor()"),Vk.forEach(t),Vg=s(ls,` this method forwards all its arguments to
Wav2Vec2CTCTokenizer\u2019s `),sl=r(ls,"A",{href:!0});var Fk=i(sl);Fg=s(Fk,"pad()"),Fk.forEach(t),Eg=s(ls,`. Please refer to the docstring of the above two methods
for more information.`),ls.forEach(t),Mm.forEach(t),Cg=p($e),Ht=r($e,"DIV",{class:!0});var Ml=i(Ht);y(bn.$$.fragment,Ml),qg=p(Ml),wn=r(Ml,"P",{});var Lm=i(wn);Pg=s(Lm,"Instantiate a "),nl=r(Lm,"A",{href:!0});var Ek=i(nl);Ag=s(Ek,"Wav2Vec2ProcessorWithLM"),Ek.forEach(t),zg=s(Lm," from a pretrained Wav2Vec2 processor."),Lm.forEach(t),Mg=p(Ml),y(ha.$$.fragment,Ml),Ml.forEach(t),Lg=p($e),rl=r($e,"DIV",{class:!0});var Ck=i(rl);y(yn.$$.fragment,Ck),Ck.forEach(t),Og=p($e),rt=r($e,"DIV",{class:!0});var cs=i(rt);y(kn.$$.fragment,cs),Dg=p(cs),Cc=r(cs,"P",{});var qk=i(Cc);Sg=s(qk,"Batch decode output logits to audio transcription with language model support."),qk.forEach(t),Ig=p(cs),y(fa.$$.fragment,cs),Ng=p(cs),Tn=r(cs,"P",{});var Om=i(Tn);Bg=s(Om,`Example:
See `),il=r(Om,"A",{href:!0});var Pk=i(il);Rg=s(Pk,"Decoding multiple audios"),Pk.forEach(t),Ug=s(Om,"."),Om.forEach(t),cs.forEach(t),Hg=p($e),Xt=r($e,"DIV",{class:!0});var Ll=i(Xt);y(xn.$$.fragment,Ll),Xg=p(Ll),qc=r(Ll,"P",{});var Ak=i(qc);Gg=s(Ak,"Decode output logits to audio transcription with language model support."),Ak.forEach(t),Kg=p(Ll),y(ua.$$.fragment,Ll),Ll.forEach(t),$e.forEach(t),qp=p(o),go=r(o,"H3",{class:!0});var Dm=i(go);ga=r(Dm,"A",{id:!0,class:!0,href:!0});var zk=i(ga);Pc=r(zk,"SPAN",{});var Mk=i(Pc);y($n.$$.fragment,Mk),Mk.forEach(t),zk.forEach(t),Jg=p(Dm),Ac=r(Dm,"SPAN",{});var Lk=i(Ac);Zg=s(Lk,"Decoding multiple audios"),Lk.forEach(t),Dm.forEach(t),Pp=p(o),xe=r(o,"P",{});var bt=i(xe);Qg=s(bt,"If you are planning to decode multiple batches of audios, you should consider using "),ll=r(bt,"A",{href:!0});var Ok=i(ll);Yg=s(Ok,"batch_decode()"),Ok.forEach(t),e_=s(bt," and passing an instantiated "),zc=r(bt,"CODE",{});var Dk=i(zc);t_=s(Dk,"multiprocessing.Pool"),Dk.forEach(t),o_=s(bt,`.
Otherwise, `),cl=r(bt,"A",{href:!0});var Sk=i(cl);a_=s(Sk,"batch_decode()"),Sk.forEach(t),s_=s(bt," performance will be slower than calling "),dl=r(bt,"A",{href:!0});var Ik=i(dl);n_=s(Ik,"decode()"),Ik.forEach(t),r_=s(bt," for each audio individually, as it internally instantiates a new "),Mc=r(bt,"CODE",{});var Nk=i(Mc);i_=s(Nk,"Pool"),Nk.forEach(t),l_=s(bt," for every call. See the example below:"),bt.forEach(t),Ap=p(o),y(jn.$$.fragment,o),zp=p(o),_o=r(o,"H2",{class:!0});var Sm=i(_o);_a=r(Sm,"A",{id:!0,class:!0,href:!0});var Bk=i(_a);Lc=r(Bk,"SPAN",{});var Rk=i(Lc);y(Wn.$$.fragment,Rk),Rk.forEach(t),Bk.forEach(t),c_=p(Sm),Oc=r(Sm,"SPAN",{});var Uk=i(Oc);d_=s(Uk,"Wav2Vec2 specific outputs"),Uk.forEach(t),Sm.forEach(t),Mp=p(o),vo=r(o,"DIV",{class:!0});var Im=i(vo);y(Vn.$$.fragment,Im),p_=p(Im),Fn=r(Im,"P",{});var Nm=i(Fn);m_=s(Nm,"Output type of "),Dc=r(Nm,"CODE",{});var Hk=i(Dc);h_=s(Hk,"Wav2Vec2DecoderWithLM"),Hk.forEach(t),f_=s(Nm,", with transcription."),Nm.forEach(t),Im.forEach(t),Lp=p(o),bo=r(o,"DIV",{class:!0});var Bm=i(bo);y(En.$$.fragment,Bm),u_=p(Bm),Sc=r(Bm,"P",{});var Xk=i(Sc);g_=s(Xk,"Base class for models that have been trained with the Wav2Vec2 loss objective."),Xk.forEach(t),Bm.forEach(t),Op=p(o),wo=r(o,"DIV",{class:!0});var Rm=i(wo);y(Cn.$$.fragment,Rm),__=p(Rm),qn=r(Rm,"P",{});var Um=i(qn);v_=s(Um,"Output type of "),pl=r(Um,"A",{href:!0});var Gk=i(pl);b_=s(Gk,"Wav2Vec2ForPreTraining"),Gk.forEach(t),w_=s(Um,", with potential hidden states and attentions."),Um.forEach(t),Rm.forEach(t),Dp=p(o),Mt=r(o,"DIV",{class:!0});var Ol=i(Mt);y(Pn.$$.fragment,Ol),y_=p(Ol),An=r(Ol,"P",{});var Hm=i(An);k_=s(Hm,"Output type of "),Ic=r(Hm,"CODE",{});var Kk=i(Ic);T_=s(Kk,"FlaxWav2Vec2BaseModelOutput"),Kk.forEach(t),x_=s(Hm,", with potential hidden states and attentions."),Hm.forEach(t),$_=p(Ol),va=r(Ol,"DIV",{class:!0});var Xm=i(va);y(zn.$$.fragment,Xm),j_=p(Xm),Nc=r(Xm,"P",{});var Jk=i(Nc);W_=s(Jk,"\u201CReturns a new object replacing the specified fields with new values."),Jk.forEach(t),Xm.forEach(t),Ol.forEach(t),Sp=p(o),Lt=r(o,"DIV",{class:!0});var Dl=i(Lt);y(Mn.$$.fragment,Dl),V_=p(Dl),Ln=r(Dl,"P",{});var Gm=i(Ln);F_=s(Gm,"Output type of "),Bc=r(Gm,"CODE",{});var Zk=i(Bc);E_=s(Zk,"FlaxWav2Vec2ForPreTrainingOutput"),Zk.forEach(t),C_=s(Gm,", with potential hidden states and attentions."),Gm.forEach(t),q_=p(Dl),ba=r(Dl,"DIV",{class:!0});var Km=i(ba);y(On.$$.fragment,Km),P_=p(Km),Rc=r(Km,"P",{});var Qk=i(Rc);A_=s(Qk,"\u201CReturns a new object replacing the specified fields with new values."),Qk.forEach(t),Km.forEach(t),Dl.forEach(t),Ip=p(o),yo=r(o,"H2",{class:!0});var Jm=i(yo);wa=r(Jm,"A",{id:!0,class:!0,href:!0});var Yk=i(wa);Uc=r(Yk,"SPAN",{});var e0=i(Uc);y(Dn.$$.fragment,e0),e0.forEach(t),Yk.forEach(t),z_=p(Jm),Hc=r(Jm,"SPAN",{});var t0=i(Hc);M_=s(t0,"Wav2Vec2Model"),t0.forEach(t),Jm.forEach(t),Np=p(o),ze=r(o,"DIV",{class:!0});var Kt=i(ze);y(Sn.$$.fragment,Kt),L_=p(Kt),In=r(Kt,"P",{});var Zm=i(In);O_=s(Zm,`The bare Wav2Vec2 Model transformer outputting raw hidden-states without any specific head on top.
Wav2Vec2 was proposed in `),Nn=r(Zm,"A",{href:!0,rel:!0});var o0=i(Nn);D_=s(o0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),o0.forEach(t),S_=s(Zm,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Zm.forEach(t),I_=p(Kt),Bn=r(Kt,"P",{});var Qm=i(Bn);N_=s(Qm,"This model inherits from "),ml=r(Qm,"A",{href:!0});var a0=i(ml);B_=s(a0,"PreTrainedModel"),a0.forEach(t),R_=s(Qm,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),Qm.forEach(t),U_=p(Kt),Rn=r(Kt,"P",{});var Ym=i(Rn);H_=s(Ym,"This model is a PyTorch "),Un=r(Ym,"A",{href:!0,rel:!0});var s0=i(Un);X_=s(s0,"torch.nn.Module"),s0.forEach(t),G_=s(Ym,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ym.forEach(t),K_=p(Kt),it=r(Kt,"DIV",{class:!0});var ds=i(it);y(Hn.$$.fragment,ds),J_=p(ds),ko=r(ds,"P",{});var Sl=i(ko);Z_=s(Sl,"The "),hl=r(Sl,"A",{href:!0});var n0=i(hl);Q_=s(n0,"Wav2Vec2Model"),n0.forEach(t),Y_=s(Sl," forward method, overrides the "),Xc=r(Sl,"CODE",{});var r0=i(Xc);e2=s(r0,"__call__"),r0.forEach(t),t2=s(Sl," special method."),Sl.forEach(t),o2=p(ds),y(ya.$$.fragment,ds),a2=p(ds),y(ka.$$.fragment,ds),ds.forEach(t),Kt.forEach(t),Bp=p(o),To=r(o,"H2",{class:!0});var eh=i(To);Ta=r(eh,"A",{id:!0,class:!0,href:!0});var i0=i(Ta);Gc=r(i0,"SPAN",{});var l0=i(Gc);y(Xn.$$.fragment,l0),l0.forEach(t),i0.forEach(t),s2=p(eh),Kc=r(eh,"SPAN",{});var c0=i(Kc);n2=s(c0,"Wav2Vec2ForCTC"),c0.forEach(t),eh.forEach(t),Rp=p(o),Me=r(o,"DIV",{class:!0});var Jt=i(Me);y(Gn.$$.fragment,Jt),r2=p(Jt),xo=r(Jt,"P",{});var Il=i(xo);i2=s(Il,"Wav2Vec2 Model with a "),Jc=r(Il,"CODE",{});var d0=i(Jc);l2=s(d0,"language modeling"),d0.forEach(t),c2=s(Il,` head on top for Connectionist Temporal Classification (CTC).
Wav2Vec2 was proposed in `),Kn=r(Il,"A",{href:!0,rel:!0});var p0=i(Kn);d2=s(p0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),p0.forEach(t),p2=s(Il,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Il.forEach(t),m2=p(Jt),Jn=r(Jt,"P",{});var th=i(Jn);h2=s(th,"This model inherits from "),fl=r(th,"A",{href:!0});var m0=i(fl);f2=s(m0,"PreTrainedModel"),m0.forEach(t),u2=s(th,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),th.forEach(t),g2=p(Jt),Zn=r(Jt,"P",{});var oh=i(Zn);_2=s(oh,"This model is a PyTorch "),Qn=r(oh,"A",{href:!0,rel:!0});var h0=i(Qn);v2=s(h0,"torch.nn.Module"),h0.forEach(t),b2=s(oh,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),oh.forEach(t),w2=p(Jt),lt=r(Jt,"DIV",{class:!0});var ps=i(lt);y(Yn.$$.fragment,ps),y2=p(ps),$o=r(ps,"P",{});var Nl=i($o);k2=s(Nl,"The "),ul=r(Nl,"A",{href:!0});var f0=i(ul);T2=s(f0,"Wav2Vec2ForCTC"),f0.forEach(t),x2=s(Nl," forward method, overrides the "),Zc=r(Nl,"CODE",{});var u0=i(Zc);$2=s(u0,"__call__"),u0.forEach(t),j2=s(Nl," special method."),Nl.forEach(t),W2=p(ps),y(xa.$$.fragment,ps),V2=p(ps),y($a.$$.fragment,ps),ps.forEach(t),Jt.forEach(t),Up=p(o),jo=r(o,"H2",{class:!0});var ah=i(jo);ja=r(ah,"A",{id:!0,class:!0,href:!0});var g0=i(ja);Qc=r(g0,"SPAN",{});var _0=i(Qc);y(er.$$.fragment,_0),_0.forEach(t),g0.forEach(t),F2=p(ah),Yc=r(ah,"SPAN",{});var v0=i(Yc);E2=s(v0,"Wav2Vec2ForSequenceClassification"),v0.forEach(t),ah.forEach(t),Hp=p(o),ue=r(o,"DIV",{class:!0});var wt=i(ue);y(tr.$$.fragment,wt),C2=p(wt),ed=r(wt,"P",{});var b0=i(ed);q2=s(b0,`Wav2Vec2 Model with a sequence classification head on top (a linear layer over the pooled output) for tasks like
SUPERB Keyword Spotting.`),b0.forEach(t),P2=p(wt),or=r(wt,"P",{});var sh=i(or);A2=s(sh,"Wav2Vec2 was proposed in "),ar=r(sh,"A",{href:!0,rel:!0});var w0=i(ar);z2=s(w0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),w0.forEach(t),M2=s(sh,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),sh.forEach(t),L2=p(wt),sr=r(wt,"P",{});var nh=i(sr);O2=s(nh,"This model inherits from "),gl=r(nh,"A",{href:!0});var y0=i(gl);D2=s(y0,"PreTrainedModel"),y0.forEach(t),S2=s(nh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),nh.forEach(t),I2=p(wt),nr=r(wt,"P",{});var rh=i(nr);N2=s(rh,"This model is a PyTorch "),rr=r(rh,"A",{href:!0,rel:!0});var k0=i(rr);B2=s(k0,"torch.nn.Module"),k0.forEach(t),R2=s(rh,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),rh.forEach(t),U2=p(wt),ct=r(wt,"DIV",{class:!0});var ms=i(ct);y(ir.$$.fragment,ms),H2=p(ms),Wo=r(ms,"P",{});var Bl=i(Wo);X2=s(Bl,"The "),_l=r(Bl,"A",{href:!0});var T0=i(_l);G2=s(T0,"Wav2Vec2ForSequenceClassification"),T0.forEach(t),K2=s(Bl," forward method, overrides the "),td=r(Bl,"CODE",{});var x0=i(td);J2=s(x0,"__call__"),x0.forEach(t),Z2=s(Bl," special method."),Bl.forEach(t),Q2=p(ms),y(Wa.$$.fragment,ms),Y2=p(ms),y(Va.$$.fragment,ms),ms.forEach(t),wt.forEach(t),Xp=p(o),Vo=r(o,"H2",{class:!0});var ih=i(Vo);Fa=r(ih,"A",{id:!0,class:!0,href:!0});var $0=i(Fa);od=r($0,"SPAN",{});var j0=i(od);y(lr.$$.fragment,j0),j0.forEach(t),$0.forEach(t),ev=p(ih),ad=r(ih,"SPAN",{});var W0=i(ad);tv=s(W0,"Wav2Vec2ForAudioFrameClassification"),W0.forEach(t),ih.forEach(t),Gp=p(o),ge=r(o,"DIV",{class:!0});var yt=i(ge);y(cr.$$.fragment,yt),ov=p(yt),sd=r(yt,"P",{});var V0=i(sd);av=s(V0,"Wav2Vec2 Model with a frame classification head on top for tasks like Speaker Diarization."),V0.forEach(t),sv=p(yt),dr=r(yt,"P",{});var lh=i(dr);nv=s(lh,"Wav2Vec2 was proposed in "),pr=r(lh,"A",{href:!0,rel:!0});var F0=i(pr);rv=s(F0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),F0.forEach(t),iv=s(lh,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),lh.forEach(t),lv=p(yt),mr=r(yt,"P",{});var ch=i(mr);cv=s(ch,"This model inherits from "),vl=r(ch,"A",{href:!0});var E0=i(vl);dv=s(E0,"PreTrainedModel"),E0.forEach(t),pv=s(ch,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),ch.forEach(t),mv=p(yt),hr=r(yt,"P",{});var dh=i(hr);hv=s(dh,"This model is a PyTorch "),fr=r(dh,"A",{href:!0,rel:!0});var C0=i(fr);fv=s(C0,"torch.nn.Module"),C0.forEach(t),uv=s(dh,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),dh.forEach(t),gv=p(yt),dt=r(yt,"DIV",{class:!0});var hs=i(dt);y(ur.$$.fragment,hs),_v=p(hs),Fo=r(hs,"P",{});var Rl=i(Fo);vv=s(Rl,"The "),bl=r(Rl,"A",{href:!0});var q0=i(bl);bv=s(q0,"Wav2Vec2ForAudioFrameClassification"),q0.forEach(t),wv=s(Rl," forward method, overrides the "),nd=r(Rl,"CODE",{});var P0=i(nd);yv=s(P0,"__call__"),P0.forEach(t),kv=s(Rl," special method."),Rl.forEach(t),Tv=p(hs),y(Ea.$$.fragment,hs),xv=p(hs),y(Ca.$$.fragment,hs),hs.forEach(t),yt.forEach(t),Kp=p(o),Eo=r(o,"H2",{class:!0});var ph=i(Eo);qa=r(ph,"A",{id:!0,class:!0,href:!0});var A0=i(qa);rd=r(A0,"SPAN",{});var z0=i(rd);y(gr.$$.fragment,z0),z0.forEach(t),A0.forEach(t),$v=p(ph),id=r(ph,"SPAN",{});var M0=i(id);jv=s(M0,"Wav2Vec2ForXVector"),M0.forEach(t),ph.forEach(t),Jp=p(o),_e=r(o,"DIV",{class:!0});var kt=i(_e);y(_r.$$.fragment,kt),Wv=p(kt),ld=r(kt,"P",{});var L0=i(ld);Vv=s(L0,"Wav2Vec2 Model with an XVector feature extraction head on top for tasks like Speaker Verification."),L0.forEach(t),Fv=p(kt),vr=r(kt,"P",{});var mh=i(vr);Ev=s(mh,"Wav2Vec2 was proposed in "),br=r(mh,"A",{href:!0,rel:!0});var O0=i(br);Cv=s(O0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),O0.forEach(t),qv=s(mh,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),mh.forEach(t),Pv=p(kt),wr=r(kt,"P",{});var hh=i(wr);Av=s(hh,"This model inherits from "),wl=r(hh,"A",{href:!0});var D0=i(wl);zv=s(D0,"PreTrainedModel"),D0.forEach(t),Mv=s(hh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),hh.forEach(t),Lv=p(kt),yr=r(kt,"P",{});var fh=i(yr);Ov=s(fh,"This model is a PyTorch "),kr=r(fh,"A",{href:!0,rel:!0});var S0=i(kr);Dv=s(S0,"torch.nn.Module"),S0.forEach(t),Sv=s(fh,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),fh.forEach(t),Iv=p(kt),pt=r(kt,"DIV",{class:!0});var fs=i(pt);y(Tr.$$.fragment,fs),Nv=p(fs),Co=r(fs,"P",{});var Ul=i(Co);Bv=s(Ul,"The "),yl=r(Ul,"A",{href:!0});var I0=i(yl);Rv=s(I0,"Wav2Vec2ForXVector"),I0.forEach(t),Uv=s(Ul," forward method, overrides the "),cd=r(Ul,"CODE",{});var N0=i(cd);Hv=s(N0,"__call__"),N0.forEach(t),Xv=s(Ul," special method."),Ul.forEach(t),Gv=p(fs),y(Pa.$$.fragment,fs),Kv=p(fs),y(Aa.$$.fragment,fs),fs.forEach(t),kt.forEach(t),Zp=p(o),qo=r(o,"H2",{class:!0});var uh=i(qo);za=r(uh,"A",{id:!0,class:!0,href:!0});var B0=i(za);dd=r(B0,"SPAN",{});var R0=i(dd);y(xr.$$.fragment,R0),R0.forEach(t),B0.forEach(t),Jv=p(uh),pd=r(uh,"SPAN",{});var U0=i(pd);Zv=s(U0,"Wav2Vec2ForPreTraining"),U0.forEach(t),uh.forEach(t),Qp=p(o),Le=r(o,"DIV",{class:!0});var Zt=i(Le);y($r.$$.fragment,Zt),Qv=p(Zt),Po=r(Zt,"P",{});var Hl=i(Po);Yv=s(Hl,"Wav2Vec2 Model with a quantizer and "),md=r(Hl,"CODE",{});var H0=i(md);eb=s(H0,"VQ"),H0.forEach(t),tb=s(Hl,` head on top.
Wav2Vec2 was proposed in `),jr=r(Hl,"A",{href:!0,rel:!0});var X0=i(jr);ob=s(X0,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),X0.forEach(t),ab=s(Hl,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Hl.forEach(t),sb=p(Zt),Wr=r(Zt,"P",{});var gh=i(Wr);nb=s(gh,"This model inherits from "),kl=r(gh,"A",{href:!0});var G0=i(kl);rb=s(G0,"PreTrainedModel"),G0.forEach(t),ib=s(gh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving etc.).`),gh.forEach(t),lb=p(Zt),Vr=r(Zt,"P",{});var _h=i(Vr);cb=s(_h,"This model is a PyTorch "),Fr=r(_h,"A",{href:!0,rel:!0});var K0=i(Fr);db=s(K0,"torch.nn.Module"),K0.forEach(t),pb=s(_h,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),_h.forEach(t),mb=p(Zt),mt=r(Zt,"DIV",{class:!0});var us=i(mt);y(Er.$$.fragment,us),hb=p(us),Ao=r(us,"P",{});var Xl=i(Ao);fb=s(Xl,"The "),Tl=r(Xl,"A",{href:!0});var J0=i(Tl);ub=s(J0,"Wav2Vec2ForPreTraining"),J0.forEach(t),gb=s(Xl," forward method, overrides the "),hd=r(Xl,"CODE",{});var Z0=i(hd);_b=s(Z0,"__call__"),Z0.forEach(t),vb=s(Xl," special method."),Xl.forEach(t),bb=p(us),y(Ma.$$.fragment,us),wb=p(us),y(La.$$.fragment,us),us.forEach(t),Zt.forEach(t),Yp=p(o),zo=r(o,"H2",{class:!0});var vh=i(zo);Oa=r(vh,"A",{id:!0,class:!0,href:!0});var Q0=i(Oa);fd=r(Q0,"SPAN",{});var Y0=i(fd);y(Cr.$$.fragment,Y0),Y0.forEach(t),Q0.forEach(t),yb=p(vh),ud=r(vh,"SPAN",{});var eT=i(ud);kb=s(eT,"TFWav2Vec2Model"),eT.forEach(t),vh.forEach(t),em=p(o),ve=r(o,"DIV",{class:!0});var Tt=i(ve);y(qr.$$.fragment,Tt),Tb=p(Tt),gd=r(Tt,"P",{});var tT=i(gd);xb=s(tT,"The bare TFWav2Vec2 Model transformer outputing raw hidden-states without any specific head on top."),tT.forEach(t),$b=p(Tt),Pr=r(Tt,"P",{});var bh=i(Pr);jb=s(bh,"This model inherits from "),xl=r(bh,"A",{href:!0});var oT=i(xl);Wb=s(oT,"TFPreTrainedModel"),oT.forEach(t),Vb=s(bh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),bh.forEach(t),Fb=p(Tt),Ar=r(Tt,"P",{});var wh=i(Ar);Eb=s(wh,"This model is also a "),zr=r(wh,"A",{href:!0,rel:!0});var aT=i(zr);Cb=s(aT,"tf.keras.Model"),aT.forEach(t),qb=s(wh,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),wh.forEach(t),Pb=p(Tt),y(Da.$$.fragment,Tt),Ab=p(Tt),ht=r(Tt,"DIV",{class:!0});var gs=i(ht);y(Mr.$$.fragment,gs),zb=p(gs),Mo=r(gs,"P",{});var Gl=i(Mo);Mb=s(Gl,"The "),$l=r(Gl,"A",{href:!0});var sT=i($l);Lb=s(sT,"TFWav2Vec2Model"),sT.forEach(t),Ob=s(Gl," forward method, overrides the "),_d=r(Gl,"CODE",{});var nT=i(_d);Db=s(nT,"__call__"),nT.forEach(t),Sb=s(Gl," special method."),Gl.forEach(t),Ib=p(gs),y(Sa.$$.fragment,gs),Nb=p(gs),y(Ia.$$.fragment,gs),gs.forEach(t),Tt.forEach(t),tm=p(o),Lo=r(o,"H2",{class:!0});var yh=i(Lo);Na=r(yh,"A",{id:!0,class:!0,href:!0});var rT=i(Na);vd=r(rT,"SPAN",{});var iT=i(vd);y(Lr.$$.fragment,iT),iT.forEach(t),rT.forEach(t),Bb=p(yh),bd=r(yh,"SPAN",{});var lT=i(bd);Rb=s(lT,"TFWav2Vec2ForSequenceClassification"),lT.forEach(t),yh.forEach(t),om=p(o),Oo=r(o,"DIV",{class:!0});var kh=i(Oo);y(Or.$$.fragment,kh),Ub=p(kh),jl=r(kh,"DIV",{class:!0});var cT=i(jl);y(Dr.$$.fragment,cT),cT.forEach(t),kh.forEach(t),am=p(o),Do=r(o,"H2",{class:!0});var Th=i(Do);Ba=r(Th,"A",{id:!0,class:!0,href:!0});var dT=i(Ba);wd=r(dT,"SPAN",{});var pT=i(wd);y(Sr.$$.fragment,pT),pT.forEach(t),dT.forEach(t),Hb=p(Th),yd=r(Th,"SPAN",{});var mT=i(yd);Xb=s(mT,"TFWav2Vec2ForCTC"),mT.forEach(t),Th.forEach(t),sm=p(o),be=r(o,"DIV",{class:!0});var xt=i(be);y(Ir.$$.fragment,xt),Gb=p(xt),Nr=r(xt,"P",{});var xh=i(Nr);Kb=s(xh,"TFWav2Vec2 Model with a "),kd=r(xh,"CODE",{});var hT=i(kd);Jb=s(hT,"language modeling"),hT.forEach(t),Zb=s(xh," head on top for Connectionist Temporal Classification (CTC)."),xh.forEach(t),Qb=p(xt),Br=r(xt,"P",{});var $h=i(Br);Yb=s($h,"This model inherits from "),Wl=r($h,"A",{href:!0});var fT=i(Wl);ew=s(fT,"TFPreTrainedModel"),fT.forEach(t),tw=s($h,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),$h.forEach(t),ow=p(xt),Rr=r(xt,"P",{});var jh=i(Rr);aw=s(jh,"This model is also a "),Ur=r(jh,"A",{href:!0,rel:!0});var uT=i(Ur);sw=s(uT,"tf.keras.Model"),uT.forEach(t),nw=s(jh,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),jh.forEach(t),rw=p(xt),y(Ra.$$.fragment,xt),iw=p(xt),ft=r(xt,"DIV",{class:!0});var _s=i(ft);y(Hr.$$.fragment,_s),lw=p(_s),So=r(_s,"P",{});var Kl=i(So);cw=s(Kl,"The "),Vl=r(Kl,"A",{href:!0});var gT=i(Vl);dw=s(gT,"TFWav2Vec2ForCTC"),gT.forEach(t),pw=s(Kl," forward method, overrides the "),Td=r(Kl,"CODE",{});var _T=i(Td);mw=s(_T,"__call__"),_T.forEach(t),hw=s(Kl," special method."),Kl.forEach(t),fw=p(_s),y(Ua.$$.fragment,_s),uw=p(_s),y(Ha.$$.fragment,_s),_s.forEach(t),xt.forEach(t),nm=p(o),Io=r(o,"H2",{class:!0});var Wh=i(Io);Xa=r(Wh,"A",{id:!0,class:!0,href:!0});var vT=i(Xa);xd=r(vT,"SPAN",{});var bT=i(xd);y(Xr.$$.fragment,bT),bT.forEach(t),vT.forEach(t),gw=p(Wh),$d=r(Wh,"SPAN",{});var wT=i($d);_w=s(wT,"FlaxWav2Vec2Model"),wT.forEach(t),Wh.forEach(t),rm=p(o),re=r(o,"DIV",{class:!0});var Re=i(re);y(Gr.$$.fragment,Re),vw=p(Re),Kr=r(Re,"P",{});var Vh=i(Kr);bw=s(Vh,`The bare Wav2Vec2 Model transformer outputting raw hidden-states without any specific head on top.
Wav2Vec2 was proposed in `),Jr=r(Vh,"A",{href:!0,rel:!0});var yT=i(Jr);ww=s(yT,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),yT.forEach(t),yw=s(Vh,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Vh.forEach(t),kw=p(Re),Zr=r(Re,"P",{});var Fh=i(Zr);Tw=s(Fh,"This model inherits from "),Fl=r(Fh,"A",{href:!0});var kT=i(Fl);xw=s(kT,"FlaxPreTrainedModel"),kT.forEach(t),$w=s(Fh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Fh.forEach(t),jw=p(Re),Qr=r(Re,"P",{});var Eh=i(Qr);Ww=s(Eh,`This model is also a Flax Linen
`),Yr=r(Eh,"A",{href:!0,rel:!0});var TT=i(Yr);Vw=s(TT,"flax.nn.Module"),TT.forEach(t),Fw=s(Eh,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Eh.forEach(t),Ew=p(Re),jd=r(Re,"P",{});var xT=i(jd);Cw=s(xT,"Finally, this model supports inherent JAX features such as:"),xT.forEach(t),qw=p(Re),Ot=r(Re,"UL",{});var vs=i(Ot);Wd=r(vs,"LI",{});var $T=i(Wd);ei=r($T,"A",{href:!0,rel:!0});var jT=i(ei);Pw=s(jT,"Just-In-Time (JIT) compilation"),jT.forEach(t),$T.forEach(t),Aw=p(vs),Vd=r(vs,"LI",{});var WT=i(Vd);ti=r(WT,"A",{href:!0,rel:!0});var VT=i(ti);zw=s(VT,"Automatic Differentiation"),VT.forEach(t),WT.forEach(t),Mw=p(vs),Fd=r(vs,"LI",{});var FT=i(Fd);oi=r(FT,"A",{href:!0,rel:!0});var ET=i(oi);Lw=s(ET,"Vectorization"),ET.forEach(t),FT.forEach(t),Ow=p(vs),Ed=r(vs,"LI",{});var CT=i(Ed);ai=r(CT,"A",{href:!0,rel:!0});var qT=i(ai);Dw=s(qT,"Parallelization"),qT.forEach(t),CT.forEach(t),vs.forEach(t),Sw=p(Re),ut=r(Re,"DIV",{class:!0});var bs=i(ut);y(si.$$.fragment,bs),Iw=p(bs),No=r(bs,"P",{});var Jl=i(No);Nw=s(Jl,"The "),Cd=r(Jl,"CODE",{});var PT=i(Cd);Bw=s(PT,"FlaxWav2Vec2PreTrainedModel"),PT.forEach(t),Rw=s(Jl," forward method, overrides the "),qd=r(Jl,"CODE",{});var AT=i(qd);Uw=s(AT,"__call__"),AT.forEach(t),Hw=s(Jl," special method."),Jl.forEach(t),Xw=p(bs),y(Ga.$$.fragment,bs),Gw=p(bs),y(Ka.$$.fragment,bs),bs.forEach(t),Re.forEach(t),im=p(o),Bo=r(o,"H2",{class:!0});var Ch=i(Bo);Ja=r(Ch,"A",{id:!0,class:!0,href:!0});var zT=i(Ja);Pd=r(zT,"SPAN",{});var MT=i(Pd);y(ni.$$.fragment,MT),MT.forEach(t),zT.forEach(t),Kw=p(Ch),Ad=r(Ch,"SPAN",{});var LT=i(Ad);Jw=s(LT,"FlaxWav2Vec2ForCTC"),LT.forEach(t),Ch.forEach(t),lm=p(o),ie=r(o,"DIV",{class:!0});var Ue=i(ie);y(ri.$$.fragment,Ue),Zw=p(Ue),Ro=r(Ue,"P",{});var Zl=i(Ro);Qw=s(Zl,"Wav2Vec2 Model with a "),zd=r(Zl,"CODE",{});var OT=i(zd);Yw=s(OT,"language modeling"),OT.forEach(t),e1=s(Zl,` head on top for Connectionist Temporal Classification (CTC).
Wav2Vec2 was proposed in `),ii=r(Zl,"A",{href:!0,rel:!0});var DT=i(ii);t1=s(DT,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),DT.forEach(t),o1=s(Zl,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Zl.forEach(t),a1=p(Ue),li=r(Ue,"P",{});var qh=i(li);s1=s(qh,"This model inherits from "),El=r(qh,"A",{href:!0});var ST=i(El);n1=s(ST,"FlaxPreTrainedModel"),ST.forEach(t),r1=s(qh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),qh.forEach(t),i1=p(Ue),ci=r(Ue,"P",{});var Ph=i(ci);l1=s(Ph,`This model is also a Flax Linen
`),di=r(Ph,"A",{href:!0,rel:!0});var IT=i(di);c1=s(IT,"flax.nn.Module"),IT.forEach(t),d1=s(Ph,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Ph.forEach(t),p1=p(Ue),Md=r(Ue,"P",{});var NT=i(Md);m1=s(NT,"Finally, this model supports inherent JAX features such as:"),NT.forEach(t),h1=p(Ue),Dt=r(Ue,"UL",{});var ws=i(Dt);Ld=r(ws,"LI",{});var BT=i(Ld);pi=r(BT,"A",{href:!0,rel:!0});var RT=i(pi);f1=s(RT,"Just-In-Time (JIT) compilation"),RT.forEach(t),BT.forEach(t),u1=p(ws),Od=r(ws,"LI",{});var UT=i(Od);mi=r(UT,"A",{href:!0,rel:!0});var HT=i(mi);g1=s(HT,"Automatic Differentiation"),HT.forEach(t),UT.forEach(t),_1=p(ws),Dd=r(ws,"LI",{});var XT=i(Dd);hi=r(XT,"A",{href:!0,rel:!0});var GT=i(hi);v1=s(GT,"Vectorization"),GT.forEach(t),XT.forEach(t),b1=p(ws),Sd=r(ws,"LI",{});var KT=i(Sd);fi=r(KT,"A",{href:!0,rel:!0});var JT=i(fi);w1=s(JT,"Parallelization"),JT.forEach(t),KT.forEach(t),ws.forEach(t),y1=p(Ue),gt=r(Ue,"DIV",{class:!0});var ys=i(gt);y(ui.$$.fragment,ys),k1=p(ys),Uo=r(ys,"P",{});var Ql=i(Uo);T1=s(Ql,"The "),Id=r(Ql,"CODE",{});var ZT=i(Id);x1=s(ZT,"FlaxWav2Vec2PreTrainedModel"),ZT.forEach(t),$1=s(Ql," forward method, overrides the "),Nd=r(Ql,"CODE",{});var QT=i(Nd);j1=s(QT,"__call__"),QT.forEach(t),W1=s(Ql," special method."),Ql.forEach(t),V1=p(ys),y(Za.$$.fragment,ys),F1=p(ys),y(Qa.$$.fragment,ys),ys.forEach(t),Ue.forEach(t),cm=p(o),Ho=r(o,"H2",{class:!0});var Ah=i(Ho);Ya=r(Ah,"A",{id:!0,class:!0,href:!0});var YT=i(Ya);Bd=r(YT,"SPAN",{});var ex=i(Bd);y(gi.$$.fragment,ex),ex.forEach(t),YT.forEach(t),E1=p(Ah),Rd=r(Ah,"SPAN",{});var tx=i(Rd);C1=s(tx,"FlaxWav2Vec2ForPreTraining"),tx.forEach(t),Ah.forEach(t),dm=p(o),le=r(o,"DIV",{class:!0});var He=i(le);y(_i.$$.fragment,He),q1=p(He),Xo=r(He,"P",{});var Yl=i(Xo);P1=s(Yl,"Wav2Vec2 Model with a quantizer and "),Ud=r(Yl,"CODE",{});var ox=i(Ud);A1=s(ox,"VQ"),ox.forEach(t),z1=s(Yl,` head on top.
Wav2Vec2 was proposed in `),vi=r(Yl,"A",{href:!0,rel:!0});var ax=i(vi);M1=s(ax,`wav2vec 2.0: A Framework for Self-Supervised Learning of Speech
Representations`),ax.forEach(t),L1=s(Yl,` by Alexei Baevski, Henry Zhou, Abdelrahman Mohamed, Michael
Auli.`),Yl.forEach(t),O1=p(He),bi=r(He,"P",{});var zh=i(bi);D1=s(zh,"This model inherits from "),Cl=r(zh,"A",{href:!0});var sx=i(Cl);S1=s(sx,"FlaxPreTrainedModel"),sx.forEach(t),I1=s(zh,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),zh.forEach(t),N1=p(He),wi=r(He,"P",{});var Mh=i(wi);B1=s(Mh,`This model is also a Flax Linen
`),yi=r(Mh,"A",{href:!0,rel:!0});var nx=i(yi);R1=s(nx,"flax.nn.Module"),nx.forEach(t),U1=s(Mh,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Mh.forEach(t),H1=p(He),Hd=r(He,"P",{});var rx=i(Hd);X1=s(rx,"Finally, this model supports inherent JAX features such as:"),rx.forEach(t),G1=p(He),St=r(He,"UL",{});var ks=i(St);Xd=r(ks,"LI",{});var ix=i(Xd);ki=r(ix,"A",{href:!0,rel:!0});var lx=i(ki);K1=s(lx,"Just-In-Time (JIT) compilation"),lx.forEach(t),ix.forEach(t),J1=p(ks),Gd=r(ks,"LI",{});var cx=i(Gd);Ti=r(cx,"A",{href:!0,rel:!0});var dx=i(Ti);Z1=s(dx,"Automatic Differentiation"),dx.forEach(t),cx.forEach(t),Q1=p(ks),Kd=r(ks,"LI",{});var px=i(Kd);xi=r(px,"A",{href:!0,rel:!0});var mx=i(xi);Y1=s(mx,"Vectorization"),mx.forEach(t),px.forEach(t),ey=p(ks),Jd=r(ks,"LI",{});var hx=i(Jd);$i=r(hx,"A",{href:!0,rel:!0});var fx=i($i);ty=s(fx,"Parallelization"),fx.forEach(t),hx.forEach(t),ks.forEach(t),oy=p(He),_t=r(He,"DIV",{class:!0});var Ts=i(_t);y(ji.$$.fragment,Ts),ay=p(Ts),Go=r(Ts,"P",{});var ec=i(Go);sy=s(ec,"The "),ql=r(ec,"A",{href:!0});var ux=i(ql);ny=s(ux,"FlaxWav2Vec2ForPreTraining"),ux.forEach(t),ry=s(ec," forward method, overrides the "),Zd=r(ec,"CODE",{});var gx=i(Zd);iy=s(gx,"__call__"),gx.forEach(t),ly=s(ec," special method."),ec.forEach(t),cy=p(Ts),y(es.$$.fragment,Ts),dy=p(Ts),y(ts.$$.fragment,Ts),Ts.forEach(t),He.forEach(t),this.h()},h(){c(m,"name","hf:doc:metadata"),c(m,"content",JSON.stringify(e$)),c(f,"id","wav2vec2"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#wav2vec2"),c(g,"class","relative group"),c(z,"id","overview"),c(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(z,"href","#overview"),c(A,"class","relative group"),c(I,"href","https://arxiv.org/abs/2006.11477"),c(I,"rel","nofollow"),c(U,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer"),c(qe,"href","https://huggingface.co/patrickvonplaten"),c(qe,"rel","nofollow"),c(ye,"id","resources"),c(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ye,"href","#resources"),c(ee,"class","relative group"),c(Ze,"href","https://colab.research.google.com/github/m3hrdadfi/soxan/blob/main/notebooks/Emotion_recognition_in_Greek_speech_using_Wav2Vec2.ipynb"),c(Ze,"rel","nofollow"),c(pe,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC"),c(se,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/audio-classification"),c(se,"rel","nofollow"),c(Ae,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/audio_classification.ipynb"),c(Ae,"rel","nofollow"),c(Mi,"href","../tasks/audio_classification"),c(js,"href","https://huggingface.co/blog/wav2vec2-with-ngram"),c(js,"rel","nofollow"),c(Vs,"href","https://huggingface.co/blog/fine-tune-wav2vec2-english"),c(Vs,"rel","nofollow"),c(Es,"href","https://huggingface.co/blog/fine-tune-xlsr-wav2vec2"),c(Es,"rel","nofollow"),c(qs,"href","https://colab.research.google.com/github/Muennighoff/ytclipcc/blob/main/wav2vec_youtube_captions.ipynb"),c(qs,"rel","nofollow"),c(Li,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC"),c(Ps,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/speech_recognition.ipynb"),c(Ps,"rel","nofollow"),c(As,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/multi_lingual_speech_recognition.ipynb"),c(As,"rel","nofollow"),c(Oi,"href","../tasks/asr"),c(Ms,"href","https://www.philschmid.de/automatic-speech-recognition-sagemaker"),c(Ms,"rel","nofollow"),c(Jo,"id","transformers.Wav2Vec2Config"),c(Jo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Jo,"href","#transformers.Wav2Vec2Config"),c(lo,"class","relative group"),c(Ii,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Model"),c(Ds,"href","https://huggingface.co/facebook/wav2vec2-base-960h"),c(Ds,"rel","nofollow"),c(Ni,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),c(Bi,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),c(Ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Qo,"id","transformers.Wav2Vec2CTCTokenizer"),c(Qo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Qo,"href","#transformers.Wav2Vec2CTCTokenizer"),c(mo,"class","relative group"),c(Ri,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer"),c(Yo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ui,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(nt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ta,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(oa,"id","transformers.Wav2Vec2FeatureExtractor"),c(oa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(oa,"href","#transformers.Wav2Vec2FeatureExtractor"),c(ho,"class","relative group"),c(Hi,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.SequenceFeatureExtractor"),c(aa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(sa,"id","transformers.Wav2Vec2Processor"),c(sa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(sa,"href","#transformers.Wav2Vec2Processor"),c(fo,"class","relative group"),c(Xi,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor"),c(Gi,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor"),c(Ki,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizer"),c(en,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.__call__"),c(Ji,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Processor.decode"),c(on,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor.__call__"),c(an,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__"),c(na,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Zi,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.SequenceFeatureExtractor.pad"),c(Qi,"href","/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.pad"),c(ra,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Yi,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(el,"href","/docs/transformers/pr_22182/en/main_classes/processors#transformers.ProcessorMixin.from_pretrained"),c(Ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(tl,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.batch_decode"),c(la,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ol,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.decode"),c(ca,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(da,"id","transformers.Wav2Vec2ProcessorWithLM"),c(da,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(da,"href","#transformers.Wav2Vec2ProcessorWithLM"),c(uo,"class","relative group"),c(gn,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2FeatureExtractor.__call__"),c(_n,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__"),c(pa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(al,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.SequenceFeatureExtractor.pad"),c(sl,"href","/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.pad"),c(ma,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(nl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM"),c(Ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(rl,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(il,"href","#decoding-multiple-audios"),c(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ga,"id","decoding-multiple-audios"),c(ga,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ga,"href","#decoding-multiple-audios"),c(go,"class","relative group"),c(ll,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM.batch_decode"),c(cl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM.batch_decode"),c(dl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ProcessorWithLM.decode"),c(_a,"id","transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput"),c(_a,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(_a,"href","#transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput"),c(_o,"class","relative group"),c(vo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(bo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(pl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForPreTraining"),c(wo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(va,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ba,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(wa,"id","transformers.Wav2Vec2Model"),c(wa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(wa,"href","#transformers.Wav2Vec2Model"),c(yo,"class","relative group"),c(Nn,"href","https://arxiv.org/abs/2006.11477"),c(Nn,"rel","nofollow"),c(ml,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(Un,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Un,"rel","nofollow"),c(hl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2Model"),c(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ta,"id","transformers.Wav2Vec2ForCTC"),c(Ta,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ta,"href","#transformers.Wav2Vec2ForCTC"),c(To,"class","relative group"),c(Kn,"href","https://arxiv.org/abs/2006.11477"),c(Kn,"rel","nofollow"),c(fl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(Qn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Qn,"rel","nofollow"),c(ul,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForCTC"),c(lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ja,"id","transformers.Wav2Vec2ForSequenceClassification"),c(ja,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ja,"href","#transformers.Wav2Vec2ForSequenceClassification"),c(jo,"class","relative group"),c(ar,"href","https://arxiv.org/abs/2006.11477"),c(ar,"rel","nofollow"),c(gl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(rr,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(rr,"rel","nofollow"),c(_l,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForSequenceClassification"),c(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Fa,"id","transformers.Wav2Vec2ForAudioFrameClassification"),c(Fa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Fa,"href","#transformers.Wav2Vec2ForAudioFrameClassification"),c(Vo,"class","relative group"),c(pr,"href","https://arxiv.org/abs/2006.11477"),c(pr,"rel","nofollow"),c(vl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(fr,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(fr,"rel","nofollow"),c(bl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForAudioFrameClassification"),c(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(qa,"id","transformers.Wav2Vec2ForXVector"),c(qa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(qa,"href","#transformers.Wav2Vec2ForXVector"),c(Eo,"class","relative group"),c(br,"href","https://arxiv.org/abs/2006.11477"),c(br,"rel","nofollow"),c(wl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(kr,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(kr,"rel","nofollow"),c(yl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForXVector"),c(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(za,"id","transformers.Wav2Vec2ForPreTraining"),c(za,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(za,"href","#transformers.Wav2Vec2ForPreTraining"),c(qo,"class","relative group"),c(jr,"href","https://arxiv.org/abs/2006.11477"),c(jr,"rel","nofollow"),c(kl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel"),c(Fr,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(Fr,"rel","nofollow"),c(Tl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2ForPreTraining"),c(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Oa,"id","transformers.TFWav2Vec2Model"),c(Oa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Oa,"href","#transformers.TFWav2Vec2Model"),c(zo,"class","relative group"),c(xl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.TFPreTrainedModel"),c(zr,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(zr,"rel","nofollow"),c($l,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.TFWav2Vec2Model"),c(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Na,"id","transformers.TFWav2Vec2ForSequenceClassification"),c(Na,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Na,"href","#transformers.TFWav2Vec2ForSequenceClassification"),c(Lo,"class","relative group"),c(jl,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Oo,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ba,"id","transformers.TFWav2Vec2ForCTC"),c(Ba,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ba,"href","#transformers.TFWav2Vec2ForCTC"),c(Do,"class","relative group"),c(Wl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.TFPreTrainedModel"),c(Ur,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),c(Ur,"rel","nofollow"),c(Vl,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.TFWav2Vec2ForCTC"),c(ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Xa,"id","transformers.FlaxWav2Vec2Model"),c(Xa,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Xa,"href","#transformers.FlaxWav2Vec2Model"),c(Io,"class","relative group"),c(Jr,"href","https://arxiv.org/abs/2006.11477"),c(Jr,"rel","nofollow"),c(Fl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(Yr,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),c(Yr,"rel","nofollow"),c(ei,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(ei,"rel","nofollow"),c(ti,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(ti,"rel","nofollow"),c(oi,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(oi,"rel","nofollow"),c(ai,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(ai,"rel","nofollow"),c(ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ja,"id","transformers.FlaxWav2Vec2ForCTC"),c(Ja,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ja,"href","#transformers.FlaxWav2Vec2ForCTC"),c(Bo,"class","relative group"),c(ii,"href","https://arxiv.org/abs/2006.11477"),c(ii,"rel","nofollow"),c(El,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(di,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),c(di,"rel","nofollow"),c(pi,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(pi,"rel","nofollow"),c(mi,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(mi,"rel","nofollow"),c(hi,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(hi,"rel","nofollow"),c(fi,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c(fi,"rel","nofollow"),c(gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ya,"id","transformers.FlaxWav2Vec2ForPreTraining"),c(Ya,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(Ya,"href","#transformers.FlaxWav2Vec2ForPreTraining"),c(Ho,"class","relative group"),c(vi,"href","https://arxiv.org/abs/2006.11477"),c(vi,"rel","nofollow"),c(Cl,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.FlaxPreTrainedModel"),c(yi,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),c(yi,"rel","nofollow"),c(ki,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),c(ki,"rel","nofollow"),c(Ti,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),c(Ti,"rel","nofollow"),c(xi,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),c(xi,"rel","nofollow"),c($i,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),c($i,"rel","nofollow"),c(ql,"href","/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.FlaxWav2Vec2ForPreTraining"),c(_t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,u){e(document.head,m),_(o,b,u),_(o,g,u),e(g,f),e(f,v),k(l,v,null),e(g,h),e(g,V),e(V,M),_(o,L,u),_(o,A,u),e(A,z),e(z,N),k(E,N,null),e(A,O),e(A,C),e(C,ce),_(o,J,u),_(o,S,u),e(S,de),e(S,I),e(I,R),e(S,De),_(o,X,u),_(o,Z,u),e(Z,Se),_(o,We,u),_(o,Q,u),e(Q,Ke),e(Ke,$t),_(o,Ie,u),_(o,D,u),e(D,Y),_(o,tt,u),_(o,ae,u),e(ae,Je),e(Je,jt),e(ae,Ve),e(ae,Fe),e(Fe,Wt),e(Fe,U),e(U,Vt),e(Fe,Ee),_(o,ot,u),_(o,we,u),e(we,Ce),e(we,qe),e(qe,Ft),e(we,he),_(o,at,u),_(o,ee,u),e(ee,ye),e(ye,Pe),k(B,Pe,null),e(ee,Et),e(ee,te),e(te,Ct),_(o,st,u),_(o,j,u),e(j,q),_(o,Nt,u),k(fe,o,u),_(o,Bt,u),_(o,ke,u),e(ke,P),e(P,Qt),e(P,Ze),e(Ze,Yt),e(P,eo),e(ke,to),e(ke,H),e(H,pe),e(pe,oo),e(H,ao),e(H,se),e(se,so),e(H,no),e(H,Ae),e(Ae,ro),e(H,Qe),e(ke,io),e(ke,tc),e(tc,Mi),e(Mi,Lh),_(o,vp,u),k(xs,o,u),_(o,bp,u),_(o,Te,u),e(Te,$s),e($s,Oh),e($s,js),e(js,Dh),e($s,Sh),e(Te,Ih),e(Te,Ws),e(Ws,Nh),e(Ws,Vs),e(Vs,Bh),e(Ws,Rh),e(Te,Uh),e(Te,Fs),e(Fs,Hh),e(Fs,Es),e(Es,Xh),e(Fs,Gh),e(Te,Kh),e(Te,Cs),e(Cs,Jh),e(Cs,qs),e(qs,Zh),e(Cs,Qh),e(Te,Yh),e(Te,Rt),e(Rt,Li),e(Li,ef),e(Rt,tf),e(Rt,Ps),e(Ps,of),e(Rt,af),e(Rt,As),e(As,sf),e(Rt,nf),e(Te,rf),e(Te,oc),e(oc,Oi),e(Oi,lf),_(o,wp,u),_(o,Di,u),e(Di,cf),_(o,yp,u),_(o,Si,u),e(Si,zs),e(zs,df),e(zs,Ms),e(Ms,pf),e(zs,mf),_(o,kp,u),_(o,lo,u),e(lo,Jo),e(Jo,ac),k(Ls,ac,null),e(lo,hf),e(lo,sc),e(sc,ff),_(o,Tp,u),_(o,Ye,u),k(Os,Ye,null),e(Ye,uf),e(Ye,co),e(co,gf),e(co,Ii),e(Ii,_f),e(co,vf),e(co,Ds),e(Ds,bf),e(co,wf),e(Ye,yf),e(Ye,po),e(po,kf),e(po,Ni),e(Ni,Tf),e(po,xf),e(po,Bi),e(Bi,$f),e(po,jf),e(Ye,Wf),k(Zo,Ye,null),_(o,xp,u),_(o,mo,u),e(mo,Qo),e(Qo,nc),k(Ss,nc,null),e(mo,Vf),e(mo,rc),e(rc,Ff),_(o,$p,u),_(o,ne,u),k(Is,ne,null),e(ne,Ef),e(ne,ic),e(ic,Cf),e(ne,qf),e(ne,Ns),e(Ns,Pf),e(Ns,Ri),e(Ri,Af),e(Ns,zf),e(ne,Mf),e(ne,Yo),k(Bs,Yo,null),e(Yo,Lf),e(Yo,lc),e(lc,Of),e(ne,Df),e(ne,Ui),k(Rs,Ui,null),e(ne,Sf),e(ne,nt),k(Us,nt,null),e(nt,If),e(nt,cc),e(cc,Nf),e(nt,Bf),e(nt,Hs),e(Hs,Rf),e(Hs,dc),e(dc,Uf),e(Hs,Hf),e(nt,Xf),k(ea,nt,null),e(ne,Gf),e(ne,ta),k(Xs,ta,null),e(ta,Kf),e(ta,pc),e(pc,Jf),_(o,jp,u),_(o,ho,u),e(ho,oa),e(oa,mc),k(Gs,mc,null),e(ho,Zf),e(ho,hc),e(hc,Qf),_(o,Wp,u),_(o,et,u),k(Ks,et,null),e(et,Yf),e(et,fc),e(fc,eu),e(et,tu),e(et,Js),e(Js,ou),e(Js,Hi),e(Hi,au),e(Js,su),e(et,nu),e(et,aa),k(Zs,aa,null),e(aa,ru),e(aa,uc),e(uc,iu),_(o,Vp,u),_(o,fo,u),e(fo,sa),e(sa,gc),k(Qs,gc,null),e(fo,lu),e(fo,_c),e(_c,cu),_(o,Fp,u),_(o,G,u),k(Ys,G,null),e(G,du),e(G,vc),e(vc,pu),e(G,mu),e(G,Ne),e(Ne,Xi),e(Xi,hu),e(Ne,fu),e(Ne,Gi),e(Gi,uu),e(Ne,gu),e(Ne,Ki),e(Ki,_u),e(Ne,vu),e(Ne,en),e(en,bc),e(bc,bu),e(en,wu),e(Ne,yu),e(Ne,Ji),e(Ji,ku),e(Ne,Tu),e(G,xu),e(G,na),k(tn,na,null),e(na,$u),e(na,qt),e(qt,ju),e(qt,on),e(on,wc),e(wc,Wu),e(on,Vu),e(qt,Fu),e(qt,yc),e(yc,Eu),e(qt,Cu),e(qt,an),e(an,kc),e(kc,qu),e(an,Pu),e(qt,Au),e(G,zu),e(G,ra),k(sn,ra,null),e(ra,Mu),e(ra,Pt),e(Pt,Lu),e(Pt,Zi),e(Zi,Ou),e(Pt,Du),e(Pt,Tc),e(Tc,Su),e(Pt,Iu),e(Pt,Qi),e(Qi,Nu),e(Pt,Bu),e(G,Ru),e(G,Yi),k(nn,Yi,null),e(G,Uu),e(G,Ut),k(rn,Ut,null),e(Ut,Hu),e(Ut,ln),e(ln,Xu),e(ln,el),e(el,Gu),e(ln,Ku),e(Ut,Ju),k(ia,Ut,null),e(G,Zu),e(G,la),k(cn,la,null),e(la,Qu),e(la,dn),e(dn,Yu),e(dn,tl),e(tl,eg),e(dn,tg),e(G,og),e(G,ca),k(pn,ca,null),e(ca,ag),e(ca,mn),e(mn,sg),e(mn,ol),e(ol,ng),e(mn,rg),_(o,Ep,u),_(o,uo,u),e(uo,da),e(da,xc),k(hn,xc,null),e(uo,ig),e(uo,$c),e($c,lg),_(o,Cp,u),_(o,oe,u),k(fn,oe,null),e(oe,cg),e(oe,jc),e(jc,dg),e(oe,pg),e(oe,pa),k(un,pa,null),e(pa,mg),e(pa,At),e(At,hg),e(At,gn),e(gn,Wc),e(Wc,fg),e(gn,ug),e(At,gg),e(At,Vc),e(Vc,_g),e(At,vg),e(At,_n),e(_n,Fc),e(Fc,bg),e(_n,wg),e(At,yg),e(oe,kg),e(oe,ma),k(vn,ma,null),e(ma,Tg),e(ma,zt),e(zt,xg),e(zt,al),e(al,$g),e(zt,jg),e(zt,Ec),e(Ec,Wg),e(zt,Vg),e(zt,sl),e(sl,Fg),e(zt,Eg),e(oe,Cg),e(oe,Ht),k(bn,Ht,null),e(Ht,qg),e(Ht,wn),e(wn,Pg),e(wn,nl),e(nl,Ag),e(wn,zg),e(Ht,Mg),k(ha,Ht,null),e(oe,Lg),e(oe,rl),k(yn,rl,null),e(oe,Og),e(oe,rt),k(kn,rt,null),e(rt,Dg),e(rt,Cc),e(Cc,Sg),e(rt,Ig),k(fa,rt,null),e(rt,Ng),e(rt,Tn),e(Tn,Bg),e(Tn,il),e(il,Rg),e(Tn,Ug),e(oe,Hg),e(oe,Xt),k(xn,Xt,null),e(Xt,Xg),e(Xt,qc),e(qc,Gg),e(Xt,Kg),k(ua,Xt,null),_(o,qp,u),_(o,go,u),e(go,ga),e(ga,Pc),k($n,Pc,null),e(go,Jg),e(go,Ac),e(Ac,Zg),_(o,Pp,u),_(o,xe,u),e(xe,Qg),e(xe,ll),e(ll,Yg),e(xe,e_),e(xe,zc),e(zc,t_),e(xe,o_),e(xe,cl),e(cl,a_),e(xe,s_),e(xe,dl),e(dl,n_),e(xe,r_),e(xe,Mc),e(Mc,i_),e(xe,l_),_(o,Ap,u),k(jn,o,u),_(o,zp,u),_(o,_o,u),e(_o,_a),e(_a,Lc),k(Wn,Lc,null),e(_o,c_),e(_o,Oc),e(Oc,d_),_(o,Mp,u),_(o,vo,u),k(Vn,vo,null),e(vo,p_),e(vo,Fn),e(Fn,m_),e(Fn,Dc),e(Dc,h_),e(Fn,f_),_(o,Lp,u),_(o,bo,u),k(En,bo,null),e(bo,u_),e(bo,Sc),e(Sc,g_),_(o,Op,u),_(o,wo,u),k(Cn,wo,null),e(wo,__),e(wo,qn),e(qn,v_),e(qn,pl),e(pl,b_),e(qn,w_),_(o,Dp,u),_(o,Mt,u),k(Pn,Mt,null),e(Mt,y_),e(Mt,An),e(An,k_),e(An,Ic),e(Ic,T_),e(An,x_),e(Mt,$_),e(Mt,va),k(zn,va,null),e(va,j_),e(va,Nc),e(Nc,W_),_(o,Sp,u),_(o,Lt,u),k(Mn,Lt,null),e(Lt,V_),e(Lt,Ln),e(Ln,F_),e(Ln,Bc),e(Bc,E_),e(Ln,C_),e(Lt,q_),e(Lt,ba),k(On,ba,null),e(ba,P_),e(ba,Rc),e(Rc,A_),_(o,Ip,u),_(o,yo,u),e(yo,wa),e(wa,Uc),k(Dn,Uc,null),e(yo,z_),e(yo,Hc),e(Hc,M_),_(o,Np,u),_(o,ze,u),k(Sn,ze,null),e(ze,L_),e(ze,In),e(In,O_),e(In,Nn),e(Nn,D_),e(In,S_),e(ze,I_),e(ze,Bn),e(Bn,N_),e(Bn,ml),e(ml,B_),e(Bn,R_),e(ze,U_),e(ze,Rn),e(Rn,H_),e(Rn,Un),e(Un,X_),e(Rn,G_),e(ze,K_),e(ze,it),k(Hn,it,null),e(it,J_),e(it,ko),e(ko,Z_),e(ko,hl),e(hl,Q_),e(ko,Y_),e(ko,Xc),e(Xc,e2),e(ko,t2),e(it,o2),k(ya,it,null),e(it,a2),k(ka,it,null),_(o,Bp,u),_(o,To,u),e(To,Ta),e(Ta,Gc),k(Xn,Gc,null),e(To,s2),e(To,Kc),e(Kc,n2),_(o,Rp,u),_(o,Me,u),k(Gn,Me,null),e(Me,r2),e(Me,xo),e(xo,i2),e(xo,Jc),e(Jc,l2),e(xo,c2),e(xo,Kn),e(Kn,d2),e(xo,p2),e(Me,m2),e(Me,Jn),e(Jn,h2),e(Jn,fl),e(fl,f2),e(Jn,u2),e(Me,g2),e(Me,Zn),e(Zn,_2),e(Zn,Qn),e(Qn,v2),e(Zn,b2),e(Me,w2),e(Me,lt),k(Yn,lt,null),e(lt,y2),e(lt,$o),e($o,k2),e($o,ul),e(ul,T2),e($o,x2),e($o,Zc),e(Zc,$2),e($o,j2),e(lt,W2),k(xa,lt,null),e(lt,V2),k($a,lt,null),_(o,Up,u),_(o,jo,u),e(jo,ja),e(ja,Qc),k(er,Qc,null),e(jo,F2),e(jo,Yc),e(Yc,E2),_(o,Hp,u),_(o,ue,u),k(tr,ue,null),e(ue,C2),e(ue,ed),e(ed,q2),e(ue,P2),e(ue,or),e(or,A2),e(or,ar),e(ar,z2),e(or,M2),e(ue,L2),e(ue,sr),e(sr,O2),e(sr,gl),e(gl,D2),e(sr,S2),e(ue,I2),e(ue,nr),e(nr,N2),e(nr,rr),e(rr,B2),e(nr,R2),e(ue,U2),e(ue,ct),k(ir,ct,null),e(ct,H2),e(ct,Wo),e(Wo,X2),e(Wo,_l),e(_l,G2),e(Wo,K2),e(Wo,td),e(td,J2),e(Wo,Z2),e(ct,Q2),k(Wa,ct,null),e(ct,Y2),k(Va,ct,null),_(o,Xp,u),_(o,Vo,u),e(Vo,Fa),e(Fa,od),k(lr,od,null),e(Vo,ev),e(Vo,ad),e(ad,tv),_(o,Gp,u),_(o,ge,u),k(cr,ge,null),e(ge,ov),e(ge,sd),e(sd,av),e(ge,sv),e(ge,dr),e(dr,nv),e(dr,pr),e(pr,rv),e(dr,iv),e(ge,lv),e(ge,mr),e(mr,cv),e(mr,vl),e(vl,dv),e(mr,pv),e(ge,mv),e(ge,hr),e(hr,hv),e(hr,fr),e(fr,fv),e(hr,uv),e(ge,gv),e(ge,dt),k(ur,dt,null),e(dt,_v),e(dt,Fo),e(Fo,vv),e(Fo,bl),e(bl,bv),e(Fo,wv),e(Fo,nd),e(nd,yv),e(Fo,kv),e(dt,Tv),k(Ea,dt,null),e(dt,xv),k(Ca,dt,null),_(o,Kp,u),_(o,Eo,u),e(Eo,qa),e(qa,rd),k(gr,rd,null),e(Eo,$v),e(Eo,id),e(id,jv),_(o,Jp,u),_(o,_e,u),k(_r,_e,null),e(_e,Wv),e(_e,ld),e(ld,Vv),e(_e,Fv),e(_e,vr),e(vr,Ev),e(vr,br),e(br,Cv),e(vr,qv),e(_e,Pv),e(_e,wr),e(wr,Av),e(wr,wl),e(wl,zv),e(wr,Mv),e(_e,Lv),e(_e,yr),e(yr,Ov),e(yr,kr),e(kr,Dv),e(yr,Sv),e(_e,Iv),e(_e,pt),k(Tr,pt,null),e(pt,Nv),e(pt,Co),e(Co,Bv),e(Co,yl),e(yl,Rv),e(Co,Uv),e(Co,cd),e(cd,Hv),e(Co,Xv),e(pt,Gv),k(Pa,pt,null),e(pt,Kv),k(Aa,pt,null),_(o,Zp,u),_(o,qo,u),e(qo,za),e(za,dd),k(xr,dd,null),e(qo,Jv),e(qo,pd),e(pd,Zv),_(o,Qp,u),_(o,Le,u),k($r,Le,null),e(Le,Qv),e(Le,Po),e(Po,Yv),e(Po,md),e(md,eb),e(Po,tb),e(Po,jr),e(jr,ob),e(Po,ab),e(Le,sb),e(Le,Wr),e(Wr,nb),e(Wr,kl),e(kl,rb),e(Wr,ib),e(Le,lb),e(Le,Vr),e(Vr,cb),e(Vr,Fr),e(Fr,db),e(Vr,pb),e(Le,mb),e(Le,mt),k(Er,mt,null),e(mt,hb),e(mt,Ao),e(Ao,fb),e(Ao,Tl),e(Tl,ub),e(Ao,gb),e(Ao,hd),e(hd,_b),e(Ao,vb),e(mt,bb),k(Ma,mt,null),e(mt,wb),k(La,mt,null),_(o,Yp,u),_(o,zo,u),e(zo,Oa),e(Oa,fd),k(Cr,fd,null),e(zo,yb),e(zo,ud),e(ud,kb),_(o,em,u),_(o,ve,u),k(qr,ve,null),e(ve,Tb),e(ve,gd),e(gd,xb),e(ve,$b),e(ve,Pr),e(Pr,jb),e(Pr,xl),e(xl,Wb),e(Pr,Vb),e(ve,Fb),e(ve,Ar),e(Ar,Eb),e(Ar,zr),e(zr,Cb),e(Ar,qb),e(ve,Pb),k(Da,ve,null),e(ve,Ab),e(ve,ht),k(Mr,ht,null),e(ht,zb),e(ht,Mo),e(Mo,Mb),e(Mo,$l),e($l,Lb),e(Mo,Ob),e(Mo,_d),e(_d,Db),e(Mo,Sb),e(ht,Ib),k(Sa,ht,null),e(ht,Nb),k(Ia,ht,null),_(o,tm,u),_(o,Lo,u),e(Lo,Na),e(Na,vd),k(Lr,vd,null),e(Lo,Bb),e(Lo,bd),e(bd,Rb),_(o,om,u),_(o,Oo,u),k(Or,Oo,null),e(Oo,Ub),e(Oo,jl),k(Dr,jl,null),_(o,am,u),_(o,Do,u),e(Do,Ba),e(Ba,wd),k(Sr,wd,null),e(Do,Hb),e(Do,yd),e(yd,Xb),_(o,sm,u),_(o,be,u),k(Ir,be,null),e(be,Gb),e(be,Nr),e(Nr,Kb),e(Nr,kd),e(kd,Jb),e(Nr,Zb),e(be,Qb),e(be,Br),e(Br,Yb),e(Br,Wl),e(Wl,ew),e(Br,tw),e(be,ow),e(be,Rr),e(Rr,aw),e(Rr,Ur),e(Ur,sw),e(Rr,nw),e(be,rw),k(Ra,be,null),e(be,iw),e(be,ft),k(Hr,ft,null),e(ft,lw),e(ft,So),e(So,cw),e(So,Vl),e(Vl,dw),e(So,pw),e(So,Td),e(Td,mw),e(So,hw),e(ft,fw),k(Ua,ft,null),e(ft,uw),k(Ha,ft,null),_(o,nm,u),_(o,Io,u),e(Io,Xa),e(Xa,xd),k(Xr,xd,null),e(Io,gw),e(Io,$d),e($d,_w),_(o,rm,u),_(o,re,u),k(Gr,re,null),e(re,vw),e(re,Kr),e(Kr,bw),e(Kr,Jr),e(Jr,ww),e(Kr,yw),e(re,kw),e(re,Zr),e(Zr,Tw),e(Zr,Fl),e(Fl,xw),e(Zr,$w),e(re,jw),e(re,Qr),e(Qr,Ww),e(Qr,Yr),e(Yr,Vw),e(Qr,Fw),e(re,Ew),e(re,jd),e(jd,Cw),e(re,qw),e(re,Ot),e(Ot,Wd),e(Wd,ei),e(ei,Pw),e(Ot,Aw),e(Ot,Vd),e(Vd,ti),e(ti,zw),e(Ot,Mw),e(Ot,Fd),e(Fd,oi),e(oi,Lw),e(Ot,Ow),e(Ot,Ed),e(Ed,ai),e(ai,Dw),e(re,Sw),e(re,ut),k(si,ut,null),e(ut,Iw),e(ut,No),e(No,Nw),e(No,Cd),e(Cd,Bw),e(No,Rw),e(No,qd),e(qd,Uw),e(No,Hw),e(ut,Xw),k(Ga,ut,null),e(ut,Gw),k(Ka,ut,null),_(o,im,u),_(o,Bo,u),e(Bo,Ja),e(Ja,Pd),k(ni,Pd,null),e(Bo,Kw),e(Bo,Ad),e(Ad,Jw),_(o,lm,u),_(o,ie,u),k(ri,ie,null),e(ie,Zw),e(ie,Ro),e(Ro,Qw),e(Ro,zd),e(zd,Yw),e(Ro,e1),e(Ro,ii),e(ii,t1),e(Ro,o1),e(ie,a1),e(ie,li),e(li,s1),e(li,El),e(El,n1),e(li,r1),e(ie,i1),e(ie,ci),e(ci,l1),e(ci,di),e(di,c1),e(ci,d1),e(ie,p1),e(ie,Md),e(Md,m1),e(ie,h1),e(ie,Dt),e(Dt,Ld),e(Ld,pi),e(pi,f1),e(Dt,u1),e(Dt,Od),e(Od,mi),e(mi,g1),e(Dt,_1),e(Dt,Dd),e(Dd,hi),e(hi,v1),e(Dt,b1),e(Dt,Sd),e(Sd,fi),e(fi,w1),e(ie,y1),e(ie,gt),k(ui,gt,null),e(gt,k1),e(gt,Uo),e(Uo,T1),e(Uo,Id),e(Id,x1),e(Uo,$1),e(Uo,Nd),e(Nd,j1),e(Uo,W1),e(gt,V1),k(Za,gt,null),e(gt,F1),k(Qa,gt,null),_(o,cm,u),_(o,Ho,u),e(Ho,Ya),e(Ya,Bd),k(gi,Bd,null),e(Ho,E1),e(Ho,Rd),e(Rd,C1),_(o,dm,u),_(o,le,u),k(_i,le,null),e(le,q1),e(le,Xo),e(Xo,P1),e(Xo,Ud),e(Ud,A1),e(Xo,z1),e(Xo,vi),e(vi,M1),e(Xo,L1),e(le,O1),e(le,bi),e(bi,D1),e(bi,Cl),e(Cl,S1),e(bi,I1),e(le,N1),e(le,wi),e(wi,B1),e(wi,yi),e(yi,R1),e(wi,U1),e(le,H1),e(le,Hd),e(Hd,X1),e(le,G1),e(le,St),e(St,Xd),e(Xd,ki),e(ki,K1),e(St,J1),e(St,Gd),e(Gd,Ti),e(Ti,Z1),e(St,Q1),e(St,Kd),e(Kd,xi),e(xi,Y1),e(St,ey),e(St,Jd),e(Jd,$i),e($i,ty),e(le,oy),e(le,_t),k(ji,_t,null),e(_t,ay),e(_t,Go),e(Go,sy),e(Go,ql),e(ql,ny),e(Go,ry),e(Go,Zd),e(Zd,iy),e(Go,ly),e(_t,cy),k(es,_t,null),e(_t,dy),k(ts,_t,null),pm=!0},p(o,[u]){const Wi={};u&2&&(Wi.$$scope={dirty:u,ctx:o}),Zo.$set(Wi);const Qd={};u&2&&(Qd.$$scope={dirty:u,ctx:o}),ea.$set(Qd);const Yd={};u&2&&(Yd.$$scope={dirty:u,ctx:o}),ia.$set(Yd);const ep={};u&2&&(ep.$$scope={dirty:u,ctx:o}),ha.$set(ep);const Vi={};u&2&&(Vi.$$scope={dirty:u,ctx:o}),fa.$set(Vi);const tp={};u&2&&(tp.$$scope={dirty:u,ctx:o}),ua.$set(tp);const op={};u&2&&(op.$$scope={dirty:u,ctx:o}),ya.$set(op);const ap={};u&2&&(ap.$$scope={dirty:u,ctx:o}),ka.$set(ap);const Fi={};u&2&&(Fi.$$scope={dirty:u,ctx:o}),xa.$set(Fi);const sp={};u&2&&(sp.$$scope={dirty:u,ctx:o}),$a.$set(sp);const np={};u&2&&(np.$$scope={dirty:u,ctx:o}),Wa.$set(np);const rp={};u&2&&(rp.$$scope={dirty:u,ctx:o}),Va.$set(rp);const ip={};u&2&&(ip.$$scope={dirty:u,ctx:o}),Ea.$set(ip);const lp={};u&2&&(lp.$$scope={dirty:u,ctx:o}),Ca.$set(lp);const Ei={};u&2&&(Ei.$$scope={dirty:u,ctx:o}),Pa.$set(Ei);const cp={};u&2&&(cp.$$scope={dirty:u,ctx:o}),Aa.$set(cp);const Ci={};u&2&&(Ci.$$scope={dirty:u,ctx:o}),Ma.$set(Ci);const dp={};u&2&&(dp.$$scope={dirty:u,ctx:o}),La.$set(dp);const qi={};u&2&&(qi.$$scope={dirty:u,ctx:o}),Da.$set(qi);const pp={};u&2&&(pp.$$scope={dirty:u,ctx:o}),Sa.$set(pp);const Pi={};u&2&&(Pi.$$scope={dirty:u,ctx:o}),Ia.$set(Pi);const mp={};u&2&&(mp.$$scope={dirty:u,ctx:o}),Ra.$set(mp);const hp={};u&2&&(hp.$$scope={dirty:u,ctx:o}),Ua.$set(hp);const fp={};u&2&&(fp.$$scope={dirty:u,ctx:o}),Ha.$set(fp);const up={};u&2&&(up.$$scope={dirty:u,ctx:o}),Ga.$set(up);const Ko={};u&2&&(Ko.$$scope={dirty:u,ctx:o}),Ka.$set(Ko);const Ai={};u&2&&(Ai.$$scope={dirty:u,ctx:o}),Za.$set(Ai);const gp={};u&2&&(gp.$$scope={dirty:u,ctx:o}),Qa.$set(gp);const Gt={};u&2&&(Gt.$$scope={dirty:u,ctx:o}),es.$set(Gt);const _p={};u&2&&(_p.$$scope={dirty:u,ctx:o}),ts.$set(_p)},i(o){pm||(T(l.$$.fragment,o),T(E.$$.fragment,o),T(B.$$.fragment,o),T(fe.$$.fragment,o),T(xs.$$.fragment,o),T(Ls.$$.fragment,o),T(Os.$$.fragment,o),T(Zo.$$.fragment,o),T(Ss.$$.fragment,o),T(Is.$$.fragment,o),T(Bs.$$.fragment,o),T(Rs.$$.fragment,o),T(Us.$$.fragment,o),T(ea.$$.fragment,o),T(Xs.$$.fragment,o),T(Gs.$$.fragment,o),T(Ks.$$.fragment,o),T(Zs.$$.fragment,o),T(Qs.$$.fragment,o),T(Ys.$$.fragment,o),T(tn.$$.fragment,o),T(sn.$$.fragment,o),T(nn.$$.fragment,o),T(rn.$$.fragment,o),T(ia.$$.fragment,o),T(cn.$$.fragment,o),T(pn.$$.fragment,o),T(hn.$$.fragment,o),T(fn.$$.fragment,o),T(un.$$.fragment,o),T(vn.$$.fragment,o),T(bn.$$.fragment,o),T(ha.$$.fragment,o),T(yn.$$.fragment,o),T(kn.$$.fragment,o),T(fa.$$.fragment,o),T(xn.$$.fragment,o),T(ua.$$.fragment,o),T($n.$$.fragment,o),T(jn.$$.fragment,o),T(Wn.$$.fragment,o),T(Vn.$$.fragment,o),T(En.$$.fragment,o),T(Cn.$$.fragment,o),T(Pn.$$.fragment,o),T(zn.$$.fragment,o),T(Mn.$$.fragment,o),T(On.$$.fragment,o),T(Dn.$$.fragment,o),T(Sn.$$.fragment,o),T(Hn.$$.fragment,o),T(ya.$$.fragment,o),T(ka.$$.fragment,o),T(Xn.$$.fragment,o),T(Gn.$$.fragment,o),T(Yn.$$.fragment,o),T(xa.$$.fragment,o),T($a.$$.fragment,o),T(er.$$.fragment,o),T(tr.$$.fragment,o),T(ir.$$.fragment,o),T(Wa.$$.fragment,o),T(Va.$$.fragment,o),T(lr.$$.fragment,o),T(cr.$$.fragment,o),T(ur.$$.fragment,o),T(Ea.$$.fragment,o),T(Ca.$$.fragment,o),T(gr.$$.fragment,o),T(_r.$$.fragment,o),T(Tr.$$.fragment,o),T(Pa.$$.fragment,o),T(Aa.$$.fragment,o),T(xr.$$.fragment,o),T($r.$$.fragment,o),T(Er.$$.fragment,o),T(Ma.$$.fragment,o),T(La.$$.fragment,o),T(Cr.$$.fragment,o),T(qr.$$.fragment,o),T(Da.$$.fragment,o),T(Mr.$$.fragment,o),T(Sa.$$.fragment,o),T(Ia.$$.fragment,o),T(Lr.$$.fragment,o),T(Or.$$.fragment,o),T(Dr.$$.fragment,o),T(Sr.$$.fragment,o),T(Ir.$$.fragment,o),T(Ra.$$.fragment,o),T(Hr.$$.fragment,o),T(Ua.$$.fragment,o),T(Ha.$$.fragment,o),T(Xr.$$.fragment,o),T(Gr.$$.fragment,o),T(si.$$.fragment,o),T(Ga.$$.fragment,o),T(Ka.$$.fragment,o),T(ni.$$.fragment,o),T(ri.$$.fragment,o),T(ui.$$.fragment,o),T(Za.$$.fragment,o),T(Qa.$$.fragment,o),T(gi.$$.fragment,o),T(_i.$$.fragment,o),T(ji.$$.fragment,o),T(es.$$.fragment,o),T(ts.$$.fragment,o),pm=!0)},o(o){x(l.$$.fragment,o),x(E.$$.fragment,o),x(B.$$.fragment,o),x(fe.$$.fragment,o),x(xs.$$.fragment,o),x(Ls.$$.fragment,o),x(Os.$$.fragment,o),x(Zo.$$.fragment,o),x(Ss.$$.fragment,o),x(Is.$$.fragment,o),x(Bs.$$.fragment,o),x(Rs.$$.fragment,o),x(Us.$$.fragment,o),x(ea.$$.fragment,o),x(Xs.$$.fragment,o),x(Gs.$$.fragment,o),x(Ks.$$.fragment,o),x(Zs.$$.fragment,o),x(Qs.$$.fragment,o),x(Ys.$$.fragment,o),x(tn.$$.fragment,o),x(sn.$$.fragment,o),x(nn.$$.fragment,o),x(rn.$$.fragment,o),x(ia.$$.fragment,o),x(cn.$$.fragment,o),x(pn.$$.fragment,o),x(hn.$$.fragment,o),x(fn.$$.fragment,o),x(un.$$.fragment,o),x(vn.$$.fragment,o),x(bn.$$.fragment,o),x(ha.$$.fragment,o),x(yn.$$.fragment,o),x(kn.$$.fragment,o),x(fa.$$.fragment,o),x(xn.$$.fragment,o),x(ua.$$.fragment,o),x($n.$$.fragment,o),x(jn.$$.fragment,o),x(Wn.$$.fragment,o),x(Vn.$$.fragment,o),x(En.$$.fragment,o),x(Cn.$$.fragment,o),x(Pn.$$.fragment,o),x(zn.$$.fragment,o),x(Mn.$$.fragment,o),x(On.$$.fragment,o),x(Dn.$$.fragment,o),x(Sn.$$.fragment,o),x(Hn.$$.fragment,o),x(ya.$$.fragment,o),x(ka.$$.fragment,o),x(Xn.$$.fragment,o),x(Gn.$$.fragment,o),x(Yn.$$.fragment,o),x(xa.$$.fragment,o),x($a.$$.fragment,o),x(er.$$.fragment,o),x(tr.$$.fragment,o),x(ir.$$.fragment,o),x(Wa.$$.fragment,o),x(Va.$$.fragment,o),x(lr.$$.fragment,o),x(cr.$$.fragment,o),x(ur.$$.fragment,o),x(Ea.$$.fragment,o),x(Ca.$$.fragment,o),x(gr.$$.fragment,o),x(_r.$$.fragment,o),x(Tr.$$.fragment,o),x(Pa.$$.fragment,o),x(Aa.$$.fragment,o),x(xr.$$.fragment,o),x($r.$$.fragment,o),x(Er.$$.fragment,o),x(Ma.$$.fragment,o),x(La.$$.fragment,o),x(Cr.$$.fragment,o),x(qr.$$.fragment,o),x(Da.$$.fragment,o),x(Mr.$$.fragment,o),x(Sa.$$.fragment,o),x(Ia.$$.fragment,o),x(Lr.$$.fragment,o),x(Or.$$.fragment,o),x(Dr.$$.fragment,o),x(Sr.$$.fragment,o),x(Ir.$$.fragment,o),x(Ra.$$.fragment,o),x(Hr.$$.fragment,o),x(Ua.$$.fragment,o),x(Ha.$$.fragment,o),x(Xr.$$.fragment,o),x(Gr.$$.fragment,o),x(si.$$.fragment,o),x(Ga.$$.fragment,o),x(Ka.$$.fragment,o),x(ni.$$.fragment,o),x(ri.$$.fragment,o),x(ui.$$.fragment,o),x(Za.$$.fragment,o),x(Qa.$$.fragment,o),x(gi.$$.fragment,o),x(_i.$$.fragment,o),x(ji.$$.fragment,o),x(es.$$.fragment,o),x(ts.$$.fragment,o),pm=!1},d(o){t(m),o&&t(b),o&&t(g),$(l),o&&t(L),o&&t(A),$(E),o&&t(J),o&&t(S),o&&t(X),o&&t(Z),o&&t(We),o&&t(Q),o&&t(Ie),o&&t(D),o&&t(tt),o&&t(ae),o&&t(ot),o&&t(we),o&&t(at),o&&t(ee),$(B),o&&t(st),o&&t(j),o&&t(Nt),$(fe,o),o&&t(Bt),o&&t(ke),o&&t(vp),$(xs,o),o&&t(bp),o&&t(Te),o&&t(wp),o&&t(Di),o&&t(yp),o&&t(Si),o&&t(kp),o&&t(lo),$(Ls),o&&t(Tp),o&&t(Ye),$(Os),$(Zo),o&&t(xp),o&&t(mo),$(Ss),o&&t($p),o&&t(ne),$(Is),$(Bs),$(Rs),$(Us),$(ea),$(Xs),o&&t(jp),o&&t(ho),$(Gs),o&&t(Wp),o&&t(et),$(Ks),$(Zs),o&&t(Vp),o&&t(fo),$(Qs),o&&t(Fp),o&&t(G),$(Ys),$(tn),$(sn),$(nn),$(rn),$(ia),$(cn),$(pn),o&&t(Ep),o&&t(uo),$(hn),o&&t(Cp),o&&t(oe),$(fn),$(un),$(vn),$(bn),$(ha),$(yn),$(kn),$(fa),$(xn),$(ua),o&&t(qp),o&&t(go),$($n),o&&t(Pp),o&&t(xe),o&&t(Ap),$(jn,o),o&&t(zp),o&&t(_o),$(Wn),o&&t(Mp),o&&t(vo),$(Vn),o&&t(Lp),o&&t(bo),$(En),o&&t(Op),o&&t(wo),$(Cn),o&&t(Dp),o&&t(Mt),$(Pn),$(zn),o&&t(Sp),o&&t(Lt),$(Mn),$(On),o&&t(Ip),o&&t(yo),$(Dn),o&&t(Np),o&&t(ze),$(Sn),$(Hn),$(ya),$(ka),o&&t(Bp),o&&t(To),$(Xn),o&&t(Rp),o&&t(Me),$(Gn),$(Yn),$(xa),$($a),o&&t(Up),o&&t(jo),$(er),o&&t(Hp),o&&t(ue),$(tr),$(ir),$(Wa),$(Va),o&&t(Xp),o&&t(Vo),$(lr),o&&t(Gp),o&&t(ge),$(cr),$(ur),$(Ea),$(Ca),o&&t(Kp),o&&t(Eo),$(gr),o&&t(Jp),o&&t(_e),$(_r),$(Tr),$(Pa),$(Aa),o&&t(Zp),o&&t(qo),$(xr),o&&t(Qp),o&&t(Le),$($r),$(Er),$(Ma),$(La),o&&t(Yp),o&&t(zo),$(Cr),o&&t(em),o&&t(ve),$(qr),$(Da),$(Mr),$(Sa),$(Ia),o&&t(tm),o&&t(Lo),$(Lr),o&&t(om),o&&t(Oo),$(Or),$(Dr),o&&t(am),o&&t(Do),$(Sr),o&&t(sm),o&&t(be),$(Ir),$(Ra),$(Hr),$(Ua),$(Ha),o&&t(nm),o&&t(Io),$(Xr),o&&t(rm),o&&t(re),$(Gr),$(si),$(Ga),$(Ka),o&&t(im),o&&t(Bo),$(ni),o&&t(lm),o&&t(ie),$(ri),$(ui),$(Za),$(Qa),o&&t(cm),o&&t(Ho),$(gi),o&&t(dm),o&&t(le),$(_i),$(ji),$(es),$(ts)}}}const e$={local:"wav2vec2",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.Wav2Vec2Config",title:"Wav2Vec2Config"},{local:"transformers.Wav2Vec2CTCTokenizer",title:"Wav2Vec2CTCTokenizer"},{local:"transformers.Wav2Vec2FeatureExtractor",title:"Wav2Vec2FeatureExtractor"},{local:"transformers.Wav2Vec2Processor",title:"Wav2Vec2Processor"},{local:"transformers.Wav2Vec2ProcessorWithLM",sections:[{local:"decoding-multiple-audios",title:"Decoding multiple audios"}],title:"Wav2Vec2ProcessorWithLM"},{local:"transformers.models.wav2vec2_with_lm.processing_wav2vec2_with_lm.Wav2Vec2DecoderWithLMOutput",title:"Wav2Vec2 specific outputs"},{local:"transformers.Wav2Vec2Model",title:"Wav2Vec2Model"},{local:"transformers.Wav2Vec2ForCTC",title:"Wav2Vec2ForCTC"},{local:"transformers.Wav2Vec2ForSequenceClassification",title:"Wav2Vec2ForSequenceClassification"},{local:"transformers.Wav2Vec2ForAudioFrameClassification",title:"Wav2Vec2ForAudioFrameClassification"},{local:"transformers.Wav2Vec2ForXVector",title:"Wav2Vec2ForXVector"},{local:"transformers.Wav2Vec2ForPreTraining",title:"Wav2Vec2ForPreTraining"},{local:"transformers.TFWav2Vec2Model",title:"TFWav2Vec2Model"},{local:"transformers.TFWav2Vec2ForSequenceClassification",title:"TFWav2Vec2ForSequenceClassification"},{local:"transformers.TFWav2Vec2ForCTC",title:"TFWav2Vec2ForCTC"},{local:"transformers.FlaxWav2Vec2Model",title:"FlaxWav2Vec2Model"},{local:"transformers.FlaxWav2Vec2ForCTC",title:"FlaxWav2Vec2ForCTC"},{local:"transformers.FlaxWav2Vec2ForPreTraining",title:"FlaxWav2Vec2ForPreTraining"}],title:"Wav2Vec2"};function t$(W){return kx(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class c$ extends vx{constructor(m){super();bx(this,m,t$,Yx,wx,{})}}export{c$ as default,e$ as metadata};
